      subroutine eight_symmetry(theta_symm, phi_symm, omega_symm,
     $     theta, phi, omega)

C     For a given orientation, generate the full set of eight symmetry
C     related orientations

      implicit none

      real, intent(in)  :: theta, phi, omega
      real, intent(out) :: theta_symm(8), phi_symm(8), omega_symm(8)

      integer i

      do i = 1, 4
         theta_symm(i) = theta
         phi_symm(i)   = phi + real(i-1)*90.0
         omega_symm(i) = omega
      enddo
      
      do i = 5, 8
         theta_symm(i) = -theta + 180.0
         phi_symm(i)   = -phi + 90.0 + real(i-5)*90.0
         omega_symm(i) =  omega + 180.0
      enddo

      do i = 1, 8
         phi_symm(i) = mod(phi_symm(i), 360.0)
      enddo

      do i = 1, 8
         if (phi_symm(i) > 180.0) then
            phi_symm(i) = phi_symm(i) - 360.0
         endif
      enddo

      return
      end subroutine eight_symmetry
