      subroutine exch_intp(hkl_max, intpl, tmppl)
      
C     Sum contributions to array intpl from across all processes and
C     distribute results to all processes
C
C     Author, Yongchang Ji 1/1002
C     Modified, Bob Sinkovits 2/15/2008
      
      implicit none
      
#ifdef MPI
      include 'mpif.h'
#endif

      include '../include/allprogs.inc'
#include "./map_type.inc"
      
      integer, intent(in) :: hkl_max
      
      FMAP_TYPE, intent(in) :: intpl(3, -hkl_max:hkl_max, 
     +     -hkl_max:hkl_max, 0:hkl_max)
      FMAP_TYPE, intent(out) :: tmppl(3, -hkl_max:hkl_max, 
     +     -hkl_max:hkl_max, frst_lst_iq(1,iam):frst_lst_iq(2,iam))
      
      integer  node, count, slice

C     The following block of code has been commented out and replaced
C     with a less efficient, but also less MPI buffer intensive
C     communications scheme

CCC      integer count_array(0:num_nodes-1)   
CCC      do node = 0, num_nodes-1
CCC         count_array(node) = (2*hkl_max + 1)**2 * 3 *
CCC     +        (frst_lst_iq(2,node) - frst_lst_iq(1,node) + 1)
CCC      enddo
CCC      call mpi_reduce_scatter(intpl, tmppl, count_array, 
CCC     +     MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, mpi_err)

#ifdef MPI
      do node = 0, num_nodes-1
         do slice = frst_lst_iq(1,node), frst_lst_iq(2,node)
            count = (2*hkl_max +1) * (2*hkl_max +1) * 3
            call mpi_reduce(intpl(1,-hkl_max,-hkl_max,slice),
     $           tmppl(1,-hkl_max,-hkl_max,slice), 
     $           count, FMAP_MPI_TYPE, MPI_SUM, node,
     $           mpi_comm_world, mpi_err)
         enddo
      enddo
#else
      tmppl = intpl ! Fortran 90 array syntax
#endif

      return
      end subroutine exch_intp
