      subroutine realtocomplx(hkl_max, first_iq, last_iq, interpolants,
     +     count, zeros, f_hkl)

C     Constructs complex array f_hkl from components of interpolants
C     array.

      implicit none
#include "./map_type.inc"

      integer, intent(in) :: hkl_max, first_iq, last_iq
      integer, intent(out) :: count(0:hkl_max), zeros(0:hkl_max)

      FMAP_TYPE, intent(in) :: interpolants(3, 
     +             -hkl_max:hkl_max, -hkl_max:hkl_max,first_iq:last_iq)

      complex, intent(out) :: f_hkl(-hkl_max:hkl_max, -hkl_max:hkl_max,
     +               first_iq:last_iq)

      integer  il, ik, ih, ir
      
      do ir = 0, hkl_max
         count(ir) = 0
         zeros(ir) = 0
      enddo

      do il = first_iq, last_iq
         do ik = -hkl_max, hkl_max
            do ih = -hkl_max, hkl_max
               ir = nint(sqrt(real(il*il + ik*ik + ih*ih)))
               if(ir <= hkl_max) count(ir) = count(ir) + 1
               if (interpolants(1,ih,ik,il) > 0.0) then
                  f_hkl(ih,ik,il) =
     +                 cmplx(interpolants(2,ih,ik,il)/
     +                 interpolants(1,ih,ik,il),
     +                 interpolants(3,ih,ik,il)/
     +                 interpolants(1,ih,ik,il))
               else 
                  f_hkl(ih,ik,il) = (0.0, 0.0)
                  if(ir <= hkl_max) zeros(ir) = zeros(ir) + 1
               endif
            enddo
         enddo
      enddo
      
      return
      end subroutine realtocomplx
