      subroutine map_2dmask (map, ncol, nrow, irad1, irad2, xcen, ycen)

C     Replace values outside circular annulus defined by rad1,rad2 with 0
C     
C     March 1993  Purdue University vax 8550, T. Baker
C     Modified 24-Mar-1993 by T. Baker
C     General cleanup, 21-Jul-2006, R. Sinkovits
      
      implicit none
      
      integer*4, intent(in) :: ncol, nrow, irad1, irad2
      real*4, intent(in)    :: xcen, ycen
      real*4, intent(inout) :: map(ncol,nrow)

      integer*4 i, j
      real*4    rsq1, rsq2, xsq, ysq, test
  
      rsq1 = real(irad1)**2
      rsq2 = real(irad2)**2
      
      do j = 1,nrow
         ysq = (real(j)-ycen)**2
         do i = 1,ncol
            xsq = (real(i)-xcen)**2
            test = xsq + ysq
            if(test > rsq2 .or. test < rsq1) map(i,j) = 0.0
         enddo
      enddo
      
      return
      end subroutine map_2dmask
