#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../include/common.h"
#include "../include/libUtil.h"

int main(int argc, char **argv) {
  int tot, fileSize, timeSwitch, totMisMatch;
  unsigned char inChar1, inChar2;
  char sysCall[256], thisSize[256];
  FILE *fIn1, *fIn2, *fSize;
  
  banner("diffit");
  
  if(argc < 3) {
    printf("USAGE diffit file1 file2 -time\n\n"); 
    exit(0);
  }
  
  timeSwitch = FALSE;
  fileSize = 0;
  
  if((argc==4) && 
     ((strstr(argv[3],"tim")==0)||(strstr(argv[3],"TIM")==0))) {
      sprintf(sysCall,"ls -l %s > temp.tmp",argv[1]);
      system(sysCall);
      fSize = fopen("temp.tmp", "r");
      fgets(sysCall,111,fSize);
      sscanf(&sysCall[22],"%s",thisSize);
      fileSize = (int)strtod(thisSize,'\0');
      fclose(fSize);
      sprintf(sysCall,"rm temp.tmp");
      system(sysCall);
      timeSwitch= TRUE;
  }
    
  fIn1 = fopen(argv[1], "r");
  fIn2 = fopen(argv[2], "r");
  if(fIn1==0) {
    printf("Can't open file [%s]\n", argv[1]);
    exit(0);
  }
  if(fIn2==0) {
    printf("Can't open file [%s]\n", argv[2]);
    exit(0);
  }
  
  totMisMatch = tot = 0;
  while(!feof(fIn1)) {
    inChar1 =fgetc(fIn1);
    inChar2 =fgetc(fIn2);
    
    // Alternative test
    // if((inChar1 != inChar2) && (inChar1 != 0) && (inChar1 < (inChar2 - 40)))
    
    if(inChar1 != inChar2) { 
	  totMisMatch++; 
	  printf("Mismatch [%d][%d][%d]\n",tot,inChar1,inChar2);
    }
    
    if(timeSwitch && tot%1000 == 0)
      printf("[%5.2f%%][%5d]\r",
	     ((float)(fileSize-tot)/(float)fileSize)*100.0, tot); 
    
    if(totMisMatch > 1000) {
      printf("Too many differences [%d]\n", totMisMatch);
      exit(0);
    }
    
    tot++;
  }
  
  printf("\n\n[%d] Mismatched chars found\n\n", totMisMatch);
  return 0;
}
