// normit.c  - run robem in batch mode to cycle all *.pif files 
// specified in the arg list and normalize the Means & Variances.

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "../include/common.h"

int main(int argc,  char **argv) {
  int i, doLinSwitch = FALSE;
  char *s1, sysCall[512];
  
  if(argc < 4) {
    printf("USAGE:  normit <-lingrad> Mean Std <list of *.pif files>\n");
    printf("Use -lingrad switch to do linear gradient also (Optional)\n");
    exit(0);
  }

  s1 = argv[1];
  if((*(s1) == '-') &&
     (*(s1+1)=='l' || *(s1+1)=='L') &&
     (*(s1+2)=='i' || *(s1+2)=='I') &&
     (*(s1+3)=='n' || *(s1+3)=='N') 
     )
    doLinSwitch = TRUE;
  
  if(doLinSwitch) {
    for(i=4; i<argc; i++) {
      sprintf(sysCall,"robem -pre %s -lingrad -norm %s %s\n",
	      argv[i], argv[2], argv[3]);
      printf("[%s]\n",sysCall);
      system(sysCall);
    }
  }
  else {
    for(i=3; i<argc; i++) {
      sprintf(sysCall,"robem -pre %s -norm %s %s\n", 
	      argv[i], argv[1], argv[2]);
      printf("[%s]\n", sysCall);
      system(sysCall);
    }
  }
  
  return 0;
}
