C*****************************************************************************
C*                                                                           *
C*                    *****   ROT_MAP    *****                               *
C*                                                                           *
C*    THIS PROGRAM READ IN A PIF MAP AND ROTATE IT USING AN INPUT MATRIX.    *
C*      Matrices used by this program is reversed matrices. For example,     *
C*      if you want to rotate the #1 map to the #2 map, the matrix used by   *
C*      the program is to rotate the #2 map to the #1 map.                   *
C*                                                                           *
C*    Xing ZHANG, Nov.07, 2003                                               *
C*****************************************************************************
C
      IMPLICIT NONE
C
      include '../include/pifhead.inc'
      type(pifhead_t) MAPHEAD, OUTHEAD1, OUTHEAD2
      COMMON /PIFHEAD/   MAPHEAD, OUTHEAD1, OUTHEAD2
C     
      INTEGER*4 NCOL, NROW, NSEC, I
      character(len=1) RW(2)
      CHARACTER MAP_FILENAME*64, MAP_OUTMAPNAME*64,FNAME*64
      CHARACTER tmpfile*256
      real*4, allocatable :: map_in(:), map_out(:)
      REAL*4  pixsize, MATRIX(3,4)
C
      MAPHEAD%LUNUM = 7      ! UNIT FOR INPUT IMAGE FILE
C
C  *****************************
C  * LOOP FOR ALL 3D MAP FILES *
C  *****************************
 11   WRITE(6,'(''Enter input map name: '')')
      READ (5,'(A)',ERR=11) MAP_FILENAME
      write(*,*) 'input map filename = ', trim(map_filename)

      RW(1) = 'r'
      RW(2) = achar(0)
      CALL PIF_OPEN (MAP_FILENAME, MAPHEAD%LUNUM, RW)
      CALL PIF_READ_GH (MAPHEAD)
      ncol = mapHead%numCols  
      nrow = mapHead%numRows 
      nsec = mapHead%numSecs 
      write(*,*) 'Map dimensions', ncol, nrow, nsec
C     
C     *************************************************************
C     * ALLOCATE VIRTUAL MEMORY FOR MAP AND MASK FILE             *
C     * READ 3D MAP INTO CORE MEMORY WITH SURFACE DENSITY IMPOSED *
C     *************************************************************
      allocate(map_in(ncol*nrow*nsec), map_out(ncol*nrow*nsec))

      write(*,*)
 13   WRITE(6,'(''Enter output map name: '')')
      READ (5,'(A)',ERR=13) MAP_OUTMAPNAME
      write(*,*) 'map_outmapname = ', trim(map_outmapname)
C
C     ********************************************************** 
C     *    SET UP PIF FORMAT MAP OUTPUT FILE OF THE MERGED MAP *
C     **********************************************************
      CALL PIF_INIT_HEAD (OUTHEAD2)
      OUTHEAD2%LUNUM = 9
      RW(1)  = 'w'
      RW(2)  = '+'
      CALL PIF_OPEN (MAP_OUTMAPNAME, OUTHEAD2%LUNUM, RW)
      OUTHEAD2%BINFACTOR  =   1
      OUTHEAD2%NIMG       =   1
      OUTHEAD2%MODE       =  20
      
      OUTHEAD2%NUMCOLS = NCOL
      OUTHEAD2%NUMROWS = NROW
      OUTHEAD2%NUMSECS = NSEC
C     
      OUTHEAD2%A_CELL      = NCOL 
      OUTHEAD2%B_CELL      = NROW 
      OUTHEAD2%C_CELL      = NSEC
      OUTHEAD2%DELA       = MAPHEAD%DELA        
      OUTHEAD2%DELB        = MAPHEAD%DELB         
      OUTHEAD2%DELC       = MAPHEAD%DELC        
      OUTHEAD2%DATAR4_MIN       = MAPHEAD%DATAR4_MIN   
      OUTHEAD2%DATAR4_MAX          = MAPHEAD%DATAR4_MAX             
      OUTHEAD2%SCALEF       = MAPHEAD%SCALEF       
      OUTHEAD2%pixelSize       = MAPHEAD%pixelSize    
      OUTHEAD2%pixSizUnits        = MAPHEAD%pixSizUnits  
      DO I =1,80
         OUTHEAD2%DESCRIPTIONSTR(I) =  MAPHEAD%DESCRIPTIONSTR(I)
      ENDDO
      CALL PIF_WRITE_GH (OUTHEAD2)
      OUTHEAD2%IMGNUM = 1
      CALL PIF_WRITE_DH (OUTHEAD2)
C     
      WRITE(*,'(/,A)') 'Enter pixel size: '
      READ (*,*,ERR=999,END=999) PIXSIZE
      write(*,*) 'Pixel size = ', pixsize
C     
      WRITE(*,'(/,A)') 'Enter matrix file name: '
      READ (*,'(A)',ERR=999,END=999) FNAME
      write(*,*) 'matrix file name = ', trim(fname)

      OPEN (UNIT=3, FILE=FNAME, STATUS='OLD', ERR=999,
     1     ACCESS='SEQUENTIAL', FORM='FORMATTED', ACTION='READ')
C     
      READ (3, '(A)', ERR=999) tmpfile
      
C     READ (3, '(4F)', ERR=999) MATRIX(1,1),MATRIX(1,2),MATRIX(1,3),MATRIX(1,4)
C     print *, MATRIX(1,1),MATRIX(1,2),MATRIX(1,3),MATRIX(1,4)
C     
C     READ (3, '(4F)', ERR=999) MATRIX(2,1),MATRIX(2,2),MATRIX(2,3),MATRIX(2,4)
C     print *, MATRIX(2,1),MATRIX(2,2),MATRIX(2,3),MATRIX(2,4)
C     
C     READ (3, '(4F)', ERR=999) MATRIX(3,1),MATRIX(3,2),MATRIX(3,3),MATRIX(3,4)
C     print *, MATRIX(3,1),MATRIX(3,2),MATRIX(3,3),MATRIX(3,4)
C     
      READ (3, *, ERR=999) MATRIX(1,1),MATRIX(2,1),MATRIX(3,1)
      READ (3, *, ERR=999) MATRIX(1,2),MATRIX(2,2),MATRIX(3,2)
      READ (3, *, ERR=999) MATRIX(1,3),MATRIX(2,3),MATRIX(3,3)
      READ (3, *, ERR=999) MATRIX(1,4),MATRIX(2,4),MATRIX(3,4)
      
      print *, '****************************************************'
      print *, '                Transform matrix'
      print *, '****************************************************'
      print *, MATRIX(1,1),MATRIX(2,1),MATRIX(3,1)
      print *, MATRIX(1,2),MATRIX(2,2),MATRIX(3,2)
      print *, MATRIX(1,3),MATRIX(2,3),MATRIX(3,3)
      print *, MATRIX(1,4),MATRIX(2,4),MATRIX(3,4)
      print *, '****************************************************'
c     
      CALL pif_read_WMAPI2(mapHead, MAP_IN, NCOL, NROW, NSEC)
C     
      CALL ROT_MAP(MAP_IN, MAP_OUT, NCOL, NROW, NSEC, MATRIX, PIXSIZE)
C     
      call pif_write_map_sections(outhead2, map_out,
     $     outhead2%mode, ncol, nrow, nsec, 0, nsec)
C     
C 200  FORMAT (3(I6,','), F8.3)      
      
      call pif_close(mapHead%luNum)
      call pif_close(OUTHEAD2%luNum)
C     
C     ******************
C     *  Free Memmory  *  
C     ******************
C     
 14   deallocate(map_out, map_in)
      
      CLOSE (UNIT=3)
      CALL TSBEND

 999  PRINT *, '*** INPUT ERROR OF MATRIX ****'
      goto 14
      END
C
C ****************************************************************************
C *                                                                          *
C *                  *****     SUBROUTINE ROT_MAP      *****                 *
C *                                                                          *
C *    ROTATE A 3D MAP USING A INPUT MATRIX.                                 *
C *                                                                          *
C *    ADAPTED FROM S. FULLER'S 20-MAR-1988 INTERP3D SUBROUTINE.             *
C *                                                                          *
C *    NOV.06 2003  X. ZHANG                                                 *
C ****************************************************************************
C
      SUBROUTINE ROT_MAP (MAP_IN, MAP_OUT, NCOL, NROW, NSEC, MATRIX,
     $     pixsize)
C
      IMPLICIT NONE
C     
      INTEGER*4 NCOL, NROW, NSEC, CENX, CENY, CENZ, ISEC,IROW,ICOL
      REAL*4    MAP_IN(NCOL,NROW,NSEC), MAP_OUT(NCOL,NROW,NSEC)
      REAL*4    TMPX, TMPY, TMPZ, VALUE, MATRIX(3,4), X,Y,Z
      REAL*4    Radius, TMPR, pixsize
C     ----------------------------------------------------------------------
C     
C     
      CENZ = (NSEC+1)/2
      CENY = (NROW+1)/2
      CENX = (NCOL+1)/2
      Radius = real(CENX*CENX)
C     
c     print *, MATRIX(1,1),MATRIX(1,2),MATRIX(1,3),MATRIX(1,4)
c     print *, MATRIX(2,1),MATRIX(2,2),MATRIX(2,3),MATRIX(2,4)
c     print *, MATRIX(3,1),MATRIX(3,2),MATRIX(3,3),MATRIX(3,4)
      
      DO ISEC = 1,NSEC
         TMPZ = real(ISEC-CENZ)
         DO IROW = 1,NROW
            TMPY = real(IROW-CENY)
            DO ICOL = 1,NCOL
               TMPX = real(ICOL-CENX)
               TMPR = TMPX*TMPX+TMPY*TMPY+TMPZ*TMPZ
               IF (TMPR.LE.RADIUS) then
                  X = MATRIX(1,1)*TMPX+MATRIX(1,2)*TMPY+MATRIX(1,3)*
     $                 TMPZ+MATRIX(1,4)/pixsize
                  Y = MATRIX(2,1)*TMPX+MATRIX(2,2)*TMPY+MATRIX(2,3)*
     $                 TMPZ+MATRIX(2,4)/pixsize
                  Z = MATRIX(3,1)*TMPX+MATRIX(3,2)*TMPY+MATRIX(3,3)*
     $                 TMPZ+MATRIX(3,4)/pixsize
                  X = X + real(CENX)
                  Y = Y + real(CENY)
                  Z = Z + real(CENZ)
                  CALL INTERP3D_X (VALUE, X, Y, Z, MAP_IN, 
     $                 NCOL, NROW, NSEC)
               ELSE
                  VALUE = 0.0
               ENDIF
               MAP_OUT(ICOL,IROW,ISEC) = VALUE
            ENDDO
         ENDDO
      ENDDO
C     
      RETURN
      END

C  ****************************************************************************
C  *                                                                          *
C  *                  *****     SUBROUTINE INTERP3D_X   *****                 *
C  *                                                                          *
C  *    PERFORM 3D INTERPOLATION IN THE MAP.  ALSO ZERO'S VALUES IF THEY FALL *
C  *     OFF THE EDGE.                                                        *
C  *                                                                          *
C  *    ADAPTED FROM S. FULLER'S 20-MAR-1988 INTERP3D SUBROUTINE.             *
C  *                                                                          *
C  *    SEPTEMBER 1989  PURDUE UNIVERSITY VAX 8550, T. BAKER                  *
C  *    NOV.06 2003  X. ZHANG                                                 *
C  ****************************************************************************
C
      SUBROUTINE INTERP3D_X (VALUE, X, Y, Z, MAP_IN, NCOL, NROW, NSEC)
C     
      IMPLICIT NONE
C     
      INTEGER*4 NCOL, NROW, NSEC, IX, IX1, IY, IY1, IZ, IZ1
      REAL*4    MAP_IN(NCOL,NROW,NSEC), DX, DY, DZ
      REAL*4    VALUE, X, Y, Z, TMPX, TMPY, TMPZ
C     -------------------------------------------------------------------
C     
      VALUE = 0.0
C     
      TMPX   = X
      DX     = TMPX - AINT(TMPX)
      IX     = INT(TMPX)
      IF(IX.LT.1  .OR. IX.GE.NCOL) RETURN
      IX1    = IX + 1
C     
      TMPY   = Y
      DY     = TMPY - AINT(TMPY)
      IY     = INT(TMPY)
      IF(IY.LT.1  .OR. IY.GE.NROW) RETURN          
      IY1    = IY + 1
C     
      TMPZ   = Z
      DZ     = TMPZ - AINT(TMPZ)
      IZ     = INT(TMPZ)
      IF(IZ.LT.1  .OR. IZ.GE.NSEC) RETURN          
      IZ1    = IZ + 1
C     
      VALUE = (1.-DX)*(1.-DY)*(1.-DZ)*MAP_IN(IX ,IY ,IZ )
     1     +    DX *(1.-DY)*(1.-DZ)*MAP_IN(IX1,IY ,IZ )
     2     +(1.-DX)*    DY *(1.-DZ)*MAP_IN(IX ,IY1,IZ )
     3     +    DX *    DY *(1.-DZ)*MAP_IN(IX1,IY1,IZ )
     4     +(1.-DX)*(1.-DY)*    DZ *MAP_IN(IX ,IY ,IZ1)
     5     +    DX *(1.-DY)*    DZ *MAP_IN(IX1,IY ,IZ1)
     6     +(1.-DX)*    DY *    DZ *MAP_IN(IX ,IY1,IZ1)
     7     +    DX *    DY *    DZ *MAP_IN(IX1,IY1,IZ1)
C     
      RETURN
      END
C     
C****************************************************************************
C*                                                                          *
C*                  *****     SUBROUTINE AVG3F_MAP   *****                  *
C*                                                                          *
C*    AVERAGE A 3D MAP USING 3-FOLD OPERATION.                              *
C*                                                                          *
C*    NOV.06 2003  X. ZHANG                                                 *
C****************************************************************************
C
      SUBROUTINE AVG3F_MAP(MAP_IN, MAP_OUT, NCOL, NROW, NSEC)
C     
      IMPLICIT NONE
C     
      INTEGER*4 NCOL, NROW, NSEC, CENX, CENY, CENZ
      INTEGER*4 ISEC, IROW, ICOL
      REAL*4    MAP_IN(NCOL,NROW,NSEC), MAP_OUT(NCOL,NROW,NSEC)
      real*4    VALUE, dian, zdegree, newX, newY, newZ, X ,Y, Z
      real*4    X2 ,Y2, Z2
      real*4    degree1, degree2, Radius, TMPR
C     ----------------------------------------------------------------
C     
      dian = 3.1415926535897843383279/180.0
      degree1 = 120.0
      degree2 = -120.0
C     
      zdegree = 90.0-69.0948425521107
C     
      CENZ = (NSEC+1)/2
      CENY = (NROW+1)/2
      CENX = (NCOL+1)/2
      Radius = real(CENX*CENX)
C     
      DO ISEC = 1,NSEC
         DO IROW = 1,NROW
            DO ICOL = 1,NCOL
               MAP_OUT(ICOL,IROW,ISEC) = MAP_IN(ICOL,IROW,ISEC)
            ENDDO
         ENDDO
      ENDDO
C     
      DO ISEC = 1, NSEC
         Z = real(ISEC-CENZ)
         DO IROW = 1, NROW
            Y = real(IROW-CENY)
            DO ICOL = 1, NCOL
               X = real(ICOL-CENX)
               TMPR = X*X+Y*Y+Z*Z
               IF (TMPR.LT.RADIUS) then
                  newY = y*cos(zdegree*dian) - z*sin(zdegree*dian)
                  newZ = y*sin(zdegree*dian) + z*cos(zdegree*dian)
                  newX = x
                  
C     rotate the desired degree along the Z-axis/2f axis*/
                  x2 = newX*cos(degree1*dian) - newY*sin(degree1*dian)
                  y2 = newX*sin(degree1*dian) + newY*cos(degree1*dian)
                  z2 = newZ
                  
C     rotate the Z-axis back to the 3-fold axis */
                  newY = y2*cos(-1.0*zdegree*dian) - 
     $                 z2*sin(-1.0*zdegree*dian)
                  newZ = y2*sin(-1.0*zdegree*dian) + 
     $                 z2*cos(-1.0*zdegree*dian)
                  newX = x2
c
                  x2 = newX + real(CENX)
                  y2 = newY + real(CENY)
                  z2 = newZ + real(CENZ)
                  
                  CALL INTERP3D_X (VALUE, X2, Y2, Z2, MAP_IN, 
     $                 NCOL, NROW, NSEC)
               ELSE
                  VALUE = 0.0
               ENDIF
               MAP_OUT(ICOL,IROW,ISEC) = VALUE
            ENDDO
         ENDDO
      ENDDO
C     
      DO ISEC = 1, NSEC
         Z = real(ISEC-CENZ)
         DO IROW = 1, NROW
            Y = real(IROW-CENY)
            DO ICOL = 1, NCOL
               X = real(ICOL-CENX)
               TMPR = X*X+Y*Y+Z*Z
               IF (TMPR.LT.RADIUS) then
                  newY = y*cos(zdegree*dian) - z*sin(zdegree*dian)
                  newZ = y*sin(zdegree*dian) + z*cos(zdegree*dian)
                  newX = x
                  
C     rotate the desired degree along the Z-axis/2f axis*/
                  x2 = newX*cos(degree2*dian) - newY*sin(degree2*dian)
                  y2 = newX*sin(degree2*dian) + newY*cos(degree2*dian)
                  z2 = newZ

C     rotate the Z-axis back to the 3-fold axis */
                  newY = y2*cos(-1.0*zdegree*dian) - 
     $                 z2*sin(-1.0*zdegree*dian)
                  newZ = y2*sin(-1.0*zdegree*dian) + 
     $                 z2*cos(-1.0*zdegree*dian)
                  newX = x2
c
                  x2 = newX + real(CENX)
                  y2 = newY + real(CENY)
                  z2 = newZ + real(CENZ)
                  
                  CALL INTERP3D_X (VALUE, X2, Y2, Z2, MAP_IN, 
     $                 NCOL, NROW, NSEC)
               ELSE
                  VALUE = 0.0
               ENDIF
               MAP_OUT(ICOL,IROW,ISEC) = MAP_OUT(ICOL,IROW,ISEC) + VALUE
               MAP_OUT(ICOL,IROW,ISEC) = MAP_OUT(ICOL,IROW,ISEC)/3.0
            ENDDO
         ENDDO
      ENDDO
C
      RETURN
      END
