#include <stdlib.h>
#include <stdio.h>
#include "../include/common.h"
#include "../include/libPIF.h"

int main(int argc, char **argv) {
  int       i, j, k, m, binCol, binRow, binSec, luNum;
  int       negPosSwitch, zero=0;
  float     *float_buffer;
  forPifHead_t  thisHead;

  banner("ZERODENS");

  if(argc < 4) {
    printf("\nUSAGE: zerodens inFiles outFile negPosSwitch(1/0)\n\n");
    printf("negPosSwitch == 0 then remove positive densities\n");
    printf("negPosSwitch == 1 then remove negative densities\n\n\n");
    exit(0);
  }

  negPosSwitch = (int)strtod(argv[3],0);
  if(negPosSwitch != 0 && negPosSwitch != 1) {
    printf("Bad switch [%d]\n", negPosSwitch);
    exit(0);
  }

  luNum = thisHead.luNum = 4;
  pif_open(argv[1], &luNum, "r");
      
  pif_read_gh(&thisHead);
  thisHead.imgNum = 1;
  pif_read_dh(&thisHead);

  if(thisHead.binFactor == 2) {
    binSec  = thisHead.numSecs/2+1;  
    binRow  = thisHead.numRows/2+1;
    binCol  = thisHead.numCols/2+1;
    if(binSec%2 == 0)
      binSec--;
    if(binRow%2 == 0)
      binRow--;
    if(binCol%2 == 0)
      binCol--;
  }
  else {
    binCol = thisHead.numCols;
    binRow = thisHead.numRows;
    binSec = thisHead.numSecs;
  }
  
  float_buffer = (float *)malloc(sizeof(float)*binCol*binRow*binSec);

  if(thisHead.mode != 20) {
      printf("zerodens for mode==20 files only.\n");
      exit(0);
  }
      
  thisHead.imgNum = 1;
  pif_read_dh(&thisHead);
  pif_read_wmapi2(&thisHead, float_buffer, &binCol, &binRow, &binSec);

  pif_close(&luNum);

  // Zero out either positive or negative densities
  m = 0;
  for(i=0; i<binSec; i++) {
    for(j=0; j<binRow; j++) {
      for(k=0; k<binCol; k++) {
	if(negPosSwitch==0 && float_buffer[m] > 0.0)
	  float_buffer[m] = 0.0;
	else if(negPosSwitch==1 && float_buffer[m] < 0.0)
	  float_buffer[m] = 0.0;
	m++;
      }
    }
  }
  
  // Write outfile
  luNum = thisHead.luNum = 7;
  pif_open(argv[2], &luNum, "w");

  calcMapStats(float_buffer,
	       &thisHead.img_bkg, 
	       &thisHead.datar4_min,
	       &thisHead.datar4_max, 
	       &thisHead.datar4_avg, 
	       &thisHead.datar4_std,
	       &binCol, &binRow, &binSec);
  thisHead.datai4_min = thisHead.datar4_min;
  thisHead.datai4_max = thisHead.datar4_max;

  pif_write_gh(&thisHead);
  thisHead.imgNum = 1;
  pif_write_dh(&thisHead);
  pif_write_map_sections(&thisHead, float_buffer, &(thisHead.mode),
			 &binCol, &binRow, &binSec,
			 &zero, &binSec);
  pif_close(&luNum);
  return 0;
}
