#!/usr/bin/perl
use strict;
use warnings;

my ($infile, $outfile) = @ARGV;
unless(scalar(@ARGV) == 2) {
    print "\n";
    print "    Usage:   bcrd2box infile outfile\n";
    print "    infile:  pif format bcrd file\n\n";
    print "    outfile: eman format box file\n";
    exit(0);
}

open(IN, "$infile");
open(OUT, ">$outfile");

my @x = ();
my @y = ();
my ($boxdim_x, $boxdim_y, $boxrad_x, $boxrad_y);

while (<IN>) {
    if($. <= 3) {
	next;
    }
    if($. == 4) {
	s/\s+//g;
	$boxrad_x = $_;
	$boxdim_x = 2*$boxrad_x;
	next;
    }
    if($. == 5) {
	s/\s+//g;
	$boxrad_y = $_;
	$boxdim_y = 2*$boxrad_y;
	next;
    }

    my($x, $y) = split;
    $x -= $boxrad_x;
    $y -= $boxrad_y;
    
    print OUT "$x\t$y\t$boxdim_x\t$boxdim_y\t-3\n";
}

close(IN);
close(OUT);
