#!/usr/bin/perl
use strict;
use warnings;

my ($infile, $outfile) = @ARGV;
unless(scalar(@ARGV) == 2) {
    print "\n";
    print "    Usage:   box2bcrd infile outfile\n";
    print "    infile:  eman format box file\n";
    print "    outfile: pif format bcrd file\n\n";
    exit(0);
}

open(IN, "$infile");
open(OUT, ">$outfile");

my @x = ();
my @y = ();
my ($boxrad_x, $boxrad_y);

while (<IN>) {
    my ($x, $y, $xbox, $ybox) = split;
    $boxrad_x = int($xbox/2);
    $boxrad_y = int($xbox/2);
    $x = int($x + $boxrad_x);
    $y = int($y + $boxrad_y);
    push(@x, $x);
    push(@y, $y);    
}

my $count = scalar(@x);

print OUT "BCRD V2.00\n";
print OUT "0\n";
print OUT "$count\n";
print OUT "$boxrad_x\n";
print OUT "$boxrad_x\n";

for (my $i=0; $i<$count; $i++) {
    print OUT "$x[$i] $y[$i]\n";
}

close(IN);
close(OUT);
