use strict;
use warnings;
use lib do { __FILE__ =~ m|^(.*?)[^/]*$|; "$1"; };

sub incr_suffix {

    # Purpose: increment suffix in the range 000...998 to the next value
    #
    # Input arguments:
    #   $suffix_ref - reference to suffix variable
    #
    # Return values:
    #   None

    my ($suffix_ref) = @_;
    $$suffix_ref =~ s/^0+//;
    $$suffix_ref++;
    if($$suffix_ref < 10) {
	$$suffix_ref = "00$$suffix_ref";
    } elsif ($$suffix_ref < 100) {
	$$suffix_ref = "0$$suffix_ref";
    }
}

sub incr_ptlefiles {

    # Purpose: increment the suffixes for a set of strings to the next
    # value. For example (dat1_008, dat2_008) --> (dat1_009, dat2_009)
    #
    # Input arguments:
    #   $ptlefiles_ref - reference to array of strings
    #
    # Return values:
    #   None

    my ($ptlefiles_ref) = @_;
    foreach my $ptlefile (@{$ptlefiles_ref}) {
	$ptlefile =~ /(.*)_(.*)/;
	my ($prefix, $suffix) = ($1, $2);
	incr_suffix(\$suffix);
	$ptlefile = "${prefix}_${suffix}";
    }
}
1;
