use strict;
use warnings;
use lib do { __FILE__ =~ m|^(.*?)[^/]*$|; "$1"; };

sub validate_commandline_args {

    # Purpose: validate command line arguments
    #
    # Input parameters:
    #   $ncpu       - number of CPUs
    #   $param_file - auto3dem parameter file
    #   $mode       = mode of operation (parallel or serial)
    # Return values:
    #   None

    my ($ncpu, $param_file, $mode) = @_;

    if($mode eq 'parallel' && !defined $ncpu) {
	print "Need to specify number of nodes\n";
	exit;
    }
    unless($ncpu =~ /^\d+$/) {
	print "$ncpu is not a valid choice for number of nodes\n";
	exit;
    }
    unless(defined $param_file) {
	print "Need to specify parameter file\n";
	exit;
    }
    unless( -r $param_file) {
	print "Parameter file $param_file is not readable\n";
	exit;
    }

}
1;
