#!/usr/bin/perl
use strict;
use warnings;

unless (@ARGV == 2) {
    print "Generate a new PDB file that contain only C-alpha atoms\n\n";
    print "Usage: pdbcalpha.pl old.pdb new.pdb\n\n";
    print "old.pdb    : original PDB file\n";
    print "new.pdb    : transformed PDB file C-alpha atoms only\n";
    print "\n";
    exit(0);
}

unless(-r $ARGV[0]) {
    print "Unable to open input file $ARGV[0]\n";
    exit(0);
}

open(OLD, "$ARGV[0]");
open(NEW, ">$ARGV[1]");

while(<OLD>) {
    if(/^ATOM/i) {
	if(substr($_, 13, 2) =~ /CA/i) {
	    print NEW;
	}
    } else {
	print NEW;
    }
}

close(OLD);
close(NEW);
