#!/usr/bin/perl
use strict;
use warnings;

unless (@ARGV == 3) {
    print "Scale the coordinates in a PDB file\n";
    print "Usage: pdbscale.pl orig.pdb scaled.pdb scale\n";
    print "\n";
    print "orig.pdb    : Original PDB file\n";
    print "scaled.pdb  : Scaled PDB file\n";
    print "scale       : scale factor\n";
    print "\n";
    exit(0);
}

unless(-r $ARGV[0]) {
    print "Unable to open input file $ARGV[0]\n";
    exit(0);
}

open(OLD, "$ARGV[0]");
open(NEW, ">$ARGV[1]");
my $scale = $ARGV[2];

while(<OLD>) {
    unless(/^\s*ATOM/i) {
	print NEW;
	next;
    }
    
    my $line = $_;

    my $x = substr($line, 30, 8);
    my $y = substr($line, 38, 8);
    my $z = substr($line, 46, 8);
    
    $x = sprintf "%8.3f", $x*$scale;
    $y = sprintf "%8.3f", $y*$scale;
    $z = sprintf "%8.3f", $z*$scale;

    substr($line, 30, 8) = $x;
    substr($line, 38, 8) = $y;
    substr($line, 46, 8) = $z;

    print NEW $line;

}

close(OLD);
close(NEW);
