#include "DM3convert.h"


int DM3Micrograph_export ( DM3Micrograph *dm3mg, Micrograph *mg ) {

    int ret = 0;
   
    if (dm3mg == NULL || mg == NULL) {
        fprintf(stderr,"Error(DM3Micrograph_export): data not abvailable for conversion!\n");
        return(1);
    }
   
    mg->header->nx = dm3mg->header->nx;
    mg->header->ny = dm3mg->header->ny;
    mg->header->dx = dm3mg->header->dx;
    mg->header->dy = dm3mg->header->dy;
    mg->header->data_type = dm3type2type(dm3mg->header->data_type);
    
    mg->data = dm3mg->data;

    return(ret);

}

int   dm3type2type( int dt) {
    int t = -1;

    switch ( dt ) {
        case 2: t = SHORT; break;  // SHORT
        case 3: t = INT; break;  // LONG
        case 4: t = USHORT; break;  // USHORT
        case 5: t = UINT; break;  // ULONG
        case 6: t = FLOAT; break;  // FLOAT
        case 7: t = DOUBLE; break;  // DOUBLE
        default:
            fprintf(stderr, "Error(dm3type2type): Can not interpret data type %d!\n", dt);
    }
	
    return(t);
}
