#ifndef __image_types_h__
#define __image_types_h__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "imageio.h"
#include "data_types.h"

typedef struct {

    int nx;                  // number of pixels along x
    int ny;                  // number of pixels along y
    float dx;                // sampling along x
    float dy;                // sampling along y
    int data_type;
    
} Micrograph_header;

typedef struct {

//    FILE * file_id;
    char filename[1024];
    char input_format[4];
    char output_format[4];
    
    Micrograph_header * header;
    char * data;

} Micrograph;

Micrograph * Micrograph_new();
void Micrograph_delete( Micrograph *mg);

int Micrograph_read ( Micrograph *mg, int bin );
int Micrograph_write( Micrograph *mg, char *fname );

Micrograph_header * Micrograph_header_new();
void Micrograph_header_delete( Micrograph_header *mgh);
int Micrograph_bin( Micrograph *mg, int bin );

//int Micrograph_open( Micrograph *mg );
//int Micrograph_close( Micrograph *mg );
//int Micrograph_read_header( Micrograph *mg );
//int Micrograph_write_header( Micrograph *mg, char *fname );
//int Micrograph_read_data( Micrograph *mg, int bin );
//int Micrograph_write_data( Micrograph *mg, char *fname );

#endif
