/******************************************************************************
** array.h
** =======

Array Utility Routines
James Conway, LMES/IBS, Grenoble, France (email: James.Conway@ibs.fr)

06-Mar-2000: Add CopyArrayByteToFloat, CopyArrayFloatToByte
             Rename old CopyArrayFloatToByte to CopyArrayFloatToUByte
             Add GetStatsByteArray, rename old GetStatsByteArray to GetStatsUByteArray
07-Mar-2000: Add GetStatsWordArray and GetStatsUWordArray
09-Mar-2000: Add GetStatsFloatArray3, change "char" to "signed char"

******************************************************************************/

#ifndef __array_h__
#define __array_h__

void   CopyArrayByteToFloat  (   signed char *src, float *dst, long size );
void   CopyArrayUByteToFloat ( unsigned char *src, float *dst, long size );
void   CopyArrayFloatToUByte ( float *src, unsigned char *dst, long size );
void   CopyArrayFloatToByte  ( float *src,   signed char *dst, long size );
void   CopyArrayShortToFloat ( short *src, float *dst, long size );
void   CopyArrayFloatToShort ( float *src, short *dst, long size );
void   CopyArrayFloatToFloat ( float *src, float *dst, long size );

void   GetStatsByteArray     (   signed char *array, long size,   signed char *min,   signed char *max, float *mean, float *stdv );
void   GetStatsUByteArray    ( unsigned char *array, long size, unsigned char *min, unsigned char *max, float *mean, float *stdv );
void   GetStatsWordArray     (          short *array, long size,          short *min,          short *max, float *mean, float *stdv );
void   GetStatsUWordArray    ( unsigned short *array, long size, unsigned short *min, unsigned short *max, float *mean, float *stdv );
void   GetStatsFloatArray    ( float *array, long size, float *min, float *max, float *mean, float *stdv );
void   GetStatsFloatArray2   ( float *array, long dx, long dy, float radius, float *min, float *max, float *mean, float *stdv );
void   GetStatsFloatArray3   ( float *array, long dx, long dy, float radius, float *min, float *max, float *mean, float *stdv );

#endif

/*****************************************************************************/
