/******************************************************************************
** X3D_types.h
** ===========

Part of X3DPreprocess. Include file for general type definitions.
See info in X3DPreprocess.doc.

Author
======
James F. Conway
Laboratory of Structural Biology Research, NIAMS
Bldg 6, Room B2-34
National Institutes of Health
Bethesda, Maryland 20892-2717
USA.
Ph: (301) 402-2361
Fax:(301) 480-7629
Email: james_conway@nih.gov

******************************************************************************/

#ifndef __X3D_TYPES__
#define __X3D_TYPES__

// Common Macro definitions
// ========================

#ifdef MAX
#undef MAX
#endif
#define MAX(m,n) (((m)>(n)) ? (m):(n))
#ifdef MIN
#undef MIN
#endif
#define MIN(m,n) (((m)<(n)) ? (m):(n))

#ifdef ROUND
#undef ROUND
#endif
#define ROUND(a) ( ( (a)<0 ) ? (int) ((a) - 0.5) : (int) ( (a)+0.5 ) )

#ifndef FALSE
#define FALSE (0)
#endif
#ifndef TRUE
#define TRUE (!FALSE)
#endif

#ifndef false
#define false (FALSE)
#endif
#ifndef true
#define true (TRUE)
#endif

#define OK     (0)
#define ERROR (!OK)

// Common Typedef definitions
// ==========================

typedef unsigned char  UBYTE;
typedef unsigned short UWORD;
typedef unsigned long  ULONG;

#ifndef bool
typedef int bool;
#endif

#endif

/*****************************************************************************/
