/****************************************************************************
** PIF_errors.c
** ============

James Conway, LMES/IBS, Grenoble, France (email: James.Conway@ibs.fr)

This version: 03-Mar-2000 (v1.4.7)
Modified from source code provided by Rob Ashmore, Purdue University, Indiana.

The routines defined here are system specific error and notification reporting.
PIF_DoError() and PIF_DoNotification()

****************************************************************************/

#include "pif_errors.h"

#if defined(macintosh)          // if we want to test for Mac
#define MACINTOSH_TOOLBOX       // no printf
#endif

#ifdef MACINTOSH_TOOLBOX
#include <stdlib.h>
#include <string.h>
#include <Dialogs.h>
#define ALERT_RES_ID  400

#else
// no MACINTOSH_TOOLBOX

#include <stdio.h>

#endif
// MACINTOSH_TOOLBOX

/****************************************************************************
** PIF_DoError
** ===========
*/
void PIF_DoError(char *msg)
{
#ifdef MACINTOSH_TOOLBOX
  int len;
  unsigned char *p;

  len = strlen(msg);
  if(len>255)
    len = 255;
  if((p = (unsigned char *) malloc(len+1)) == NULL)
    return;
  p[0] = len;
  strncpy((char *) &p[1], msg, len);
  ParamText(p, "\p", "\p", "\p");
  NoteAlert(ALERT_RES_ID, 0L);
  free(p);
#else
  fprintf(stderr, "%s\n", msg);
  fflush(stderr);
#endif
}
/****************************************************************************
** PIF_DoNotify
** ============
*/
void PIF_DoNotify(char *msg)
{
#ifdef MACINTOSH_TOOLBOX
#pragma unused(msg)
// Do nothing
#else
  printf("%s", msg);
  fflush(stdout);
#endif
}
/***************************************************************************/
