#include "../include/common.h"
#include "fixpif.h"

void create_windows() {

  // function name: create_windows
  // Create and initialize attributes of main screen and info box
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Fixpif"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 20);
  XtSetArg(arglst[5], XmNy, 20);
  XtSetArg(arglst[6], XmNwidth, 1000);
  XtSetArg(arglst[7], XmNheight, 900);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_ANY);
  XtSetArg(arglst[9], XmNresizable, 1);
  mainWindowW = XmCreateFormDialog(topLevelW, "main", arglst, 10);

  // Forms containing header label and text box widgets

  XtSetArg(arglst[0], XmNy, 100);
  XtSetArg(arglst[1], XmNwidth, 1000);
  XtSetArg(arglst[2], XmNheight, 800);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[6], XmNresizable, 0);
  imageFormW = XmCreateForm(mainWindowW, "imghead", arglst, 7);
  XtManageChild(imageFormW);

  XtSetArg(arglst[0], XmNy, 100);
  XtSetArg(arglst[1], XmNwidth, 1000);
  XtSetArg(arglst[2], XmNheight, 700);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[6], XmNresizable, 0);
  globalFormW = XmCreateForm(mainWindowW, "glbhead", arglst, 7);
  XtManageChild(globalFormW);

  // Header number widgets

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Header Number"));
  XtSetArg(arglst[1], XmNy, 5);
  XtSetArg(arglst[2], XmNy, 50);
  headNumLabW = XmCreateLabel(mainWindowW, "headl", arglst, 3);
  XtManageChild(headNumLabW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 50);
  headNumTextW = XmCreateText(mainWindowW, "headt", arglst, 3);
  XtManageChild(headNumTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, headNumTextW);
  XtSetArg(arglst[4], XmNy, 48);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[6], XmNresizable, 0);
  headNumUpW = XmCreateArrowButton(mainWindowW, "headup", arglst, 7);
  XtAddCallback(headNumUpW, XmNactivateCallback, 
		headNumArrow_activate, NULL);
  XtManageChild(headNumUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, headNumTextW);
  XtSetArg(arglst[4], XmNy, 66);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[6], XmNresizable, 0);
  headNumDownW = XmCreateArrowButton(mainWindowW, "headdn", arglst, 7);
  XtAddCallback(headNumDownW, XmNactivateCallback, 
		headNumArrow_activate, NULL);
  XtManageChild(headNumDownW);

  // Push buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write Header"));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 50);
  writeOneW = XmCreatePushButton(mainWindowW, "write_one", arglst, 3);
  XtAddCallback(writeOneW, XmNactivateCallback, write_activate, NULL);
  XtManageChild(writeOneW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write All Headers"));
  XtSetArg(arglst[1], XmNx, 370);
  XtSetArg(arglst[2], XmNy, 50);
  writeAllW = XmCreatePushButton(mainWindowW, "write_all", arglst, 3);
  XtAddCallback(writeAllW, XmNactivateCallback, write_all_activate, NULL);
  XtManageChild(writeAllW);

  // Menu widgets

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  menuBarW = XmCreateMenuBar(mainWindowW, "mb", arglst, 4);
  XtManageChild(menuBarW);

  menuW = XmCreatePulldownMenu(menuBarW, "m", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("File"));
  XtSetArg(arglst[1], XmNsubMenuId, menuW);
  menuEntryW = XmCreateCascadeButton(menuBarW, "me", arglst, 2);
  XtManageChild(menuEntryW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Read"));
  menuReadBW = XmCreatePushButton(menuW, "m_rb", arglst, 1);
  XtAddCallback(menuReadBW, XmNactivateCallback, read_activate, NULL);
  XtManageChild(menuReadBW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Exit"));
  menuExitBW = XmCreatePushButton(menuW, "m_eb", arglst, 1);
  XtAddCallback(menuExitBW, XmNactivateCallback, exit_activate, NULL);
  XtManageChild(menuExitBW);

  // Info message box

  XtSetArg(arglst[0], XmNmessageString, 
	   XmStringCreateLocalized("Give me some guidance"));
  XtSetArg(arglst[1], XmNdialogTitle, XmStringCreateLocalized("Info"));
  XtSetArg(arglst[2], XmNx, 150);
  XtSetArg(arglst[3], XmNy, 150);
  infoBoxW = XmCreateInformationDialog(topLevelW, "ib", arglst, 4);
  XtAddCallback(infoBoxW, XmNcancelCallback, infoCancel, NULL);
  XtAddCallback(infoBoxW, XmNokCallback, infoOK, NULL);

} // end function create_windows
