#include <unistd.h>
#include <sys/types.h>

#define EM_VERSION "v4.03"

#define FALSE 0
#define TRUE 1
#define DEFAULT 2

#define BELL '\007'
#define MAXINT 2147483647  
#define MAXSHORT 32767

#define EQU(x,y) (((x)!=NULL &&(y)!=NULL &&(strcmp((x),(y))==0)))
#define MAX(x,y)  (((x)>(y)) ? (x) : (y))  
#define MIN(x,y)  (((x)<(y)) ? (x) : (y)) 
#define CK(x) checkMemory(x, __LINE__, __FILE__)

typedef unsigned char BYTE;     

typedef struct __cue_t__ {
  float *depth;
  float *radial;
  float *shad;
} cue_t;

typedef struct __fortran_Strings__ {
  short  length;
  BYTE   type;
  BYTE   class;
  char   *addr;
} fString_t;

/* Struct for Purdue INT*2 file header */
typedef struct _pifHead_t {
  short numCols,numRows;
  float img_bkg;
  int   nimg,nrec_last;
  int   bimg_sizes;
  float img_min,img_max;
  float img_avg,img_std;
  int   file_id1, file_id2;
} pifHead_t;

typedef struct _forPifHead_t {
  off_t    imgOffset;
  int      luNum;
  int      nimg;
  int      imgNum;
  float    floatScaleFactor;
  float    recipFloatScaleFactor;
  float    int4scaleF;
  int      htype;
  int      numCols;
  int      numRows;
  int      numSecs;
  int      mode;
  int      endianNess;
  char     versionStr[80];
  float    img_bkg;
  int      datai4_min;
  int      datai4_max;
  float    datar4_min;
  float    datar4_max;
  float    datar4_avg;
  float    datar4_std;
  char     descriptionStr[80];
  char     timeStr[80];
  char     micrographStr[80];
  char     scanNumberStr[80];
  float    aoverb;
  float    map_abang;
  float    a_cell;
  float    b_cell;
  float    c_cell;
  float    alp;
  float    bet;
  float    gam;
  float    dela;
  float    delb;
  float    delc;
  float    a_star;
  float    b_star;
  float    c_star;
  float    alp_star;
  float    bet_star;
  float    gam_star;
  float    pixelSize;
  int      t_matrix[6];
  int      packRadius;
  int      binFactor;
  float    dthe;
  float    dphi_90;
  int      symmetry;
  int      pixSizUnits; 
  float    res_out;
  int      ctfMode; 
  float    tempFactor;
  float    wiener;
  int      borderType;
  int      borderWidth;
  int      rad_lo;
  int      rad_hi;    
  float    pifVersion;
  int      even;    
  int      mrcX;    
  int      mrcY;    
  int      mrcZ;    
  int      transX;
  int      transY;
  int      transZ;
  int      isTrunc;
  int      origX;
  int      origY;
  int      origZ;
  float    a0;
  float    a1;
  float    a2;
  float    a3;
  float    a4;
  float    a5;
} forPifHead_t;

/* Struct for Structure Factors */
typedef struct _strucFact_t {
  short h,k,l;
  float a_amp,b_phi,sig,dstr;
} strucFact_t;
