/* libPIF.h header file
   Generated from libPIF.c 7/11/2007 */

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>

#include "../include/libUtil.h"

static float binVals2D[9] = {0.0625,0.125,0.0625,0.125,0.25,
			     0.125,0.0625,0.125,0.0625};
static float binVals3D[27] = {0.015625, 0.03125,  0.015625, 
			      0.03125,  0.0625,   0.03125,
			      0.015625, 0.03125,  0.015625, 
			      0.03125,  0.0625,   0.03125,
			      0.0625,   0.125,    0.0625,   
			      0.03125,  0.0625,   0.03125,
			      0.015625, 0.03125,  0.015625, 
			      0.03125,  0.0625,   0.03125,
			      0.015625, 0.03125,  0.015625 };

void pif_tsbworld(int setValue);
void pif_tsbworld_(int setValue);

void calcMapStats(float *inbuffer, float *img_bkg, float *map_min,
	  float *map_max, float *img_avg, float *img_std,
	  int *width, int *height, int *nSecs);
void calcmapstats(float *inbuffer, float *img_bkg, float *map_min,
		  float *map_max, float *img_avg, float *img_std,
		  int *width, int *height, int *nSecs);
void calcmapstats_(float *inbuffer, float *img_bkg, float *map_min,
		   float *map_max, float *img_avg, float *img_std,
		   int *width, int *height, int *nSecs);
void calcMapStats_(float *inbuffer, float *img_bkg, float *map_min,
		  float *map_max, float *img_avg, float *img_std,
		  int *width, int *height, int *nSecs);

void pif_set_i2map(int *value);
void pif_set_i2map_(int *value);

void determine_scaling(forPifHead_t *thisHead, float *inbuffer,
			int *ncol, int *nrow, int *nsec);
void determine_scaling_(forPifHead_t *thisHead, float *inbuffer,
		       int *ncol, int *nrow, int *nsec);

void increment_fname_unix(char *inFname, char *outFname);
void increment_fname_unix_(char *inFname, char *outFname);

void increment_fname(fString_t *inFname, fString_t *outFname);
void increment_fname_(fString_t *inFname, fString_t *outFname);

static int Util_IAmBigEndian(void);
static int Util_IAmBigEndian_(void);

void differentEndian(BYTE *inStr, int length, int endianNess );
void differentEndian_(BYTE *inStr, int length, int endianNess );

void convertBackFloat(int thisInt, float *thisFloat, 
		      float recipFloatScaleFactor);
void convertBackFloat_(int thisInt, float *thisFloat, 
		      float recipFloatScaleFactor);

void convertFloat(int *thisInt, float thisFloat, float floatScaleFactor);
void convertFloat_(int *thisInt, float thisFloat, float floatScaleFactor);

void pif_close(int *luNum);
void pif_close_(int *luNum);

void pif_open(char *fName, int *luNum, char *readWrite);
void pif_open_(char *fName, int *luNum, char *readWrite);

int pif_read_gh(forPifHead_t *thisHead);
int pif_read_gh_(forPifHead_t *thisHead);

int pif_read_dh(forPifHead_t *thisHead);
int pif_read_dh_(forPifHead_t *thisHead);

void pif_read_byte_image(int *luNum, BYTE *byte_buffer, off_t *imgOffset,
			 int *numCols, int *numRows, int *numSecs);
void pif_read_byte_image_(int *luNum, BYTE *byte_buffer, off_t *imgOffset,
			 int *numCols, int *numRows, int *numSecs);

int pif_read_float_image(int *luNum, float *in_float_buffer, off_t *imgOffset,
			  int *numCols, int *numRows, int *numSecs,
			  int *binSwitch, float *recipScaleF);
int pif_read_float_image_(int *luNum, float *float_buffer, off_t *imgOffset,
			 int *numCols, int *numRows, int *numSecs,
			 int *binSwitch, float *recipScaleF);

void pif_read_short_image(int *luNum, short *short_buffer,
			   off_t *imgOffset,
			   int *numCols, int *numRows, int *numSecs);
void pif_read_short_image_(int *luNum, short *short_buffer,
			  off_t *imgOffset,
			  int *numCols, int *numRows, int *numSecs);

void pif_read_wmapi2(forPifHead_t *thisHead, float *float_buffer,
		      int *ncol, int *nrow, int *nsec);
void pif_read_wmapi2_(forPifHead_t *thisHead, float *float_buffer,
		     int *ncol, int *nrow, int *nsec);

void pif_read_mapi2(forPifHead_t *thisHead, float *float_buffer,
		     int *sec1, int *sec2, int *ncol, int *nrow, int *nsec);
void pif_read_mapi2_(forPifHead_t *thisHead, float *float_buffer,
		    int *sec1, int *sec2,
		    int *ncol, int *nrow, int *nsec);

void pif_read_mapi4(forPifHead_t *thisHead,
		     float *float_buffer,
		     int *sec1, int *sec2,
		     int *ncol, int *nrow, int *nsec);
void pif_read_mapi4_(forPifHead_t *thisHead, float *float_buffer,
                     int *sec1, int *sec2,
                     int *ncol, int *nrow, int *nsec);

void pif_read_map_short_image(int *luNum,
			       float *float_buffer,
			       off_t *imgOffset,
			       int *numCols, int *numRows, int *numSecs,
			       float *recipFloatScaleFactor,
			       float *minMapPixel, float *maxMapPixel,
			       int *binSwitch,
			       int *strtCol, int *strtRow, int *strtSec,
			       int *ncol, int *nrow, int *nsec);
void pif_read_map_short_image_(int *luNum,
			      float *float_buffer,
			      off_t *imgOffset,
			      int *numCols, int *numRows, int *numSecs,
			      float *recipFloatScaleFactor,
			      float *minMapPixel, float *maxMapPixel,
			      int *binSwitch,
			      int *strtCol, int *strtRow, int *strtSec,
			      int *ncol, int *nrow, int *nsec );

void pif_read_imgi4(forPifHead_t *thisHead, float *float_buffer,
		     int *ncol, int *nrow, int *thisImg);
void pif_read_imgi4_(forPifHead_t *thisHead, float *float_buffer,
		    int *ncol, int *nrow, int *thisImg);

void pif_read_map_int_image(int *luNum,
			     float *float_buffer,
			     off_t *imgOffset,
			     int *numCols, int *numRows, int *numSecs,
			     float *recipFloatScaleFactor,
			     float *minMapPixel, float *maxMapPixel,
			     int *binSwitch, int *mode);
void pif_read_map_int_image_(int *luNum, float *float_buffer,
			    off_t *imgOffset,
			    int *numCols, int *numRows, int *numSecs,
			    float *recipFloatScaleFactor,
			    float *minMapPixel, float *maxMapPixel,
			    int *binSwitch, int *mode);

void pif_read_sf(forPifHead_t *sfHead, strucFact_t *sfs);
void pif_read_sf_(forPifHead_t *sfHead, strucFact_t *sfs);

void pif_init_head(forPifHead_t *thisHead);
void pif_init_head_(forPifHead_t *thisHead);

void pif_list_head(forPifHead_t *thisHead);
void pif_list_head_(forPifHead_t *thisHead);

int pif_write_gh(forPifHead_t *thisHead);
int pif_write_gh_(forPifHead_t *thisHead);

int pif_write_dh(forPifHead_t *thisHead);
int pif_write_dh_(forPifHead_t *thisHead);

void pif_write_prji1(forPifHead_t *prjHead, float *float_buffer,
		      int *id,
		      int *numCols, int *numRows,
		      float *sFac, float *min);
void pif_write_prji1_(forPifHead_t *prjHead, float *float_buffer,
		     int *id, int *numCols, int *numRows,
		     float *sFac, float *min);

void pif_write_byte_image(int *luNum, BYTE *byte_buffer, off_t *imgOffset,
			   int *numCols, int *numRows, int *numSecs);
void pif_write_byte_image_(int *luNum, BYTE *byte_buffer, off_t *imgOffset,
			  int *numCols, int *numRows, int *numSecs);

void pif_write_byteshort_image(int *luNum, short *short_buffer, off_t *imgOffset,
				int *numCols, int *numRows, int *numSecs);
void pif_write_byteshort_image_(int *luNum, short *short_buffer, 
				off_t *imgOffset, int *numCols, 
				int *numRows, int *numSecs);

void pif_write_short_image(int *luNum,
			    short *short_buffer,
			    off_t *imgOffset,
			    int *numCols, int *numRows, int *numSecs);
void pif_write_short_image_(int *luNum, short *short_buffer,
			   off_t *imgOffset,
			   int *numCols, int *numRows, int *numSecs);

void pif_write_rowi4(forPifHead_t *thisHead, float *float_buffer, 
		      int *nrot, int *nannuli,
		      int *whichAnnulus, int *whichImg);
void pif_write_rowi4_(forPifHead_t *thisHead,  float *float_buffer, 
		     int *nrot,  int *nannuli,
		     int *whichAnnulus, int *whichImg);

void pif_write_map_short_image(int *luNum, short *short_buffer,
				off_t *mapOffset, int *numCols);
void pif_write_map_short_image_(int *luNum, short *short_buffer,
			       off_t *mapOffset, int *numCols);

void pif_write_map_float_image(int *luNum, float *float_buffer,
				off_t *mapOffset,
				int *numCols, int *numRows, int *numSecs,
				float *floatScaleFactor);
void pif_write_map_float_image_(int *luNum, float *float_buffer,
			       off_t *mapOffset,
			       int *numCols, int *numRows, int *numSecs,
			       float *floatScaleFactor);

void pif_write_map_fltint(int *luNum, float *float_buffer, off_t *mapOffset,
			   int *numCols, int *numRows, int *numSecs,
			   float *floatScaleFactor);
void pif_write_map_fltint_(int *luNum, float *float_buffer, off_t *mapOffset,
			   int *numCols, int *numRows, int *numSecs,
			   float *floatScaleFactor);

void pif_write_sf(forPifHead_t *sfHead, strucFact_t *sfs);
void pif_write_sf_(forPifHead_t *sfHead, strucFact_t *sfs);

void pif_read_boxi4(forPifHead_t *boxHead, float *float_buffer);
void pif_read_boxi4_(forPifHead_t *boxHead, float *float_buffer);

void pif_copy_head(forPifHead_t *fromHead,forPifHead_t *toHead);
void pif_copy_head_(forPifHead_t *fromHead,forPifHead_t *toHead);

void chk_file_exists(char *fname);
void chk_file_exists_(char *fname);

void pif_write_map_sections(forPifHead_t *head, float *float_buffer,
			    int *mode, int *ncol, int *nrow, int *nsec,
			    int *secOffset, int *sections);
void pif_write_map_sections_(forPifHead_t *head, float *float_buffer,
			    int *mode, int *ncol, int *nrow, int *nsec,
			     int *secOffset, int *sections);
