      subroutine arrange_3d_1(fft3d, f_tmp, num_nodes, hkl_max, 
     $     first_y, last_y, frst_lst_iq)

C     Rearranges elements of 3D FT into 1D structure in preparation for 
C     parallel computation

      implicit none
 
      integer, intent(in) :: hkl_max, num_nodes, first_y, last_y
      integer, intent(in) :: frst_lst_iq(2, 0:num_nodes-1)
      complex, intent(in) :: fft3d(0:hkl_max, -hkl_max:hkl_max, 
     +     first_y:last_y)

      complex, intent(out) :: f_tmp((hkl_max+1)*(2*hkl_max+1)*
     +     (last_y - first_y + 1))

      integer i, j, k, z, recv
        
      recv = 0
      do i = 0, num_nodes -1 
         do z = first_y, last_y
            do k = -hkl_max, hkl_max
               do j = frst_lst_iq(1,i), frst_lst_iq(2,i)
                  recv = recv + 1
                  f_tmp(recv) = fft3d(j,k,z)
               enddo
            enddo
         enddo
      enddo

      return
      end subroutine arrange_3d_1
