      subroutine Rearrange_fft_Style_(idim1, idim2, array) 
      integer, intent(in) :: idim1, idim2
      real, intent(inout) :: array(idim1, idim2)
      call Rearrange_fft_Style(idim1, idim2, array) 
      end subroutine Rearrange_fft_Style_

      subroutine calc_mod_tps_(mod_ts, mod_ps, the1, the2, phi1, 
     $     del_the, del_phi_90, nview_mod, sym)
      integer*4, intent(in)    :: sym, nview_mod
      real*4, intent(in)       :: the1, the2, phi1
      real*4, intent(in)       :: del_the, del_phi_90      
      real*4, intent(out)      :: mod_ts(nview_mod), mod_ps(nview_mod)
      call calc_mod_tps(mod_ts, mod_ps, the1, the2, phi1, 
     $     del_the, del_phi_90, nview_mod, sym)
      end subroutine calc_mod_tps_

      SUBROUTINE FFT_HIP_(FFT, IDIM1, IDIM2, RES_MIN, CUT_MIN, FFT_FULL)
      INTEGER*4, intent(in) :: IDIM1, IDIM2
      real*4, intent(in)    :: RES_MIN, CUT_MIN
      LOGICAL, intent(in)   :: FFT_FULL
      complex, intent(inout) :: fft(idim1,idim2)
      call FFT_HIP(FFT, IDIM1, IDIM2, RES_MIN, CUT_MIN, FFT_FULL)
      end SUBROUTINE FFT_HIP_

      SUBROUTINE FFT_LOP_(FFT, IDIM1, IDIM2, RES_MAX, CUT_MAX, FFT_FULL)
      INTEGER*4, intent(in) :: IDIM1, IDIM2
      REAL*4, intent(in)    :: RES_MAX, CUT_MAX
      LOGICAL, intent(in)   :: FFT_FULL
      complex, intent(inout) :: fft(idim1,idim2)
      call FFT_LOP(FFT, IDIM1, IDIM2, RES_MAX, CUT_MAX, FFT_FULL)
      end SUBROUTINE FFT_LOP_

      subroutine get_nview_mod_(sym, dthe, dphi_90, nview_mod)
      integer*4, intent(in)  ::  sym
      integer*4, intent(out) ::  nview_mod
      real*4, intent(in)     ::  dthe, dphi_90
      call get_nview_mod(sym, dthe, dphi_90, nview_mod)
      end subroutine get_nview_mod_

      subroutine get_t1t2p1_(sym, the1, the2, phi1)
      integer*4, intent(in) :: sym
      real*4, intent(out)   :: the1, the2, phi1
      call get_t1t2p1(sym, the1, the2, phi1)
      end subroutine get_t1t2p1_

      SUBROUTINE MAP_PRJ_(MAP2D, MAP3D, NCOL, NROW, NSEC, THETA,
     $     PHI, OMEGA, ZLO, ZHI)
      INTEGER*4, INTENT(IN) :: NCOL, NROW, NSEC
      REAL*4, INTENT(IN)    :: THETA, PHI, OMEGA, ZLO, ZHI
      REAL*4, INTENT(IN)    :: MAP3D(NCOL,NROW,NSEC)
      REAL*4, INTENT(OUT)   :: MAP2D(NCOL,NROW)
      call MAP_PRJ(MAP2D, MAP3D, NCOL, NROW, NSEC, THETA,
     $     PHI, OMEGA, ZLO, ZHI)
      end SUBROUTINE MAP_PRJ_
      
      subroutine focus_astig_(focus, focus_maj, focus_min, psi, phi)
      real*4, intent(in)  :: FOCUS_MAJ, FOCUS_MIN, PSI, PHI
      real*4, intent(out) :: focus
      call focus_astig(focus, focus_maj, focus_min, psi, phi)
      end subroutine focus_astig_


      SUBROUTINE CTF_DIVIDE_(CTFMODE, FILTER, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, FILT_FAC, TFAC, FFT_FULL, Cc, BETA, dE,
     $     VOLTS)
      INTEGER*4 CTFMODE, IDIM1, IDIM2, FILTER
      INTEGER*4 UNITS
      REAL*4    FFT(1), PIXSIZE
      REAL*4    FOCUS_MAJ, FOCUS_MIN, ANG_MAJ, TFAC
      REAL*4    PI, RADIAN, WAVELENGTH, AMP_FAC, Cs
      REAL*4    Cc, BETA, dE, VOLTS, FILT_FAC(10)
      LOGICAL   FFT_FULL
      call CTF_DIVIDE(CTFMODE, FILTER, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, FILT_FAC, TFAC, FFT_FULL, Cc, BETA, dE,
     $     VOLTS)
      end subroutine ctf_divide_

      SUBROUTINE CTF_MULTIPLY_(CTFMODE, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, Cc, BETA, dE, VOLTS, TEMPFAC, FFT_FULL)
      INTEGER*4 IDIM1, IDIM2
      INTEGER*4 UNITS, CTFMODE
      REAL*4    FFT(1), PIXSIZE
      REAL*4    FOCUS_MAJ, FOCUS_MIN, ANG_MAJ
      REAL*4    PI, RADIAN, WAVELENGTH, AMP_FAC, Cs
      REAL*4    TEMPFAC, Cc, BETA, dE, VOLTS
      LOGICAL   FFT_FULL
      call CTF_MULTIPLY(CTFMODE, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, Cc, BETA, dE, VOLTS, TEMPFAC, FFT_FULL)
      end subroutine ctf_multiply_

      SUBROUTINE CTF_FIRSTPEAK_PFT_(defocus, wavelength1, fft_rad,
     $     pixel_size,IDIM1, Cs, pi, units, amp_fac)
      integer*4 idim1, units
      real*4  defocus, pi, pixel_size, wavelength1
      real*4  fft_rad, Cs, amp_fac
      call CTF_FIRSTPEAK_PFT(defocus, wavelength1, fft_rad,
     $     pixel_size,IDIM1, Cs, pi, units, amp_fac)
      end subroutine ctf_firstpeak_pft_

      subroutine ctf_func_(ctf, d_star, pi, wavelength, df, amp_fac, 
     $     cs, cc, beta,de, volts)
      real, intent(in) :: d_star, pi, wavelength, df, amp_fac, cs, cc,
     $     beta, de, volts
      real, intent(out) :: ctf
      call ctf_func(ctf, d_star, pi, wavelength, df, amp_fac, 
     $     cs, cc, beta,de, volts)
      end subroutine ctf_func_
