      double precision function elapsed_time(c1, c2)
      implicit none

C     Return the elapsed time bewteen the clock counts c1 and
C     c2. Although c2 corresponds to a later time than c1, we need to
C     explicitly test for the possibility that the system clock had
C     rolled over.

      integer, intent(in) :: c1, c2
      integer ticks, clockrate, clockmax

      call system_clock(count_max=clockmax, count_rate=clockrate)

      ticks = c2-c1
      if(ticks < 0) then
         ticks = clockmax + ticks
      endif
      elapsed_time = dble(ticks)/dble(clockrate)

      return
      end function elapsed_time
      
