      subroutine equivalent_view(theta, phi, omega, rot, 
     1     thetar, phir, omegar)
C
C     Find the (theta, phi, omega) for an equivalent view generated by
C     application of rotation matrix. New formulation which avoids the
C     cummulative errors in the many multiplications of the previous
C     version formulation suggested by Peter Metcalf
C
C     Author: Steve Fuller 10/29/89
C
C     Modified: Robert Sinkovits 6/28/06 - general cleanup and bringing
C     in line with Fortran 90 standard

      implicit none
      
      real*4, intent(in)  :: rot(3,3)             ! Rotation matrix
      real*4, intent(in)  :: theta, phi, omega    ! Original angles
      real*4, intent(out) :: thetar, phir, omegar ! Rotated angles

      real*4 view(3,3) ! Equivalent rotation matrix to crowther angles
      real*4 prot(3,3) ! Product matrix

      call crowther_to_matrix(theta, phi, omega, view)
      prot = matmul(view,rot) ! F90 matmul intrinsic
      call matrix_to_crowther(thetar, phir, omegar, prot)

      return
      end subroutine equivalent_view
