      subroutine fft_setdim_def_same (ncol, nrow, idim1, idim2, nfac)

C     Set up default fourier transform dimensions.
C     
C     The size of the FFT dimensions (idim1 by idim2) will be the
C     smallest power of 2 allowed for the ncol by nrow dimensions,
C     multiplied by nfac, with the additional restriction that idim1 and
C     idim2 are made equal to the larger of the two default values.
C     
C     December 1989  purdue university vax 8550, t. baker
C     Modified 22-aug-2006, R Sinkovits, general cleanup and modernization

      implicit none

      integer*4, intent(in)  :: ncol, nrow, nfac
      integer*4, intent(out) :: idim1, idim2

      integer*4 i
      real*4    test

C     Determine minimum allowed fft size

      test = float(ncol*(2**(nfac-1)))
      i    = 0
      do while (test > 1.0)
        i    = i + 1
        test = test/2.0
      enddo
      idim1 = 2**i

      test = float(nrow*(2**(nfac-1)))
      i    = 0
      do while (test > 1.0)
        i    = i + 1
        test = test/2.0
      enddo
      idim2 = 2**i

      idim1 = max(idim1,idim2)
      idim2 = idim1

      return
      end subroutine fft_setdim_def_same
