      subroutine frame_stats(npix_row, npix_col, pixels, 
     $     fmin, fmax, favg, fstd)

C     Calculate statistics for a pixel frame

      implicit none
      integer, intent(in) :: npix_row, npix_col
      real, intent(in)    :: pixels(npix_row, npix_col)
      real, intent(out)   :: fmin, fmax, favg, fstd

      double precision sum, sum2
      integer count, ix, iy

      favg = 0.0
      fstd = 0.0
      fmin = pixels((npix_row+1)/2,(npix_col+1)/2)
      fmax = pixels((npix_row+1)/2,(npix_col+1)/2)

      sum   = 0.0
      sum2  = 0.0
      count = 0

      do iy = 1,npix_row 
         do ix = 1,npix_col 
            if ((ix-(npix_col+1)/2)**2+(iy-(npix_row+1)/2)**2 
     +           <= npix_col**2) then
               sum  = sum  + pixels(ix,iy)
               sum2 = sum2 + pixels(ix,iy)**2
               if (pixels(ix,iy) > fmax) fmax = pixels(ix,iy)
               if (pixels(ix,iy) < fmin) fmin = pixels(ix,iy)
               count = count + 1
            endif
         enddo
      enddo

      if (count > 0) then
         favg = real(sum/count)
         fstd = real(sqrt(abs(sum2/count - favg*favg)))
      endif
      
      return
      end subroutine frame_stats
