      subroutine map_grid (x, y, nang, xcen, ycen, xgrid, ygrid,
     $     a11, a12, a21, a22)

c     Find locations of grid points in an annulus
c     
c     Input:
c       a11, a12, a21, a22  - rotation matrix elements
c       xcen, ycen          - center of image
c       x, y                - coordinates of first point in annulus
c       nang                - number of steps to take through annulus
c
c     Output:
c       xgrid, ygrid        - coordinates of grid points

      implicit none

      integer*4, intent(in) :: nang
      real*4, intent(in)    :: a11, a12, a21, a22, xcen, ycen, x, y
      real*4, intent(out)   :: xgrid(nang), ygrid(nang)

      integer*4 k

      xgrid(1) = x
      ygrid(1) = y
      do k = 2,nang
         xgrid(k) = a11*(xgrid(k-1)-xcen)+a21*(ygrid(k-1)-ycen)+xcen
         ygrid(k) = a12*(xgrid(k-1)-xcen)+a22*(ygrid(k-1)-ycen)+ycen
      enddo

      return
      end subroutine map_grid
