      subroutine norm(x)
C     
C     Normalizes a three-element vector and returns the normalized value
C
C     Author: Steve Fuller 1/8/88
C
C     Modified: Robert Sinkovits 6/28/06 - general cleanup and bringing
C     in line with Fortran 90 standard

      implicit none
      
      real, intent(inout) :: x(3)
      real  ndot
      
      ndot = sqrt(x(1)*x(1) + x(2)*x(2) + x(3)*x(3))
      if(ndot > 1.0e-20) then
         x = x / ndot ! F90 array syntax
      else
         print *, 'Subroutine norm - zero length vector ', x
         x = 0.0 ! F90 array syntax
      endif

      return
      end subroutine norm
