      subroutine rearrange_fft_style(idim1, idim2, array) 

C     Rearrange "Fourier style" packed data into normal style image with
C     center in the middle of the array.  This is especially useful for
C     CC style maps
C     
C     December 2003 MBS  PURDUE UNIVERSITY
C     Modified 10-Dec-2003 BY M. Sherman
C     Modified 30-May-2007 by RSS to do rearrangement in-place

      implicit none

      integer, intent(in) :: idim1, idim2
      real, intent(inout) :: array(idim1, idim2)

      integer i, j, iprime, jprime, idim1d2, idim2d2
      real tmp

      idim1d2 = idim1/2
      idim2d2 = idim2/2

      do j = 1, idim2d2
         jprime = j+idim2d2
         do i = 1, idim1
            iprime = i+idim1d2
            if(iprime > idim1) iprime = iprime - idim1
            tmp = array(i,j)
            array(i,j) = array(iprime,jprime)
            array(iprime,jprime) = tmp
         enddo
      enddo

      return
      end subroutine rearrange_fft_style
