      subroutine scopy(n, sx, incx, sy, incy)

c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to 1.
c     Adapted from jack dongarra, linpack, 3/11/78.

      implicit none

      integer, intent(in) :: n, incx, incy
      real, intent(in)    :: sx(n)
      real, intent(out)   :: sy(n)
      integer i, ix, iy, m, mp1

      if(n <= 0) return

      if(incx == 1 .and. incy == 1) then
         m = mod(n,7)
         if(m == 0) go to 40
         do i = 1,m
            sy(i) = sx(i)
         enddo
         if(n < 7) return
 40      mp1 = m + 1
         
         do i = mp1,n,7
            sy(i) = sx(i)
            sy(i + 1) = sx(i + 1)
            sy(i + 2) = sx(i + 2)
            sy(i + 3) = sx(i + 3)
            sy(i + 4) = sx(i + 4)
            sy(i + 5) = sx(i + 5)
            sy(i + 6) = sx(i + 6)
         enddo
      else
         ix = 1
         iy = 1
         if(incx < 0) ix = (-n+1)*incx + 1
         if(incy < 0) iy = (-n+1)*incy + 1
         do i = 1,n
            sy(iy) = sx(ix)
            ix = ix + incx
            iy = iy + incy
         enddo
      endif
      
      return
      end subroutine scopy


      subroutine scopyi8(n, sx, incx, sy, incy)

c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to 1.
c     Adapted from jack dongarra, linpack, 3/11/78.

      implicit none

      integer*8, intent(in) :: n
      integer, intent(in) :: incx, incy
      real, intent(in)    :: sx(n)
      real, intent(out)   :: sy(n)
      integer*8 i, ix, iy, m, mp1

      if(n <= 0) return

      if(incx == 1 .and. incy == 1) then
         m = mod(n,7)
         if(m == 0) go to 40
         do i = 1,m
            sy(i) = sx(i)
         enddo
         if(n < 7) return
 40      mp1 = m + 1
         
         do i = mp1,n,7
            sy(i) = sx(i)
            sy(i + 1) = sx(i + 1)
            sy(i + 2) = sx(i + 2)
            sy(i + 3) = sx(i + 3)
            sy(i + 4) = sx(i + 4)
            sy(i + 5) = sx(i + 5)
            sy(i + 6) = sx(i + 6)
         enddo
      else
         ix = 1
         iy = 1
         if(incx < 0) ix = (-n+1)*incx + 1
         if(incy < 0) iy = (-n+1)*incy + 1
         do i = 1,n
            sy(iy) = sx(ix)
            ix = ix + incx
            iy = iy + incy
         enddo
      endif
      
      return
      end subroutine scopyi8
