      subroutine bcast_parameters

      implicit none
      integer mcw

#ifdef MPI
      include 'mpif.h'
      include '../include/sizes.inc'
      include '../include/allprogs.inc'
      include '../include/info.inc'

      mcw = mpi_comm_world

C     Integer scalars
      call mpi_bcast(num_symm,     1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(min_x,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(max_x,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(min_y,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(max_y,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(min_z,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(max_z,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(max_views,    1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(npix_row,     1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(npix_col,     1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(num_den_pix,  1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(pixhd_htyp,   1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(ctfmode,      1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(filter,       1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(outmode,      1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(symm_code,    1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(nimg,         1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(box_out,      1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(nangle,       1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(funcmode,     1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(ncenter,      1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(quick_search, 1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(apo_border,   1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(per_ptle_ctf, 1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(nmagf,        1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(magfreset,    1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(magfcalib,    1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(handtest,     1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(gangle,       1, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(refine_mode,  1, mpi_integer, 0, mcw, mpi_err)
      
C     Real scalars
      call mpi_bcast(res_max,      1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(res_min,      1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(mapmagfactor, 1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(resolution,   1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(zero_fill,    1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(tempfac,      1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(ctf_ff1,      1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(ctf_ff2,      1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(dangle,       1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(funcweight,   1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(dcenter,      1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(pixsiz_out,   1, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(magfstep,     1, mpi_real, 0, mcw, mpi_err)

C     Integer arrays
      call mpi_bcast(nids,      nimg, mpi_integer, 0, mcw, mpi_err)
      call mpi_bcast(nbox,      nimg, mpi_integer, 0, mcw, mpi_err)

C     Real arrays
      call mpi_bcast(pixsizs,   nimg, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(volts,     nimg, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(delf_majs, nimg, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(delf_mins, nimg, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(ang_majs,  nimg, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(ampfacs,   nimg, mpi_real, 0, mcw, mpi_err)
      call mpi_bcast(cs_coeffs, nimg, mpi_real, 0, mcw, mpi_err)
#endif
      
      return
      end subroutine bcast_parameters
