      SUBROUTINE CC_3D (MAP, MAP2, NCOL1, NROW1, NSEC1, NCOL2, NROW2, 
     1     NSEC2, ICHC, STD, xc,yc,zc, mag_cen, mag_step, mag_num,
     2     radlo, radhi, radstep, bmag, iix, iiy, iiz, mags,
     3     coefs, subMap2d3d, qtr_switch)

      IMPLICIT NONE

      INTEGER*4 NCOL1, NROW1, NSEC1, NCOL2, NROW2, NSEC2
      INTEGER*4 I, J, K, NCOL, NROW, NSEC, IB, ICHC
      INTEGER*4 MAG_NUM, NMAG, II, IIX, IIY, IIZ, LIM, NBINS, BIN
      PARAMETER (LIM=1001)
      INTEGER*4 NTOT(LIM), NFIT, TNTOT, win_size, QTR_SWITCH
      INTEGER*4 ITEST, twod_switch, array_tot, subMap2d3d, nsec_local
      REAL*4    RADIB(lim), BMAG
      REAL*4    MAG, MAG_CEN, MAG_STEP, TCCOEF, TBCCOEF
      REAL*4    AVE,ADEV,SDEV,VAR,SKEW,CURT,MAGCCOEF(LIM), STD
      REAL*4    RADLO,RADHI,RADDSQ,XC,YC,ZC,RADLOSQ,RADHISQ,YSQ,ZSQ
      REAL*4    MAP(NCOL1,NROW1,NSEC1), A, B, RADSTEP, AA, BB
      REAL*4    CCOEF(LIM), CCOEF2(LIM), TCCOEF2, TBCCOEF2
      real*4, allocatable :: rdens(:), wrdens(:), wccoef(:), s_wccoef(:)
      real*4, allocatable :: CNTR1(:), CNTR2(:)
      real*4    mags(mag_num),coefs(mag_num)
      REAL*4    BMAG2, MAGCCOEF2(LIM), TOT, MAP2(NCOL2,NROW2,NSEC2)
      REAL*8    TSUMA, TSUMB, TSUMASQ, TSUMBSQ, TSUMAB, SUMAB(LIM)
      REAL*8    SUMA(LIM), SUMB(LIM), SUMASQ(LIM), SUMBSQ(LIM)
      integer   alloc_stat

C *  Get number of bins between RADHI and RADLO  *
      NBINS = 1 + NINT((RADHI-RADLO)/RADSTEP)
      IF(NBINS.LE.0) NBINS = 1
      IF(NBINS.GT.LIM) THEN
        PRINT *, '*****************************'
        PRINT *, '* RADSTEP must be increased *'
        PRINT *, '*****************************'
        GO TO 999
      ENDIF
      RADLOSQ = RADLO*RADLO
      RADHISQ = (RADHI+RADSTEP)**2

C *  Set NCOL, NROW, NSEC to maximum NCOL of the two maps  *
      array_tot = 1   ! Array counter
      NCOL = MAX (NCOL1, NCOL2)
      NROW = NCOL
      NSEC = NCOL

C* Reset NSEC, NROW if using only quarter map *
       ITEST = INT(NCOL1/2) + 1
       IF (QTR_SWITCH.EQ.1) THEN
        NSEC = INT(NSEC1/2) + 1
        NROW = INT(NROW1/2) + 1
       ENDIF

C *  Initialize variables  *
      MAG     = MAG_CEN - (((MAG_NUM-1)/2)*MAG_STEP)
      NMAG    = 0
      TCCOEF  = 0.0
      TBCCOEF = 0.0
      TBCCOEF2= 0.0
      BMAG    = 1.0
      BMAG2   = 1.0

Ca * Setup for 2D processing
      nsec_local = nsec
Ca      Check to see if we're doing 2d or 3d algorithm
      if(subMap2d3d .eq. 2) then
         iiz = INT(zc)
         nsec_local = INT(zc+1)
      endif

C *  Determine Cor. Coef. over mag. range  *
      DO II = 1,MAG_NUM
C         *  Initialize variables for each mag.  *
        TCCOEF2 = 0.0
        TSUMA   = 0.0
        TSUMB   = 0.0
        TSUMAB  = 0.0
        TSUMASQ = 0.0
        TSUMBSQ = 0.0
        NFIT    = 0
        TNTOT   = 0
C         *  Set sums to zero for each mag.  *
        DO IB = 1,NBINS
          SUMA(IB)    = 0.0
          SUMB(IB)    = 0.0
          SUMAB(IB)   = 0.0
          SUMASQ(IB)  = 0.0
          SUMBSQ(IB)  = 0.0
          NTOT(IB)    = 0
        ENDDO

C       *  If voxel in selected radii, interpolate, and sum  *

        DO K = iiz,NSEC_local
          ZSQ = (K-ZC)**2
          DO J = iiy,NROW
            YSQ = (J-YC)**2
            DO I = iix,NCOL
             IF (K.EQ.NSEC_local.OR.J.EQ.NROW) THEN
            IF (QTR_SWITCH.EQ.1) THEN
              IF (I.GT.ITEST) GOTO 53
            ENDIF
             ENDIF
              RADDSQ = (I-XC)**2 + YSQ + ZSQ
              IF(RADDSQ.GE.RADLOSQ .AND. RADDSQ.LE.RADHISQ) THEN
                B = MAP(I,J,K)
                CALL MAG3D_INTRP (A, MAP2, NCOL1, NROW1, NSEC1, I, J, 
     1          K, MAG, XC, YC, ZC)
              BIN = INT((SQRT(RADDSQ) - RADLO) / RADSTEP) + 1
              IF(BIN.GT.NBINS) GOTO 53 
              SUMA(BIN)   = SUMA(BIN)   + A
              SUMB(BIN)   = SUMB(BIN)   + B
              SUMAB(BIN)  = SUMAB(BIN)  + A*B
              SUMASQ(BIN) = SUMASQ(BIN) + A*A
              SUMBSQ(BIN) = SUMBSQ(BIN) + B*B
                NTOT(BIN)   = NTOT(BIN)   + 1
                NFIT        = NFIT        + 1
               IF(BIN.EQ.1) THEN
               ENDIF
              ENDIF
53            ENDDO
          ENDDO
        ENDDO

C       *  Compute Correlation Coef.  *
      DO 303 IB = 1,NBINS
        CCOEF2(IB) = 0.
        IF (NTOT(IB).EQ.0) THEN                ! TRAPPING OVERFLOWING 
          CCOEF(IB) = 0.
          GO TO 303
        ENDIF
        TOT = REAL(NTOT(IB))
        IF ((SUMASQ(IB) - (SUMA(IB)*SUMA(IB))/TOT).LE.0. .OR.
     1     (SUMBSQ(IB) - (SUMB(IB)*SUMB(IB))/TOT).LE.0.) THEN 
           CCOEF(IB) = 0.
         ELSE
           CCOEF(IB) = REAL((SUMAB(IB) - (SUMA(IB)*SUMB(IB))/TOT) /
     1             (SQRT(SUMASQ(IB) - (SUMA(IB)*SUMA(IB))/TOT)*
     2              SQRT(SUMBSQ(IB) - (SUMB(IB)*SUMB(IB))/TOT)))
           CCOEF2(IB)= CCOEF(IB)*CCOEF(IB) 
           TCCOEF2   = TCCOEF2 + CCOEF2(IB) 
           RADIB(IB) = RADLO   + (IB-1)*RADSTEP
           TSUMA     = TSUMA   + SUMA(IB)    
           TSUMB     = TSUMB   + SUMB(IB)
           TSUMAB    = TSUMAB  + SUMAB(IB)   
           TSUMASQ   = TSUMASQ + SUMASQ(IB) 
           TSUMBSQ   = TSUMBSQ + SUMBSQ(IB)  
           TNTOT     = TNTOT   + NTOT(IB)  
           IF(MAG_NUM.NE.1 .AND. IB.EQ.1) WRITE(9,'(2F10.4,A)') 
     1     RADIB(IB), CCOEF(IB), '  MOV'
       ENDIF
 303      CONTINUE
      IF(TNTOT.LE.0) THEN                 ! TRAP FOR OVERFLOWING
        PRINT *
        PRINT *, 'TNTOT=0,  @MAG: ',MAG
        GO TO 900
      ENDIF
      IF ((TSUMASQ - (TSUMA*TSUMA)/TNTOT).LE.0. .OR.
     2   (TSUMBSQ - (TSUMB*TSUMB)/TNTOT).LE.0.) THEN 
        PRINT *
        PRINT *, 'OVERFLOW IN CCOEF CALC,  @MAG: ',MAG
        GO TO 900
      ENDIF
C
        TCCOEF = REAL((TSUMAB - (TSUMA*TSUMB)/REAL(TNTOT)) /
     1           (SQRT(TSUMASQ - (TSUMA*TSUMA)/REAL(TNTOT))*
     2            SQRT(TSUMBSQ - (TSUMB*TSUMB)/REAL(TNTOT))))
        NMAG             = NMAG + 1
        MAGCCOEF (NMAG)  = TCCOEF 
        MAGCCOEF2 (NMAG) = TCCOEF2 
        IF (ABS(TCCOEF).GT.ABS(TBCCOEF)) THEN
          TBCCOEF = TCCOEF
          BMAG    = MAG
        ENDIF
        IF (TCCOEF2.GT.TBCCOEF2) THEN
          TBCCOEF2 = TCCOEF2
          BMAG2    = MAG
        ENDIF
        mags(array_tot)    = mag
        coefs(array_tot)   = tccoef
        array_tot = array_tot + 1
  900        MAG = MAG + MAG_STEP
      ENDDO

C *  Output best mag. (if a range) and other parameters  *
      IF(NMAG.GT.2) THEN
        CALL MOMENT295 (MAGCCOEF,NMAG,AVE,ADEV,SDEV,VAR,SKEW,CURT)
      ENDIF

C *  If user chose to also scale densities, then call CCOMAP3CS  *
      IF(ICHC.EQ.3) THEN
         allocate(cntr1(nfit), cntr2(nfit), rdens(nbins), wrdens(nbins),
     $        wccoef(nbins), s_wccoef(nbins), stat=alloc_stat)
        if(alloc_stat > 0) then
           write(*,*) ' ERR>  NOT ENOUGH MEMORY FOR CONTRAST SCALING !'
           write(*,*)
           write(*,*)
           go to 999
        endif

        IF (win_size.LE.0) win_size = 4
        twod_switch = 3         ! 3 dimensional
C GCA: to investigate if the last two arguments are correct
        CALL CCOMAP3CS (MAP, MAP2, NCOL1, NROW1, NSEC1,
     1       NCOL2, NROW2, NSEC2, NFIT, CNTR1, CNTR2, STD,
     2       XC,YC,ZC,RADLO,RADHI,RADSTEP,BMAG,rdens,wrdens,
     3       ccoef,wccoef,s_wccoef,nbins,BB,AA, QTR_SWITCH,
     4       twod_switch, 1.0, 0)
        deallocate(cntr1, cntr2, rdens, wrdens, wccoef, s_wccoef)

      ENDIF
      RETURN

C *    ERROR    *
  999      PRINT *, '** BUG ALERT!  pls send a log to [rhc] **'
      CALL TSBEND
      END
C
C****************************************************************************
C*  SUBROUTINE CCOMAP3CS 
C*  Modified 5/25/00 RWA - Added args necessary to avoid using common
C*  block to pass.
C*  Modified 7/27/00 J. Folk - Improved algorithm for determining recommended
C*  RADLO and RADHI values, using S_WCCOEF to find the largest "bunch" of
C*  continuous nonzero values, then within that range of radii finding the
C*  peak value of WCCOEF, and searching radii less than that peak value
C*  to find RADLO, and searching radii greater than that peak value to find
C*  RADHI.
C****************************************************************************
      SUBROUTINE CCOMAP3CS (MAP, MAP2, NCOL1, NROW1, NSEC1,
     1 NCOL2, NROW2, NSEC2, NFIT, CNTR1, CNTR2, MAP_STD,
     2 XC,YC,ZC,RADLO,RADHI,RADSTEP,BMAG,
     3 rdens,wrdens,ccoef,wccoef,s_wccoef,nbins, BB, AA,
     4 QTR_SWITCH, twod_switch, threshValue, useAbs)

      IMPLICIT NONE

      INTEGER*4 NCOL1, NROW1, NSEC1, NCOL2, NROW2, NSEC2
      INTEGER*4 I, J, K, NCOL, NROW, NSEC
      INTEGER*4 IIX, IIY, IIZ, LIM, NBINS, BIN, IIC
      INTEGER*4 LOWTAG, RADTAG, IB, NFIT
      INTEGER*4 NRDENS, QTR_SWITCH
      INTEGER*4 ITEST, twod_switch, useAbs, isOK
      PARAMETER (LIM=501)
      integer alloc_stat
      REAL*4    threshValue, absThreshValue
      REAL*4    WCCOEF(nbins), RDENS(nbins), WRDENS(nbins)
      REAL*4    CCOEF(nbins)
      REAL*4    RSQ_LIM, WCCOEF_MAX, S_WCCOEF(nbins)      
      REAL*4    CNTR1(NFIT), CNTR2(NFIT), MAG, MAP_STD
      REAL*4    AA, BB, UNA, UNB, CHISQ, GDNS, TCCOEF, BMAG
      REAL*4    RADLO,RADHI,RADDSQ,XC,YC,ZC,RADLOSQ,RADHISQ,YSQ,ZSQ
      REAL*4    MAP(NCOL1,NROW1,NSEC1),A,B,RADSTEP
      REAL*4    MAP2(NCOL2,NROW2,NSEC2)
      REAL*4    TNTOT, NTOT(LIM), RADIB, TMPLO, TMPHI, TMP1
      REAL*8    TSUMA, TSUMB, TSUMASQ, TSUMBSQ, TSUMAB, SUMAB(LIM)
      REAL*8    SUMA(LIM), SUMB(LIM), SUMASQ(LIM), SUMBSQ(LIM)
      integer*4, allocatable :: rdens_num(:)
      real*4, allocatable    :: rdens_std(:)

Ca      RWA - for now let's just init these - we'll pas them in later???
      absThreshValue = abs(threshValue)
      iix = 1
      iiy = 1
      iiz = 1
      MAG     = BMAG 
      LOWTAG  = 0 
      RADTAG  = 0 
      TMPLO   = RADLO
      TMPHI   = RADHI
      NCOL    = MAX (NCOL1, NCOL2)
      NROW    = NCOL
Ca  Careful!!! What about twod_switch???      NSEC    = NCOL
      NSEC = NCOL
      if(twod_switch .eq. 2) then
         nsec = 1
      endif
      WCCOEF_MAX = 0.0

C  * Reset NSEC and NROW if only using quarter map *
       ITEST = INT(NCOL1/2) + 1
       IF (QTR_SWITCH.EQ.1) THEN 
        NSEC = INT(NSEC1/2) + 1
        NROW = INT(NROW1/2) + 1
       ENDIF

C  *    PRINT TO SCREEN AND FILE RAD, CCOEF,NTOT FOR ALL RADII* 
C  *    NOTE: ASSUMES NCOL1=NCOL2 AND NROW1=NROW2 
       RADHISQ = (REAL((NCOL-1)/2)+RADSTEP)**2
      RSQ_LIM = RADHISQ  ! USED FOR CMP_MAP_1D 
Ca Pass these in       NBINS = 1 + NINT(((NCOL-1)/2)/RADSTEP)
      NRDENS = NBINS ! USED FOR CMP_MAP_1D
C  ************************************************************
C  *  CALL CMP_MAP_1D TO USE CIRCULAR DENSITY AVERAGING TO    *
C  *  AND NORMALIZATION TO 1.0 AND REMOVAL OF NEGATIVE        *
C  *  DENSITIES CALCULATE WRDENS, WHICH IS LATER USED TO      *
C  *  CALCULATE WCCOEF, A WEIGHTED CORRELATION COEFFICIENT.   *
C  ************************************************************
      allocate(rdens_num(nrdens), rdens_std(nrdens),
     $     stat = alloc_stat)
      if(alloc_stat > 0) then
         write(*,*) 'Unable to allocate memory in CCOMAP3CS'
      endif

      CALL CMP_MAP_1D (MAP, NCOL1, NROW1, NSEC1, XC, YC, ZC, 
     1        NRDENS, RSQ_LIM, RDENS, WRDENS, RDENS_NUM, RDENS_STD,
     2  QTR_SWITCH)

C  *  CALCULATE CORRELATION COEFFICIENT   *
        DO IB = 1,NBINS
          SUMA(IB)    = 0.0
          SUMB(IB)    = 0.0
          SUMAB(IB)   = 0.0
          SUMASQ(IB)  = 0.0
          SUMBSQ(IB)  = 0.0
          NTOT(IB)    = 0.0
        ENDDO
        DO K = iiz,NSEC
          ZSQ = (K-ZC)**2
          DO J = iiy,NROW
            YSQ = (J-YC)**2
            DO 9 I = iix,NCOL
           IF (K.EQ.NSEC.OR.J.EQ.NROW) THEN
            IF(QTR_SWITCH.EQ.1) THEN
            IF(I.GT.ITEST) GOTO 9 
            ENDIF
           ENDIF
              RADDSQ = (I-XC)**2 + YSQ + ZSQ
              IF(RADDSQ.GT.RADHISQ) GOTO 9
                B = MAP(I,J,K)
                CALL MAG3D_INTRP (A, MAP2, NCOL1, NROW1, NSEC1, I, J,
     1 K, MAG, XC, YC, ZC)
            BIN = INT(SQRT(RADDSQ) / RADSTEP) + 1
            IF(BIN.GT.NBINS) GOTO 9 
            SUMA(BIN)   = SUMA(BIN)   + A
            SUMB(BIN)   = SUMB(BIN)   + B
            SUMAB(BIN)  = SUMAB(BIN)  + A*B
            SUMASQ(BIN) = SUMASQ(BIN) + A*A
            SUMBSQ(BIN) = SUMBSQ(BIN) + B*B
            NTOT(BIN)   = NTOT(BIN)   + 1.0
9           ENDDO
          ENDDO
        ENDDO

        DO 10 IB = 1,NBINS
         CCOEF(IB) = 0.
         RADIB = (IB-1)*RADSTEP
         IF (NTOT(IB).EQ.0.) THEN
           WCCOEF(IB) = CCOEF(IB)*WRDENS(IB)
         IF (WCCOEF(IB).LT.0.0) WCCOEF(IB) = 0.0
           GOTO 10
         ENDIF
         IF ((SUMASQ(IB) - (SUMA(IB)*SUMA(IB))/NTOT(IB)).LE.0. .OR.
     1 (SUMBSQ(IB) - (SUMB(IB)*SUMB(IB))/NTOT(IB)).LE.0.) THEN
           WCCOEF(IB) = CCOEF(IB)*WRDENS(IB)
          IF (WCCOEF(IB).LT.0.0) WCCOEF(IB) = 0.0
         ELSE
           CCOEF(IB) = REAL((SUMAB(IB) - (SUMA(IB)*SUMB(IB))/NTOT(IB))/
     1 (SQRT( SUMASQ(IB) - (SUMA(IB)*SUMA(IB))/NTOT(IB))*
     2 SQRT(SUMBSQ(IB) - (SUMB(IB)*SUMB(IB))/NTOT(IB))))
           WCCOEF(IB) = CCOEF(IB)*WRDENS(IB)
          IF (WCCOEF(IB).LT.0.0) WCCOEF(IB) = 0.0
         ENDIF
      WCCOEF_MAX = MAX(WCCOEF_MAX, WCCOEF(IB)) 
10      ENDDO 
      DO IB = 1,NBINS
        IF(WCCOEF(IB).LT.(0.01*WCCOEF_MAX)) WCCOEF(IB) = 0.0
          RADIB = (IB-1)*RADSTEP
        IF(IB.GT.2) THEN
          IF((WCCOEF(IB-2).EQ.0.0).AND.(WCCOEF(IB).EQ.0.0)) THEN
            WCCOEF(IB-1) = 0.0
          ENDIF
        ENDIF
      ENDDO      

C *   SLIDING WINDOW ALGORITHM   *
      DO IB = 1, NRDENS
        S_WCCOEF(IB) = 0.0
      ENDDO

      IB = 0
      tmp1 = 0.
      
C
Ca We are only going once now

      NBINS = 1 + NINT((RADHI-RADLO)/RADSTEP)
      IF(NBINS.LE.0) NBINS = 1
      RADLOSQ = RADLO*RADLO
      RADHISQ = (RADHI+RADSTEP)**2 
      DO IB = 1,NBINS
        SUMA(IB)    = 0.0
        SUMB(IB)    = 0.0
        SUMAB(IB)   = 0.0
        SUMASQ(IB)  = 0.0
        SUMBSQ(IB)  = 0.0
        NTOT(IB)    = 0.0
      ENDDO

      IIC = 0 

      DO K = iiz,NSEC
        ZSQ = (K-ZC)**2
        DO J = iiy,NROW
          YSQ = (J-YC)**2
          DO I = iix,NCOL
            IF (QTR_SWITCH.EQ.1) THEN
            IF(K.EQ.NSEC.AND.I.GT.(INT(NCOL/2)+1)) GOTO 8
            IF(J.EQ.NROW.AND.I.GT.(INT(NCOL/2)+1)) GOTO 8
            ENDIF
            RADDSQ = (I-XC)**2 + YSQ + ZSQ
            IF(RADDSQ.GE.RADLOSQ .AND. RADDSQ.LE.RADHISQ) THEN
              B = MAP(I,J,K) 
            CALL MAG3D_INTRP (A, MAP2, NCOL1, NROW1, NSEC1, I, J,
     1        K, MAG, XC, YC, ZC)
            isOK = 0
            if(useAbs.eq.1) then
               if (abs(b-a) .lt. absThreshValue) isOK = 1
            else
               if((B-A) .gt. threshValue ) isOK = 1
            endif
            if(isOK .eq. 1) THEN
                BIN = INT((SQRT(RADDSQ) - RADLO) / RADSTEP) + 1
                IF(BIN.GT.NBINS) GOTO 8 
                  IIC = IIC + 1
                  CNTR1 (IIC) = B
                  CNTR2 (IIC) = A 
                SUMA(BIN)   = SUMA(BIN)   + A
                SUMB(BIN)   = SUMB(BIN)   + B
                SUMAB(BIN)  = SUMAB(BIN)  + A*B
                SUMASQ(BIN) = SUMASQ(BIN) + A*A
                SUMBSQ(BIN) = SUMBSQ(BIN) + B*B
                NTOT(BIN)   = NTOT(BIN)   + 1.0
            endif
            ENDIF
8          ENDDO
        ENDDO
      ENDDO
      GO TO 300

 300  TSUMA   = 0.0
        TSUMB   = 0.0
        TSUMAB  = 0.0
        TSUMASQ = 0.0
        TSUMBSQ = 0.0
        TNTOT   = 0.0

      DO 303 IB = 1,NBINS 
       CCOEF(IB) = 0.
       RADIB = RADLO + (IB-1)*RADSTEP
       IF (NTOT(IB).EQ.0.) THEN 
           GOTO 303
       ENDIF
       IF ((SUMASQ(IB) - (SUMA(IB)*SUMA(IB))/NTOT(IB)).LE.0. .OR.
     1 (SUMBSQ(IB) - (SUMB(IB)*SUMB(IB))/NTOT(IB)).LE.0.) THEN 
         ELSE 
         CCOEF(IB) = REAL((SUMAB(IB) - (SUMA(IB)*SUMB(IB))/NTOT(IB)) /
     1           (SQRT( SUMASQ(IB) - (SUMA(IB)*SUMA(IB))/NTOT(IB))*
     2            SQRT(SUMBSQ(IB) - (SUMB(IB)*SUMB(IB))/NTOT(IB))))
        TSUMA   = TSUMA   + SUMA(IB)    
        TSUMB   = TSUMB   + SUMB(IB)
        TSUMAB  = TSUMAB  + SUMAB(IB)   
        TSUMASQ = TSUMASQ + SUMASQ(IB) 
        TSUMBSQ = TSUMBSQ + SUMBSQ(IB)  
        TNTOT   = TNTOT   + NTOT(IB)  
       ENDIF
 303      CONTINUE
      TCCOEF = REAL((TSUMAB - (TSUMA*TSUMB)/TNTOT) /
     1           (SQRT(TSUMASQ - (TSUMA*TSUMA)/TNTOT)*
     2            SQRT(TSUMBSQ - (TSUMB*TSUMB)/TNTOT)))
C

      deallocate(rdens_num, rdens_std)

      CALL CHI2FIT (CNTR2, CNTR1, IIC, MAP_STD, 1, AA, BB, UNA, UNB, 
     1 CHISQ, GDNS)

      RETURN
      END


      SUBROUTINE MAG3D_INTRP (A,MAP,NCOL,NROW,NSEC,I,J,K,MAG,
     1      XC, YC, ZC)

      IMPLICIT NONE

      INTEGER*4 NCOL, NROW, NSEC, I, J, K, IX, IY, IZ 
      REAL*4    MAP(NCOL,NROW,NSEC)
      REAL*4    DX, DY, DZ, XC, YC, ZC, MAG, A, X, Y, Z
      REAL*4    D1, D2, D3, D4, D5, D6, D7, D8 

      A = 0.0

      X = MAG*(REAL(I)-XC) + XC
      Y = MAG*(REAL(J)-YC) + YC
      Z = MAG*(REAL(K)-ZC) + ZC
      IX = INT(X)
      IY = INT(Y)
      IZ = INT(Z)
Ca  I need this here for robem and doing 2D sections      
      if(iz .lt. 1) then
         iz = 1
      endif
      IF(IX.LT.1 .OR. IY.LT.1 .OR. IZ.LT.1 .OR.
     1  IX.GT.NCOL .OR. IY.GT.NROW .OR. IZ.GT.NSEC) RETURN 

      D2        = 0.0
      D3        = 0.0
      D4        = 0.0
      D5        = 0.0
      D6        = 0.0
      D7        = 0.0
      D8        = 0.0
      D1        = MAP(IX,IY,IZ)
      IF(IX.LT.NCOL) THEN 
         D2 = MAP(IX+1,IY,IZ)
         IF(IY.LT.NROW) THEN
            D3 = MAP(IX,IY+1,IZ)
            D4 = MAP(IX+1,IY+1,IZ)
            IF(IZ.LT.NSEC) THEN
               D5 = MAP(IX,IY,IZ+1)
               D6 = MAP(IX+1,IY,IZ+1)
               D7 = MAP(IX,IY+1,IZ+1)
               D8 = MAP(IX+1,IY+1,IZ+1)
            ENDIF
         ENDIF
      ENDIF
      DX        = X-IX
      DY        = Y-IY
      DZ        = Z-IZ

      A  =     (1.-DX)*(1.-DY)*(1.-DZ)*D1 + DX *(1.-DY)*(1.-DZ)*D2 
     1       + (1.-DX)*    DY *(1.-DZ)*D3 + DX *    DY *(1.-DZ)*D4
     2       + (1.-DX)*(1.-DY)*    DZ *D5 + DX *(1.-DY)*    DZ *D6
     3       + (1.-DX)*    DY *    DZ *D7 + DX *    DY *    DZ *D8

      RETURN
      END

      SUBROUTINE CHI2FIT (X, Y, NDATA, SIG, MWT, A, B, SIGA, SIGB,
     1 CHI2, Q)

      IMPLICIT NONE
C
      INTEGER  NDATA, I, MWT
      REAL*4   X(NDATA), Y(NDATA), SX, SY, ST2, WT, SS, SXOSS, T
      REAL*4   SIG, A, B, SIGA, SIGB, CHI2, Q, SIGDAT

      SX  = 0.0
      SY  = 0.0
      ST2 = 0.0
      B   = 0.0
      IF(MWT.NE.0) THEN
         SS = 0.0
         DO I = 1,NDATA
             WT = 1./(SIG**2)
             SS = SS+WT
             SX = SX+X(I)*WT
             SY = SY+Y(I)*WT
         ENDDO
       ELSE
           DO I = 1,NDATA
             SX = SX+X(I)
             SY = SY+Y(I)
         ENDDO
           SS = REAL(NDATA)
      ENDIF

      SXOSS = SX/SS

      IF(MWT.NE.0) THEN
         DO I = 1,NDATA
           T   = (X(I) - SXOSS)/SIG
           ST2 = ST2 + T*T
           B   = B + T*Y(I)/SIG
         ENDDO
       ELSE
         DO I = 1,NDATA
           T   = X(I) - SXOSS
           ST2 = ST2 + T*T
           B   = B + T*Y(I)
         ENDDO
      ENDIF

      B    = B/ST2
      A    = (SY-SX*B)/SS
      SIGA = SQRT((1.+SX*SX/(SS*ST2))/SS)
      SIGB = SQRT(1./ST2)
      CHI2 = 0.0

      IF(MWT.EQ.0) THEN
         DO I = 1,NDATA
           CHI2 = CHI2+(Y(I)-A-B*X(I))**2
         ENDDO
         Q      = 1.0
         SIGDAT = SQRT(CHI2/(NDATA-2))
         SIGA   = SIGA*SIGDAT
         SIGB   = SIGB*SIGDAT
       ELSE
         DO I=1,NDATA
           CHI2 = CHI2 + ((Y(I)-A-B*X(I))/SIG)**2
         ENDDO
         q = 1.
      ENDIF

      RETURN
      END


      SUBROUTINE MOMENT295 (DATA, N, AVE, ADEV, SDEV, VAR, SKEW, CURT)
      IMPLICIT NONE
      INTEGER  N,J
      REAL*4   DATA(N),S,AVE,ADEV,SDEV,VAR,SKEW,CURT,P

      IF(N.LE.1) THEN
         write(*,*) 'N must be at least 2'
         stop
      endif
      S=0.
      DO 11 J=1,N
        S=S+DATA(J)
11    CONTINUE
      AVE=S/N
      ADEV=0.
      VAR=0.
      SKEW=0.
      CURT=0.
      DO 12 J=1,N
        S=DATA(J)-AVE
        ADEV=ADEV+ABS(S)
        P=S*S
        VAR=VAR+P
        P=P*S
        SKEW=SKEW+P
        P=P*S
        CURT=CURT+P
12    CONTINUE
      ADEV=ADEV/N
      VAR=VAR/(N-1)
      SDEV=SQRT(VAR)
      IF(VAR.ne.0.)THEN
        SKEW=SKEW/(N*SDEV**3)
        CURT=CURT/(N*VAR**2)-3.  
      ELSE
        print *, 'no skew/kurtosis was calc when variance is to small'
        print *, '02-feb-1995[rhc]'
      ENDIF
      RETURN
      END

      SUBROUTINE CMP_MAP_1D (MAP, NCOL, NROW, NSEC, XC, YC, ZC,
     1            NRDENS, RSQ_LIM, RDENS, WRDENS, RDENS_NUM, RDENS_STD,
     2   QTR_SWITCH)

      IMPLICIT NONE

      INTEGER*4    NCOL, NROW, NSEC, INUM, IR, QTR_SWITCH, NRDENS
      INTEGER*4    I, J, K, RDENS_NUM(NRDENS)
      REAL*4       XC, YC, ZC, RDENS(NRDENS), RDENS_MIN, RDENS_MAX
      REAL*4       WRDENS(NRDENS), SCALEFAC      
      REAL*4       MAP(NCOL,NROW,NSEC), X, Y, Z, YSQ, ZSQ
      REAL*4       TEST, RSQ_LIM, RDENS_STD(NRDENS)

      INUM    = NRDENS

      DO I = 1,INUM                      ! INITIALIZE 1D INTERPOLATION ARRAY
        RDENS_NUM(I) = 0
        RDENS(I)  = 0.0
        RDENS_STD(I) = 0.0
      ENDDO

C  *    STEP THROUGH IMAGE AND REDUCE TO 1D CIRCULAR AVERAGE    *
      DO K = 1,NSEC
        Z   = REAL(K) - ZC
        ZSQ = Z*Z
        DO J = 1,NROW
          Y   = REAL(J) - YC
          YSQ = Y*Y
          DO I = 1,NCOL
             IF(QTR_SWITCH.EQ.1) THEN
              IF(K.EQ.NSEC.AND.I.GT.(INT(NCOL/2)+1)) GOTO 5
              IF(J.EQ.NROW.AND.I.GT.(INT(NCOL/2)+1)) GOTO 5
             ENDIF
             X    = REAL(I) - XC
             TEST = X*X + YSQ + ZSQ
             IF(TEST.LE.RSQ_LIM) THEN
               IR             = NINT(SQRT(TEST)) + 1
             IF (IR.GT.NRDENS) GOTO 5 
               RDENS_NUM(IR)      = RDENS_NUM(IR) + 1
               RDENS(IR)       = RDENS(IR) + MAP(I,J,K)
             ENDIF
5          ENDDO
        ENDDO
      ENDDO

C  *    NORMALIZE THE 1D ARRAY    *
      RDENS_MIN =  HUGE(RDENS_MIN)
      RDENS_MAX = -HUGE(RDENS_MAX)
      DO I = 1,INUM
        IF(RDENS_NUM(I).GT.1) THEN
          RDENS(I)     = RDENS(I)/REAL(RDENS_NUM(I))            ! Get average
        ENDIF
        RDENS_MIN = MIN(RDENS_MIN,RDENS(I))
        RDENS_MAX = MAX(RDENS_MAX,RDENS(I))
      ENDDO


C  *  NORMALIZE RDENS TO 1.0, REMOVE NEGATIVE DENSITY,  *
C  *  SAVE THIS WEIGHTED VALUE AS WRDENS                *
      SCALEFAC = 1.0 / RDENS_MIN
      DO 10 I = 1,INUM
        WRDENS(I) = RDENS(I) * SCALEFAC 
        IF(RDENS(I).GT.0.0) THEN
          WRDENS(I) = 0.0
        ENDIF
10      ENDDO 

C  *  Compute standard deviation at each radius where RDENS_NUM > 1  *
      DO K = 1,NSEC
        Z   = REAL(K) - ZC
        ZSQ = Z*Z
        DO J = 1,NROW
          Y   = REAL(J) - YC
          YSQ = Y*Y
          DO I = 1,NCOL
             IF(QTR_SWITCH.EQ.1) THEN
              IF(K.EQ.NSEC.AND.I.GT.(INT(NCOL/2)+1)) GOTO 55
              IF(J.EQ.NROW.AND.I.GT.(INT(NCOL/2)+1)) GOTO 55
             ENDIF
             X    = REAL(I) - XC
             TEST = X*X + YSQ + ZSQ
             IF(TEST.LE.RSQ_LIM) THEN
               IR        = NINT(SQRT(TEST)) + 1
             IF(IR.GT.NRDENS) GOTO 55
               RDENS_STD(IR) = RDENS_STD(IR) + (RDENS(IR)-MAP(I,J,K))**2
             ENDIF
55          ENDDO
        ENDDO
      ENDDO
      DO I = 1,INUM
        IF (RDENS_NUM(I).GT.1) THEN
           RDENS_STD(I) = SQRT( RDENS_STD(I) / REAL(RDENS_NUM(I)-1) )
         ELSE
           RDENS_STD(I) = 0.0
        ENDIF
      ENDDO

      RETURN
      END
