      SUBROUTINE FFT_2D_ROB_(FFT, IDIM1, IDIM2, ksign, iform)
      INTEGER*4 IDIM1, IDIM2, ksign, iform
      REAL*4    FFT(2*IDIM1,IDIM2)
      call FFT_2D_ROB(FFT, IDIM1, IDIM2, ksign, iform)
      end SUBROUTINE FFT_2D_ROB_

      SUBROUTINE REC_TO_REAL_(A_CELL,B_CELL,C_CELL,ALP,BET,GAM,VOL,
     1     A_STAR,B_STAR,C_STAR,VOL_STAR,ALP_STAR,BET_STAR,GAM_STAR)
      REAL*4  A_CELL, B_CELL, C_CELL, ALP, BET, GAM, VOL
      REAL*4  A_STAR, B_STAR, C_STAR, VOL_STAR
      REAL*4  ALP_STAR, BET_STAR, GAM_STAR
      CALL REC_TO_REAL (A_CELL,B_CELL,C_CELL,ALP,BET,GAM,VOL,
     1     A_STAR,B_STAR,C_STAR,VOL_STAR,ALP_STAR,BET_STAR,GAM_STAR)
      END SUBROUTINE REC_TO_REAL_

      SUBROUTINE R4_IMG_SYM_(IMG1, NCOL, NROW, XCEN, YCEN, NROT,
     1     IMG_BKG, rint, numAlloc)
      INTEGER*4 NROT, NCOL, NROW, numAlloc
      REAL*4    XCEN, YCEN
      real*4    IMG_BKG
      real*4    IMG1(1), rint(numAlloc)
      CALL R4_IMG_SYM(IMG1, NCOL, NROW, XCEN, YCEN, NROT,
     1     IMG_BKG, rint, numAlloc)
      END SUBROUTINE R4_IMG_SYM_

      SUBROUTINE MAP_SCALE_(MAP, NCOL, NROW, NSEC, MIN_OLD,
     1     MAX_OLD, MIN_NEW, MAX_NEW, MAP_MIN, MAP_MAX, 
     2     MAP_AVG, MAP_STD)
      INTEGER*4 NCOL, NROW, NSEC
      REAL*4    MAP(1), MIN_OLD, MAX_OLD, MIN_NEW, MAX_NEW
      REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
      CALL MAP_SCALE(MAP, NCOL, NROW, NSEC, MIN_OLD,
     1     MAX_OLD, MIN_NEW, MAX_NEW, MAP_MIN, MAP_MAX, 
     2     MAP_AVG, MAP_STD)
      END SUBROUTINE MAP_SCALE_

      SUBROUTINE MAP_ROT_(MAP1, NCOL, NROW, NSEC, RANGL, AXIS)
      INTEGER*4 NCOL, NROW, NSEC
      REAL*4    MAP1(NCOL, NROW, NSEC), RANGL
      CHARACTER AXIS*1
      CALL MAP_ROT(MAP1, NCOL, NROW, NSEC, RANGL, AXIS)
      END SUBROUTINE MAP_ROT_

      SUBROUTINE PEAK_CHK_(PEAKS, NPEAK, NPEAK_UNIQUE, D)
      INTEGER*4 NPEAK, NPEAK_UNIQUE
      REAL*4    PEAKS(3,NPEAK), D
      CALL PEAK_CHK(PEAKS, NPEAK, NPEAK_UNIQUE, D)
      END SUBROUTINE PEAK_CHK_

      SUBROUTINE PEAK_CEN_(PEAKS, NPEAK, IMG, NCOL, NROW)
      INTEGER*4 NCOL, NROW, NPEAK
      REAL*4    PEAKS(3,NPEAK)
      REAL*4    IMG(NCOL,NROW)
      CALL PEAK_CEN(PEAKS, NPEAK, IMG, NCOL, NROW)
      END SUBROUTINE PEAK_CEN_

      SUBROUTINE PEAK_SORT_HI_(PEAKS, NPEAK)
      INTEGER*4 NPEAK
      REAL*4    PEAKS(3,NPEAK)
      CALL PEAK_SORT_HI(PEAKS, NPEAK)
      END SUBROUTINE PEAK_SORT_HI_

      SUBROUTINE FFT_PSHIFT_(FFT, IDIM1, IDIM2, X_SHIFT, Y_SHIFT,
     1     FFT_FULL)
      INTEGER*4 IDIM1, IDIM2
      REAL*4    X_SHIFT, Y_SHIFT
      REAL*4    FFT(1)
      LOGICAL   FFT_FULL
      call FFT_PSHIFT(FFT, IDIM1, IDIM2, X_SHIFT, Y_SHIFT, FFT_FULL)
      end SUBROUTINE FFT_PSHIFT_

      SUBROUTINE FFT_COPY1_(FFT2, FFT1, IDIM1, IDIM2)
      INTEGER*4 IDIM1, IDIM2
      REAL*4  FFT1(2*IDIM1,((IDIM2/2)+1)), FFT2(2*IDIM1,IDIM2)
      call FFT_COPY1(FFT2, FFT1, IDIM1, IDIM2)
      end SUBROUTINE FFT_COPY1_

      SUBROUTINE FFT_2DBT_R4_(FFT, IDIM1, IDIM2, MAP, NCOL, NROW, 
     $     IMG_BKG)
      INTEGER*4 IDIM1, IDIM2, NCOL, NROW
      real*4    IMG_BKG
      REAL*4    FFT(2*IDIM1,IDIM2), MAP(NCOL,NROW)
      call FFT_2DBT_R4(FFT, IDIM1, IDIM2, MAP, NCOL, NROW,
     $     IMG_BKG)
      end SUBROUTINE FFT_2DBT_R4_

      SUBROUTINE CC_3D_(MAP, MAP2, NCOL1, NROW1, NSEC1, NCOL2, NROW2,
     $     NSEC2, ICHC, STD, xc, yc, zc, mag_cen, mag_step, mag_num,
     $     radlo, radhi, radstep, bmag, iix, iiy, iiz, mags,
     $     coefs ,subMap2d3d, qtr_switch)
      INTEGER*4 NCOL1, NROW1, NSEC1, NCOL2, NROW2, NSEC2
      INTEGER*4 MAG_NUM, IIX, IIY, IIZ
      INTEGER*4 subMap2d3d, ichc, qtr_switch
      REAL*4    MAG_CEN, MAG_STEP, STD, BMAG
      REAL*4    RADLO, RADHI, radstep, XC, YC, ZC
      REAL*4    MAP(NCOL1,NROW1,NSEC1)
      real*4    mags(mag_num), coefs(mag_num)
      REAL*4    MAP2(NCOL2,NROW2,NSEC2)
      call CC_3D(MAP, MAP2, NCOL1, NROW1, NSEC1, NCOL2, NROW2,
     $     NSEC2, ICHC, STD, xc, yc, zc, mag_cen, mag_step, mag_num,
     $     radlo, radhi, radstep, bmag, iix, iiy, iiz, mags,
     $     coefs ,subMap2d3d, qtr_switch)
      end subroutine cc_3d_

C     ----------------------------------------

      SUBROUTINE R4_IMG_FFT_FILL_(img, NCOL, NROW, FFT,
     1           IDIM1, IDIM2, img_bkg)
      INTEGER*4 NCOL, NROW, IDIM1, IDIM2
      real*4    img_bkg, IMG(NCOL,NROW), FFT(2*IDIM1,IDIM2)
      call R4_IMG_FFT_FILL(img, NCOL, NROW, FFT,
     1           IDIM1, IDIM2, img_bkg)
      end subroutine R4_IMG_FFT_FILL_

