      subroutine pmap_fft (pmap, pfft, nrot, nannuli)

C     Calculate PFT (Polar Fourier Transform) from polar map
c     
c     august 1992  purdue university vax 8550, t. baker
c     modified 18-aug-2006, rss - array A declared to be automatic
c     modified 6/4/07 RSS - use complex arrays

      implicit none

      integer, intent(in)  :: nannuli, nrot
      real, intent(in)     :: pmap(nrot,nannuli)
      complex, intent(out) :: pfft(nrot,nannuli)

      integer i, j
      complex a(nrot)
      real    work, div, radius

      div = float(nrot)

      do i = 1,nannuli
         radius = float(i)
         do j = 1,nrot
            a(j) = cmplx(pmap(j,i), 0.0)
         enddo
         call fourt (a, nrot, 1, 1, 0, work)
         do j = 1,nrot
            pfft(j,i) = radius*a(j)/div
         enddo
      enddo
      
      return
      end subroutine pmap_fft
