C  ****************************************************************************
C  *                                                                          *
C  *                    *****     STRINGLIB.SUBS     *****                    *
C  *                                                                          *
C  *    LIBRARY OF CHARACTER STRING MANIPULATION SUBROUTINES/FUNCTIONS:       *
C  *                                                                          *
C  *      STRING_LEN      - DETERMINE LENGTH OF "STRING"                      *
C  *      STRING_UPPER    - MAKE ALL CHARACTERS IN "STRING" UPPER CASE        *
C  ****************************************************************************
C


C  ****************************************************************************
C  *                                                                          *
C  *                  *****     FUNCTION STRING_LEN     *****                 *
C  *                                                                          *
C  *    DETERMINE THE NUMBER OF CHARACTERS IN "STRING" BY DISREGARDING        *
C  *     TRAILING BLANKS IN THE RIGHTHAND SIDE OF THE ARRAY                   *
C  *                                                                          *
C  *    AUGUST 1985  PURDUE UNIVERSITY VAX 11/750, T. BAKER                   *
C  ****************************************************************************
C
      INTEGER*4 FUNCTION STRING_LEN (STRING)
C
      IMPLICIT NONE
C
      INTEGER*4      I
      CHARACTER *(*) STRING
C  ----------------------------------------------------------------------------
C
      STRING_LEN = 0
C
      DO I = LEN(STRING),1,-1
        IF(STRING(I:I).GT.' ') THEN
          STRING_LEN = I
          RETURN
        ENDIF
      ENDDO
C
       RETURN
      END


C  **************************************************************
C  *                                                            *
C  *          *****     SUBROUTINE STRING_UPPER     *****       *
C  *                                                            *
C  *    MAKE ALL CHARACTERS IN "STRING" UPPER CASE              *
C  *                                                            *
C  *    OCTOBER 1986  PURDUE UNIVERSITY VAX 11/750, T. BAKER    *
C  **************************************************************
C
      SUBROUTINE STRING_UPPER (STRING)
C
      IMPLICIT NONE
C
      INTEGER*4     STRING_LEN, NUMCHR, ICHR, I
      CHARACTER*(*) STRING
C  ----------------------------------------------------------------------------
C
      NUMCHR = STRING_LEN (STRING)
      DO I = 1,NUMCHR
        ICHR = ICHAR(STRING(I:I))
        IF(ICHR.GT.96.AND.ICHR.LT.123) ICHR = ICHR-32
        STRING(I:I) = CHAR(ICHR)
      ENDDO
C
      RETURN
      END
