C  *    TRUSLIB.SUBS: SUBROUTINES SUPPLIED BY BENES TRUS, MARCH 1989, NIH.
C
      SUBROUTINE TRUS_POLYS (AMPS, IPEAKX, IPEAKY, PEAKX, PEAKY)
C
C      QUADRATIC FIT SUBROUTINE
      DOUBLE PRECISION X,Y,A,C
      DIMENSION X(5),Y(5),A(20),C(3),AMPS(15,15)
      REAL*4 PEAKX, PEAKY
      INTEGER*2 IPEAKX, IPEAKY
C  ----------------------------------------------------------------------------
C
      N      = 2
      M      = 5
      AMPSMX = -999.
      DO J = 1,15
        DO I = 1,15
          IF(AMPS(I,J).GT.AMPSMX) THEN
            AMPSMX = AMPS(I,J)
            IMX    = I
            JMX    = J
          ENDIF
        ENDDO
      ENDDO
      II=0
      DO I=IMX-2,IMX+2
        II=II+1
        Y(II)=AMPS(max(1,I),JMX)            !  bug fix sdf 5may93
        X(II)=REAL(I+(IPEAKX-8))
      ENDDO
C      DO I = 1,5
C        TYPE *, I, X(I), Y(I)
C      ENDDO
      CALL TRUS_SOLVE (M, X, Y, N, C, IFLAG, A)
      IF(IFLAG.NE.1) WRITE(5,8)IFLAG
8      FORMAT(' ERROR RETURN FROM TRUS_SOLVE',I5)
C      WRITE(5,9)(C(I),I=1,3)
C9      FORMAT(' C:',3F16.6)
      if(C(2).eq.0.0) then      ! bug fix 5may93
            PEAKX = 0
      else
            PEAKX = REAL((-C(2))/2./C(1))
      end if
C      WRITE(5,'('' X MAXIMUM ='',F)') PEAKX
C
      DO I=1,15
        A(I)=0.0
      ENDDO
      C(1)=0.
      C(2)=0.
      C(3)=0.
      II=0
      DO I=JMX-2,JMX+2
        II=II+1
        Y(II)=AMPS(IMX,max(1,I))            ! bug fix sdf 5may93
        X(II)=REAL(-(8-IPEAKY)+I)
      ENDDO
C      DO I = 1,5
C        TYPE *, I, X(I), Y(I)
C      ENDDO
      CALL TRUS_SOLVE (M, X, Y, N, C, IFLAG, A)
      IF(IFLAG.NE.1) WRITE(5,8)IFLAG
C      WRITE(5,9)(C(I),I=1,3)
      if(C(2).eq.0.0) then      ! bug fix 5may93
            PEAKY = 0
      else
            PEAKY = REAL((-C(2))/2./C(1))
      end if
C      WRITE(5,'('' Y MAXIMUM ='',F)') PEAKY
C
      RETURN
      END

C       SUBROUTINE TRUS_SOLVE
C
C                 LEAST SQUARES REGRESSION
C   PURPOSE
C
C   TO FIT A POLYNOMIAL OF DEGREE N TO M OBSERVATIONS BY THE METHOD OF
C   LEAST SQUARES.
C
C   ACCURACY
C
C   ALL CALCULATIONS ARE CARRIED OUT IN SINGLE-PRECISION FLOATING-POINT
C   ARITHMETIC, WITH 23 SIGNIFICANT BINARY DIGITS IN THE ARGUMENT, PLUS
C   A SIGN BIT AND AN 8-BIT CHARACTERISTIC.
C
C   CALLING SEQUENCE
C
C   CALL TRUS_SOLVE (M,X,Y,N,C,IFLAG,A)
C
C
C  ARGUMENTS
C
C        ARGUMENT    USE         DESCRIPTION
C
C        M           INPUT       NUMBER OF OBSERVATIONS (X(I),Y(I))
C                                WHERE I=1,...,M.
C        X           INPUT       INDEPENDENT VARIABLE VALUES WHERE X
C                                IS AN ARRAY OF DIMENSION M.
C        Y           INPUT       DEPENDENT VARIABLE VALUES WHERE Y
C                                IS AN ARRAY OF DIMENSION M.
C        N           INPUT       ORDER OF POLYNOMIAL
C        C           OUTPUT      COEFFICIENTS OF POLYNOMIAL OF FORM
C                                     N      N-1
C                                C(1)X +C(2)X   +...+C(N)X+C(N+1).
C        IFLAG       OUTPUT      COMMUNICATION FLAG
C                                1=POLYNOMIAL FOUND.
C                                2 OR 3 =POLYNOMIAL NOT FOUND.
C        A           WORK        WORKING ARRAY OF DIMENSION %N&1<%N&2< )
C                                (EFFECTIVELY MATRIX OF (N&1) ROWS AND
C                                (N&2) COLUMNS).
C
C
C   OTHER SUBROUTINES USED
C
C   TRUS_MATINV (THIS SUBROUTINE IS USED TO SOLVE THE SET OF (N+1)
C   NORMAL EQUATIONS TO OBTAIN THE COEFFICIENTS OF THE
C   REQUIRED POLYNOMIAL - SEE METHOD BELOW)
C
C
C   METHOD
C
C   GIVEN  (X(I),Y(I))  I=1,...,M  APPROXIMATE THE DATA BY A
C   POLYNOMIAL OF DEGREE N<M GIVEN BY-
C   N          N-1
C   P(X)=C(1)X +C(2)X   +...+C(N)X+C(N+1)
C
C   THE COEFFICIENTS C(I) I=1,...,(N+1) ARE DETERMINED SUCH THAT
C   M          2
C   O(C(1),C(2),...,C(N+1))=SUM(P(X(I))-Y(I)) .......(1)
C   I=1
C   IS A MINIMUM.
C
C   DIFFERENTIATING RELATIONSHIP (1) PARTIALLY WITH RESPECT TO EACH
C   OF THE PARAMETERS C(I) I=1,...,(N+1) AND EQUATING TO ZERO, A SET OF
C   (N&1) NORMAL EQUATIONS IS OBTAINED OF THE FORM
C
C   N+1     M    N+K-J+1 M      K
C   SUMC(J)SUMX(I)       =SUMY(I)X(I)   K=0,1,...,N.
C   J=1        I=1       I=1
C
C   SOLVING THIS SET OF (N+1) NORMAL EQUATIONS THE COEFFICIENTS
C   C(1),...,C(N+1) OF THE REQUIRED POLYNOMIAL ARE OBTAINED.
C
C
C   CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      SUBROUTINE TRUS_SOLVE (M,X,Y,N,C,IFLAG,A)
C
C
      INTEGER M
      DOUBLE PRECISION X,Y,A,C,XPWR
      DIMENSION X(M),Y(M),A(20),C(3)
      INTEGER*4 DUMMY(20)
C
C   INITIALIZE PARAMETERS
C      TYPE *,'X',(X(I),I=1,M)
C      TYPE *,'Y',(Y(I),I=1,M)
      N1=N+1
      N2=N1+1
      NXN1=N*N1
      N1PN1=N1+N1
      N1XN1=NXN1+N1
C
C   ARRAY A HAS (N+1) ROWS AND (N+2) COLUMNS AND IS HELD IN COLUMN
C   ORDER
C   CLEAR FIRST ROW AND LAST TWO COLUMNS OF ARRAY A EXCLUDING INITIAL
C   ELEMENT
      I=NXN1+2
      J=N1XN1+2
      K=N2
      DO 10 L=1,N
      A(I)=0.0
      A(J)=0.0
      A(K)=0.0
      I=I+1
      J=J+1
   10 K=K+N1
      A(N1XN1+1)=0.0
C
C   COMPUTE SUMS OF POWERS FOR FIRST ROW AND LAST TWO COLUMNS.
C   SET INITIAL ELEMENT
      A(1)=M
C
C   LOOP FOR NUMBER OF (X,Y) VALUES
      DO 40 I=1,M
C
C   INITIALIZE VALUE AND POWER OF NEXT X
      XPWR=X(I)
C
C   INITIALIZE FIRST ROW, SECOND ELEMENT
      J=N2
C
C   LOOP FOR ELEMENTS 2 TO (N+1) OF FIRST/LAST ROW/COLUMN
      DO 20 K=2,N1
C
C   INCREMENTAL COUNTER FOR LAST COLUMN
      L=N1XN1+K
C
C   INCREMENT NEXT ELEMENT FIRST/LAST ROW/COLUMN
      A(J)=A(J)+XPWR
      A(L)=A(L)+XPWR*Y(I)
      XPWR=XPWR*X(I)
C
C   NEXT ROW ELEMENT
   20 J=J+N1
C
C   LOOP (N+1)TH COLUMN EXCLUDING FIRST ELEMENT
      DO 30 J=2,N1
C
C   INCREMENT COUNTER FOR COLUMN ELEMENT
      K=NXN1+J
C
C   INCREMENT NEXT ELEMENT
      A(K)=A(K)+XPWR
   30 XPWR=XPWR*X(I)
C
C   INCREMENT FIRST ELEMENT LAST COLUMN
   40 A(N1XN1+1)=A(N1XN1+1)+Y(I)
C
C   FILL IN REMAINING N ROWS/COLUMNS OF MATRIX (IE. 2N ELEMENTS)
C   NEXT ROW ELEMENT = ELEMENT PREVIOUS ROW NEXT COLUMN
C
C   ROW LOOP
      DO 50 I=2,N1
C
C   ROW ELEMENT COUNTER
      J=I
C
C   COLUMN LOOP
      DO 50 K=1,N
C
C   IDENTITY ELEMENT INDICATOR
      L=J+N
C
C   EQUATE NEXT ELEMENT
      A(J)=A(L)
C
C   NEXT ELEMENT
   50 J=J+N1
C
C   SOLVE SIMULTANEOUS EQUATIONS FOR POLYNOMIAL COEFFICIENTS
C   SET COLUMN ARGUMENT FOR SUBROUTINE TRUS_MATINV
      NC=-N2
C
C   CALL SUBROUTINE TO SOLVE EQUATIONS
      CALL TRUS_MATINV (IFLAG, I, N1, NC, A, N1, DUMMY, XPWR)
C
C   ARRANGE ANSWER ARRAY
      J=N1XN1+N1
      DO 60 I=1,N1
      C(I)=A(J)
   60 J=J-1
      RETURN
      END

C      SUBROUTINE TRUS_MATINV
C
C                 MATRIX INVERSION, DETERIMINANT, SIMULTANEOUS EQUATIONS
C   PURPOSE
C
C   TO SOLVE SIMULTANEOUS LINEAR EQUATIONS AND TO FIND THE INVERSE
C   (IF REQUIRED) AND THE DETERMINANT OF A REAL MATRIX.
C
C   ACCURACY
C
C   ALL CALCULATIONS ARE CARRIED OUT IN SINGLE-PRECISION FLOATING-POINT
C   ARITHEMTIC, WITH 23 SIGNIFICANT BINARY DIGITS IN THE ARGUMENT, PLUS
C   A SIGN BIT AND AN 8-BIT CHARACTERISTIC.
C
C   CALLING SEQUENCE
C
C           CALL TRUS_MATINV (ISOL, IDSOL, NR, NC, A, MRA, KWA, DET)
C
C
C  ARGUMENTS
C
C        ARGUMENT    USE         DESCRIPTION
C
C        ISOL        OUTPUT      COMMUNICATION FLAG
C                                1=EQUATIONS SOLVED AND INVERSE FOUND
C                                  (IF REQUIRED)
C                                2=UNABLE TO SOLVE
C                                3=INPUT ERROR
C        IDSOL       OUTPUT      DETERMINANT CALCULATION FLAG
C                                1=DID NOT OVERFLOW
C                                2=OVERFLOW
C                                3=DETERMINANT CALCULATION INCOMPLETE
C        NR          INPUT       NUMBER OF ROWS OF INPUT MATRIX A
C        NC          INPUT       ABSOLUTE VALUE IS NUMBER OF COLUMNS
C                                OF INPUT MATRIX A.
C                                IF NC IS NEGATIVE THE INVERSE MATRIX
C                                OF A WILL NOT BE FOUND.
C                                IF THE ABSOLUTE VALUE OF NC IS LESS
C                                THAN OR EQUAL TO NR NO SIMULTANEOUS
C                                EQUATIONS WILL BE SOLVED.
C        A           INPUT       INPUT MATRIX.  FIRST NR COLUMNS FORM
C                                SQUARE MATRIX TO BE INVERTED (IF NC
C                                IS POSITIVE ).  NEXT ABSOLUTE VALUE
C                                OF NC LESS NR COLUMNS ARE CONSTANT
C                                COLUMNS FOR THESE DIFFERENT SETS OF
C                                SIMULTANEOUS EQUATIONS
C                    OUTPUT      RESULT MATRIX.  FIRST NR COLUMNS
C                                FORM INVERSE IF INPUT NC IS POSITIVE,
C                                OTHERWISE THE IDENTITY MATRIX IS
C                                OUTPUT.  REMAINING COLUMNS ARE
C                                CORRESPONDING SOLUTIONS TO THE INPUT
C                                SIMULTANEOUS EQUATIONS SETS.
C        MRA         INPUT       NUMBER OF ROWS RESERVED FOR MATRIX A
C                                IN DIMENSION STATEMENT IN MAIN
C                                PROGRAM.
C        KWA         WORK        WORK ARRAY.  IF NC IS POSITIVE KWA
C                                MUST HAVE DIMENSION NR, OTHERWISE
C                                IT MAY BE A DUMMY VARIABLE.
C        DET         OUTPUT      VALUE OF DETERMINANT ONLY IF ISOL=1.
C
C   IT SHOULD BE CAREFULLY NOTED THAT THE MATRIX A IS STORED IN
C   COLUMN ORDER.
C
C
C   ERRORS
C
C   SEE DEFINITION OF OUTPUT ARGUMENTS ISOL AND IDSOL.
C
C
C   METHOD
C
C   CONSIDER THE LINEAR SIMULTANEOUS EQUATIONS IN THE UNKNOWNS X(I)
C   I=1,...,N
C   A(1,1)X(1)+A(1,2)X(2)+............+A(1,N)X(N)=B(1)
C   .          .                       .          .
C   .          .                       .          .
C   .          .                       .          .
C   A(N,1)X(1)+A(N,2)X(2)+............+A(N,N)X(N)=B(N)
C
C   WHOSE SOLUTIONS ARE REQUIRED TOGETHER WITH THE VALUE OF THE
C   DETERMINANT OF AND THE INVERSE MATRIX OF (OPTIONAL) THE MATRIX
C   GIVEN BY A(I,J)  I=1,...,NOJ=1,...,N.
C
C   THE FOLLOWING PROCESS IS PERFORMED COMMENCING WITH THE FIRST ROW
C   OF THE MATRIX AB AND CONTINUING FOR EACH SUBSEQUENT ROW UNTIL ALL
C   N ROWS HAVE BEEN PROCESSED (AB REPRESENTS THE MATRIX A AUGMENTED
C   BY THE EQUATION CONSTANTS B(I) I=1,...,N FORMING THE (N+1)TH
C   COLUMN OF AB)-
C
C   1.REARRANGE THE MATRIX AB SO THAT FOR THE ITH ROW BEING
C   PROCESSED THE DIAGONAL ELEMENT A(I,I) IS GREATER THAN OR
C   EQUAL TO ALL A(K,I) FOR K=I+1,...,N.
C   IF REARRANGFMENT IS NECESSARY INFORMATION RELATING TO THE
C   INTERCHANGED ROWS IS STORED SO THAT THE FINAL INVERSE
C   MATRIX A CAN BE REARRANGED TO THE ORIGINAL ROW ORDER OF
C   THE MATRIX A.
C   THE DETERMINANT VALUE (AT INITIALISATION 1.0) IS MULTIPLIED
C   BY THE DIAGONAL ELEMENT AND ITS SIGN CHANGED IF REARRANGE-
C   -MENT WAS NECESSARY.
C
C   2.AFTER STORING THE INVERSE OF THE DIAGONAL ELEMENT FOR THE
C   ROW BEING PROCESSED THE DIAGONAL ELEMENT IS GIVEN THE VALUE
C   1.0 AND THE ROW MULTIPLIED BY THE STORED VALUE OF THE
C   INVERSE OF THE DIAGONAL ELEMENT.
C
C   3.FOR THE ITH ROW BEING PROCESSED THE FOLLOWING IS PERFORMED
C   ON ALL OTHER ROWS J=1,...,I-1,I+1,...,N
C   SET A(J,I)=0.0
C   SET A(J,K)=A(J,K)-A(J,I)*A(I,K)        K=1,...,N+1
C
C   WHEN ALL ROWS HAVE BEEN PROCESSED THE INVERSE MATRIX IS REARRANGED
C   APPROPRIATELY.
C   NOTE THAT IF THE INVERSE MATRIX IS NOT REQUIRED THE ABOVE
C   PROCESSING IS MODIFIED SO THAT THE RESULTING MATRIX A IS THE
C   IDENTITY MATRIX.
C
C
C   CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      SUBROUTINE TRUS_MATINV (ISOL, IDSOL, NR, NC, A, MRA, KWA, DET)
C
      INTEGER*4 ISOL, IDSOL, NR, NC, KWA(20)
      DOUBLE PRECISION A(20), PSTO, DET
C
C   INITIALIZE OVERFL
C      CALL OVERFL (IFR)
C      GO TO (5,5) ,IER
C
C   INITIALIZE PARAMETERS AND TEST INPUT
      ISOL=1
      IDSOL=1
      IF (NR.LE.0) GO TO 250
      IF (NR.GT.MRA) GO TO 250
      IC=IABS(NC)
      IF (IC.LT.NR)      IC=NR
      MRAP1=MRA+1
      LM = NR*MRA
      LEQ=IC*MRA
      IF (NC) 10,250,20
   10 MDIV=MRA+1
      NRIC=NR-IC
      GO TO 30
   20 MDIV=1
   30 MAD=MDIV
      MSER=1
      KSER=NR
      MZ=1
      DET=1.0
C
C   TEST FOR PIVOT ELEMENT OF NEXT COLUMN
   40 PIV=0.0
      I=MSER
C
C   TEST ALL COLUMN ELEMENTS COMPARED
   50 IF (I.GT.KSER) GO TO 70
C
C   COMPARE COLUMN ELEMENTS AND STORE ABSOLUTE VALUE OF GREATEST
      IF (ABS(A(I)).LE.PIV) GO TO 60
      PIV=REAL(ABS(A(I)))
      IP=I
   60 I=I+1
      GO TO 50
C
C   TEST ALL COLUMN ELEMENTS NOT ZERO
   70 IF (PIV.EQ.0.0) GO TO 260
C
C   TEST INVERSE MATRIX REQUIRED
      IF (NC.LT.0) GO TO 80
C
      I=IP-((IP-1)/MRA)*MRA
      J=MSER-((MSER-1)/MRA)*MRA
      JJ=MSER/MRAP1+1
      II=JJ+(IP-MSER)
      KWA(JJ)=II
      GO TO 90
C
C   SET ROW INTERCHANGE PARAMETERS FROM DIAGONAL ELEMENT-INVERSE
C   NOT REQUIRED
   80 I=IP
      J=MSER
C
C   TEST PIVOT ELEMENT IS DIAGONAL ELEMENT-NO ROW INTERCHANGE
C   NECESSARY
   90      IF (IP.EQ.MSER) GO TO 120
C
C   TEST INTERCHANGE COMPLETE
  100      IF (J.GT.LEQ) GO TO 110
C
C   INTERCHANGE ROWS
      PSTO=A(I)
      A(I)=A(J)
      A(J)=PSTO
      I=I+MRA
      J=J+MRA
      GO TO 100
C
C   AMEND SIGN OF DETERMINANT
  110 DET=-DET
C
C   MULTIPLY DETERMINANT BY VALUE OF NEXT DIAGONAL ELEMENT
  120 PSTO=A(MSER)
      DET=DET*PSTO
C
C   TEST DETERMINANT OVERFLOW
C      CALL OVERFL (IER)
C      GO TO (124,125),IER
C
C   DETERMINANT OVERFLOW
C  124 IDSOL=2
C
C   NO DETERMINANT OVERFLOW
C   CALCULATE INVERSE OF DIAGONAL ELEMENT AND TEST FOR ERROR
  125 PSTO=1.0/PSTO
C      CALL OVERFL(IER)
C      GO TO (127,128),IER
C
C   ERROR
C  127 ISOL=2
C      IDSOL=3
C      RETURN
C
C   NO ERROR,SET DIAGONAL ELEMENT TO ONE
  128 A(MSER)=1.0
      I=MDIV
C
C   MULTIPLY CURRENT ROW ELEMENTS BY STORED INVERSE OF
C   DIAGONAL ELEMENT
C
C   TEST ALL ROW ELEMENTS MULTIPLIED BY DIAGONAL ELEMENT
  130 IF (I.GT.LEQ) GO TO 140
      A(I)=A(I)*PSTO
      I=I+MRA
      GO TO 130
C
C   ADJUST REMAINING ROWS
C
C   TEST ALL ROWS ADJUSTED
  140 IF (MZ.GT.KSER) GO TO 170
C
C   TEST SAME ROW AS DIAGONAL ELEMENT
      IF (MZ.EQ.MSER) GO TO 160
      I=MAD
      J=MDIV
      PSTO=A(MZ)
      IF(PSTO.EQ.0.0) GO TO 160
      A(MZ)=0.0
C
C   TEST END OF ROW
  150 IF (J.GT.LEQ) GO TO 160
      A(I)=A(I)-A(J)*PSTO
      J=J+MRA
      I=I+MRA
      GO TO 150
C
C   NEXT ROW
  160 MAD=MAD+1
      MZ=MZ+1
      GO TO 140
C
C   TEST FOR ERROR
170      CONTINUE
C  170 CALL OVERFL (IER)
C      GO TO (127,172),IER
C
C   NO ERROR
C   TEST FOR END OF ROW PROCESSING
  172 KSER=KSER+MRA
      IF (KSER.GT.LM) GO TO 210
C
C   NEXT DIAGONAL ELEMENT
      MSER=MSER+MRAP1
C
C   TEST INVERSE MATRIX REQUIRED
      IF (NC.LT.0) GO TO 180
C
C   REINITIALIZE FOR NEXT ROW WHEN INVERSE MATRIX REQUIRED
      MDIV=MDIV+1
      MZ= ((MSER-1)/MRA)*MRA+1
      MAD=1
      GO TO 40
C
C   REINITIALIZE FOR NEXT ROW WHEN INVERSE MATRIX NOT REQUIRED
  180 MDIV=MDIV+MRAP1
      IF (NRIC.NE.0) GO TO 190
      MZ=MSER+1
      GO TO 200
  190 MZ=((MSER-1)/MRA)*MRA+1
  200 MAD=MZ+MRA
      GO TO 40
C
C   TEST IF INVERSE REQUIRED
  210 IF (NC.LT.0)  RETURN
C
C   REARRANGE ROWS FOR INVERSE MATRIX
      JR=NR
  220 IF(JR.EQ.0)  RETURN
      IF(KWA(JR).EQ.JR) GO TO 240
      K= (JR-1)*MRA
      J=K+NR
      L= (KWA(JR)-1)*MRA+NR
  230 IF (J.EQ.K) GO TO 240
      PSTO=A(L)
      A(L)=A(J)
      A(J)=PSTO
      J=J-1
      L=L-1
      GO TO 230
  240 JR=JR-1
      GO TO 220
C
C   INPUT ERROR
  250 ISOL=3
      IDSOL=3
      RETURN
C
C   NO SOLUTION
  260 DET=0.0
      ISOL=2
      RETURN
      END

C ----------------------------------------------------------------------- 
C *                                                      *
C *      SET UP THE FUNCTION TO FIT:  AX + BY + C.                  *
C *      EVERY PIXEL (FXY) WHICH IS INSIDE THE CRITICAL RADIUS         *
C *      IS FIGURED INTO THIS CALCULATION.                        *
C *                                                      *
C *      LAST MODIFIED: 15th June, 1990  by nrd@bragg.bio.purdue.edu      *
C ----------------------------------------------------------------------- 

      SUBROUTINE TRUS_PLYFIT (IX, IY, FXY)

      IMPLICIT NONE

      INTEGER*4 NFIT, NNFIT, ITEST, IX, IY, I, J
      DOUBLE PRECISION Q, G, X, Y, FXY, H
      COMMON /FITTER/Q(20,20),H(20)
      DIMENSION G(20)
      COMMON /PARAM/NFIT,NNFIT
      DATA ITEST/0/
C -----------------------------------------------------------------------
      IF(ITEST.EQ.1)PRINT *,'FXY',FXY !RSS TYPE --> PRINT
C      IF(ITEST.EQ.1)PRINT *,' IX,IY,FXY',IX,IY,FXY !RSS TYPE --> PRINT
      X=REAL(IX)
      Y=REAL(IY)
      G(1)=X
      G(2)=Y
      G(3)=1.D0
      DO 2 I=1,NFIT
      DO 2 J=1,NFIT
      Q(I,J)=Q(I,J)+G(I)*G(J)
2      CONTINUE
      DO 3 I=1,2
      IF(ITEST.EQ.1) THEN 
        PRINT *,'Q',(Q(I,1))!RSS TYPE --> PRINT
        PRINT *,'Q',(Q(I,2))!RSS TYPE --> PRINT
      ENDIF
3      CONTINUE
      DO 1 I=1,NFIT
      H(I)=H(I)+G(I)*FXY
      IF(ITEST.EQ.1)PRINT *,'I,G(I),H(I)',I,G(I),H(I) !RSS TYPE --> PRINT
1      CONTINUE

      RETURN
      END


C ----------------------------------------------------------------------- 
C *                                                      *
C *      USE FUNCTION TO CORRECT IMAGE (SUBTRACT BACKGROUND GRADIENT)      *
C *      BEFORE DATA IS REWRITTEN TO FILE.                        *
C *                                                      *
C *      LAST MODIFIED:      15th June, 1990  by nrd@bragg.bio.purdue.edu      *
C ----------------------------------------------------------------------- 

      SUBROUTINE TRUS_PLYOUT (IX, IY, FXY)

      IMPLICIT NONE

      INTEGER*4 IX, IY, I, NFIT, NNFIT
      DOUBLE PRECISION X, Y, FXY, G(20), SUM, T
      COMMON /FITOUT/T(20,21)
      COMMON /PARAM/NFIT,NNFIT
C ---------------------------------------------------------------------
      SUM=0.
      X=REAL(IX)
      Y=REAL(IY)
      G(1)=X
      G(2)=Y
      G(3)=1.D0
      DO I=1,NFIT
        SUM=SUM+G(I)*T(I,NNFIT)
      ENDDO
      FXY=FXY-SUM

      RETURN
      END


C ----------------------------------------------------------------------- 
C
C    TITLE   MATDBL
C                 MATRIX INVERSION, DETERIMINANT, SIMULTANEOUS EQUATIONS
C   PURPOSE
C
C   TO SOLVE SIMULTANEOUS LINEAR EQUATIONS AND TO FIND THE INVERSE
C   (IF REQUIRED) AND THE DETERMINANT OF A REAL MATRIX.
C
C   ACCURACY
C
C   ALL CALCULATIONS ARE CARRIED OUT IN SINGLE-PRECISION FLOATING-POINT
C   ARITHEMTIC, WITH 23 SIGNIFICANT BINARY DIGITS IN THE ARGUMENT, PLUS
C   A SIGN BIT AND AN 8-BIT CHARACTERISTIC.
C
C   CALLING SEQUENCE
C
C           CALL MATDBL(ISOL,IDSOL,NR,NC,A,MRA,KWA,DET)
C
C
C  ARGUMENTS
C
C        ARGUMENT    USE         DESCRIPTION
C
C        ISOL        OUTPUT      COMMUNICATION FLAG
C                                1=EQUATIONS SOLVED AND INVERSE FOUND
C                                  (IF REQUIRED)
C                                2=UNABLE TO SOLVE
C                                3=INPUT ERROR
C        IDSOL       OUTPUT      DETERMINANT CALCULATION FLAG
C                                1=DID NOT OVERFLOW
C                                2=OVERFLOW
C                                3=DETERMINANT CALCULATION INCOMPLETE
C        NR          INPUT       NUMBER OF ROWS OF INPUT MATRIX A
C        NC          INPUT       ABSOLUTE VALUE IS NUMBER OF COLUMNS
C                                OF INPUT MATRIX A.
C                                IF NC IS NEGATIVE THE INVERSE MATRIX
C                                OF A WILL NOT BE FOUND.
C                                IF THE ABSOLUTE VALUE OF NC IS LESS
C                                THAN OR EQUAL TO NR NO SIMULTANEOUS
C                                EQUATIONS WILL BE SOLVED.
C        A           INPUT       INPUT MATRIX.  FIRST NR COLUMNS FORM
C                                SQUARE MATRIX TO BE INVERTED (IF NC
C                                IS POSITIVE ).  NEXT ABSOLUTE VALUE
C                                OF NC LESS NR COLUMNS ARE CONSTANT
C                                COLUMNS FOR THESE DIFFERENT SETS OF
C                                SIMULTANEOUS EQUATIONS
C                    OUTPUT      RESULT MATRIX.  FIRST NR COLUMNS
C                                FORM INVERSE IF INPUT NC IS POSITIVE,
C                                OTHERWISE THE IDENTITY MATRIX IS
C                                OUTPUT.  REMAINING COLUMNS ARE
C                                CORRESPONDING SOLUTIONS TO THE INPUT
C                                SIMULTANEOUS EQUATIONS SETS.
C        MRA         INPUT       NUMBER OF ROWS RESERVED FOR MATRIX A
C                                IN DIMENSION STATEMENT IN MAIN
C                                PROGRAM.
C        KWA         WORK        WORK ARRAY.  IF NC IS POSITIVE KWA
C                                MUST HAVE DIMENSION NR, OTHERWISE
C                                IT MAY BE A DUMMY VARIABLE.
C        DET         OUTPUT      VALUE OF DETERMINANT ONLY IF ISOL=1.
C
C   IT SHOULD BE CAREFULLY NOTED THAT THE MATRIX A IS STORED IN
C   COLUMN ORDER.
C
C
C   ERRORS
C
C   SEE DEFINITION OF OUTPUT ARGUMENTS ISOL AND IDSOL.
C
C
C   METHOD
C
C   CONSIDER THE LINEAR SIMULTANEOUS EQUATIONS IN THE UNKNOWNS X(I)
C   I=1,...,N
C   A(1,1)X(1)+A(1,2)X(2)+............+A(1,N)X(N)=B(1)
C   .          .                       .          .
C   .          .                       .          .
C   .          .                       .          .
C   A(N,1)X(1)+A(N,2)X(2)+............+A(N,N)X(N)=B(N)
C
C   WHOSE SOLUTIONS ARE REQUIRED TOGETHER WITH THE VALUE OF THE
C   DETERMINANT OF AND THE INVERSE MATRIX OF (OPTIONAL) THE MATRIX
C   GIVEN BY A(I,J)  I=1,...,NOJ=1,...,N.
C
C   THE FOLLOWING PROCESS IS PERFORMED COMMENCING WITH THE FIRST ROW
C   OF THE MATRIX AB AND CONTINUING FOR EACH SUBSEQUENT ROW UNTIL ALL
C   N ROWS HAVE BEEN PROCESSED (AB REPRESENTS THE MATRIX A AUGMENTED
C   BY THE EQUATION CONSTANTS B(I) I=1,...,N FORMING THE (N+1)TH
C   COLUMN OF AB)-
C
C   1.REARRANGE THE MATRIX AB SO THAT FOR THE ITH ROW BEING
C   PROCESSED THE DIAGONAL ELEMENT A(I,I) IS GREATER THAN OR
C   EQUAL TO ALL A(K,I) FOR K=I+1,...,N.
C   IF REARRANGFMENT IS NECESSARY INFORMATION RELATING TO THE
C   INTERCHANGED ROWS IS STORED SO THAT THE FINAL INVERSE
C   MATRIX A CAN BE REARRANGED TO THE ORIGINAL ROW ORDER OF
C   THE MATRIX A.
C   THE DETERMINANT VALUE (AT INITIALISATION 1.0) IS MULTIPLIED
C   BY THE DIAGONAL ELEMENT AND ITS SIGN CHANGED IF REARRANGE-
C   MENT WAS NECESSARY.
C
C   2.AFTER STORING THE INVERSE OF THE DIAGONAL ELEMENT FOR THE
C   ROW BEING PROCESSED THE DIAGONAL ELEMENT IS GIVEN THE VALUE
C   1.0 AND THE ROW MULTIPLIED BY THE STORED VALUE OF THE
C   INVERSE OF THE DIAGONAL ELEMENT.
C
C   3.FOR THE ITH ROW BEING PROCESSED THE FOLLOWING IS PERFORMED
C   ON ALL OTHER ROWS J=1,...,I-1,I+1,...,N
C   SET A(J,I)=0.0
C   SET A(J,K)=A(J,K)-A(J,I)*A(I,K)        K=1,...,N+1
C
C   WHEN ALL ROWS HAVE BEEN PROCESSED THE INVERSE MATRIX IS REARRANGED
C   APPROPRIATELY.
C   NOTE THAT IF THE INVERSE MATRIX IS NOT REQUIRED THE ABOVE
C   PROCESSING IS MODIFIED SO THAT THE RESULTING MATRIX A IS THE
C   IDENTITY MATRIX.
C
C
C ----------------------------------------------------------------------- 
C
C
      SUBROUTINE TRUS_MATDBL (ISOL, IDSOL, NR, NC, A, MRA, KWA, DET)

      IMPLICIT NONE

      INTEGER*4 IER, ISOL, IDSOL, NR, NC, MRA, IC, MRAP1
      INTEGER*4 LM, LEQ, MDIV, NRIC, MAD, MSER, KSER, MZ, I 
      INTEGER*4 IP, J, JJ, II, JR, K, L, KWA(20)
      DOUBLE PRECISION A(1),PIV,PSTO,DET
C
C   INITIALIZE OVERFL
C      CALL OVERFL (IFR)
      IER=2
      GO TO (5,5) ,IER
C
C   INITIALIZE PARAMETERS AND TEST INPUT
    5 ISOL=1
      IDSOL=1
      IF (NR.LE.0) GO TO 250
      IF (NR.GT.MRA) GO TO 250
      IC=IABS(NC)
      IF (IC.LT.NR)      IC=NR
      MRAP1=MRA+1
      LM = NR*MRA
      LEQ=IC*MRA
      IF (NC) 10,250,20
   10 MDIV=MRA+1
      NRIC=NR-IC
      GO TO 30
   20 MDIV=1
   30 MAD=MDIV
      MSER=1
      KSER=NR
      MZ=1
      DET=1.0D0
C
C   TEST FOR PIVOT ELEMENT OF NEXT COLUMN
   40 PIV=0.0D0
      I=MSER
C
C   TEST ALL COLUMN ELEMENTS COMPARED
   50 IF (I.GT.KSER) GO TO 70
C
C   COMPARE COLUMN ELEMENTS AND STORE ABSOLUTE VALUE OF GREATEST
      IF (ABS(A(I)).LE.PIV) GO TO 60
      PIV=ABS(A(I))
      IP=I
   60 I=I+1
      GO TO 50
C
C   TEST ALL COLUMN ELEMENTS NOT ZERO
   70 IF (PIV.EQ.0.0) GO TO 260
C
C   TEST INVERSE MATRIX REQUIRED
      IF (NC.LT.0) GO TO 80
C
      I=IP-((IP-1)/MRA)*MRA
      J=MSER-((MSER-1)/MRA)*MRA
      JJ=MSER/MRAP1+1
      II=JJ+(IP-MSER)
      KWA(JJ)=II
      GO TO 90
C
C   SET ROW INTERCHANGE PARAMETERS FROM DIAGONAL ELEMENT-INVERSE
C   NOT REQUIRED
   80 I=IP
      J=MSER
C
C   TEST PIVOT ELEMENT IS DIAGONAL ELEMENT-NO ROW INTERCHANGE
C   NECESSARY
   90 IF (IP.EQ.MSER) GO TO 120
C
C   TEST INTERCHANGE COMPLETE
  100 IF (J.GT.LEQ) GO TO 110
C
C   INTERCHANGE ROWS
      PSTO=A(I)
      A(I)=A(J)
      A(J)=PSTO
      I=I+MRA
      J=J+MRA
      GO TO 100
C
C   AMEND SIGN OF DETERMINANT
  110 DET=-DET
C
C   MULTIPLY DETERMINANT BY VALUE OF NEXT DIAGONAL ELEMENT
  120 PSTO=A(MSER)
C      DET=DET*PSTO/100.D0
C
C   TEST DETERMINANT OVERFLOW
C      CALL OVERFL (IER)
      IER=2
      GO TO (124,125),IER
C
C   DETERMINANT OVERFLOW
  124 IDSOL=2
C
C   NO DETERMINANT OVERFLOW
C   CALCULATE INVERSE OF DIAGONAL ELEMENT AND TEST FOR ERROR
  125 PSTO=1.0/PSTO
C      CALL OVERFL(IER)
      IER=2
      GO TO (127,128),IER
C
C   ERROR
  127 ISOL=2
      IDSOL=3
      RETURN
C
C   NO ERROR,SET DIAGONAL ELEMENT TO ONE
  128 A(MSER)=1.0D0
      I=MDIV
C
C   MULTIPLY CURRENT ROW ELEMENTS BY STORED INVERSE OF
C   DIAGONAL ELEMENT
C
C   TEST ALL ROW ELEMENTS MULTIPLIED BY DIAGONAL ELEMENT
  130 IF (I.GT.LEQ) GO TO 140
      A(I)=A(I)*PSTO
      I=I+MRA
      GO TO 130
C
C   ADJUST REMAINING ROWS
C
C   TEST ALL ROWS ADJUSTED
  140 IF (MZ.GT.KSER) GO TO 170
C
C   TEST SAME ROW AS DIAGONAL ELEMENT
      IF (MZ.EQ.MSER) GO TO 160
      I=MAD
      J=MDIV
      PSTO=A(MZ)
      IF(PSTO.EQ.0.0) GO TO 160
      A(MZ)=0.0D0
C
C   TEST END OF ROW
  150 IF (J.GT.LEQ) GO TO 160
      A(I)=A(I)-A(J)*PSTO
      J=J+MRA
      I=I+MRA
      GO TO 150
C
C   NEXT ROW
  160 MAD=MAD+1
      MZ=MZ+1
      GO TO 140
C
C   TEST FOR ERROR
C  170 CALL OVERFL (IER)
170      CONTINUE
      IER=2
      GO TO (127,172),IER
C
C   NO ERROR
C   TEST FOR END OF ROW PROCESSING
  172 KSER=KSER+MRA
      IF (KSER.GT.LM) GO TO 210
C
C   NEXT DIAGONAL ELEMENT
      MSER=MSER+MRAP1
C
C   TEST INVERSE MATRIX REQUIRED
      IF (NC.LT.0) GO TO 180
C
C   REINITIALIZE FOR NEXT ROW WHEN INVERSE MATRIX REQUIRED
      MDIV=MDIV+1
      MZ= ((MSER-1)/MRA)*MRA+1
      MAD=1
      GO TO 40
C
C   REINITIALIZE FOR NEXT ROW WHEN INVERSE MATRIX NOT REQUIRED
  180 MDIV=MDIV+MRAP1
      IF (NRIC.NE.0) GO TO 190
      MZ=MSER+1
      GO TO 200
  190 MZ=((MSER-1)/MRA)*MRA+1
  200 MAD=MZ+MRA
      GO TO 40
C
C   TEST IF INVERSE REQUIRED
  210 IF (NC.LT.0)  RETURN
C
C   REARRANGE ROWS FOR INVERSE MATRIX
      JR=NR
  220 IF(JR.EQ.0)  RETURN
      IF(KWA(JR).EQ.JR) GO TO 240
      K= (JR-1)*MRA
      J=K+NR
      L= (KWA(JR)-1)*MRA+NR
  230 IF (J.EQ.K) GO TO 240
      PSTO=A(L)
      A(L)=A(J)
      A(J)=PSTO
      J=J-1
      L=L-1
      GO TO 230
  240 JR=JR-1
      GO TO 220
C
C   INPUT ERROR
  250 ISOL=3
      IDSOL=3
      RETURN
C
C   NO SOLUTION
  260 DET=0.0D0
      ISOL=2
      RETURN
      END

