#!/usr/bin/perl
use strict;
use warnings;
use File::Copy;

my $dist = $ARGV[0];

mkdir $dist;
mkdir "$dist/DOC";
mkdir "$dist/ctfniko";
mkdir "$dist/POR";
mkdir "$dist/PCUT";
mkdir "$dist/PSF";
mkdir "$dist/P3DR";
mkdir "$dist/PCTFR";
mkdir "$dist/PPFT";
mkdir "$dist/libCommpk";
mkdir "$dist/libCompar";
mkdir "$dist/libVfftpk";
mkdir "$dist/libR";
mkdir "$dist/libDIERCKX";
mkdir "$dist/lib3DAll";
mkdir "$dist/libEMF";
mkdir "$dist/include";
mkdir "$dist/UTILS";
mkdir "$dist/bin";
mkdir "$dist/bin/modules";
mkdir "$dist/convert";
mkdir "$dist/conway_tiff2pif";
mkdir "$dist/ctfdisp";
mkdir "$dist/em_tools";
mkdir "$dist/fixpif";
mkdir "$dist/oned";
mkdir "$dist/pftprj";
mkdir "$dist/robem";
mkdir "$dist/bitmaps";

copy("README", "$dist/README");
copy("MINOR_RELEASE_NOTES", "$dist/MINOR_RELEASE_NOTES");
copy("make.inc.parallel", "$dist/make.inc.parallel");
copy("make.inc.serial", "$dist/make.inc.serial");
copy("make.inc.common", "$dist/make.inc.common");
copy("make_all", "$dist/make_all");
copy("clean_all", "$dist/clean_all");
copy("config_test.pl", "$dist/config_test.pl");
copy("license.txt", "$dist/license.txt");

my @dirlist = qw(DOC bin POR PCUT PSF P3DR PPFT PCTFR
		 bin/modules libCommpk libCompar libVfftpk include
		 ctfniko convert conway_tiff2pif ctfdisp em_tools
		 UTILS fixpif oned pftprj robem bitmaps
		 libR libDIERCKX libEMF lib3DAll );

foreach my $dir (@dirlist) {

    my @filelist = <${dir}/*.f>;
    push @filelist, <${dir}/*.F>;
    push @filelist, <${dir}/*.c>;
    push @filelist, <${dir}/*.h>;
    push @filelist, <${dir}/*.apx>;
    push @filelist, <${dir}/*.mdoc>;
    push @filelist, <${dir}/*.cmm>;
    push @filelist, <${dir}/*.xbm>;
    push @filelist, <${dir}/*.bit>;
    push @filelist, <${dir}/*.txt>;
    push @filelist, <${dir}/*.uil>;
    push @filelist, <${dir}/*.uih>;
    push @filelist, <${dir}/*.pdf>;
    push @filelist, <${dir}/*.htm>;
    push @filelist, <${dir}/*.mscp>;
    push @filelist, <${dir}/*.inc>;
    push @filelist, <${dir}/*.pm>;
    push @filelist, <${dir}/*.pl>;
    push @filelist, "${dir}/Makefile";
    
    foreach my $oldfile (@filelist) {
	my $newfile = "$dist/$oldfile";
	copy($oldfile, $newfile);
    }
    
}

# Make perl files, make_all, and make_clean executable
my @perlfiles = (<$dist/bin/*.pl>, <$dist/*.pl>);
chmod 0755, "$dist/make_all", "$dist/clean_all", @perlfiles;

# Create symbolic links for perl scripts
my $startdir = `pwd`;
chdir "$dist/bin";
foreach my $perlscript (<*.pl>) {
    my $link = $perlscript;
    $link =~ s/\.pl//;
    symlink $perlscript, $link;
}

chdir $startdir;
