#ifndef _3D_GRAPHICS_H_
#define _3D_GRAPHICS_H_
#define MAX3D 20

typedef struct {
  float sx,sy;     /* Screen coordinates */
  float lx,ly,lz;  /* Local coordinates */
  float wx,wy,wz;  /* World coordinates */
}point_type;

typedef struct {
  unsigned int x,y,z;
  unsigned int hidden;
  unsigned int color;
} face_type;

typedef struct {
  point_type vertex[MAX3D];
  face_type faces[MAX3D];
  float dx,dy,dz; /* It's position releative to (0,0,0) */
  float sx,sy,sz; /* Scale factors */
  float angx,angy,angz; /* Rotation for object */
  float wangx,wangy,wangz;
  unsigned int num_points,num_faces;
} object_type;

object_type icosabox;
int icosdist;

float scncord(float x,float z,float dist);
void rotx(float *y,float *z,float xang);
void roty(float *x,float *z,float yang);
void rotz(float *x,float *y,float zang);
void init_vertices();
void Convert3d_to_scrcords();
void print_verticies();
void scale_verticies(float scale);
void translate_verticies(float translatex, float translatey);

#endif
