#include "gui.h"

static void backgroundMode_change(Widget w, XtPointer client_data,
				  XtPointer call_data) {
  backgroundMode = *((int *) client_data);
}

static void featherMode_change(Widget w, XtPointer client_data,
			       XtPointer call_data) {
  featherMode = *((int *) client_data);
}



void create_appodizescreen () {
  // function name: create_appodizescreen
  // Create and initialize attributes of appodization screen

  int *tag1, *tag2, *tag3, *tag4, *tag5, *tag6, *tag7, *tag8;
  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));
  tag3 = (int *) malloc(sizeof(int));
  tag4 = (int *) malloc(sizeof(int));
  tag5 = (int *) malloc(sizeof(int));
  tag6 = (int *) malloc(sizeof(int));
  tag7 = (int *) malloc(sizeof(int));
  tag8 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Appodize Params"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 500);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNwidth, 500);
  XtSetArg(arglst[7], XmNheight, 400);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  appodizeScreenW = XmCreateFormDialog(toplevel_widget, "appod", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 360);
  appodizeExitW = XmCreatePushButton(appodizeScreenW, "appod_exit", arglst, 5);
  XtAddCallback(appodizeExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(appodizeExitW);
  
  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 70);
  XtSetArg(arglst[4], XmNy, 360);
  appodizeHelpW = XmCreatePushButton(appodizeScreenW, "appod_help", arglst, 5);
  *tag1 = APPODIZEHELP;
  XtAddCallback(appodizeHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(appodizeHelpW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Do It"));
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 360);
  appodizeDoW = XmCreatePushButton(appodizeScreenW, "appod_do", arglst, 3);
  XtAddCallback(appodizeDoW, XmNactivateCallback, appodize_activate, NULL);
  XtManageChild(appodizeDoW);
  
  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 390);
  XtSetArg(arglst[2], XmNy, 60);
  appodBoxRadW = XmCreateText(appodizeScreenW, "appod_boxr", arglst, 3);
  XtManageChild(appodBoxRadW);
  XmTextSetString(appodBoxRadW, "9999");
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Border Width:"));
  XtSetArg(arglst[1], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNrightWidget, appodBoxRadW);
  XtSetArg(arglst[3], XmNy, 60);
  appodBoxRadLW = XmCreateLabel(appodizeScreenW, "appod_boxrl", arglst, 4);
  XtManageChild(appodBoxRadLW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 390);
  XtSetArg(arglst[2], XmNy, 100);
  appodFeaRadW = XmCreateText(appodizeScreenW, "appod_fear", arglst, 3);
  XtManageChild(appodFeaRadW);
  XmTextSetString(appodFeaRadW, "9999");

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Final Particle Radius:"));
  XtSetArg(arglst[1], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNrightWidget, appodFeaRadW);
  XtSetArg(arglst[3], XmNy, 100);
  appodFeaRadLW = XmCreateLabel(appodizeScreenW, "appod_fearl", arglst, 4);
  XtManageChild(appodFeaRadLW);


  // ---- Start widgets associated with appodization type selection ----
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Appodize Type:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 15);
  apFeaLabelW = XmCreateLabel(appodizeScreenW, "appod_flabel", arglst, 3);
  XtManageChild(apFeaLabelW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 40);
  apFeaRadioW = XmCreateRadioBox(appodizeScreenW, "appod_fradio", arglst, 5);
  XtManageChild(apFeaRadioW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Linear"));
  apLinearW = XmCreateToggleButton(apFeaRadioW, "appod_lin", arglst, 1);
  *tag2 = LINEAR;
  XtAddCallback(apLinearW, XmNvalueChangedCallback, 
		featherMode_change, (XtPointer)tag2);
  XtManageChild(apLinearW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Gaussian"));
  apGaussianW = XmCreateToggleButton(apFeaRadioW, "appod_gau", arglst, 1);
  *tag3 = GAUSSIAN;
  XtAddCallback(apGaussianW, XmNvalueChangedCallback, 
		featherMode_change, (XtPointer)tag3);
  XtManageChild(apGaussianW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Exponential"));
  XtSetArg(arglst[1], XmNset, 1);
  apExponentialW = XmCreateToggleButton(apFeaRadioW, "appod_exp", arglst, 2);
  *tag4 = EXPONENTIAL;
  XtAddCallback(apExponentialW, XmNvalueChangedCallback, 
		featherMode_change, (XtPointer)tag4);
  XtManageChild(apExponentialW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("No Appodize"));
  apOldW = XmCreateToggleButton(apFeaRadioW, "appod_old", arglst, 1);
  *tag5 = OLD;
  XtAddCallback(apOldW, XmNvalueChangedCallback, 
		featherMode_change, (XtPointer)tag5);
  XtManageChild(apOldW);
  

  // ---- Start widgets associated with background method selection ----
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Background Method:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 200);
  apBkgLabelW = XmCreateLabel(appodizeScreenW, "appod_blabel", arglst, 3);
  XtManageChild(apBkgLabelW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 230);
  apBkgRadioW = XmCreateRadioBox(appodizeScreenW, "appod_bradio", arglst, 5);
  XtManageChild(apBkgRadioW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Pick 1,1"));
  apPickW = XmCreateToggleButton(apBkgRadioW, "appod_pick", arglst, 1);
  *tag6 = PICK;
  XtAddCallback(apPickW, XmNvalueChangedCallback, 
		backgroundMode_change, (XtPointer)tag6);
  XtManageChild(apPickW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Circle"));
  XtSetArg(arglst[1], XmNset, 1);
  apCircleW = XmCreateToggleButton(apBkgRadioW, "appod_circle", arglst, 2);
  *tag7 = USECIRCLE;
  XtAddCallback(apCircleW, XmNvalueChangedCallback, 
		backgroundMode_change, (XtPointer)tag7);
  XtManageChild(apCircleW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Rectangle"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  apRectW = XmCreateToggleButton(apBkgRadioW, "appod_rect", arglst, 2);
  *tag8 = USERECT;
  XtAddCallback(apRectW, XmNvalueChangedCallback, 
		backgroundMode_change, (XtPointer)tag8);
  XtManageChild(apRectW);

} // end function create_appodizescreen
