#include "gui.h"

void create_auto2ddrscreen() {
  // function name: create_auto2ddrscreen
  // Create and initialize auto 2D defocus refinement
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Automatic 2D Defocus Refinement"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 550);
  auto2DDRScreenW = XmCreateFormDialog(toplevel_widget, "a2", arglst, 8);

  // Text boxes and labels

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Focus Major: "));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 40);
  auto2DDRFMajLW = XmCreateLabel(auto2DDRScreenW, "a2_fjl", arglst, 3);
  XtManageChild(auto2DDRFMajLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Focus Minor: "));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 70);
  auto2DDRFMinLW = XmCreateLabel(auto2DDRScreenW, "a2_fnl", arglst, 3);
  XtManageChild(auto2DDRFMinLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Ang Major: "));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 100);
  auto2DDRAngLW = XmCreateLabel(auto2DDRScreenW, "a2_angl", arglst, 3);
  XtManageChild(auto2DDRAngLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Highest Resolution: "));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 160);
  auto2DDRResLW = XmCreateLabel(auto2DDRScreenW, "a2_resl", arglst, 3);
  XtManageChild(auto2DDRResLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ChiSq: "));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 190);
  auto2DDRChiLW = XmCreateLabel(auto2DDRScreenW, "a2_chil", arglst, 3);
  XtManageChild(auto2DDRChiLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Note - this make take a minute to finish"));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 230);
  a2ddrWarnW = XmCreateLabel(auto2DDRScreenW, "a2_warn", arglst, 3);
  XtManageChild(a2ddrWarnW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 40);
  XtSetArg(arglst[3], XmNvalue, "0");
  a2ddrfjW = XmCreateText(auto2DDRScreenW, "a2_txt1", arglst, 4);
  XtManageChild(a2ddrfjW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNvalue, "0");
  a2ddrfnW = XmCreateText(auto2DDRScreenW, "a2_txt2", arglst, 4);
  XtManageChild(a2ddrfnW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 100);
  XtSetArg(arglst[3], XmNvalue, "0");
  a2ddragW = XmCreateText(auto2DDRScreenW, "a2_txt3", arglst, 4);
  XtManageChild(a2ddragW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 160);
  XtSetArg(arglst[3], XmNvalue, "20.0");
  a2ddrtfW = XmCreateText(auto2DDRScreenW, "a2_txt4", arglst, 4);
  XtManageChild(a2ddrtfW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 190);
  XtSetArg(arglst[3], XmNvalue, " ");
  a2ddrcsqW = XmCreateText(auto2DDRScreenW, "a2_txt5", arglst, 4);
  XtManageChild(a2ddrcsqW);

  // Toggles

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Draw CTF lines "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 270); 
  a2ddrTog1W = XmCreateToggleButton(auto2DDRScreenW, "a2_tog1", arglst, 3);
  XtAddCallback(a2ddrTog1W, XmNvalueChangedCallback, 
		auto2DDR_ctflines_activate, NULL);
  XtManageChild(a2ddrTog1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("sCurve at angle    "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 290); 
  a2ddrTog2W = XmCreateToggleButton(auto2DDRScreenW, "a2_tog2", arglst, 3);
  XtAddCallback(a2ddrTog2W, XmNvalueChangedCallback, 
		auto2DDR_scurve_activate, NULL);
  XtManageChild(a2ddrTog2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("s = b + ctf^2 * d "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 310); 
  a2ddrTog3W = XmCreateToggleButton(auto2DDRScreenW, "a2_tog3", arglst, 3);
  XtAddCallback(a2ddrTog3W, XmNvalueChangedCallback, 
		auto2DDR_drawmodified_activate, NULL);
  XtManageChild(a2ddrTog3W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("s "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 330); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  a2ddrSW = XmCreateToggleButton(auto2DDRScreenW, "a2_tog4", arglst, 4);
  XtAddCallback(a2ddrSW, XmNvalueChangedCallback, 
		auto2DDR_curves_activate, NULL);
  XtManageChild(a2ddrSW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("s - b "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 350); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[BLUE]);
  a2ddrSMBW = XmCreateToggleButton(auto2DDRScreenW, "a2_tog5", arglst, 4);
  XtAddCallback(a2ddrSMBW, XmNvalueChangedCallback, 
		auto2DDR_curves_activate, NULL);
  XtManageChild(a2ddrSMBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ctf^2"));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 370); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  a2ddrCTF2W = XmCreateToggleButton(auto2DDRScreenW, "a2_tog6", arglst, 4);
  XtAddCallback(a2ddrCTF2W, XmNvalueChangedCallback, 
		auto2DDR_curves_activate, NULL);
  XtManageChild(a2ddrCTF2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("d "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 390); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[WHITE]);
  a2ddrDW = XmCreateToggleButton(auto2DDRScreenW, "a2_tog7", arglst, 4);
  XtAddCallback(a2ddrDW, XmNvalueChangedCallback, 
		auto2DDR_curves_activate, NULL);
  XtManageChild(a2ddrDW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("b "));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 410); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[BLUE]);
  a2ddrBW = XmCreateToggleButton(auto2DDRScreenW, "a2_tog8", arglst, 4);
  XtAddCallback(a2ddrBW, XmNvalueChangedCallback, 
		auto2DDR_curves_activate, NULL);
  XtManageChild(a2ddrBW);

  // Bottom row of controls

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 515);
  auto2DDRExitW = XmCreatePushButton(auto2DDRScreenW, "a2_exit", arglst, 5);
  XtAddCallback(auto2DDRExitW, XmNactivateCallback, 
		auto2ddr_deactivate, NULL);
  XtManageChild(auto2DDRExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 80);
  XtSetArg(arglst[4], XmNy, 515);
  auto2DDRHelpW = XmCreatePushButton(auto2DDRScreenW, "a2_help", arglst, 5);
  *tag[++j] = AUTO2DDRHELP;
  XtAddCallback(auto2DDRHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(auto2DDRHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Estimate the Defocus"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 515);
  auto2DDRDoW = XmCreatePushButton(auto2DDRScreenW, "a2_do", arglst, 3);
  XtAddCallback(auto2DDRDoW, XmNactivateCallback, 
		auto2DDR_activate, NULL);
  XtManageChild(auto2DDRDoW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Update FFT screen"));
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 515);
  auto2DDRUpdateW = XmCreatePushButton(auto2DDRScreenW, "a2_upd", arglst, 3);
  XtAddCallback(auto2DDRUpdateW, XmNactivateCallback, 
		auto2DDR_update_activate, NULL);
  XtManageChild(auto2DDRUpdateW);

} // end function create_auto2ddrscreen
