#include "gui.h"

void create_autodrscreen () {
  // function name: create_autodrscreen
  // Create and initialize attributes of auto defocus refinement screen

  int *tag[20], i, j=-1;
  for (i=0; i<20; i++)
    tag[i]  = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Automatic Defocus Refinement"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 600);
  XtSetArg(arglst[7], XmNheight, 550);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  autoDRScreenW = XmCreateFormDialog(toplevel_widget, "adr", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 515);
  autoDRExitW = XmCreatePushButton(autoDRScreenW, "adr_exit", arglst, 5);
  XtAddCallback(autoDRExitW, XmNactivateCallback, autodr_deactivate, NULL);
  XtManageChild(autoDRExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 80);
  XtSetArg(arglst[4], XmNy, 515);
  autoDRHelpW = XmCreatePushButton(autoDRScreenW, "adr_help", arglst, 5);
  *tag[++j] = AUTODRHELP;
  XtAddCallback(autoDRHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(autoDRHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Coeffs of ctf (a0-a5) and bkg(b0-b5) fits"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 25);
  adrHeaderW = XmCreateLabel(autoDRScreenW, "adr_head", arglst, 3);
  XtManageChild(adrHeaderW);

  // ------ a0-a5 labels and values ------
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a0: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 60);
  adraLW[0] = XmCreateLabel(autoDRScreenW, "adra0_lab", arglst, 3);
  XtManageChild(adraLW[0]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a1: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 80);
  adraLW[1] = XmCreateLabel(autoDRScreenW, "adra1_lab", arglst, 3);
  XtManageChild(adraLW[1]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a2: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 100);
  adraLW[2] = XmCreateLabel(autoDRScreenW, "adra2_lab", arglst, 3);
  XtManageChild(adraLW[2]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a3: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 120);
  adraLW[3] = XmCreateLabel(autoDRScreenW, "adra3_lab", arglst, 3);
  XtManageChild(adraLW[3]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a4: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 140);
  adraLW[4] = XmCreateLabel(autoDRScreenW, "adra4_lab", arglst, 3);
  XtManageChild(adraLW[4]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a5: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 160);
  adraLW[5] = XmCreateLabel(autoDRScreenW, "adra5_lab", arglst, 3);
  XtManageChild(adraLW[5]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("1.0"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 60);
  adraW[0] = XmCreateLabel(autoDRScreenW, "adra0_vab", arglst, 3);
  XtManageChild(adraW[0]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 80);
  adraW[1] = XmCreateLabel(autoDRScreenW, "adra1_vab", arglst, 3);
  XtManageChild(adraW[1]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 100);
  adraW[2] = XmCreateLabel(autoDRScreenW, "adra2_vab", arglst, 3);
  XtManageChild(adraW[2]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 120);
  adraW[3] = XmCreateLabel(autoDRScreenW, "adra3_vab", arglst, 3);
  XtManageChild(adraW[3]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 140);
  adraW[4] = XmCreateLabel(autoDRScreenW, "adra4_vab", arglst, 3);
  XtManageChild(adraW[4]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 160);
  adraW[5] = XmCreateLabel(autoDRScreenW, "adra5_vab", arglst, 3);
  XtManageChild(adraW[5]);

  // ------ b0-b5 labels and values ------
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("b0: "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 60);
  adrbLW[0] = XmCreateLabel(autoDRScreenW, "adrb0_lab", arglst, 3);
  XtManageChild(adrbLW[0]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("b1: "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 80);
  adrbLW[1] = XmCreateLabel(autoDRScreenW, "adrb1_lab", arglst, 3);
  XtManageChild(adrbLW[1]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("b2: "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 100);
  adrbLW[2] = XmCreateLabel(autoDRScreenW, "adrb2_lab", arglst, 3);
  XtManageChild(adrbLW[2]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("b3: "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 120);
  adrbLW[3] = XmCreateLabel(autoDRScreenW, "adrb3_lab", arglst, 3);
  XtManageChild(adrbLW[3]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("b4: "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 140);
  adrbLW[4] = XmCreateLabel(autoDRScreenW, "adrb4_lab", arglst, 3);
  XtManageChild(adrbLW[4]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("b5: "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 160);
  adrbLW[5] = XmCreateLabel(autoDRScreenW, "adrb5_lab", arglst, 3);
  XtManageChild(adrbLW[5]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("1.0"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 60);
  adrbW[0] = XmCreateLabel(autoDRScreenW, "adrb0_vab", arglst, 3);
  XtManageChild(adrbW[0]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 80);
  adrbW[1] = XmCreateLabel(autoDRScreenW, "adrb1_vab", arglst, 3);
  XtManageChild(adrbW[1]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 100);
  adrbW[2] = XmCreateLabel(autoDRScreenW, "adrb2_vab", arglst, 3);
  XtManageChild(adrbW[2]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 120);
  adrbW[3] = XmCreateLabel(autoDRScreenW, "adrb3_vab", arglst, 3);
  XtManageChild(adrbW[3]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 140);
  adrbW[4] = XmCreateLabel(autoDRScreenW, "adrb4_vab", arglst, 3);
  XtManageChild(adrbW[4]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.0"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 160);
  adrbW[5] = XmCreateLabel(autoDRScreenW, "adrb5_vab", arglst, 3);
  XtManageChild(adrbW[5]);

  // Results (defocus and chi^2) labels
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Estimated Defocus (um): "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 210);
  adrDefocusLW = XmCreateLabel(autoDRScreenW, "adr_defl", arglst, 3);
  XtManageChild(adrDefocusLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(" "));
  XtSetArg(arglst[1], XmNx, 225);
  XtSetArg(arglst[2], XmNy, 210);
  adrDefocusW = XmCreateLabel(autoDRScreenW, "adr_def", arglst, 3);
  XtManageChild(adrDefocusW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Chi squared: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 235);
  adrChisqLW = XmCreateLabel(autoDRScreenW, "adr_chil", arglst, 3);
  XtManageChild(adrChisqLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(" "));
  XtSetArg(arglst[1], XmNx, 225);
  XtSetArg(arglst[2], XmNy, 235);
  adrChisqW = XmCreateLabel(autoDRScreenW, "adr_chi", arglst, 3);
  XtManageChild(adrChisqW);

  // Plot options
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Select quantities to plot: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 350);
  adrPlotLW = XmCreateLabel(autoDRScreenW, "adr_plotl", arglst, 3);
  XtManageChild(adrPlotLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Circular Average"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 380);
  XtSetArg(arglst[3], XmNhighlightThickness, 0);
  XtSetArg(arglst[4], XmNforeground, pixels_return[GREEN]);
  adrCircW = XmCreateToggleButton(autoDRScreenW, "adr_circ", arglst, 5);
  XtAddCallback(adrCircW, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrCircW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Signal"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 400);
  XtSetArg(arglst[3], XmNhighlightThickness, 0);
  XtSetArg(arglst[4], XmNforeground, pixels_return[RED]);
  adrSW = XmCreateToggleButton(autoDRScreenW, "adr_s", arglst, 5);
  XtAddCallback(adrSW, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrSW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Signal - Bkg"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 420);
  XtSetArg(arglst[3], XmNhighlightThickness, 0);
  XtSetArg(arglst[4], XmNforeground, pixels_return[BLUE]);
  XtSetArg(arglst[5], XmNset, 1);  
  adrSMBW = XmCreateToggleButton(autoDRScreenW, "adr_smb", arglst, 6);
  XtAddCallback(adrSMBW, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrSMBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ctf^2"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 440);
  XtSetArg(arglst[3], XmNhighlightThickness, 0);
  XtSetArg(arglst[4], XmNforeground, pixels_return[GREEN]);
  XtSetArg(arglst[5], XmNset, 1);  
  adrCtf2W = XmCreateToggleButton(autoDRScreenW, "adr_ctf2", arglst, 6);
  XtAddCallback(adrCtf2W, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrCtf2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("D"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 460);
  XtSetArg(arglst[3], XmNhighlightThickness, 0);
  XtSetArg(arglst[4], XmNforeground, pixels_return[WHITE]);
  adrDW = XmCreateToggleButton(autoDRScreenW, "adr_d", arglst, 5);
  XtAddCallback(adrDW, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrDW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Bkg"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 480);
  XtSetArg(arglst[3], XmNhighlightThickness, 0);
  XtSetArg(arglst[4], XmNforeground, pixels_return[BLUE]);
  adrBW = XmCreateToggleButton(autoDRScreenW, "adr_b", arglst, 5);
  XtAddCallback(adrBW, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Zoom FFT image"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 420);
  adrZoomW = XmCreateToggleButton(autoDRScreenW, "adr_zoom", arglst, 3);
  XtAddCallback(adrZoomW, XmNvalueChangedCallback, 
		adr_toggle_change, NULL);
  XtManageChild(adrZoomW);

  // Widgets for highest resolution used in fit
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Highest Resolution (Angs)"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 300);
  adrHiResLW = XmCreateLabel(autoDRScreenW, "adr_hil", arglst, 3);
  XtManageChild(adrHiResLW);

  XtSetArg(arglst[0], XmNcolumns,  12);
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 300);
  adrHiResW = XmCreateText(autoDRScreenW, "adr_hi", arglst, 3);
  XtManageChild(adrHiResW);

  // Buttons
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Estimate Defocus"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 515);
  adrDoitW = XmCreatePushButton(autoDRScreenW, "adr_doit", arglst, 3);
  *tag[++j] = 1;
  XtAddCallback(adrDoitW, XmNactivateCallback,
		autoDR_activate, (XtPointer)tag[j]);
  XtManageChild(adrDoitW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("*10"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 515);
  adrDoit10W = XmCreatePushButton(autoDRScreenW, "adr_doit10", arglst, 3);
  *tag[++j] = 10;
  XtAddCallback(adrDoit10W, XmNactivateCallback,
		autoDR_activate, (XtPointer)tag[j]);
  XtManageChild(adrDoit10W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Reset Coefficients"));
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 110);
  adrabResetW = XmCreatePushButton(autoDRScreenW, "adr_reset", arglst, 3);
  XtAddCallback(adrabResetW, XmNactivateCallback, 
		adrab_reset_activate, NULL);
  XtManageChild(adrabResetW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Update FFT screen"));
  XtSetArg(arglst[1], XmNx, 360);
  XtSetArg(arglst[2], XmNy, 515);
  adrUpdateW = XmCreatePushButton(autoDRScreenW, "adr_update", arglst, 3);
  XtAddCallback(adrUpdateW, XmNactivateCallback, 
		autoDR_update_activate, NULL);
  XtManageChild(adrUpdateW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write a0-a5 to PIF head"));
  XtSetArg(arglst[1], XmNx, 360);
  XtSetArg(arglst[2], XmNy, 485);
  adrPIFW = XmCreatePushButton(autoDRScreenW, "adr_pif", arglst, 3);
  XtAddCallback(adrPIFW, XmNactivateCallback, 
		autoDwritePIFhead_activate, NULL);
  XtManageChild(adrPIFW);

} // end function create_autodrscreen
