#include "gui.h"

void create_batchjobscreen () {
  // function name: create_batchjobscreen
  // Create and initialize attributes of batchjob screen
  
  int *tag1;
  tag1 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Batch Job"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 710);
  XtSetArg(arglst[7], XmNheight, 650);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  batchScreenW = XmCreateFormDialog(toplevel_widget, "bj", arglst, 9);

  // Buttons

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 600);
  batchExitW = XmCreatePushButton(batchScreenW, "bj_exit", arglst, 5);
  XtAddCallback(batchExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(batchExitW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Browse"));
  XtSetArg(arglst[1], XmNx, 600);
  XtSetArg(arglst[2], XmNy, 10);
  batchBrowseW = XmCreatePushButton(batchScreenW, "bj_browse", arglst, 3);
  *tag1 = BATCHJOB;
  XtAddCallback(batchBrowseW, XmNactivateCallback, 
		paramFile_browse_activate, (XtPointer)tag1);
  XtManageChild(batchBrowseW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Submit Batch Job"));
  XtSetArg(arglst[1], XmNx, 110);
  XtSetArg(arglst[2], XmNy, 600);
  batchSubmitW = XmCreatePushButton(batchScreenW, "bj_submit", arglst, 3);
  XtAddCallback(batchSubmitW, XmNactivateCallback, 
		batchjob_submit_activate, NULL);
  XtManageChild(batchSubmitW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Just ASU all orientations"));
  XtSetArg(arglst[1], XmNx, 310);
  XtSetArg(arglst[2], XmNy, 600);
  batchASUW = XmCreatePushButton(batchScreenW, "bj_asu", arglst, 3);
  XtAddCallback(batchASUW, XmNactivateCallback, 
		batchjob_allasu_activate, NULL);
  XtManageChild(batchASUW);

  // Other widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Batch File:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  batchFileLabelW = XmCreateLabel(batchScreenW, "bj_fl", arglst, 3);
  XtManageChild(batchFileLabelW);

  XtSetArg(arglst[0], XmNcolumns, 37);
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 10);
  batchFileTextW = XmCreateText(batchScreenW, "bj_ft", arglst, 3);
  XtManageChild(batchFileTextW);

  XtSetArg(arglst[0], XmNlabelString, //RSS
	   XmStringCreateLocalized("                                       "));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 480);
  batchHelpLabelW = XmCreateLabel(batchScreenW, "bj_hl", arglst, 3);
  XtManageChild(batchHelpLabelW);
  
  XtSetArg(arglst[0], XmNscrollVertical, 1);
  XtSetArg(arglst[1], XmNscrollHorizontal, 0);
  XtSetArg(arglst[2], XmNeditMode, XmMULTI_LINE_EDIT);
  XtSetArg(arglst[3], XmNcursorPositionVisible, 1);
  XtSetArg(arglst[4], XmNwordWrap, 1);
  XtSetArg(arglst[5], XmNcolumns, 82);
  XtSetArg(arglst[6], XmNrows, 16);
  XtSetArg(arglst[7], XmNx, 10);
  XtSetArg(arglst[8], XmNy, 50);
  batchTextW = XmCreateScrolledText(batchScreenW, "bj_text", arglst, 9);
  XtManageChild(batchTextW);

  XtSetArg(arglst[0], XmNwidth, 80);
  XtSetArg(arglst[1], XmNvisibleItemCount, 3);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 520);
  XtSetArg(arglst[4], XmNselectionPolicy, XmSINGLE_SELECT);
  batchParamFileW = XmCreateScrolledList(batchScreenW, "bj_pf", arglst, 5);
  XtAddCallback(batchParamFileW, XmNsingleSelectionCallback, 
		batchparam_list_proc, NULL);
  XtManageChild(batchParamFileW);

  // Text boxes
  XtSetArg(arglst[0], XmNcolumns, 7);   // Common attribute rows 1-4

  // Row1 text boxes
  XtSetArg(arglst[1], XmNy, 298);       // Common attribute

  XtSetArg(arglst[2], XmNx, 10);
  batchModeW = XmCreateText(batchScreenW, "bj_modet", arglst, 3);
  XtAddCallback(batchModeW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchModeW);

  XtSetArg(arglst[2], XmNx, 110);
  batchBinW = XmCreateText(batchScreenW, "bj_bint", arglst, 3);
  XtAddCallback(batchBinW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchBinW);

  XtSetArg(arglst[2], XmNx, 210);
  batchSymW = XmCreateText(batchScreenW, "bj_symt", arglst, 3);
  XtAddCallback(batchSymW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchSymW);

  XtSetArg(arglst[2], XmNx, 310);
  batchDtheW = XmCreateText(batchScreenW, "bj_dthet", arglst, 3);
  XtAddCallback(batchDtheW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchDtheW);

  XtSetArg(arglst[2], XmNx, 410);
  batchDphi90W = XmCreateText(batchScreenW, "bj_dphi90t", arglst, 3);
  XtAddCallback(batchDphi90W, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchDphi90W);

  XtSetArg(arglst[2], XmNx, 510);
  batchIlistW = XmCreateText(batchScreenW, "bj_ilistt", arglst, 3);
  XtAddCallback(batchIlistW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchIlistW);

  // Row 2 text boxes
  XtSetArg(arglst[1], XmNy, 329);       // Common attribute

  XtSetArg(arglst[2], XmNx, 10);
  batchRadLoW = XmCreateText(batchScreenW, "bj_radlot", arglst, 3);
  XtAddCallback(batchRadLoW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchRadLoW);

  XtSetArg(arglst[2], XmNx, 110);
  batchRadHiW = XmCreateText(batchScreenW, "bj_radhit", arglst, 3);
  XtAddCallback(batchRadHiW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchRadHiW);

  XtSetArg(arglst[2], XmNx, 210);
  batchRadStepW = XmCreateText(batchScreenW, "bj_radstept", arglst, 3);
  XtAddCallback(batchRadStepW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchRadStepW);

  XtSetArg(arglst[2], XmNx, 310);
  batchAnnLoW = XmCreateText(batchScreenW, "bj_annlot", arglst, 3);
  XtAddCallback(batchAnnLoW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchAnnLoW);

  XtSetArg(arglst[2], XmNx, 410);
  batchAnnHiW = XmCreateText(batchScreenW, "bj_annhit", arglst, 3);
  XtAddCallback(batchAnnHiW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchAnnHiW);

  // Row 3 text boxes
  XtSetArg(arglst[1], XmNy, 360);       // Common attribute

  XtSetArg(arglst[2], XmNx, 10);
  batchResLoW = XmCreateText(batchScreenW, "bj_reslot", arglst, 3);
  XtAddCallback(batchResLoW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchResLoW);

  XtSetArg(arglst[2], XmNx, 110);
  batchResHiW = XmCreateText(batchScreenW, "bj_reshit", arglst, 3);
  XtAddCallback(batchResHiW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchResHiW);

  XtSetArg(arglst[2], XmNx, 210);
  batchJCutW = XmCreateText(batchScreenW, "bj_jcutt", arglst, 3);
  XtAddCallback(batchJCutW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchJCutW);

  XtSetArg(arglst[2], XmNx, 310);
  batchSigW = XmCreateText(batchScreenW, "bj_sigt", arglst, 3);
  XtAddCallback(batchSigW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchSigW);

  // Row 4 text boxes
  XtSetArg(arglst[1], XmNy, 391);       // Common attribute

  XtSetArg(arglst[2], XmNx, 10);
  batchMagCenW = XmCreateText(batchScreenW, "bj_magcent", arglst, 3);
  XtAddCallback(batchMagCenW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchMagCenW);

  XtSetArg(arglst[2], XmNx, 110);
  batchMagStepW = XmCreateText(batchScreenW, "bj_magstept", arglst, 3);
  XtAddCallback(batchMagStepW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchMagStepW);

  XtSetArg(arglst[2], XmNx, 210);
  batchMagNumW = XmCreateText(batchScreenW, "bj_magnumt", arglst, 3);
  XtAddCallback(batchMagNumW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchMagNumW);

  XtSetArg(arglst[2], XmNx, 310);
  batchMagNormW = XmCreateText(batchScreenW, "bj_magnormt", arglst, 3);
  XtAddCallback(batchMagNormW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchMagNormW);

  // More text boxes

  XtSetArg(arglst[0], XmNcolumns, 17);  // Common attribute
  XtSetArg(arglst[1], XmNx, 10);        // Common attribute

  XtSetArg(arglst[2], XmNy, 422);
  batch3DMapW = XmCreateText(batchScreenW, "bj_3dt", arglst, 3);
  XtAddCallback(batch3DMapW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batch3DMapW);

  XtSetArg(arglst[2], XmNy, 453);
  batchPrjsFileW = XmCreateText(batchScreenW, "bj_prjst", arglst, 3);
  XtAddCallback(batchPrjsFileW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchPrjsFileW);

  XtSetArg(arglst[2], XmNy, 484);
  batchPftsFileW = XmCreateText(batchScreenW, "bj_pftst", arglst, 3);
  XtAddCallback(batchPftsFileW, XmNfocusCallback, batch_focus, NULL);
  XtManageChild(batchPftsFileW);

} // end function create_batchjobscreen
