#include "gui.h"

static void setbin(Widget w, XtPointer client_data, XtPointer call_data) {
  doBinning = *((int *) client_data);
}



void create_binningscreen () {
  // function name: create_binningscreen
  // Create and initialize attributes of binning screen

  int *tag1, *tag2, *tag3, *tag4;
  tag1 = (int *)malloc(sizeof(int));
  tag2 = (int *)malloc(sizeof(int));
  tag3 = (int *)malloc(sizeof(int));
  tag4 = (int *)malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Binning"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 300);
  XtSetArg(arglst[7], XmNheight, 190);
  binningScreenW = XmCreateFormDialog(toplevel_widget, "bin", arglst, 8);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Bin It"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 150);
  binningDoW = XmCreatePushButton(binningScreenW, "bin_do", arglst, 3);
  XtAddCallback(binningDoW, XmNactivateCallback, binning_activate, NULL);
  XtManageChild(binningDoW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 150);
  binningExitW = XmCreatePushButton(binningScreenW, "bin_exit", arglst, 5);
  XtAddCallback(binningExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(binningExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 80);
  XtSetArg(arglst[4], XmNy, 150);
  binningHelpW = XmCreatePushButton(binningScreenW, "bin_help", arglst, 5);
  *tag1 = BINNING;
  XtAddCallback(binningHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(binningHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Select Binning Factor"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 20);
  binningLabelW = XmCreateLabel(binningScreenW, "bin_label", arglst, 3);
  XtManageChild(binningLabelW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 200);
  XtSetArg(arglst[4], XmNy, 20);
  binningRadioW = XmCreateRadioBox(binningScreenW, "bin_radio", arglst, 5);
  XtManageChild(binningRadioW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("2x2"));
  binningToggle2W = XmCreateToggleButton(binningRadioW, "bin_2", arglst, 1);
  *tag2 = 2;
  XtAddCallback(binningToggle2W, XmNvalueChangedCallback, setbin, (XtPointer)tag2);
  XtManageChild(binningToggle2W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("3x3"));
  binningToggle3W = XmCreateToggleButton(binningRadioW, "bin_3", arglst, 1);
  *tag3 = 3;
  XtAddCallback(binningToggle3W, XmNvalueChangedCallback, setbin, (XtPointer)tag3);
  XtManageChild(binningToggle3W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("4x4"));
  binningToggle4W = XmCreateToggleButton(binningRadioW, "bin_4", arglst, 1);
  *tag4 = 4;
  XtAddCallback(binningToggle4W, XmNvalueChangedCallback, setbin, (XtPointer)tag4);
  XtManageChild(binningToggle4W);

} // end function create_binningscreen
