#include "gui.h"

void create_boxscreen () {
  // function name: create_boxscreen
  // Create/initialize particle boxing screen

  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  // All arrow behaviors controlled by radiusArrowActivateButton()

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Boxing"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 900);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNwidth, 520);
  XtSetArg(arglst[7], XmNheight, 700);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  boxScreenW = XmCreateFormDialog(toplevel_widget, "box", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 660);
  boxExitW = XmCreatePushButton(boxScreenW, "box_exit", arglst, 5);
  XtAddCallback(boxExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(boxExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 100);
  XtSetArg(arglst[4], XmNy, 660);
  boxStopW = XmCreatePushButton(boxScreenW, "box_stop", arglst, 5);
  XtManageChild(boxStopW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 200);
  XtSetArg(arglst[4], XmNy, 660);
  boxHelpW = XmCreatePushButton(boxScreenW, "box_help", arglst, 5);
  *tag[++j] = BOXHELP;
  XtAddCallback(boxHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(boxHelpW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Color"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 660);
  boxcolorPushW = XmCreatePushButton(boxScreenW, "box_col", arglst, 3);
  XtAddCallback(boxcolorPushW, XmNactivateCallback, boxcolor_change, NULL);
  XtManageChild(boxcolorPushW);
  
  // Top set of toggle buttons
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Draw Thick Circles"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  boxThickW = XmCreateToggleButton(boxScreenW, "box_thk", arglst, 3);
  *tag[++j] = CIRCLEWIDTH;
  XtAddCallback(boxThickW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(boxThickW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Show Reference"));
  XtSetArg(arglst[1], XmNx, 215);
  XtSetArg(arglst[2], XmNy, 10);
  boxShowrefW = XmCreateToggleButton(boxScreenW, "box_shr", arglst, 3);
  *tag[++j] = DRAWREFERENCE;
  XtAddCallback(boxShowrefW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(boxShowrefW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Display Circle#"));
  XtSetArg(arglst[1], XmNx, 365);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNset, 1);
  boxDispnumW = XmCreateToggleButton(boxScreenW, "box_dsn", arglst, 4);
  XtAddCallback(boxDispnumW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(boxDispnumW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Refinement Feedback"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  boxReffeedW = XmCreateToggleButton(boxScreenW, "box_rff", arglst, 3);
  *tag[++j] = DRAWREFINE;
  XtAddCallback(boxReffeedW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(boxReffeedW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Show Clusters"));
  XtSetArg(arglst[1], XmNx, 215);
  XtSetArg(arglst[2], XmNy, 40);
  boxShowclW = XmCreateToggleButton(boxScreenW, "box_scl", arglst, 3);
  *tag[++j] = DRAWCLUSTERS;
  XtAddCallback(boxShowclW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(boxShowclW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Cycle RefCorr"));
  XtSetArg(arglst[1], XmNx, 365);
  XtSetArg(arglst[2], XmNy, 40);
  boxCycleW = XmCreateToggleButton(boxScreenW, "box_cyc", arglst, 3);
  *tag[++j] = CYCLEREF;
  XtAddCallback(boxCycleW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(boxCycleW);

  // Emma radius widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Emma Radius:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  XtSetArg(arglst[4], XmNborderColor, pixels_return[GREEN]);
  emmaRadiusLabelW = XmCreateLabel(boxScreenW, "box_eal", arglst, 5);
  XtManageChild(emmaRadiusLabelW);

  XtSetArg(arglst[0], XmNcolumns,  4);
  XtSetArg(arglst[1], XmNx, 135);
  XtSetArg(arglst[2], XmNy, 70);
  emmaRadiusTextW = XmCreateText(boxScreenW, "box_eat", arglst, 3);
  XtAddCallback(emmaRadiusTextW, XmNvalueChangedCallback, 
		radiusText_changed, NULL);
  XtManageChild(emmaRadiusTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, emmaRadiusTextW);
  emmaRadiusArrowUpW = XmCreateArrowButton(boxScreenW, "box_eau", arglst, 6);
  XtManageChild(emmaRadiusArrowUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 88);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, emmaRadiusTextW);
  emmaRadiusArrowDownW = XmCreateArrowButton(boxScreenW, "box_ead", arglst, 6);
  XtManageChild(emmaRadiusArrowDownW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(""));
  XtSetArg(arglst[1], XmNx, 215);
  XtSetArg(arglst[2], XmNy, 78);
  XtSetArg(arglst[3], XmNset, 1);
  emmaRadiusTogW = XmCreateToggleButton(boxScreenW, "box_eag", arglst, 4);
  *tag[++j] = EMMARADIUSBUTTON;
  XtAddCallback(emmaRadiusTogW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(emmaRadiusTogW);

  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  // Note that boxRadius and featherRadius widgets are
  // misleadingly named. The featherRadius widgets really control the box
  // size and the boxSize widgets really control the feather radius
  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  // "feather width" widgets (named as box radius widgets)
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Feather Width:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 110);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  XtSetArg(arglst[4], XmNborderColor, pixels_return[RED]);
  boxRadiusLabelW = XmCreateLabel(boxScreenW, "box_rdl", arglst, 5);
  XtManageChild(boxRadiusLabelW);

  XtSetArg(arglst[0], XmNcolumns,  4);
  XtSetArg(arglst[1], XmNx, 135);
  XtSetArg(arglst[2], XmNy, 110);
  boxRadiusTextW = XmCreateText(boxScreenW, "box_rdt", arglst, 3);
  XtAddCallback(boxRadiusTextW, XmNvalueChangedCallback, 
		radiusText_changed, NULL);
  XtManageChild(boxRadiusTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 110);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, boxRadiusTextW);
  boxRadiusArrowUpW = XmCreateArrowButton(boxScreenW, "box_rdu", arglst, 6);
  XtManageChild(boxRadiusArrowUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 128);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, boxRadiusTextW);
  boxRadiusArrowDownW = XmCreateArrowButton(boxScreenW, "box_frd", arglst, 6);
  XtManageChild(boxRadiusArrowDownW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(""));
  XtSetArg(arglst[1], XmNx, 215);
  XtSetArg(arglst[2], XmNy, 118);
  XtSetArg(arglst[3], XmNset, 1);
  boxRadiusTogW = XmCreateToggleButton(boxScreenW, "box_rdg", arglst, 4);
  *tag[++j] = BOXRADIUSBUTTON;
  XtAddCallback(boxRadiusTogW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(boxRadiusTogW);

  // "Box size" widgets (named as feather width widgets)
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Box Size:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 150);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  XtSetArg(arglst[4], XmNborderColor, pixels_return[BLUE]);
  featherRadiusLabelW = XmCreateLabel(boxScreenW, "box_fel", arglst, 5);
  XtManageChild(featherRadiusLabelW);

  XtSetArg(arglst[0], XmNcolumns,  4);
  XtSetArg(arglst[1], XmNx, 135);
  XtSetArg(arglst[2], XmNy, 150);
  featherRadiusTextW = XmCreateText(boxScreenW, "box_fet", arglst, 3);
  XtAddCallback(featherRadiusTextW, XmNvalueChangedCallback, 
		radiusText_changed, NULL);
  XtManageChild(featherRadiusTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 150);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, featherRadiusTextW);
  featherRadiusArrowUpW = XmCreateArrowButton(boxScreenW, "boxfeu", arglst, 6);
  XtManageChild(featherRadiusArrowUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 168);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, featherRadiusTextW);
  featherRadiusArrowDownW = XmCreateArrowButton(boxScreenW, "bxfd", arglst, 6);
  XtManageChild(featherRadiusArrowDownW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(""));
  XtSetArg(arglst[1], XmNx, 215);
  XtSetArg(arglst[2], XmNy, 158);
  XtSetArg(arglst[3], XmNset, 1);
  featherRadiusTogW = XmCreateToggleButton(boxScreenW, "box_feg", arglst, 4);
  *tag[++j] = FEATHERRADIUSBUTTON;
  XtAddCallback(featherRadiusTogW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(featherRadiusTogW);

  // Empty shell widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Empty Shell Width:"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  XtSetArg(arglst[4], XmNborderColor, pixels_return[WHITE]);
  emptyShellLabelW = XmCreateLabel(boxScreenW, "box_eml", arglst, 5);
  XtManageChild(emptyShellLabelW);

  XtSetArg(arglst[0], XmNcolumns,  4);
  XtSetArg(arglst[1], XmNx, 400);
  XtSetArg(arglst[2], XmNy, 70);
  emptyShellTextW = XmCreateText(boxScreenW, "box_emt", arglst, 3);
  XtAddCallback(emptyShellTextW, XmNvalueChangedCallback, 
		radiusText_changed, NULL);
  XtManageChild(emptyShellTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, emptyShellTextW);
  emptyShellArrowUpW = XmCreateArrowButton(boxScreenW, "box_emu", arglst, 6);
  XtManageChild(emptyShellArrowUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 88);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, emptyShellTextW);
  emptyShellArrowDownW = XmCreateArrowButton(boxScreenW, "box_emd", arglst, 6);
  XtManageChild(emptyShellArrowDownW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(""));
  XtSetArg(arglst[1], XmNx, 480);
  XtSetArg(arglst[2], XmNy, 78);
  emptyShellTogW = XmCreateToggleButton(boxScreenW, "box_emg", arglst, 3);
  *tag[++j] = EMPTYSHELLBUTTON;
  XtAddCallback(emptyShellTogW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(emptyShellTogW);

  XtSetArg(arglst[0], XmNcolumns,  40);
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 220);
  XtSetArg(arglst[3], XmNeditable, 0);
  XtSetArg(arglst[4], XmNvalue, "Select boxing parameters");
  timeLeftBoxW = XmCreateText(boxScreenW, "box_tlb", arglst, 5);
  XtManageChild(timeLeftBoxW);

  // Dilate widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Dilation Layers:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 270);
  dilateLabelW = XmCreateLabel(boxScreenW, "box_dl", arglst, 3);
  XtManageChild(dilateLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("1"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 270);
  dilateValueW = XmCreateLabel(boxScreenW, "box_dv", arglst, 3);
  XtManageChild(dilateValueW);

  XtSetArg(arglst[0], XmNmaximum, 11);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNx, 160);
  XtSetArg(arglst[4], XmNy, 275);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[7], XmNvalue, 1);
  dilateScrollW = XmCreateScrollBar(boxScreenW, "box_ds", arglst, 8);
  *tag[++j] = DILATE;
  XtAddCallback(dilateScrollW, XmNvalueChangedCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = DILATE;
  XtAddCallback(dilateScrollW, XmNdragCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  XtManageChild(dilateScrollW);

  // Thinning widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Thinning Layers:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 300);
  thinLabelW = XmCreateLabel(boxScreenW, "box_tl", arglst, 3);
  XtManageChild(thinLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("2"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 300);
  thinValueW = XmCreateLabel(boxScreenW, "box_tv", arglst, 3);
  XtManageChild(thinValueW);

  XtSetArg(arglst[0], XmNmaximum, 11);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNx, 160);
  XtSetArg(arglst[4], XmNy, 305);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[7], XmNvalue, 2);
  thinScrollW = XmCreateScrollBar(boxScreenW, "box_ts", arglst, 8);
  *tag[++j] = THINNING;
  XtAddCallback(thinScrollW, XmNvalueChangedCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = THINNING;
  XtAddCallback(thinScrollW, XmNdragCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  XtManageChild(thinScrollW);

  // Box type stuff
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Box Type"));
  XtSetArg(arglst[1], XmNx, 390);
  XtSetArg(arglst[2], XmNy, 260);
  boxTypeLabelW = XmCreateLabel(boxScreenW, "box_tv", arglst, 3);
  XtManageChild(boxTypeLabelW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 390);
  XtSetArg(arglst[4], XmNy, 290);
  boxRadioW = XmCreateRadioBox(boxScreenW, "box_br", arglst, 5);
  XtManageChild(boxRadioW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Rectangle"));
  boxRectW = XmCreateToggleButton(boxRadioW, "box_rect", arglst, 1);
  *tag[++j] = USERECT;
  XtAddCallback(boxRectW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(boxRectW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Square"));
  boxSquareW = XmCreateToggleButton(boxRadioW, "box_sq", arglst, 1);
  *tag[++j] = USESQUARE;
  XtAddCallback(boxSquareW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(boxSquareW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Circle"));
  XtSetArg(arglst[1], XmNset, 1);
  boxCircleW = XmCreateToggleButton(boxRadioW, "box_cir", arglst, 2);
  *tag[++j] = USECIRCLE;
  XtAddCallback(boxCircleW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(boxCircleW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Polygon"));
  boxPolyW = XmCreateToggleButton(boxRadioW, "box_poly", arglst, 1);
  *tag[++j] = USEPOLY;
  XtAddCallback(boxPolyW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(boxPolyW);

  XtSetArg(arglst[0], XmNcolumns,  9);
  XtSetArg(arglst[1], XmNx, 387);
  XtSetArg(arglst[2], XmNy, 427);
  XtSetArg(arglst[3], XmNvalue, "Square Dimension");
  squareTextW = XmCreateText(boxScreenW, "box_sqt", arglst, 4);
  XtAddCallback(squareTextW, XmNvalueChangedCallback, 
		squareText_changed, NULL);
  XtManageChild(squareTextW);

  // Action buttons (autobox, correlate, etc.)
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Automatic Boxing"));
  XtSetArg(arglst[1], XmNwidth, 270);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 360);
  autoBoxW = XmCreatePushButton(boxScreenW, "box_ab", arglst, 4);
  *tag[++j] = AUTOBOX;
  XtAddCallback(autoBoxW, XmNactivateCallback, 
		autoBox_activate, (XtPointer)tag[j]);
  XtManageChild(autoBoxW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Reference Correlate Refinement"));
  XtSetArg(arglst[1], XmNwidth, 270);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 400);
  correlateButton2W = XmCreatePushButton(boxScreenW, "box_c2", arglst, 4);
  *tag[++j] = CORRELATE2;
  XtAddCallback(correlateButton2W, XmNactivateCallback, 
		correlate_activate, (XtPointer)tag[j]);
  XtManageChild(correlateButton2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("AutoBox and Correlate"));
  XtSetArg(arglst[1], XmNwidth, 270);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 440);
  correlateButtonW = XmCreatePushButton(boxScreenW, "box_c1", arglst, 4);
  *tag[++j] = CORRELATE;
  XtAddCallback(correlateButtonW, XmNactivateCallback, 
		autoBox_activate, (XtPointer)tag[j]);
  XtManageChild(correlateButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Empty Particle AutoBoxing"));
  XtSetArg(arglst[1], XmNwidth, 270);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 480);
  emptyBoxW = XmCreatePushButton(boxScreenW, "box_eb", arglst, 4);
  *tag[++j] = 0;
  XtAddCallback(emptyBoxW, XmNactivateCallback, 
		boxgrid_activate, (XtPointer)tag[j]);
  XtManageChild(emptyBoxW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Clear Boxes"));
  XtSetArg(arglst[1], XmNwidth, 270);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 520);
  clearBoxW = XmCreatePushButton(boxScreenW, "box_cb", arglst, 4);
  *tag[++j] = CLEARBOXES;
  XtAddCallback(clearBoxW, XmNactivateCallback, 
		correlate_activate, (XtPointer)tag[j]);
  XtManageChild(clearBoxW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("     "));
  XtSetArg(arglst[1], XmNx, 290);
  XtSetArg(arglst[2], XmNy, 360);
  autoBoxLabelW = XmCreateLabel(boxScreenW, "box_abl", arglst, 3);
  XtManageChild(autoBoxLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("     "));
  XtSetArg(arglst[1], XmNx, 290);
  XtSetArg(arglst[2], XmNy, 400);
  refCorrLabelW = XmCreateLabel(boxScreenW, "box_rcl", arglst, 3);
  XtManageChild(refCorrLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("     "));
  XtSetArg(arglst[1], XmNx, 290);
  XtSetArg(arglst[2], XmNy, 440);
  autoCorrLabelW = XmCreateLabel(boxScreenW, "box_acl", arglst, 3);
  XtManageChild(autoCorrLabelW);

  // Correlation cutoff widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Correlation Coeff Cutoffs"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 565);
  autoMinMaxLabelW = XmCreateLabel(boxScreenW, "box_cmm", arglst, 3);
  XtManageChild(autoMinMaxLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Min:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 590);
  autoMinLabelW = XmCreateLabel(boxScreenW, "box_cmin", arglst, 3);
  XtManageChild(autoMinLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Max:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 620);
  autoMaxLabelW = XmCreateLabel(boxScreenW, "box_cmax", arglst, 3);
  XtManageChild(autoMaxLabelW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNx, 60);
  XtSetArg(arglst[4], XmNy, 595);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  minBoxScrollW = XmCreateScrollBar(boxScreenW, "box_mbsq", arglst, 7);
  *tag[++j] = AUTOBOX;
  XtAddCallback(minBoxScrollW, XmNvalueChangedCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = AUTOBOX;
  XtAddCallback(minBoxScrollW, XmNdragCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  XtManageChild(minBoxScrollW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNx, 60);
  XtSetArg(arglst[4], XmNy, 625);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[7], XmNvalue, 100);
  maxBoxScrollW = XmCreateScrollBar(boxScreenW, "box_xbsw", arglst, 8);
  *tag[++j] = CORRELATE;
  XtAddCallback(maxBoxScrollW, XmNvalueChangedCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = CORRELATE;
  XtAddCallback(maxBoxScrollW, XmNdragCallback, 
  		autobox_scroll_change, (XtPointer)tag[j]);
  XtManageChild(maxBoxScrollW);

  // Boxing threshold widgets
  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 600);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  autoMenuBarW = XmCreateMenuBar(boxScreenW, "box_amb", arglst, 4);
  XtManageChild(autoMenuBarW);

  autoMenuW = XmCreatePulldownMenu(autoMenuBarW, "box_am", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Threshold"));
  XtSetArg(arglst[1], XmNsubMenuId, autoMenuW);
  autoMenuEntryW = XmCreateCascadeButton(autoMenuBarW, "box_ame", arglst, 2);
  XtManageChild(autoMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("By Correlation coefficient"));
  autoBycW = XmCreatePushButton(autoMenuW, "box_byc", arglst, 1);
  *tag[++j] = AMMCORRCOEF;
  XtAddCallback(autoBycW, XmNactivateCallback, box_change, (XtPointer)tag[j]);
  XtManageChild(autoBycW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("By avg density inside particle"));
  autoByaW = XmCreatePushButton(autoMenuW, "box_bya", arglst, 1);
  *tag[++j] = AMMAVGDENS;
  XtAddCallback(autoByaW, XmNactivateCallback, box_change, (XtPointer)tag[j]);
  XtManageChild(autoByaW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("By std dev of particle density"));
  autoBysW = XmCreatePushButton(autoMenuW, "box_bya", arglst, 1);
  *tag[++j] = AMMSTDEV;
  XtAddCallback(autoBysW, XmNactivateCallback, box_change, (XtPointer)tag[j]);
  XtManageChild(autoBysW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Remove These Boxes"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 600);  
  autoThreshW = XmCreatePushButton(boxScreenW, "box_thresh", arglst, 3);
  *tag[++j] = REMOVEBOXES;
  XtAddCallback(autoThreshW, XmNactivateCallback, 
		autobox_scroll_change, (XtPointer)tag[j]);
  XtManageChild(autoThreshW);

  // The following widgets are normally unmanaged by main program

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Show boxing stats histogram"));
  XtSetArg(arglst[1], XmNx, 360);
  XtSetArg(arglst[2], XmNy, 460);
  showBoxingStatsToggleW = XmCreateToggleButton(boxScreenW, "box_sbst", 
						arglst, 3);
  *tag[++j] = SHOWBOXINGSTATS;
  XtAddCallback(showBoxingStatsToggleW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(showBoxingStatsToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Experimental empties autobox"));
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 520);  
  XtSetArg(arglst[3], XmNwidth, 220);  
  boxGrid2W = XmCreatePushButton(boxScreenW, "box_g2", arglst, 4);
  XtAddCallback(boxGrid2W, XmNactivateCallback, boxgrid2_activate, NULL);
  XtManageChild(boxGrid2W);

} // end function create_boxscreen
