#include "gui.h"

void create_cavgppscreen () {
  // function name: create_cavgppscreen
  // Create/initialize circular avg ptle parameter screen
  
  int *tag1, *tag2, *tag3, *tag4, *tag5;
  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));
  tag3 = (int *) malloc(sizeof(int));
  tag4 = (int *) malloc(sizeof(int));
  tag5 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Circular/NSymmetry Avg"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 450);
  XtSetArg(arglst[7], XmNheight, 350);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  cavgPPScreenW = XmCreateFormDialog(toplevel_widget, "cpp", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 300);
  cavgPPExitW = XmCreatePushButton(cavgPPScreenW, "cpp_exit", arglst, 5);
  XtAddCallback(cavgPPExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(cavgPPExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 80);
  XtSetArg(arglst[4], XmNy, 300);
  cavgPPHelpW = XmCreatePushButton(cavgPPScreenW, "cpp_help", arglst, 5);
  *tag1 = CAVGPP;
  XtAddCallback(cavgPPHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(cavgPPHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Do Circular Average"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 300);
  cavgPPDoW = XmCreatePushButton(cavgPPScreenW, "cpp_do", arglst, 3);
  XtAddCallback(cavgPPDoW, XmNactivateCallback, cavgPP_do_activate, NULL);
  XtManageChild(cavgPPDoW);

  // Averaging options
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 10);
  cavgPPAoptW = XmCreateRadioBox(cavgPPScreenW, "cpp_aopt", arglst, 5);
  XtManageChild(cavgPPAoptW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Circular Average"));
  cavgPPAopt1W = XmCreateToggleButton(cavgPPAoptW, "cpp_rand", arglst, 1);
  *tag2 = CAVGDO;
  XtAddCallback(cavgPPAopt1W, XmNdisarmCallback, 
		cavgPP_change, (XtPointer)tag2);
  XtManageChild(cavgPPAopt1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Apply N Symmetry"));
  cavgPPAopt2W = XmCreateToggleButton(cavgPPAoptW, "cpp_rand", arglst, 1);
  *tag3 = NSYMDO;
  XtAddCallback(cavgPPAopt2W, XmNdisarmCallback, 
		cavgPP_change, (XtPointer)tag3);
  XtManageChild(cavgPPAopt2W);

  // Centering options
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 100);
  cavgPPCoptW = XmCreateRadioBox(cavgPPScreenW, "cpp_copt", arglst, 5);
  XtManageChild(cavgPPCoptW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Use param file x,y as center"));
  cavgPPCopt1W = XmCreateToggleButton(cavgPPCoptW, "cpp_para", arglst, 1);
  *tag4 = PARAMXY;
  XtAddCallback(cavgPPCopt1W, XmNdisarmCallback, 
		cavgPP_change, (XtPointer)tag4);
  XtManageChild(cavgPPCopt1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Use center of box as center"));
  cavgPPCopt2W = XmCreateToggleButton(cavgPPCoptW, "cpp_box", arglst, 1);
  *tag5 = BOXXY;
  XtAddCallback(cavgPPCopt2W, XmNdisarmCallback, 
		cavgPP_change, (XtPointer)tag5);
  XtManageChild(cavgPPCopt2W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("N Fold:"));
  XtSetArg(arglst[1], XmNx, 215);
  XtSetArg(arglst[2], XmNy, 45);
  cavgPPNflW = XmCreateLabel(cavgPPScreenW, "cpp_nfl", arglst, 3);
  XtManageChild(cavgPPNflW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 275);
  XtSetArg(arglst[2], XmNy, 40);
  cavgPPNftW = XmCreateText(cavgPPScreenW, "cpp_nft", arglst, 3);
  XtManageChild(cavgPPNftW);
  XmTextSetString(cavgPPNftW, "2");

} // end function create_cavgppscreen

