#include "gui.h"

void create_circavgscreen () {
  // function name: create_circavgscreen
  // Create and initialize attributes of circular average screen
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Spherical Average"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 40);
  XtSetArg(arglst[5], XmNy, 350);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 450);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  circAvgScreenW = XmCreateFormDialog(toplevel_widget, "cavg", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 400);
  circAvgExitW = XmCreatePushButton(circAvgScreenW, "cavg_exit", arglst, 5);
  XtAddCallback(circAvgExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(circAvgExitW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Clear"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 400);
  circAvgClearW = XmCreatePushButton(circAvgScreenW, "cavg_clear", arglst, 3);
  XtAddCallback(circAvgClearW, XmNactivateCallback, 
		DrawCircAvgWindow, NULL);
  XtManageChild(circAvgClearW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Print"));
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 400);
  circAvgPrintW = XmCreatePushButton(circAvgScreenW, "cavg_print", arglst, 3);
  XtAddCallback(circAvgPrintW, XmNactivateCallback, 
		circAvg_print_activate, NULL);
  XtManageChild(circAvgPrintW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("PIF 2D plot"));
  XtSetArg(arglst[1], XmNx, 230);
  XtSetArg(arglst[2], XmNy, 400);
  circAvgPifoutW = XmCreatePushButton(circAvgScreenW, "cavg_pif", arglst, 3);
  XtAddCallback(circAvgPifoutW, XmNactivateCallback, 
		circAvg_pifOut_activate, NULL);
  XtManageChild(circAvgPifoutW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("---"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 15);
  circAvgLineW[0] = XmCreateLabel(circAvgScreenW, "cavg_line1", arglst, 3);
  XtManageChild(circAvgLineW[0]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("---"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 40);
  circAvgLineW[1] = XmCreateLabel(circAvgScreenW, "cavg_line2", arglst, 3);
  XtManageChild(circAvgLineW[1]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("---"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 65);
  circAvgLineW[2] = XmCreateLabel(circAvgScreenW, "cavg_line3", arglst, 3);
  XtManageChild(circAvgLineW[2]);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                "));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 15);
  circAvgLabelW[0] = XmCreateLabel(circAvgScreenW, "cavg_draw1", arglst, 3);
  XtManageChild(circAvgLabelW[0]);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                "));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 40);
  circAvgLabelW[1] = XmCreateLabel(circAvgScreenW, "cavg_draw2", arglst, 3);
  XtManageChild(circAvgLabelW[1]);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                "));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 65);
  circAvgLabelW[2] = XmCreateLabel(circAvgScreenW, "cavg_draw3", arglst, 3);
  XtManageChild(circAvgLabelW[2]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("ZoomX:"));
  XtSetArg(arglst[1], XmNx, 330);
  XtSetArg(arglst[2], XmNy, 400);
  circAvgZoomW = XmCreateLabel(circAvgScreenW, "cavg_zoom", arglst, 3);
  XtManageChild(circAvgZoomW);

  XtSetArg(arglst[0], XmNcolumns, 2);
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 400);
  circAvgTextW = XmCreateText(circAvgScreenW, "cavg_text", arglst, 3);
  XtAddCallback(circAvgTextW, XmNvalueChangedCallback, 
		circAvgText_changed, NULL);
  XtManageChild(circAvgTextW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Invert Contrast"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 245);
  circAvgToggleW = XmCreateToggleButton(circAvgScreenW, "cavg_tog", arglst, 3);
  XtAddCallback(circAvgToggleW, XmNvalueChangedCallback, 
		circAvg_change, NULL);
  XtManageChild(circAvgToggleW);

  XtSetArg(arglst[0], XmNwidth, 256);
  XtSetArg(arglst[1], XmNheight, 256);
  XtSetArg(arglst[2], XmNx, 5);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNborderWidth, 1);
  circAvgW = XmCreateDrawingArea(circAvgScreenW, "cavg_draw", arglst, 5);
  XtAddCallback(circAvgW, XmNexposeCallback, 
		DrawCircAvgWindow, NULL);
  XtManageChild(circAvgW);

  XtSetArg(arglst[0], XmNwidth, 200);
  XtSetArg(arglst[1], XmNvisibleItemCount, 3);
  XtSetArg(arglst[2], XmNx, 250);
  XtSetArg(arglst[3], XmNy, 300);
  XtSetArg(arglst[4], XmNselectionPolicy, XmSINGLE_SELECT);
  circAvgListW = XmCreateScrolledList(circAvgScreenW, "cavg_list", arglst, 5);
  XtAddCallback(circAvgListW, XmNsingleSelectionCallback, 
		circAvg_list_proc, NULL);
  XtManageChild(circAvgListW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 400);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, circAvgTextW);
  circAvgUpW = XmCreateArrowButton(circAvgScreenW, "cavg_up", arglst, 6);
  XtAddCallback(circAvgUpW, XmNactivateCallback, circAvgArrowActivate, NULL);
  XtManageChild(circAvgUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 419);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, circAvgTextW);
  circAvgDownW = XmCreateArrowButton(circAvgScreenW, "cavg_down", arglst, 6);
  XtAddCallback(circAvgDownW, XmNactivateCallback, circAvgArrowActivate, NULL);
  XtManageChild(circAvgDownW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNx, 5);
  XtSetArg(arglst[4], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNtopWidget, circAvgW);
  XtSetArg(arglst[6], XmNwidth, 260);
  XtSetArg(arglst[7], XmNorientation, XmHORIZONTAL);
  circAvgScrollW = XmCreateScrollBar(circAvgScreenW, "cavg_scroll", arglst, 8);
  XtAddCallback(circAvgScrollW, XmNvalueChangedCallback, circAvg_change, NULL);
  XtAddCallback(circAvgScrollW, XmNdragCallback, circAvg_change, NULL);
  XtManageChild(circAvgScrollW);

} // end function create_circavgscreen
