#include "gui.h"

void create_colorscreen () {
  // function name: create_colorscreen
  // Create/initialize color map screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Colormap Editor"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 100);
  XtSetArg(arglst[5], XmNy, 350);
  XtSetArg(arglst[6], XmNwidth, 510);
  XtSetArg(arglst[7], XmNheight, 620);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  colorScreenW = XmCreateFormDialog(toplevel_widget, "clr", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 50);
  XtSetArg(arglst[4], XmNy, 50);
  colorExitW = XmCreatePushButton(colorScreenW, "clr_exit", arglst, 5);
  XtAddCallback(colorExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(colorExitW);

  // First set of colormap toggles
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNx, 200);
  XtSetArg(arglst[3], XmNy, 15);
  colorRadio1W = XmCreateRadioBox(colorScreenW, "clr_rad1", arglst, 4);
  XtManageChild(colorRadio1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Normal Grayscale"));
  XtSetArg(arglst[1], XmNset, 1);
  colorGnW = XmCreateToggleButton(colorRadio1W, "clr_gn", arglst, 2);
  *tag[++j] = USEGENERIC;
  XtAddCallback(colorGnW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorGnW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Reverse Contrast"));
  colorRvW = XmCreateToggleButton(colorRadio1W, "clr_rv", arglst, 1);
  *tag[++j] = USEREVERSE;
  XtAddCallback(colorRvW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorRvW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Local Contrast Stretching"));
  colorFtW = XmCreateToggleButton(colorRadio1W, "clr_ft", arglst, 1);
  *tag[++j] = USEFITTO;
  XtAddCallback(colorFtW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorFtW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Randomized"));
  colorRnW = XmCreateToggleButton(colorRadio1W, "clr_rn", arglst, 1);
  *tag[++j] = USERANDOM;
  XtAddCallback(colorRnW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorRnW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Build your own"));
  colorBdW = XmCreateToggleButton(colorRadio1W, "clr_bd", arglst, 1);
  *tag[++j] = USEBUILD;
  XtAddCallback(colorBdW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorBdW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Read from file"));
  colorRdW = XmCreateToggleButton(colorRadio1W, "clr_rd", arglst, 1);
  *tag[++j] = READCM;
  XtAddCallback(colorRdW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorRdW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write to file"));
  colorWrW = XmCreateToggleButton(colorRadio1W, "clr_wr", arglst, 1);
  *tag[++j] = WRITECM;
  XtAddCallback(colorWrW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(colorWrW);

  // Second set of colormap toggles
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 510);
  colorRadio2W = XmCreateRadioBox(colorScreenW, "clr_rad2", arglst, 4);
  XtManageChild(colorRadio2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("No Contrast Stretching (Global)"));
  XtSetArg(arglst[1], XmNset, 1);
  noContrastW = XmCreateToggleButton(colorRadio2W, "clr_nc", arglst, 2);
  *tag[++j] = NOCONTRAST;
  XtAddCallback(noContrastW, XmNvalueChangedCallback, 
		histMode_change, (XtPointer)tag[j]);
  XtManageChild(noContrastW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Contrast Stretch Scanned Images (Global)"));
  useContrastW = XmCreateToggleButton(colorRadio2W, "clr_cs", arglst, 1);
  *tag[++j] = USECONTRAST;
  XtAddCallback(useContrastW, XmNvalueChangedCallback, 
		histMode_change, (XtPointer)tag[j]);
  XtManageChild(useContrastW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Histogram Equalization (Global)"));
  histEqualW = XmCreateToggleButton(colorRadio2W, "clr_he", arglst, 1);
  *tag[++j] = USEHISTEQUAL;
  XtAddCallback(histEqualW, XmNvalueChangedCallback, 
		histMode_change, (XtPointer)tag[j]);
  XtManageChild(histEqualW);

  // Red scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Red"));
  XtSetArg(arglst[1], XmNx, 295);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[RED] = XmCreateLabel(colorScreenW, "clr_rdl", arglst, 3);
  XtManageChild(colorLabelW[RED]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 295);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[RED] = XmCreateLabel(colorScreenW, "clr_rdv", arglst, 3);
  XtManageChild(colorValueW[RED]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 300);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  colorScrollW[RED] = XmCreateScrollBar(colorScreenW, "clr_rds", arglst, 9);
  XtManageChild(colorScrollW[RED]);
  *tag[++j] = RED;
  XtAddCallback(colorScrollW[RED], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag[j]);
  *tag[++j] = RED;
  XtAddCallback(colorScrollW[RED], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag[j]);

  // Green scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Grn"));
  XtSetArg(arglst[1], XmNx, 345);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[GREEN] = XmCreateLabel(colorScreenW, "clr_grl", arglst, 3);
  XtManageChild(colorLabelW[GREEN]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 345);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[GREEN] = XmCreateLabel(colorScreenW, "clr_grv", arglst, 3);
  XtManageChild(colorValueW[GREEN]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 350);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  colorScrollW[GREEN] = XmCreateScrollBar(colorScreenW, "clr_grs", arglst, 9);
  XtManageChild(colorScrollW[GREEN]);
  *tag[++j] = GREEN;
  XtAddCallback(colorScrollW[GREEN], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag[j]);
  *tag[++j] = GREEN;
  XtAddCallback(colorScrollW[GREEN], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag[j]);

  // Blue scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Blue"));
  XtSetArg(arglst[1], XmNx, 392);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[BLUE] = XmCreateLabel(colorScreenW, "clr_bll", arglst, 3);
  XtManageChild(colorLabelW[BLUE]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 395);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[BLUE] = XmCreateLabel(colorScreenW, "clr_blv", arglst, 3);
  XtManageChild(colorValueW[BLUE]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 400);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  colorScrollW[BLUE] = XmCreateScrollBar(colorScreenW, "clr_bls", arglst, 9);
  XtManageChild(colorScrollW[BLUE]);
  *tag[++j] = BLUE;
  XtAddCallback(colorScrollW[BLUE], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag[j]);
  *tag[++j] = BLUE;
  XtAddCallback(colorScrollW[BLUE], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag[j]);

  // Bright scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Bright"));
  XtSetArg(arglst[1], XmNx, 438);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[BRIGHT] = XmCreateLabel(colorScreenW, "clr_brl", arglst, 3);
  XtManageChild(colorLabelW[BRIGHT]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("255"));
  XtSetArg(arglst[1], XmNx, 445);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[BRIGHT] = XmCreateLabel(colorScreenW, "clr_brv", arglst, 3);
  XtManageChild(colorValueW[BRIGHT]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 450);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  XtSetArg(arglst[9], XmNvalue, 255);
  colorScrollW[BRIGHT] = XmCreateScrollBar(colorScreenW, "clr_brs", arglst, 10);
  XtManageChild(colorScrollW[BRIGHT]);
  *tag[++j] = BRIGHT;
  XtAddCallback(colorScrollW[BRIGHT], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag[j]);
  *tag[++j] = BRIGHT;
  XtAddCallback(colorScrollW[BRIGHT], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag[j]);

  // Step scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Steps:"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 480);
  stepCMLabelW = XmCreateLabel(colorScreenW, "clr_cml", arglst, 3);
  XtManageChild(stepCMLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(" 256"));
  XtSetArg(arglst[1], XmNx, 195);
  XtSetArg(arglst[2], XmNy, 480);
  stepCMValueW = XmCreateLabel(colorScreenW, "clr_cmv", arglst, 3);
  XtManageChild(stepCMValueW);

  XtSetArg(arglst[0], XmNmaximum, 276);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 20);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 90);
  XtSetArg(arglst[5], XmNy, 485);
  XtSetArg(arglst[6], XmNvalue, 256);
  XtSetArg(arglst[7], XmNsliderSize, 20);
  stepCMScrollW = XmCreateScrollBar(colorScreenW, "clr_cms", arglst, 8);
  XtManageChild(stepCMScrollW);
  *tag[++j] = STEPCM;
  XtAddCallback(stepCMScrollW, XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag[j]);
  *tag[++j] = STEPCM;
  XtAddCallback(stepCMScrollW, XmNdragCallback, 
		colorScrollChange, (XtPointer)tag[j]);

  // ramp and rainbow buttons + test color area
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Ramp"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 350);
  colorRampW = XmCreateToggleButton(colorScreenW, "clr_ramp", arglst, 3);
  XtAddCallback(colorRampW, XmNvalueChangedCallback, 
		colormap_ramp_change, NULL);
  XtManageChild(colorRampW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Rainbow"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 380);
  colorRbowW = XmCreateToggleButton(colorScreenW, "clr_rbow", arglst, 3);
  XtAddCallback(colorRbowW, XmNvalueChangedCallback, 
		colormap_ramp_change, NULL);
  XtManageChild(colorRbowW);

  XtSetArg(arglst[0], XmNborderWidth, 2);
  XtSetArg(arglst[1], XmNx, 230);
  XtSetArg(arglst[2], XmNy, 410);
  XtSetArg(arglst[3], XmNwidth, 32);
  XtSetArg(arglst[4], XmNheight, 32);
  testcolormapW = XmCreateDrawingArea(colorScreenW, "clr_tmap", arglst, 5);
  XtAddCallback(testcolormapW, XmNexposeCallback, 
		DrawTestColormapWindow, NULL);
  XtManageChild(testcolormapW);

  // Histogram and associated widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 109);
  radialValueW = XmCreateLabel(colorScreenW, "clr_rvw", arglst, 3);
  XtManageChild(radialValueW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 365);
  colorValueW[ENTRY] = XmCreateLabel(colorScreenW, "clr_elw", arglst, 3);
  XtManageChild(colorValueW[ENTRY]);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 104);
  XtSetArg(arglst[3], XmNy, 378);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_RIGHT);
  colorHistUpW = XmCreateArrowButton(colorScreenW, "clr_hup", arglst, 5);
  XtAddCallback(colorHistUpW, XmNactivateCallback, 
		histArrowActivate, NULL);
  XtManageChild(colorHistUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 86);
  XtSetArg(arglst[3], XmNy, 378);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_LEFT);
  colorHistDnW = XmCreateArrowButton(colorScreenW, "clr_hdn", arglst, 5);
  XtAddCallback(colorHistDnW, XmNactivateCallback, 
		histArrowActivate, NULL);
  XtManageChild(colorHistDnW);
  
  XtSetArg(arglst[0], XmNborderWidth, 2);
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 120);
  XtSetArg(arglst[3], XmNwidth, 32);
  XtSetArg(arglst[4], XmNheight, 256);
  colormapW = XmCreateDrawingArea(colorScreenW, "clr_cmw", arglst, 5);
  XtAddCallback(colormapW, XmNexposeCallback, DrawColormapWindow, NULL);
  XtAddCallback(colormapW, XmNinputCallback, colorClick, NULL);
  XtManageChild(colormapW);
  
  XtSetArg(arglst[0], XmNborderWidth, 2);
  XtSetArg(arglst[1], XmNx, 84);
  XtSetArg(arglst[2], XmNy, 120);
  XtSetArg(arglst[3], XmNwidth, 32);
  XtSetArg(arglst[4], XmNheight, 256);
  histW = XmCreateDrawingArea(colorScreenW, "clr_hist2", arglst, 5);
  XtAddCallback(histW, XmNexposeCallback, 
		DrawTestColormapWindow, NULL);
  XtAddCallback(histW, XmNinputCallback, colorClick, NULL);
  XtManageChild(histW);

  // Up/down arrow behaviors controlled by cmScrollArrowActivateButton
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 120);
  XtSetArg(arglst[3], XmNy, 120);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  colormapScrollW = XmCreateArrowButton(colorScreenW, "clr_su", arglst, 5);
  XtManageChild(colormapScrollW);
  XtSetArg(arglst[3], XmNy, 358);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  colormapScrollDownW = XmCreateArrowButton(colorScreenW, "clr_sd", arglst, 5);
  XtManageChild(colormapScrollDownW);

} // end function create_colorscreen
