#include "gui.h"

void create_crysdispscreen() {
  // function name: create_crysdispscreen
  // Create and initialize attributes of crystal display screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Crystal Display"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNwidth, 490);
  XtSetArg(arglst[7], XmNheight, 500);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  crysDispScreenW = XmCreateFormDialog(toplevel_widget, "cd", arglst, 9);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Unit Cell Shape"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 10);
  crysDispLabelW = XmCreateLabel(crysDispScreenW, "cd_lab", arglst, 3);
  XtManageChild(crysDispLabelW);

  // Buttons and toggles

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 470);
  crysDispExitW = XmCreatePushButton(crysDispScreenW, "cd_exit", arglst, 5);
  XtAddCallback(crysDispExitW, XmNactivateCallback, crysdisp_deactivate, NULL);
  XtManageChild(crysDispExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 400);
  XtSetArg(arglst[4], XmNy, 90);
  crysDispResetW = XmCreatePushButton(crysDispScreenW, "cd_res", arglst, 5);
  XtAddCallback(crysDispResetW, XmNactivateCallback, 
		crysDisp_reset_activate, NULL);
  XtManageChild(crysDispResetW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rescale A/B dim"));
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 320);
  crysDispABW = XmCreatePushButton(crysDispScreenW, "cd_ab", arglst, 3);
  XtAddCallback(crysDispABW, XmNactivateCallback, 
		cDisp_newAdimBdim_changed, NULL);
  XtManageChild(crysDispABW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Immediate Update"));
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 470); 
  crysDispImmW = XmCreateToggleButton(crysDispScreenW, "cd_imm", arglst, 3);
  XtAddCallback(crysDispImmW, XmNvalueChangedCallback, 
		crystalDisp_changed, NULL);
  XtManageChild(crysDispImmW);

  // Upper controls (gamma and a/b widgets)

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Gamma"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 60);
  crysDispGamLW = XmCreateLabel(crysDispScreenW, "cd_gaml", arglst, 3);
  XtManageChild(crysDispGamLW);
  
  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 95);
  XtSetArg(arglst[2], XmNy, 55);
  map_abangTextW = XmCreateText(crysDispScreenW, "cd_gamt", arglst, 3);
  XtAddCallback(map_abangTextW, XmNvalueChangedCallback, 
		crystalDisp_changed, NULL);
  XtManageChild(map_abangTextW);

  XtSetArg(arglst[0], XmNx, 195);
  XtSetArg(arglst[1], XmNy, 60);
  XtSetArg(arglst[2], XmNmaximum, 198);
  XtSetArg(arglst[3], XmNminimum, 0);
  XtSetArg(arglst[4], XmNpageIncrement, 5);
  XtSetArg(arglst[5], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[6], XmNwidth, 100);
  mapScrollW = XmCreateScrollBar(crysDispScreenW, "cd_gams", arglst, 7);
  XtAddCallback(mapScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(mapScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(mapScrollW);  

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("           "));
  XtSetArg(arglst[1], XmNx, 310);
  XtSetArg(arglst[2], XmNy, 60);
  mapValueW = XmCreateLabel(crysDispScreenW, "cd_gamv", arglst, 3);
  XtManageChild(mapValueW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("a/b"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 90);
  crysDispABLW = XmCreateLabel(crysDispScreenW, "cd_abl", arglst, 3);
  XtManageChild(crysDispABLW);
  
  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 95);
  XtSetArg(arglst[2], XmNy, 85);
  aoverbTextW = XmCreateText(crysDispScreenW, "cd_abt", arglst, 3);
  XtAddCallback(aoverbTextW, XmNvalueChangedCallback, 
		crystalDisp_changed, NULL);
  XtManageChild(aoverbTextW);

  XtSetArg(arglst[0], XmNx, 195);
  XtSetArg(arglst[1], XmNy, 90);
  XtSetArg(arglst[2], XmNmaximum, 1111);
  XtSetArg(arglst[3], XmNminimum, 0);
  XtSetArg(arglst[4], XmNpageIncrement, 50);
  XtSetArg(arglst[5], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[6], XmNwidth, 100);
  abScrollW = XmCreateScrollBar(crysDispScreenW, "cd_abs", arglst, 7);
  XtAddCallback(abScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(abScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(abScrollW);  

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("           "));
  XtSetArg(arglst[1], XmNx, 310);
  XtSetArg(arglst[2], XmNy, 90);
  abValueW = XmCreateLabel(crysDispScreenW, "cd_abv", arglst, 3);
  XtManageChild(abValueW);

  // Zoom widgets

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ZoomFactor"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 130);
  crysDispZoomLW = XmCreateLabel(crysDispScreenW, "cd_zl", arglst, 3);
  XtManageChild(crysDispZoomLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 125);
  XtSetArg(arglst[2], XmNy, 130);
  XtSetArg(arglst[3], XmNvalue, "1.0");
  scaleXvalueW = XmCreateText(crysDispScreenW, "cd_zv", arglst, 4);
  XtAddCallback(scaleXvalueW, XmNvalueChangedCallback, 
		crystalDisp_changed, NULL);
  XtManageChild(scaleXvalueW);

  // Up/down arrow behaviors controlled by cDisp_zoom_activate
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, scaleXvalueW);
  XtSetArg(arglst[4], XmNy, 127);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  cDispZoomArrowUpW = XmCreateArrowButton(crysDispScreenW, "czu", arglst, 6);
  XtManageChild(cDispZoomArrowUpW);
  XtSetArg(arglst[4], XmNy, 148);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  cDispZoomArrowDownW = XmCreateArrowButton(crysDispScreenW, "czd", arglst, 6);
  XtManageChild(cDispZoomArrowDownW);

  // Origin widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("X Origin"));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 173);
  crysDispXLW = XmCreateLabel(crysDispScreenW, "cd_xl", arglst, 3);
  XtManageChild(crysDispXLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 173);
  cDispSymmOrigXW = XmCreateText(crysDispScreenW, "cd_xt", arglst, 3);
  XtManageChild(cDispSymmOrigXW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Y Origin"));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 198);
  crysDispYLW = XmCreateLabel(crysDispScreenW, "cd_yl", arglst, 3);
  XtManageChild(crysDispYLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 193);
  cDispSymmOrigYW = XmCreateText(crysDispScreenW, "cd_xt", arglst, 3);
  XtManageChild(cDispSymmOrigYW);

  // Symmetry pulldown

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 173);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  crysDispMenuBarW = XmCreateMenuBar(crysDispScreenW, "cd_mb", arglst, 4);
  XtManageChild(crysDispMenuBarW);

  crysDispMenuW = XmCreatePulldownMenu(crysDispMenuBarW, "cd_m", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Plane Group Symmetry"));
  XtSetArg(arglst[1], XmNsubMenuId, crysDispMenuW);
  crysDispMenuEntryW = XmCreateCascadeButton(crysDispMenuBarW, 
					     "cd_me", arglst, 2);
  XtManageChild(crysDispMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p1"));
  crysDispP1W = XmCreatePushButton(crysDispMenuW, "cd_1", arglst, 1);
  *tag[++j] = 1;
  XtAddCallback(crysDispP1W, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP1W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p2"));
  crysDispP2W = XmCreatePushButton(crysDispMenuW, "cd_2", arglst, 1);
  *tag[++j] = 2;
  XtAddCallback(crysDispP2W, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP2W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("pm"));
  crysDispPmW = XmCreatePushButton(crysDispMenuW, "cd_3", arglst, 1);
  *tag[++j] = 3;
  XtAddCallback(crysDispPmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispPmW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("pg"));
  crysDispPgW = XmCreatePushButton(crysDispMenuW, "cd_4", arglst, 1);
  *tag[++j] = 4;
  XtAddCallback(crysDispPgW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispPgW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("cm"));
  crysDispCmW = XmCreatePushButton(crysDispMenuW, "cd_5", arglst, 1);
  *tag[++j] = 5;
  XtAddCallback(crysDispCmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispCmW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p2mm"));
  crysDispP2mmW = XmCreatePushButton(crysDispMenuW, "cd_6", arglst, 1);
  *tag[++j] = 6;
  XtAddCallback(crysDispP2mmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP2mmW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p2mg"));
  crysDispP2mgW = XmCreatePushButton(crysDispMenuW, "cd_7", arglst, 1);
  *tag[++j] = 7;
  XtAddCallback(crysDispP2mgW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP2mgW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p2gg"));
  crysDispP2ggW = XmCreatePushButton(crysDispMenuW, "cd_8", arglst, 1);
  *tag[++j] = 8;
  XtAddCallback(crysDispP2ggW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP2ggW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("c2mm"));
  crysDispC2mmW = XmCreatePushButton(crysDispMenuW, "cd_9", arglst, 1);
  *tag[++j] = 9;
  XtAddCallback(crysDispC2mmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispC2mmW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p4"));
  crysDispP4W = XmCreatePushButton(crysDispMenuW, "cd_10", arglst, 1);
  *tag[++j] = 10;
  XtAddCallback(crysDispP4W, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP4W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p4mm"));
  crysDispP4mmW = XmCreatePushButton(crysDispMenuW, "cd_11", arglst, 1);
  *tag[++j] = 11;
  XtAddCallback(crysDispP4mmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP4mmW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p4gm"));
  crysDispP4gmW = XmCreatePushButton(crysDispMenuW, "cd_12", arglst, 1);
  *tag[++j] = 12;
  XtAddCallback(crysDispP4gmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP4gmW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p3"));
  crysDispP3W = XmCreatePushButton(crysDispMenuW, "cd_13", arglst, 1);
  *tag[++j] = 13;
  XtAddCallback(crysDispP3W, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP3W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p3m1"));
  crysDispP3m1W = XmCreatePushButton(crysDispMenuW, "cd_14", arglst, 1);
  *tag[++j] = 14;
  XtAddCallback(crysDispP3m1W, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP3m1W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p31m"));
  crysDispP31mW = XmCreatePushButton(crysDispMenuW, "cd_15", arglst, 1);
  *tag[++j] = 15;
  XtAddCallback(crysDispP31mW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP31mW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p6"));
  crysDispP6W = XmCreatePushButton(crysDispMenuW, "cd_16", arglst, 1);
  *tag[++j] = 16;
  XtAddCallback(crysDispP6W, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP6W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("p6mm"));
  crysDispP6mmW = XmCreatePushButton(crysDispMenuW, "cd_17", arglst, 1);
  *tag[++j] = 17;
  XtAddCallback(crysDispP6mmW, XmNactivateCallback, 
		cDispSymm_changed, (XtPointer)tag[j]);
  XtManageChild(crysDispP6mmW);

  // xtallize widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Xtallize"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 230);
  crysDispXtalLW = XmCreateLabel(crysDispScreenW, "cd_xtal", arglst, 3);
  XtManageChild(crysDispXtalLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("ncellx"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 260);
  crysDispNcellxLW = XmCreateLabel(crysDispScreenW, "cd_ncxl", arglst, 3);
  XtManageChild(crysDispNcellxLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("ncelly"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 290);
  crysDispNcellyLW = XmCreateLabel(crysDispScreenW, "cd_ncyl", arglst, 3);
  XtManageChild(crysDispNcellyLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("a Dimension"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 320);
  crysDispAdimLW = XmCreateLabel(crysDispScreenW, "cd_adiml", arglst, 3);
  XtManageChild(crysDispAdimLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("b Dimension"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 350);
  crysDispBdimLW = XmCreateLabel(crysDispScreenW, "cd_bdiml", arglst, 3);
  XtManageChild(crysDispBdimLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Gamma"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 380);
  crysDispGLW = XmCreateLabel(crysDispScreenW, "cd_gl", arglst, 3);
  XtManageChild(crysDispGLW);

  // Common scroll bar attributes
  XtSetArg(arglst[0], XmNx, 125);
  XtSetArg(arglst[1], XmNmaximum, 22);
  XtSetArg(arglst[2], XmNminimum, 1);
  XtSetArg(arglst[3], XmNpageIncrement, 5);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNvalue, 1);

  XtSetArg(arglst[7], XmNy, 265);
  ncellxScrollW = XmCreateScrollBar(crysDispScreenW, "cd_ncxs", arglst, 8);
  XtAddCallback(ncellxScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(ncellxScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(ncellxScrollW);  

  XtSetArg(arglst[7], XmNy, 295);
  ncellyScrollW = XmCreateScrollBar(crysDispScreenW, "cd_ncys", arglst, 8);
  XtAddCallback(ncellyScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(ncellyScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(ncellyScrollW);  

  XtSetArg(arglst[7], XmNy, 325);
  adimScrollW = XmCreateScrollBar(crysDispScreenW, "cd_adims", arglst, 8);
  XtAddCallback(adimScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(adimScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(adimScrollW);  

  XtSetArg(arglst[7], XmNy, 355);
  bdimScrollW = XmCreateScrollBar(crysDispScreenW, "cd_bdims", arglst, 8);
  XtAddCallback(bdimScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(bdimScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(bdimScrollW);  

  XtSetArg(arglst[7], XmNy, 385);
  gammaXtalScrollW = XmCreateScrollBar(crysDispScreenW, "cd_gxs", arglst, 8);
  XtAddCallback(gammaXtalScrollW, XmNvalueChangedCallback, 
		crysDisp_scroll_change, NULL);
  XtAddCallback(gammaXtalScrollW, XmNdragCallback, 
		crysDisp_scroll_change, NULL);
  XtManageChild(gammaXtalScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  1"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 260);
  ncellxvalueW = XmCreateLabel(crysDispScreenW, "cd_ncxv", arglst, 3);
  XtManageChild(ncellxvalueW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  1"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 290);
  ncellyvalueW = XmCreateLabel(crysDispScreenW, "cd_ncyv", arglst, 3);
  XtManageChild(ncellyvalueW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 320);
  XtSetArg(arglst[3], XmNvalue, "1.00            ");
  adimTextW = XmCreateText(crysDispScreenW, "cd_adimt", arglst, 4);
  XtAddCallback(adimTextW, XmNvalueChangedCallback, crystalDisp_changed, NULL);
  XtManageChild(adimTextW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 350);
  XtSetArg(arglst[3], XmNvalue, "1.00            ");
  bdimTextW = XmCreateText(crysDispScreenW, "cd_bdimt", arglst, 4);
  XtAddCallback(bdimTextW, XmNvalueChangedCallback, crystalDisp_changed, NULL);
  XtManageChild(bdimTextW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 380);
  XtSetArg(arglst[3], XmNvalue, "90.0            ");
  gammaXtalTextW = XmCreateText(crysDispScreenW, "cd_gxt", arglst, 4);
  XtAddCallback(gammaXtalTextW, XmNvalueChangedCallback, 
		crystalDisp_changed, NULL);
  XtManageChild(gammaXtalTextW);

} // end function create_crysdispscreen
