#include "gui.h"

void create_dioscreen () {
  // function name: create_dioscreen
  // Create and initialize icos projection attributes screen
  
  int *tag1, *tag2, *tag3, *tag4, *tag5, *tag6;
  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));
  tag3 = (int *) malloc(sizeof(int));
  tag4 = (int *) malloc(sizeof(int));
  tag5 = (int *) malloc(sizeof(int));
  tag6 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Icos options"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 450);
  XtSetArg(arglst[7], XmNheight, 270);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  dioScreenW = XmCreateFormDialog(toplevel_widget, "dio", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 230);
  dioExitW = XmCreatePushButton(dioScreenW, "dio_exit", arglst, 5);
  XtAddCallback(dioExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(dioExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 80);
  XtSetArg(arglst[4], XmNy, 230);
  dioHelpW = XmCreatePushButton(dioScreenW, "dio_help", arglst, 5);
  *tag1 = DIOHELP;
  XtAddCallback(dioHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(dioHelpW);

  // Icosahedral projection parameters
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Threshold: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 145);
  dioThreshLabelW = XmCreateLabel(dioScreenW, "dio_tl", arglst, 3);
  XtManageChild(dioThreshLabelW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 115);
  XtSetArg(arglst[2], XmNy, 145);
  dioThreshTextW = XmCreateText(dioScreenW, "dio_tt", arglst, 3);
  XtManageChild(dioThreshTextW);
  XmTextSetString(dioThreshTextW, "1.0");

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Slide: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 175);
  dioSlideLabelW = XmCreateLabel(dioScreenW, "dio_sl", arglst, 3);
  XtManageChild(dioSlideLabelW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 115);
  XtSetArg(arglst[2], XmNy, 175);
  dioSlideTextW = XmCreateText(dioScreenW, "dio_st", arglst, 3);
  XtManageChild(dioSlideTextW);
  XmTextSetString(dioSlideTextW, "0.4");

  // Destructive option
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Destructive"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 100);
  dioDestW = XmCreateToggleButton(dioScreenW, "dio_destroy", arglst, 3);
  *tag6 = DIODESTROY;
  XtAddCallback(dioDestW, XmNvalueChangedCallback, dio_change, (XtPointer)tag6);
  XtManageChild(dioDestW);

  // Icosahedral projection options
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 10);
  XtSetArg(arglst[5], XmNspacing, 1);
  dioControlsW = XmCreateRadioBox(dioScreenW, "bin_controls", arglst, 6);
  XtManageChild(dioControlsW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Cut out Icos Face"));
  dioFaceW = XmCreateToggleButton(dioControlsW, "dio_face", arglst, 1);
  *tag2 = CUTFACE;
  XtAddCallback(dioFaceW, XmNvalueChangedCallback, dio_change, (XtPointer)tag2);
  XtManageChild(dioFaceW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Cut out ASU"));
  dioAsuW = XmCreateToggleButton(dioControlsW, "dio_asu", arglst, 1);
  *tag3 = CUTASYM;
  XtAddCallback(dioAsuW, XmNvalueChangedCallback, dio_change, (XtPointer)tag3);
  XtManageChild(dioAsuW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Bulge"));
  dioBulgeW = XmCreateToggleButton(dioControlsW, "dio_bulge", arglst, 1);
  *tag4 = BULGE;
  XtAddCallback(dioBulgeW, XmNvalueChangedCallback, dio_change, (XtPointer)tag4);
  XtManageChild(dioBulgeW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Normal Icos Shell"));
  XtSetArg(arglst[1], XmNset, 1);
  dioNormW = XmCreateToggleButton(dioControlsW, "dio_norm", arglst, 2);
  *tag5 = ICOSNORMAL;
  XtAddCallback(dioNormW, XmNvalueChangedCallback, dio_change, (XtPointer)tag5);
  XtManageChild(dioNormW);

} // end function create_dioscreen
