#include "gui.h"

void create_editboxscreen() {
  // function name: create_editboxscreen
  // Create and initialize attributes of movie display screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("2D Rendering"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 100);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 550);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  editBoxScreenW = XmCreateFormDialog(toplevel_widget, "eb", arglst, 9);

  XtSetArg(arglst[0], XmNheight, 38);
  XtSetArg(arglst[1], XmNborderWidth, 1);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNtopAttachment, XmATTACH_FORM);
  editBarW = XmCreateForm(editBoxScreenW, "eb_bar", arglst, 5);
  XtManageChild(editBarW);

  XtSetArg(arglst[0], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNtopWidget, editBarW);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNresizePolicy, XmRESIZE_ANY);
  editBoxW = XmCreateDrawingArea(editBoxScreenW, "eb_draw", arglst, 6);
  XtAddCallback(editBoxW, XmNexposeCallback, DrawEditBoxWindow, NULL);
  XtAddCallback(editBoxW, XmNinputCallback, editBoxClick, NULL);
  XtManageChild(editBoxW);

  // editBarW controls

  // Up/down arrow behaviors controlled by boxNumArrowActivateButton
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 1);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNy, 1);
  boxUpW = XmCreateArrowButton(editBarW, "eb_up", arglst, 5);
  XtManageChild(boxUpW);  
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNy, 18);
  boxDownW = XmCreateArrowButton(editBarW, "eb_dn", arglst, 5);
  XtManageChild(boxDownW);  

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, boxUpW);
  XtSetArg(arglst[3], XmNy, 1);
  XtSetArg(arglst[4], XmNvalue, "1");
  editBoxTextW = XmCreateText(editBarW, "eb_txt", arglst, 5);
  XtManageChild(editBoxTextW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, editBoxTextW);
  movieDoneW = XmCreatePushButton(editBarW, "eb_exit", arglst, 5);
  XtAddCallback(movieDoneW, XmNactivateCallback, movie_deactivate, NULL);
  XtManageChild(movieDoneW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("10x,10y"));
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, movieDoneW);
  lightSourceLabelW = XmCreateLabel(editBarW, "eb_lsl", arglst, 5);
  XtManageChild(lightSourceLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("C"));
  XtSetArg(arglst[1], XmNy, 5);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, lightSourceLabelW);
  movieCBW = XmCreatePushButton(editBarW, "eb_cbw", arglst, 4);
  XtAddCallback(movieCBW, XmNactivateCallback, movie_contour_activate, NULL);
  XtManageChild(movieCBW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Zoom"));
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, movieCBW);
  movieZLW = XmCreateLabel(editBarW, "eb_zlw", arglst, 5);
  XtManageChild(movieZLW);

  XtSetArg(arglst[0], XmNcolumns, 2);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, movieZLW);
  XtSetArg(arglst[3], XmNy, 1);
  XtSetArg(arglst[4], XmNvalue, "1");
  editBoxZoomTextW = XmCreateText(editBarW, "eb_ztxt", arglst, 5);
  XtAddCallback(editBoxZoomTextW, XmNactivateCallback, 
		editBoxZoomText_changed, NULL);
  XtManageChild(editBoxZoomTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, editBoxZoomTextW);
  XtSetArg(arglst[5], XmNy, 1);
  editBoxZoomUpW = XmCreateArrowButton(editBarW, "eb_zup", arglst, 6);
  XtAddCallback(editBoxZoomUpW, XmNactivateCallback, 
		editBoxZoomArrowActivate, NULL);
  XtManageChild(editBoxZoomUpW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, editBoxZoomTextW);
  XtSetArg(arglst[5], XmNy, 18);
  editBoxZoomDownW = XmCreateArrowButton(editBarW, "eb_zdn", arglst, 6);
  XtAddCallback(editBoxZoomDownW, XmNactivateCallback, 
		editBoxZoomArrowActivate, NULL);
  XtManageChild(editBoxZoomDownW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Save"));
  XtSetArg(arglst[1], XmNx, 290);
  movieSaveW = XmCreatePushButton(editBarW, "eb_save", arglst, 2);
  XtAddCallback(movieSaveW, XmNactivateCallback, editBox_save_activate, NULL);
  XtManageChild(movieSaveW);

  // Paint form (child of editBarW)
  XtSetArg(arglst[0], XmNheight, 38);
  XtSetArg(arglst[1], XmNx, 290);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  paintFormW = XmCreateForm(editBarW, "eb_pf", arglst, 3);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Paint"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_FORM);
  paintFormLW = XmCreateLabel(paintFormW, "eb_pfl", arglst, 2);
  XtManageChild(paintFormLW);
  
  XtSetArg(arglst[0], XmNcolumns, 2);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, paintFormLW);
  XtSetArg(arglst[3], XmNy, 1);
  XtSetArg(arglst[4], XmNvalue, "10");
  editBoxPaintTextW = XmCreateText(paintFormW, "eb_pft", arglst, 5);
  XtAddCallback(editBoxPaintTextW, XmNactivateCallback, 
		editBoxPaintText_changed, NULL);
  XtManageChild(editBoxPaintTextW);

  // Up/down arrow behaviors controlled by paintSizeArrowActivateButton
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, editBoxPaintTextW);
  XtSetArg(arglst[4], XmNy, 1);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  paintUpW = XmCreateArrowButton(paintFormW, "eb_pfu", arglst, 6);
  XtManageChild(paintUpW);  
  XtSetArg(arglst[4], XmNy, 18);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  paintDownW = XmCreateArrowButton(paintFormW, "eb_pfd", arglst, 6);
  XtManageChild(paintDownW);  
  // End paint form (child of editBarW)

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Undo"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, paintFormW);
  undoW = XmCreatePushButton(editBarW, "eb_unb", arglst, 3);
  XtAddCallback(undoW, XmNactivateCallback, editBox_undo_activate, NULL);
  XtManageChild(undoW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("SavPnt"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, undoW);
  savePaintW = XmCreatePushButton(editBarW, "eb_unb", arglst, 3);
  XtAddCallback(savePaintW, XmNactivateCallback, editBox_save_activate, NULL);
  XtManageChild(savePaintW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("000"));
  XtSetArg(arglst[1], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, movieSaveW);
  XtSetArg(arglst[4], XmNrecomputeSize, 0);
  XtSetArg(arglst[5], XmNwidth, 20);
  // XtSetArg(arglst[6], XmNfontList, globFont2);
  minLabelW = XmCreateLabel(editBarW, "eb_minl", arglst, 6);
  XtManageChild(minLabelW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNy, 3);
  XtSetArg(arglst[5], XmNheight, 30);
  XtSetArg(arglst[6], XmNwidth, 12);
  XtSetArg(arglst[7], XmNsliderSize, 1);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  XtSetArg(arglst[9], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[10], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[11], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[12], XmNleftWidget, minLabelW);
  movieMinW = XmCreateScrollBar(editBarW, "eb_mins", arglst, 13);
  *tag[++j] = MOVIEMIN;
  XtAddCallback(movieMinW, XmNvalueChangedCallback, 
		movieMinMax_change, (XtPointer)tag[j]);

  // Movie controls form (child of editBarW) and children
  XtSetArg(arglst[0], XmNheight, 38);
  XtSetArg(arglst[1], XmNborderWidth, 2);
  XtSetArg(arglst[2], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, movieMinW);
  playFormW = XmCreateForm(editBarW, "eb_plf", arglst, 6);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 21);
  XtSetArg(arglst[2], XmNheight, 21);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNtopAttachment, XmATTACH_FORM);
  movieArrowUpW = XmCreatePushButton(playFormW, "eb_pfup", arglst, 6);
  XtAddCallback(movieArrowUpW, XmNactivateCallback, 
		mapMovieArrowActivate, NULL);
  XtManageChild(movieArrowUpW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 21);
  XtSetArg(arglst[2], XmNheight, 21);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_FORM);
  movieArrowDownW = XmCreatePushButton(playFormW, "eb_pfdn", arglst, 6);
  XtAddCallback(movieArrowDownW, XmNactivateCallback, 
		mapMovieArrowActivate, NULL);
  XtManageChild(movieArrowDownW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 19);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, movieArrowDownW);
  XtSetArg(arglst[6], XmNbottomAttachment, XmATTACH_FORM);
  flashLightW = XmCreatePushButton(playFormW, "eb_pffl", arglst, 7);
  *tag[++j] = FLASHLIGHT;
  XtAddCallback(flashLightW, XmNactivateCallback, 
		mapMovie_show_activate, (XtPointer)tag[j]);
  XtManageChild(flashLightW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 19);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, movieArrowUpW);
  XtSetArg(arglst[6], XmNtopAttachment, XmATTACH_FORM);
  rockW = XmCreatePushButton(playFormW, "eb_pfrk", arglst, 7);
  *tag[++j] = ROCKER;
  XtAddCallback(rockW, XmNactivateCallback, 
		mapMovie_show_activate, (XtPointer)tag[j]);
  XtManageChild(rockW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, rockW);
  infiniW = XmCreatePushButton(playFormW, "eb_pfrk", arglst, 6);
  *tag[++j] = INFINIMAP;
  XtAddCallback(infiniW, XmNactivateCallback, 
		mapMovie_show_activate, (XtPointer)tag[j]);
  XtManageChild(infiniW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, infiniW);
  playW = XmCreatePushButton(playFormW, "eb_pfpl", arglst, 6);
  *tag[++j] = MAP;
  XtAddCallback(playW, XmNactivateCallback, 
		mapMovie_show_activate, (XtPointer)tag[j]);
  XtManageChild(playW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, playW);
  stopW = XmCreatePushButton(playFormW, "eb_pfst", arglst, 6);
  *tag[++j] = MAPSTOP;
  XtAddCallback(stopW, XmNactivateCallback, 
		mapMovie_show_activate, (XtPointer)tag[j]);
  XtManageChild(stopW);
  // End movie controls form (child of editBarW)

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNy, 3);
  XtSetArg(arglst[5], XmNheight, 30);
  XtSetArg(arglst[6], XmNwidth, 12);
  XtSetArg(arglst[7], XmNsliderSize, 1);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  XtSetArg(arglst[9], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[10], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[11], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[12], XmNleftWidget, playFormW);
  XtSetArg(arglst[13], XmNvalue, 100);
  movieMaxW = XmCreateScrollBar(editBarW, "eb_maxs", arglst, 14);
  *tag[++j] = MOVIEMAX;
  XtAddCallback(movieMaxW, XmNvalueChangedCallback, 
		movieMinMax_change, (XtPointer)tag[j]);


  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("100"));
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, movieMaxW);
  XtSetArg(arglst[4], XmNrecomputeSize, 0);
  XtSetArg(arglst[5], XmNwidth, 20);
  // XtSetArg(arglst[6], XmNfontList, globFont2);
  maxLabelW = XmCreateLabel(editBarW, "eb_maxl", arglst, 6);
  XtManageChild(maxLabelW);

} // end function create_editboxscreen
