#include "gui.h"

void create_emcoravgscreen () {
  // function name: create_emcoravgscreen
  // Create and initialize attributes of emcoravg screen
  
  int *tag[20], i, j=-1;
  for (i=0; i<20; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("EMCORAVG"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 540);
  XtSetArg(arglst[5], XmNy, 200);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 450);
  emcorAvgScreenW = XmCreateFormDialog(toplevel_widget, "emc", arglst, 8);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 370);
  emcorAvgExitW = XmCreatePushButton(emcorAvgScreenW, "emc_exit", arglst, 5);
  XtAddCallback(emcorAvgExitW, XmNactivateCallback, emcoravg_deactivate, NULL);
  XtManageChild(emcorAvgExitW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Tryit"));
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 370);
  emcorAvgTryW = XmCreatePushButton(emcorAvgScreenW, "emc_try", arglst, 3);
  XtAddCallback(emcorAvgTryW, XmNactivateCallback, emcoravg_tryit_activate, NULL);
  XtManageChild(emcorAvgTryW);

  XtSetArg(arglst[0], XmNwidth, 256);
  XtSetArg(arglst[1], XmNheight, 256);
  XtSetArg(arglst[2], XmNx, 5);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  emcorAvgDrawW = XmCreateDrawingArea(emcorAvgScreenW, "emd_draw", arglst, 5);
  XtAddCallback(emcorAvgDrawW, XmNexposeCallback, 
		DrawEmcoravgWindow, NULL);
  XtManageChild(emcorAvgDrawW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Save Averaged Image"));
  XtSetArg(arglst[1], XmNx, 220);
  XtSetArg(arglst[2], XmNy, 370);
  emcorAvgSaveW = XmCreatePushButton(emcorAvgScreenW, "emc_save", arglst, 3);
  XtAddCallback(emcorAvgSaveW, XmNactivateCallback, emcoravg_save_activate, NULL);
  XtManageChild(emcorAvgSaveW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Get reference file"));
  XtSetArg(arglst[1], XmNx, 310);
  XtSetArg(arglst[2], XmNy, 70);
  emcorAvgFileW = XmCreatePushButton(emcorAvgScreenW, "emc_file", arglst, 3);
  *tag[++j] = EMCORAVGREAD;
  XtAddCallback(emcorAvgFileW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(emcorAvgFileW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Zoom"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 10);
  emcorAvgZLW = XmCreateLabel(emcorAvgScreenW, "emc_zl", arglst, 3);
  XtManageChild(emcorAvgZLW);

  XtSetArg(arglst[0], XmNcolumns, 3);
  XtSetArg(arglst[1], XmNx, 310);
  XtSetArg(arglst[2], XmNy, 8);
  emcorAvgZTW = XmCreateText(emcorAvgScreenW, "emc_zt", arglst, 3);
  XtAddCallback(emcorAvgZTW, XmNvalueChangedCallback, emcoravg_text_changed, NULL);
  XtManageChild(emcorAvgZTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Radius"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 150);
  emcorAvgRLW = XmCreateLabel(emcorAvgScreenW, "emc_rl", arglst, 3);
  XtManageChild(emcorAvgRLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 325);
  XtSetArg(arglst[2], XmNy, 148);
  XtSetArg(arglst[3], XmNvalue, "10       ");
  emcorAvgRTW = XmCreateText(emcorAvgScreenW, "emc_rt", arglst, 4);
  XtManageChild(emcorAvgRTW);

  // Up/down arrow behaviors controlled by coravgArrowButton
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, emcorAvgRTW);
  XtSetArg(arglst[4], XmNy, 148);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  emcorAvgUAW = XmCreateArrowButton(emcorAvgScreenW, "emc_ua", arglst, 6);
  XtManageChild(emcorAvgUAW);
  XtSetArg(arglst[4], XmNy, 163);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  emcorAvgDAW = XmCreateArrowButton(emcorAvgScreenW, "emc_da", arglst, 6);
  XtManageChild(emcorAvgDAW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("LowLim "));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 220);
  emcorAvgLLLW = XmCreateLabel(emcorAvgScreenW, "emc_lll", arglst, 3);
  XtManageChild(emcorAvgLLLW);

  XtSetArg(arglst[0], XmNmaximum, 28350);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 500);	
  XtSetArg(arglst[3], XmNincrement, 100);	
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNy, 220);
  XtSetArg(arglst[6], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[7], XmNleftWidget, emcorAvgLLLW);
  emcorAvgLLSW = XmCreateScrollBar(emcorAvgScreenW, "emc_lls", arglst, 8);
  XtAddCallback(emcorAvgLLSW, XmNvalueChangedCallback, 
		coravg_scroll_change, NULL);
  XtAddCallback(emcorAvgLLSW, XmNdragCallback, 
		coravg_scroll_change, NULL);
  XtManageChild(emcorAvgLLSW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0   "));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, emcorAvgLLSW);
  XtSetArg(arglst[3], XmNy, 220);
  emcorAvgLLVW = XmCreateLabel(emcorAvgScreenW, "emc_llv", arglst, 4);
  XtManageChild(emcorAvgLLVW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Show LowLim"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 260); 
  emcorAvgLLSTW = XmCreateToggleButton(emcorAvgScreenW, "emc_llst", arglst, 3);
  *tag[++j] = SHOWLOWLIM;
  XtAddCallback(emcorAvgLLSTW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(emcorAvgLLSTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Use Average Image"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 300); 
  emcorAvgLLUTW = XmCreateToggleButton(emcorAvgScreenW, "emc_llut", arglst, 3);
  *tag[++j] = USEAVGCORAVG;
  XtAddCallback(emcorAvgLLUTW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(emcorAvgLLUTW);


} // end function create_emcoravgscreen
