#include "gui.h"

void create_fftscreen() {
  // function name: create_fftscreen
  // Create and initialize attributes of FFT screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("FFT"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 40);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 1050);
  XtSetArg(arglst[7], XmNheight, 750);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  fftScreenW = XmCreateFormDialog(toplevel_widget, "fft", arglst, 9);

  // Drawlite widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("D"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, fftHelpW);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  drawFFTLiteButtonW = XmCreatePushButton(fftScreenW, "fft_dlb", arglst, 4);
  *tag[++j] = 1;
  XtAddCallback(drawFFTLiteButtonW, XmNactivateCallback, 
		drawFFTLiteActivate, (XtPointer)tag[j]);
  XtManageChild(drawFFTLiteButtonW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Dmain"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, drawFFTLiteButtonW);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  drawFFT2LiteButtonW = XmCreatePushButton(fftScreenW, "fft_dl2b", arglst, 4);
  *tag[++j] = 2;
  XtAddCallback(drawFFT2LiteButtonW, XmNactivateCallback, 
		drawFFTLiteActivate, (XtPointer)tag[j]);
  XtManageChild(drawFFT2LiteButtonW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 560);
  latResetButW = XmCreatePushButton(fftScreenW, "fft_latrb", arglst, 5);
  XtAddCallback(latResetButW, XmNactivateCallback, latReset_activate, NULL);
  XtManageChild(latResetButW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("A*,B*,Gamma*,Omega"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, latResetButW);
  XtSetArg(arglst[3], XmNy, 565);
  latResetLabelW = XmCreateLabel(fftScreenW, "fft_latrl", arglst, 4);
  XtManageChild(latResetLabelW);

  // Display form (upper right)

  XtSetArg(arglst[0], XmNheight, 245);
  XtSetArg(arglst[1], XmNwidth, 420);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  displayFFTFormW = XmCreateForm(fftScreenW, "fft_dispf", arglst, 6);
  XtManageChild(displayFFTFormW);

  // FFT menu button (child of display form)

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  fftMenuBarW = XmCreateMenuBar(displayFFTFormW, "fft_fftmb", arglst, 4);
  XtManageChild(fftMenuBarW);

  fftMenuW = XmCreatePulldownMenu(fftMenuBarW, "fft_fftm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("FFT"));
  XtSetArg(arglst[1], XmNsubMenuId, fftMenuW);
  fftMenuEntryW = XmCreateCascadeButton(fftMenuBarW, "fft_fftme", arglst, 2);
  XtManageChild(fftMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("LOP/HIP Filter"));
  fftLopHipBW = XmCreatePushButton(fftMenuW, "fft_lophipb", arglst, 1);
  *tag[++j] = LOPHIP;
  XtAddCallback(fftLopHipBW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(fftLopHipBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("CTF Estimation"));
  fftCtfEstBW = XmCreatePushButton(fftMenuW, "fft_ctfestb", arglst, 1);
  *tag[++j] = CTF;
  XtAddCallback(fftCtfEstBW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(fftCtfEstBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Lattice Refinement/Filtering"));
  fftLatRefBW = XmCreatePushButton(fftMenuW, "fft_latrefb", arglst, 1);
  *tag[++j] = LATREFINE;
  XtAddCallback(fftLatRefBW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(fftLatRefBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rotational Filtering"));
  fftRotFltBW = XmCreatePushButton(fftMenuW, "fft_rotfltfb", arglst, 1);
  XtAddCallback(fftRotFltBW, XmNactivateCallback, 
		rotflt_screen_activate, NULL);
  XtManageChild(fftRotFltBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Measure FFT"));
  fftMeasBW = XmCreatePushButton(fftMenuW, "fft_measb", arglst, 1);
  *tag[++j] = FFTMEASURE;
  XtAddCallback(fftMeasBW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(fftMeasBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write FFT to RAW file"));
  fftWriteFFTBW = XmCreatePushButton(fftMenuW, "fft_wrfb", arglst, 1);
  *tag[++j] = WRITEFFT;
  XtAddCallback(fftWriteFFTBW, XmNactivateCallback, 
		fft_writeFB_activate, (XtPointer)tag[j]);
  XtManageChild(fftWriteFFTBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write Filtered Image to RAW/PIF files"));
  fftWriteBackBW = XmCreatePushButton(fftMenuW, "fft_wrfb", arglst, 1);
  *tag[++j] = WRITEBACK;
  XtAddCallback(fftWriteBackBW, XmNactivateCallback, 
		fft_writeFB_activate, (XtPointer)tag[j]);
  XtManageChild(fftWriteBackBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write BYTE images after applying CTF"));
  fftWriteCtf1BW = XmCreatePushButton(fftMenuW, "fft_wctf1b", arglst, 1);
  *tag[++j] = APPLYCTF;
  XtAddCallback(fftWriteCtf1BW, XmNactivateCallback, 
		ctf_appodize_activate, (XtPointer)tag[j]);
  XtManageChild(fftWriteCtf1BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write BYTE images after applying 1/CTF"));
  fftWriteCtf2BW = XmCreatePushButton(fftMenuW, "fft_wctf2b", arglst, 1);
  *tag[++j] = APPLYINVERSECTF;
  XtAddCallback(fftWriteCtf2BW, XmNactivateCallback, 
		ctf_appodize_activate, (XtPointer)tag[j]);
  XtManageChild(fftWriteCtf2BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write R4 images after applying CTF"));
  fftWriteCtf3BW = XmCreatePushButton(fftMenuW, "fft_wctf3b", arglst, 1);
  *tag[++j] = APPLYCTFR4;
  XtAddCallback(fftWriteCtf3BW, XmNactivateCallback, 
		ctf_appodize_activate, (XtPointer)tag[j]);
  XtManageChild(fftWriteCtf3BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write R4 images after applying 1/CTF"));
  fftWriteCtf4BW = XmCreatePushButton(fftMenuW, "fft_wctf4b", arglst, 1);
  *tag[++j] = APPLYINVERSECTFR4;
  XtAddCallback(fftWriteCtf4BW, XmNactivateCallback, 
		ctf_appodize_activate, (XtPointer)tag[j]);
  XtManageChild(fftWriteCtf4BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Read fft_buffer.dat"));
  fftReadFFTBW = XmCreatePushButton(fftMenuW, "fft_readfb", arglst, 1);
  XtAddCallback(fftReadFFTBW, XmNactivateCallback, 
		read_fftbuffer_activate, NULL);
  XtManageChild(fftReadFFTBW);

  // Linear/log/non-linear radio (child of display form) 

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNx, 5);
  XtSetArg(arglst[4], XmNy, 5);
  XtSetArg(arglst[5], XmNspacing, 10);
  linlogRadioW = XmCreateRadioBox(displayFFTFormW, "fft_linlog", arglst, 6);
  XtManageChild(linlogRadioW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Linear"));
  linearFFTtoggleW = XmCreateToggleButton(linlogRadioW, "fft_lint", arglst, 1);
  *tag[++j] = LINEARFFT;
  XtAddCallback(linearFFTtoggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(linearFFTtoggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Log"));
  XtSetArg(arglst[1], XmNset, 1); 
  logFFTtoggleW = XmCreateToggleButton(linlogRadioW, "fft_logt", arglst, 2);
  *tag[++j] = LOGFFT;
  XtAddCallback(logFFTtoggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(logFFTtoggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Non-Linear"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  nonlinFFTtoggleW = XmCreateToggleButton(linlogRadioW, "fft_nont", arglst, 2);
  *tag[++j] = NONLINFFT;
  XtAddCallback(nonlinFFTtoggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(nonlinFFTtoggleW);

  // FFT size radio (child of display form) 

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNx, 129);
  XtSetArg(arglst[4], XmNy, 5);
  XtSetArg(arglst[5], XmNspacing, 3);
  fftsizeRadioW = XmCreateRadioBox(displayFFTFormW, "fft_size", arglst, 6);
  XtManageChild(fftsizeRadioW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("1024 x 1024"));
  a1024FFTW = XmCreateToggleButton(fftsizeRadioW, "fft_1024", arglst, 1);
  *tag[++j] = A1024FFT;
  XtAddCallback(a1024FFTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(a1024FFTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("512 x 512"));
  XtSetArg(arglst[1], XmNset, 1); 
  a512FFTW = XmCreateToggleButton(fftsizeRadioW, "fft_512", arglst, 2);
  *tag[++j] = A512FFT;
  XtAddCallback(a512FFTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(a512FFTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("256 x 256"));
  a256FFTW = XmCreateToggleButton(fftsizeRadioW, "fft_256", arglst, 1);
  *tag[++j] = A256FFT;
  XtAddCallback(a256FFTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(a256FFTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("128 x 128"));
  a128FFTW = XmCreateToggleButton(fftsizeRadioW, "fft_128", arglst, 1);
  *tag[++j] = A128FFT;
  XtAddCallback(a128FFTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(a128FFTW);

  // Intensity/recalc radio (child of display form) 

  XtSetArg(arglst[0], XmNx, 250);
  XtSetArg(arglst[1], XmNy, 5);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  ampFormW = XmCreateForm(displayFFTFormW, "fft_ampf", arglst, 3);
  XtManageChild(ampFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Intensity"));
  XtSetArg(arglst[1], XmNx, 3);
  XtSetArg(arglst[2], XmNy, 3);
  amplitudeToggleW = XmCreatePushButton(ampFormW, "fft_ampt", arglst, 3);
  *tag[++j] = AMPLITUDE;
  XtAddCallback(amplitudeToggleW, XmNactivateCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(amplitudeToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Recalc FFT"));
  XtSetArg(arglst[1], XmNx, 3);
  XtSetArg(arglst[2], XmNy, 30);
  recalcToggleW = XmCreatePushButton(ampFormW, "fft_recalc", arglst, 3);
  *tag[++j] = RECALCFFT;
  XtAddCallback(recalcToggleW, XmNactivateCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(recalcToggleW);

  // Other display controls

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Display 1024 FFT"));
  XtSetArg(arglst[1], XmNx, 260);
  XtSetArg(arglst[2], XmNy, 70);
  disp1024W = XmCreateToggleButton(displayFFTFormW, "fft_d1024", arglst, 3);
  *tag[++j] = DISP1024FFT;
  XtAddCallback(disp1024W, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(disp1024W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Lock Scrolls"));
  XtSetArg(arglst[1], XmNx, 260);
  XtSetArg(arglst[2], XmNy, 100);
  fftLockW = XmCreateToggleButton(displayFFTFormW, "fft_lock", arglst, 3);
  *tag[++j] = FFTLOCK;
  XtAddCallback(fftLockW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(fftLockW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Min"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 145);
  dispMinLW = XmCreateLabel(displayFFTFormW, "fft_dmin", arglst, 3);
  XtManageChild(dispMinLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Max"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 175);
  dispMaxLW = XmCreateLabel(displayFFTFormW, "fft_dmax", arglst, 3);
  XtManageChild(dispMaxLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("TFac"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 205);
  dispTfacLW = XmCreateLabel(displayFFTFormW, "fft_dtfac", arglst, 3);
  XtManageChild(dispTfacLW);

  XtSetArg(arglst[0], XmNmaximum, 1111111);
  XtSetArg(arglst[1], XmNminimum, -1111111);
  XtSetArg(arglst[2], XmNpageIncrement, 10000);
  XtSetArg(arglst[3], XmNincrement, 1000);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 60);
  XtSetArg(arglst[6], XmNy, 145);
  XtSetArg(arglst[7], XmNwidth, 190);
  minFFTscrollW = XmCreateScrollBar(displayFFTFormW, "fft_minsc", arglst, 8);
  *tag[++j] = FFTMIN;
  XtAddCallback(minFFTscrollW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = FFTMIN;
  XtAddCallback(minFFTscrollW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(minFFTscrollW);  

  XtSetArg(arglst[0], XmNmaximum, 1111111);
  XtSetArg(arglst[1], XmNminimum, -1111111);
  XtSetArg(arglst[2], XmNpageIncrement, 10000);
  XtSetArg(arglst[3], XmNincrement, 1000);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 60);
  XtSetArg(arglst[6], XmNy, 175);
  XtSetArg(arglst[7], XmNwidth, 190);
  XtSetArg(arglst[8], XmNvalue, 100);
  maxFFTscrollW = XmCreateScrollBar(displayFFTFormW, "fft_maxsc", arglst, 9);
  *tag[++j] = FFTMAX;
  XtAddCallback(maxFFTscrollW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = FFTMAX;
  XtAddCallback(maxFFTscrollW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(maxFFTscrollW);  

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, -111);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 60);
  XtSetArg(arglst[5], XmNy, 205);
  XtSetArg(arglst[6], XmNwidth, 190);
  tfacFFTscrollW = XmCreateScrollBar(displayFFTFormW, "fft_tfacsc", arglst, 7);
  *tag[++j] = FFTTFAC;
  XtAddCallback(tfacFFTscrollW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = FFTTFAC;
  XtAddCallback(tfacFFTscrollW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(tfacFFTscrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.00001"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 145);
  minFFTW = XmCreateLabel(displayFFTFormW, "fft_d2min", arglst, 3);
  XtManageChild(minFFTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.00100"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 175);
  maxFFTW = XmCreateLabel(displayFFTFormW, "fft_d2max", arglst, 3);
  XtManageChild(maxFFTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 205);
  tfacFFTW = XmCreateLabel(displayFFTFormW, "fft_d2tfac", arglst, 3);
  XtManageChild(tfacFFTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Range Min:                       "));
  XtSetArg(arglst[1], XmNx, 30);
  XtSetArg(arglst[2], XmNy, 225);
  theominFFTW = XmCreateLabel(displayFFTFormW, "fft_theomin", arglst, 3);
  XtManageChild(theominFFTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Max:                        "));
  XtSetArg(arglst[1], XmNx, 230);
  XtSetArg(arglst[2], XmNy, 225);
  theomaxFFTW = XmCreateLabel(displayFFTFormW, "fft_theomax", arglst, 3);
  XtManageChild(theomaxFFTW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, minFFTscrollW);
  XtSetArg(arglst[3], XmNy, 143);
  fftMinFixW = XmCreatePushButton(displayFFTFormW, "fft_minfix", arglst, 4);
  *tag[++j] = FFTMIN;
  XtAddCallback(fftMinFixW, XmNactivateCallback, 
		fixit_activate, (XtPointer)tag[j]);
  XtManageChild(fftMinFixW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, maxFFTscrollW);
  XtSetArg(arglst[3], XmNy, 173);
  fftMaxFixW = XmCreatePushButton(displayFFTFormW, "fft_maxfix", arglst, 4);
  *tag[++j] = FFTMAX;
  XtAddCallback(fftMaxFixW, XmNactivateCallback, 
		fixit_activate, (XtPointer)tag[j]);
  XtManageChild(fftMaxFixW);

  // Measure form (middle right)

  XtSetArg(arglst[0], XmNheight, 230);
  XtSetArg(arglst[1], XmNwidth, 238);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNy, 290);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  fftMeasureFormW = XmCreateForm(fftScreenW, "fft_measf", arglst, 5);
  XtManageChild(fftMeasureFormW);

  XtSetArg(arglst[0], XmNcolumns, 12);
  XtSetArg(arglst[1], XmNx, 80);
  XtSetArg(arglst[2], XmNy, 40);
  fftMeasurePSTextW = XmCreateText(fftMeasureFormW, "fft_measft", arglst, 3);
  XtManageChild(fftMeasurePSTextW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Button1 - 1st measure point"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 90);
  fftMeas1W = XmCreateLabel(fftMeasureFormW, "fft_meas1", arglst, 3);
  XtManageChild(fftMeas1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Button2 - 2nd measure point"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 110);
  fftMeas2W = XmCreateLabel(fftMeasureFormW, "fft_meas2", arglst, 3);
  XtManageChild(fftMeas2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Button3 - 1st MP is center"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 130);
  fftMeas3W = XmCreateLabel(fftMeasureFormW, "fft_meas3", arglst, 3);
  XtManageChild(fftMeas3W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Angstroms per pixel:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  fftMeas4W = XmCreateLabel(fftMeasureFormW, "fft_meas4", arglst, 3);
  XtManageChild(fftMeas4W);

  // Images form (bottom center)

  XtSetArg(arglst[0], XmNheight, 120);
  XtSetArg(arglst[1], XmNwidth, 150);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNx, 552);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  fftImagesFormW = XmCreateForm(fftScreenW, "imgf", arglst, 5);
  XtManageChild(fftImagesFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FFT Average    "));
  XtSetArg(arglst[1], XmNx, 2);
  XtSetArg(arglst[2], XmNy, 5);
  fftImagesTitleW = XmCreateLabel(fftImagesFormW, "imgftitl", arglst, 3);
  XtManageChild(fftImagesTitleW);

  // Up/down arrows behavior controlled by fftImgNumArrowButton
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 29);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  fftImgnumArrowUpW = XmCreateArrowButton(fftImagesFormW, 
					  "imgup", arglst, 5);
  XtManageChild(fftImgnumArrowUpW);
  XtSetArg(arglst[3], XmNy, 48);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  fftImgnumArrowDownW = XmCreateArrowButton(fftImagesFormW, 
					    "imgdn", arglst, 5);
  XtManageChild(fftImgnumArrowDownW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNy, 35);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, fftImgnumArrowDownW);
  fftImgNumW = XmCreateText(fftImagesFormW, "imgint", arglst, 4);
  XtManageChild(fftImgNumW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Img#"));
  XtSetArg(arglst[1], XmNy, 40);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, fftImgNumW);
  fftImgNumLW = XmCreateLabel(fftImagesFormW, "imgl", arglst, 4);
  XtManageChild(fftImgNumLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Average FFTs"));
  XtSetArg(arglst[1], XmNx, 5);
  XtSetArg(arglst[2], XmNy, 70);
  fftAvgBW = XmCreatePushButton(fftImagesFormW, "imgavgb", arglst, 3);
  XtAddCallback(fftAvgBW, XmNactivateCallback, fft_average_activate, NULL);
  XtManageChild(fftAvgBW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, fftAvgBW);
  XtSetArg(arglst[5], XmNy, 70);
  fftStopW = XmCreatePushButton(fftImagesFormW, "imgstop", arglst, 6);
  XtManageChild(fftStopW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Incoherent Avg"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 90);
  XtSetArg(arglst[3], XmNset, 1);
  fftCtfEnhW = XmCreateToggleButton(fftImagesFormW, "imgctfen", arglst, 4);
  *tag[++j] = CTFENHANCE;
  XtAddCallback(fftCtfEnhW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(fftCtfEnhW);

  // Feedback form (bottom center)

  XtSetArg(arglst[0], XmNheight, 130);
  XtSetArg(arglst[1], XmNwidth, 400);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNy, 560);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  fftFeedbackFormW = XmCreateForm(fftScreenW, "fft_fbf", arglst, 6);
  XtManageChild(fftFeedbackFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FFT Measurements"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNborderWidth, 1);
  fftFeedTitleW = XmCreateLabel(fftFeedbackFormW, "fft_fbft", arglst, 4);
  XtManageChild(fftFeedTitleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                        "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  fftMeasPixW = XmCreateLabel(fftFeedbackFormW, "fft_fbmp", arglst, 3);
  XtManageChild(fftMeasPixW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                        "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  fftMeasAngW = XmCreateLabel(fftFeedbackFormW, "fft_fbma", arglst, 3);
  XtManageChild(fftMeasAngW);

  // Help and exit buttons

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 710);
  fftExitW = XmCreatePushButton(fftScreenW, "fft_exit", arglst, 5);
  XtAddCallback(fftExitW, XmNactivateCallback, fft_deactivate, NULL);
  XtManageChild(fftExitW);
  
  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 65);
  XtSetArg(arglst[4], XmNy, 710);
  fftHelpW = XmCreatePushButton(fftScreenW, "fft_help", arglst, 5);
  *tag[++j] = FFTHELP;
  XtAddCallback(fftHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(fftHelpW);

  // Drawing areas and associated or nearby widgets

  XtSetArg(arglst[0], XmNwidth, 512);
  XtSetArg(arglst[1], XmNheight, 512);
  XtSetArg(arglst[2], XmNx, 5);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  fftDrawingW = XmCreateDrawingArea(fftScreenW, "fft_fdraw", arglst, 5);
  XtAddCallback(fftDrawingW, XmNexposeCallback, DrawFFTWindow, NULL);
  XtAddCallback(fftDrawingW, XmNinputCallback, fftClick, NULL);
  XtManageChild(fftDrawingW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Back Transform"));
  XtSetArg(arglst[1], XmNx, 540);
  XtSetArg(arglst[2], XmNy, 250); 
  backFFTToggleW = XmCreateToggleButton(fftScreenW, "fft_btog", arglst, 3);
  *tag[++j] = BACKFFT;
  XtAddCallback(backFFTToggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(backFFTToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Pointer Detail"));
  XtSetArg(arglst[1], XmNx, 540);
  XtSetArg(arglst[2], XmNy, 275);
  fftFeedbackW = XmCreatePushButton(fftScreenW, "fft_feed", arglst, 3);
  *tag[++j] = FFT;
  XtAddCallback(fftFeedbackW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(fftFeedbackW);

  XtSetArg(arglst[0], XmNwidth, 128);
  XtSetArg(arglst[1], XmNheight, 128);
  XtSetArg(arglst[2], XmNx, 520);
  XtSetArg(arglst[3], XmNy, 300);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  contourW = XmCreateDrawingArea(fftScreenW, "fft_cdraw", arglst, 5);
  XtAddCallback(contourW, XmNexposeCallback, DrawFFTWindow, NULL);
  XtAddCallback(contourW, XmNinputCallback, fftClick, NULL);
  XtManageChild(contourW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Overlay Intensity"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 440);
  overlayLW = XmCreateLabel(fftScreenW, "fft_overl", arglst, 3);
  XtManageChild(overlayLW);

  XtSetArg(arglst[0], XmNmaximum, 277);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNincrement, 10);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 540);
  XtSetArg(arglst[6], XmNy, 470);
  XtSetArg(arglst[7], XmNvalue, 100);
  overlaySW = XmCreateScrollBar(fftScreenW, "fft_overs", arglst, 8);
  *tag[++j] = LATCOLOR;
  XtAddCallback(overlaySW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = LATCOLOR;
  XtAddCallback(overlaySW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(overlaySW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Zoom"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 500); 
  fftZoomToggleW = XmCreateToggleButton(fftScreenW, "fft_zoomt", arglst, 3);
  *tag[++j] = FFTZOOM;
  XtAddCallback(fftZoomToggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(fftZoomToggleW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Contour"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 530); 
  fftContourTW = XmCreateToggleButton(fftScreenW, "fft_cont", arglst, 3);
  *tag[++j] = FFTCONTOUR;
  XtAddCallback(fftContourTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(fftContourTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("1D CircAvg"));
  XtSetArg(arglst[1], XmNx, 612);
  XtSetArg(arglst[2], XmNy, 530);
  fft1dcircW = XmCreatePushButton(fftScreenW, "fft_1dcavg", arglst, 3);
  XtAddCallback(fft1dcircW, XmNactivateCallback, 
		fft_1DCA_activate, NULL);
  XtManageChild(fft1dcircW);

  // LOP/HIP controls (middle right)

  XtSetArg(arglst[0], XmNheight, 190);
  XtSetArg(arglst[1], XmNwidth, 280);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNy, 250);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  lophipFormW = XmCreateForm(fftScreenW, "lohif", arglst, 6);
  // Unmanaged by default XtManageChild(lophipFormW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("LoRad"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  lophipLoLW = XmCreateLabel(lophipFormW, "lohif_lol", arglst, 4);
  XtManageChild(lophipLoLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("HiRad"));
  XtSetArg(arglst[1], XmNx, 145);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  lophipHiLW = XmCreateLabel(lophipFormW, "lohif_hil", arglst, 4);
  XtManageChild(lophipHiLW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNy, 10);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, lophipLoLW);
  lopRadiusTextW = XmCreateText(lophipFormW, "lohif_lot", arglst, 4);
  XtManageChild(lopRadiusTextW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNy, 10);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, lophipHiLW);
  hipRadiusTextW = XmCreateText(lophipFormW, "lohif_hit", arglst, 4);
  XtManageChild(hipRadiusTextW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("LEFT   - LOPass"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  lophipL1W = XmCreateLabel(lophipFormW, "lohif_l1", arglst, 4);
  XtManageChild(lophipL1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("MIDDLE - HIPass"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  lophipL2W = XmCreateLabel(lophipFormW, "lohif_l2", arglst, 4);
  XtManageChild(lophipL2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("RIGHT  - Reset"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  lophipL3W = XmCreateLabel(lophipFormW, "lohif_l3", arglst, 3);
  XtManageChild(lophipL3W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("LOP cutmax:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 95);
  lophipL4W = XmCreateLabel(lophipFormW, "lohif_l4", arglst, 3);
  XtManageChild(lophipL4W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("HIP cutmax:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 140);
  lophipL5W = XmCreateLabel(lophipFormW, "lohif_l5", arglst, 3);
  XtManageChild(lophipL5W);

  XtSetArg(arglst[0], XmNmaximum, 555);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 20);
  XtSetArg(arglst[5], XmNy, 115);
  XtSetArg(arglst[6], XmNwidth, 150);
  lopScrollW = XmCreateScrollBar(lophipFormW, "lohif_ls", arglst, 7);
  *tag[++j] = LOP;
  XtAddCallback(lopScrollW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = LOP;
  XtAddCallback(lopScrollW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(lopScrollW);  

  XtSetArg(arglst[0], XmNmaximum, 555);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 20);
  XtSetArg(arglst[5], XmNy, 160);
  XtSetArg(arglst[6], XmNwidth, 150);
  hipScrollW = XmCreateScrollBar(lophipFormW, "lohif_hs", arglst, 7);
  *tag[++j] = HIP;
  XtAddCallback(hipScrollW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = HIP;
  XtAddCallback(hipScrollW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(hipScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 185);
  XtSetArg(arglst[2], XmNy, 105);
  lopTextW = XmCreateText(lophipFormW, "lohif_lt", arglst, 3);
  XtManageChild(lopTextW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 185);
  XtSetArg(arglst[2], XmNy, 150);
  hipTextW = XmCreateText(lophipFormW, "lohif_ht", arglst, 3);
  XtManageChild(hipTextW);

  // CTF controls (middle right)

  XtSetArg(arglst[0], XmNheight, 190);
  XtSetArg(arglst[1], XmNwidth, 280);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNy, 250);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  ctfContFormW = XmCreateForm(fftScreenW, "ctfcf", arglst, 6);
  // Unmanaged by default XtManageChild(ctfContFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Generate Param File (full)"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 15);
  ctfFullW = XmCreatePushButton(ctfContFormW, "ctfcf_b1", arglst, 3);
  *tag[++j] = FULL;
  XtAddCallback(ctfFullW, XmNactivateCallback, 
		paramFileGenerate_activate, (XtPointer)tag[j]);
  XtManageChild(ctfFullW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Generate Param File (empty)"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 45);
  ctfEmptyW = XmCreatePushButton(ctfContFormW, "ctfcf_b2", arglst, 3);
  *tag[++j] = EMPTY;
  XtAddCallback(ctfEmptyW, XmNactivateCallback, 
		paramFileGenerate_activate, (XtPointer)tag[j]);
  XtManageChild(ctfEmptyW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Read Param File"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 75);
  ctfReadW = XmCreatePushButton(ctfContFormW, "ctfcf_b3", arglst, 3);
  *tag[++j] = READPARAM;
  XtAddCallback(ctfReadW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ctfReadW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Defocus Refinement"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_FORM);
  ctfAutoW = XmCreatePushButton(ctfContFormW, "ctfcf_b4", arglst, 3);
  *tag[++j] = 1;
  XtAddCallback(ctfAutoW, XmNactivateCallback, 
		autoDefocusRefine_activate, (XtPointer)tag[j]);
  XtManageChild(ctfAutoW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("2D Defocus Refinement"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNbottomWidget, ctfAutoW);
  ctfAuto2W = XmCreatePushButton(ctfContFormW, "ctfcf_b5", arglst, 4);
  XtAddCallback(ctfAuto2W, XmNactivateCallback, 
		auto2DDefocusRefine_activate, NULL);
  XtManageChild(ctfAuto2W);

  // CTF params form (bottom right)

  XtSetArg(arglst[0], XmNheight, 250);
  XtSetArg(arglst[1], XmNwidth, 340);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  ctfParamsW = XmCreateForm(fftScreenW, "ctfpf", arglst, 6);
  // Unmanged by default XtManageChild(ctfParamsW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ScStp(um)"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 15);
  ctfScanLW = XmCreateLabel(ctfParamsW, "ctfpf_scanl", arglst, 3);
  XtManageChild(ctfScanLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("PxSiz(nm)"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 45);
  ctfPixLW = XmCreateLabel(ctfParamsW, "ctfpf_pixl", arglst, 3);
  XtManageChild(ctfPixLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("AmpCont"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 75);
  ctfAmpLW = XmCreateLabel(ctfParamsW, "ctfpf_ampl", arglst, 3);
  XtManageChild(ctfAmpLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Volts(kV)"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 105);
  ctfVoltsLW = XmCreateLabel(ctfParamsW, "ctfpf_voltsl", arglst, 3);
  XtManageChild(ctfVoltsLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Cs(mm)"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 135);
  ctfCsLW = XmCreateLabel(ctfParamsW, "ctfpf_csl", arglst, 3);
  XtManageChild(ctfCsLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Wiener"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 165);
  ctfWienerLW = XmCreateLabel(ctfParamsW, "ctfpf_wienerl", arglst, 3);
  XtManageChild(ctfWienerLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("tFac"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 195);
  ctfTfacLW = XmCreateLabel(ctfParamsW, "ctfpf_tfacl", arglst, 3);
  XtManageChild(ctfTfacLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Wave(nm)"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 225);
  ctfWaveLW = XmCreateLabel(ctfParamsW, "ctfpf_wavel", arglst, 3);
  XtManageChild(ctfWaveLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("0.002511"));
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 225);
  ctfWaveW = XmCreateLabel(ctfParamsW, "ctfpf_wave", arglst, 3);
  XtManageChild(ctfWaveW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Mag"));
  XtSetArg(arglst[1], XmNx, 170);
  XtSetArg(arglst[2], XmNy, 15);
  ctfMagLW = XmCreateLabel(ctfParamsW, "ctfpf_magl", arglst, 3);
  XtManageChild(ctfMagLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Mode (0,1,2,3)"));
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 135);
  ctfModeLW = XmCreateLabel(ctfParamsW, "ctfpf_model", arglst, 3);
  XtManageChild(ctfModeLW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNvalue, "14");
  ctfScanStepW = XmCreateText(ctfParamsW, "ctfpf_scant", arglst, 4);
  XtManageChild(ctfScanStepW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 40);
  XtSetArg(arglst[3], XmNvalue, "0.3570");
  ctfPixSizeW = XmCreateText(ctfParamsW, "ctfpf_pixt", arglst, 4);
  XtManageChild(ctfPixSizeW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 220);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNvalue, "39200");
  ctfMagW = XmCreateText(ctfParamsW, "ctfpf_magt", arglst, 4);
  XtManageChild(ctfMagW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNvalue, "0.07");
  ctfAmpFactorW = XmCreateText(ctfParamsW, "ctfpf_ampt", arglst, 4);
  *tag[++j] = AMPFACTOR;
  XtAddCallback(ctfAmpFactorW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfAmpFactorW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 100);
  XtSetArg(arglst[3], XmNvalue, "200");
  ctfKvW = XmCreateText(ctfParamsW, "ctfpf_kvt", arglst, 4);
  *tag[++j] = KV;
  XtAddCallback(ctfKvW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfKvW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 130);
  XtSetArg(arglst[3], XmNvalue, "2.0");
  ctfSpAberW = XmCreateText(ctfParamsW, "ctfpf_cst", arglst, 4);
  *tag[++j] = SPABER;
  XtAddCallback(ctfSpAberW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfSpAberW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 190);
  XtSetArg(arglst[3], XmNvalue, "0.0");
  ctfMajorDefocusW = XmCreateText(ctfParamsW, "ctfpf_majdt", arglst, 4);
  *tag[++j] = MAJORDEFOCUS;
  XtAddCallback(ctfMajorDefocusW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  // Unmanged by default XtManageChild(ctfMajorDefocusW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 220);
  XtSetArg(arglst[3], XmNvalue, "0.0");
  ctfMinorDefocusW = XmCreateText(ctfParamsW, "ctfpf_mindt", arglst, 4);
  *tag[++j] = MINORDEFOCUS;
  XtAddCallback(ctfMinorDefocusW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  // Unmanaged by default XtManageChild(ctfMinorDefocusW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 160);
  XtSetArg(arglst[3], XmNvalue, "0.2");
  ctfWienerW = XmCreateText(ctfParamsW, "ctfpf_wienert", arglst, 4);
  *tag[++j] = WIENER;
  XtAddCallback(ctfWienerW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfWienerW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 70);
  XtSetArg(arglst[2], XmNy, 220);
  XtSetArg(arglst[3], XmNvalue, "0.0");
  ctfAngMajorW = XmCreateText(ctfParamsW, "ctfpf_angmajt", arglst, 4);
  *tag[++j] = ANGMAJOR;
  XtAddCallback(ctfAngMajorW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  // Unmanaged by default XtManageChild(ctfAngMajorW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 190);
  XtSetArg(arglst[3], XmNvalue, "0");
  ctfTFactorW = XmCreateText(ctfParamsW, "ctfpf_tfact", arglst, 4);
  *tag[++j] = TFACTOR;
  XtAddCallback(ctfTFactorW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfTFactorW);

  XtSetArg(arglst[0], XmNcolumns, 2);
  XtSetArg(arglst[1], XmNx, 290);
  XtSetArg(arglst[2], XmNy, 130);
  XtSetArg(arglst[3], XmNvalue, "1");
  ctfModeW = XmCreateText(ctfParamsW, "ctfpf_tfact", arglst, 4);
  *tag[++j] = MODE;
  XtAddCallback(ctfModeW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfModeW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("CTF"));
  XtSetArg(arglst[1], XmNx, 165);
  XtSetArg(arglst[2], XmNy, 170);
  ctfApplyW = XmCreatePushButton(ctfParamsW, "ctfpf_apply", arglst, 3);
  *tag[++j] = APPLYCTF;
  XtAddCallback(ctfApplyW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(ctfApplyW);

  // Scopes menu bar (child of CTF params form)

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNtopWidget, ctfMagW);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 152);
  scopesMenuBarW = XmCreateMenuBar(ctfParamsW, "ctfpf_scmb", arglst, 5);
  XtManageChild(scopesMenuBarW);

  scopesMenuW = XmCreatePulldownMenu(scopesMenuBarW, "ctfpf_scsm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Microscope Defaults"));
  XtSetArg(arglst[1], XmNsubMenuId, scopesMenuW);
  scopesMenuEntryW = XmCreateCascadeButton(scopesMenuBarW, 
					   "ctfpf_scme", arglst, 2);
  XtManageChild(scopesMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("CM200FEG"));
  fegBW = XmCreatePushButton(scopesMenuW, "scopes_feg", arglst, 1);
  *tag[++j] = FEG;
  XtAddCallback(fegBW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(fegBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("CM300FEG"));
  feg300BW = XmCreatePushButton(scopesMenuW, "scopes_feg300", arglst, 1);
  *tag[++j] = FEG300;
  XtAddCallback(feg300BW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(feg300BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("EM420-W"));
  em420BW = XmCreatePushButton(scopesMenuW, "scopes_em420", arglst, 1);
  *tag[++j] = EM420W;
  XtAddCallback(em420BW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(em420BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("EM420-LaB6"));
  em420lBW = XmCreatePushButton(scopesMenuW, "scopes_em420l", arglst, 1);
  *tag[++j] = EM420L;
  XtAddCallback(em420lBW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(em420lBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("EM300"));
  em300BW = XmCreatePushButton(scopesMenuW, "scopes_em300", arglst, 1);
  *tag[++j] = EM300;
  XtAddCallback(em300BW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(em300BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("JEOL EM_2010F_HT (FEG)"));
  htfegBW = XmCreatePushButton(scopesMenuW, "scopes_htfeg", arglst, 1);
  *tag[++j] = JEOL_EM_2010F_HT_FEG;
  XtAddCallback(htfegBW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(htfegBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("JEOL EM_2010F_UHR (FEG)"));
  uhrfegBW = XmCreatePushButton(scopesMenuW, "scopes_uhrfeg", arglst, 1);
  *tag[++j] = JEOL_EM_2010F_UHR_FEG;
  XtAddCallback(uhrfegBW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(uhrfegBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("JEOL 1010"));
  jeol1010BW = XmCreatePushButton(scopesMenuW, "scopes_jeol1010", arglst, 1);
  *tag[++j] = JEOL1010;
  XtAddCallback(jeol1010BW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(jeol1010BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Hitachi H9000"));
  h9000BW = XmCreatePushButton(scopesMenuW, "scopes_h9000", arglst, 1);
  *tag[++j] = Hitachi_H9000;
  XtAddCallback(h9000BW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(h9000BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Hitachi HF2000"));
  hf2000BW = XmCreatePushButton(scopesMenuW, "scopes_hf2000", arglst, 1);
  *tag[++j] = Hitachi_HF2000;
  XtAddCallback(hf2000BW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(hf2000BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FEI Tecnai G2 Polara"));
  polaraBW = XmCreatePushButton(scopesMenuW, "scopes_polara", arglst, 1);
  *tag[++j] = FEI_Tecnai_G2_Polara;
  XtAddCallback(polaraBW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(polaraBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FEI Tecnai G2 Sphera"));
  spheraBW = XmCreatePushButton(scopesMenuW, "scopes_sphera", arglst, 1);
  *tag[++j] = FEI_Tecnai_G2_Sphera;
  XtAddCallback(spheraBW, XmNactivateCallback, 
		ctf_reset_activate, (XtPointer)tag[j]);
  XtManageChild(spheraBW);

  // 1/ctf menu bar (child of CTF params form)

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, ctfApplyW);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNy, 170);
  ctfinvMenuBarW = XmCreateMenuBar(ctfParamsW, "ctfpf_cimb", arglst, 5);
  XtManageChild(ctfinvMenuBarW);

  ctfinvMenuW = XmCreatePulldownMenu(ctfinvMenuBarW, "ctfpf_cim", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("1/CTF"));
  XtSetArg(arglst[1], XmNsubMenuId, ctfinvMenuW);
  ctfinvMenuEntryW = XmCreateCascadeButton(ctfinvMenuBarW, 
					   "ctfpf_cime", arglst, 2);
  XtManageChild(ctfinvMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter 1"));
  ctfinv1BW = XmCreatePushButton(ctfinvMenuW, "ctfinv_b1", arglst, 1);
  *tag[++j] = APPLYINVERSE1CTF;
  XtAddCallback(ctfinv1BW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(ctfinv1BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter 2"));
  ctfinv2BW = XmCreatePushButton(ctfinvMenuW, "ctfinv_b2", arglst, 1);
  *tag[++j] = APPLYINVERSE2CTF;
  XtAddCallback(ctfinv2BW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(ctfinv2BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter 3"));
  ctfinv3BW = XmCreatePushButton(ctfinvMenuW, "ctfinv_b3", arglst, 1);
  *tag[++j] = APPLYINVERSE3CTF;
  XtAddCallback(ctfinv3BW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(ctfinv3BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter 4"));
  ctfinv4BW = XmCreatePushButton(ctfinvMenuW, "ctfinv_b4", arglst, 1);
  *tag[++j] = APPLYINVERSE4CTF;
  XtAddCallback(ctfinv4BW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(ctfinv4BW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter 5"));
  ctfinv5BW = XmCreatePushButton(ctfinvMenuW, "ctfinv_b5", arglst, 1);
  *tag[++j] = APPLYINVERSE5CTF;
  XtAddCallback(ctfinv5BW, XmNactivateCallback, 
		fft_mode_activate, (XtPointer)tag[j]);
  XtManageChild(ctfinv5BW);

  // CTF node form (middle bottom)

  XtSetArg(arglst[0], XmNheight, 135);
  XtSetArg(arglst[1], XmNwidth, 140);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNx, 407);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  ctfCurveFormW = XmCreateForm(fftScreenW, "ctfcf", arglst, 5);
  XtManageChild(ctfCurveFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("CTF Node Num:"));
  XtSetArg(arglst[1], XmNx, 5);
  XtSetArg(arglst[2], XmNy, 5);
  ctfCurveTitleW = XmCreateLabel(ctfCurveFormW, "ctfcf_title", arglst, 3);
  XtManageChild(ctfCurveTitleW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 29);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  ctfCurveUpW = XmCreateArrowButton(ctfCurveFormW, "ctfcf_up", arglst, 5);
  XtAddCallback(ctfCurveUpW, XmNactivateCallback, ctfArrowActivate, NULL);
  XtManageChild(ctfCurveUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 48);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  ctfCurveDownW = XmCreateArrowButton(ctfCurveFormW, "ctfcf_down", arglst, 5);
  XtAddCallback(ctfCurveDownW, XmNactivateCallback, ctfArrowActivate, NULL);
  XtManageChild(ctfCurveDownW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, ctfCurveDownW);
  XtSetArg(arglst[3], XmNy, 35);
  XtSetArg(arglst[4], XmNvalue, "1");
  ctfCurveTextW = XmCreateText(ctfCurveFormW, "ctfcf_text", arglst, 5);
  *tag[++j] = CTFCURVENUM;
  XtAddCallback(ctfCurveTextW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(ctfCurveTextW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                  "));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNy, 75);
  ctfMeasureLabelW = XmCreateLabel(ctfCurveFormW, "ctfcf_l1", arglst, 3);
  XtManageChild(ctfMeasureLabelW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                  "));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNy, 95);
  ctfMeasureLabel2W = XmCreateLabel(ctfCurveFormW, "ctfcf_l2", arglst, 3);
  XtManageChild(ctfMeasureLabel2W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("O"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNy, 110);
  ctfCurveOutBW = XmCreatePushButton(ctfCurveFormW, "ctfcf_b1", arglst, 3);
  XtAddCallback(ctfCurveOutBW, XmNactivateCallback, 
		ctf_ioparms_activate, NULL);
  XtManageChild(ctfCurveOutBW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("I"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, ctfCurveOutBW);
  XtSetArg(arglst[3], XmNy, 110);
  ctfCurveInBW = XmCreatePushButton(ctfCurveFormW, "ctfcf_b2", arglst, 4);
  XtAddCallback(ctfCurveInBW, XmNactivateCallback, 
		ctf_ioparms_activate, NULL);
  XtManageChild(ctfCurveInBW);

  // CTF scrolls form (lower left)

  XtSetArg(arglst[0], XmNheight, 160);
  XtSetArg(arglst[1], XmNwidth, 400);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNy, 540);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  ctfScrollsFormW = XmCreateForm(fftScreenW, "ctfs", arglst, 6);
  XtManageChild(ctfScrollsFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Force focus maj = focus min (1D CTF)"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNset, 1); 
  ctfForce1dTW = XmCreateToggleButton(ctfScrollsFormW, "ctfs_1d", arglst, 4);
  *tag[++j] = DISP1DCA;
  XtAddCallback(ctfForce1dTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(ctfForce1dTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Pick CTF Pts"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  XtSetArg(arglst[3], XmNset, 1); 
  pickCTFtoggleW = XmCreateToggleButton(ctfScrollsFormW, "ctfs_pt", arglst, 4);
  *tag[++j] = PICKCTF;
  XtAddCallback(pickCTFtoggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(pickCTFtoggleW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Flicker"));
  XtSetArg(arglst[1], XmNx, 155);
  XtSetArg(arglst[2], XmNy, 40);
  ctfFlickerW = XmCreatePushButton(ctfScrollsFormW, "ctfs_flick", arglst, 3);
  *tag[++j] = 1;
  XtAddCallback(ctfFlickerW, XmNarmCallback,
		fft_flicker_activate, (XtPointer)tag[j]);
  *tag[++j] = 0;
  XtAddCallback(ctfFlickerW, XmNdisarmCallback,
		fft_flicker_activate, (XtPointer)tag[j]);
  XtManageChild(ctfFlickerW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Determine Image CTF"));
  XtSetArg(arglst[1], XmNx, 230);
  XtSetArg(arglst[2], XmNy, 40);
  ctfScrollLW = XmCreateLabel(ctfScrollsFormW, "ctfs_l", arglst, 3);
  XtManageChild(ctfScrollLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Ang Major"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 75);
  ctfAmajLW = XmCreateLabel(ctfScrollsFormW, "ctfs_amajl", arglst, 3);
  XtManageChild(ctfAmajLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Focus Major"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 105);
  ctfFmajLW = XmCreateLabel(ctfScrollsFormW, "ctfs_fmajl", arglst, 3);
  XtManageChild(ctfFmajLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Focus Minor"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 135);
  ctfFminLW = XmCreateLabel(ctfScrollsFormW, "ctfs_fminl", arglst, 3);
  XtManageChild(ctfFminLW);

  XtSetArg(arglst[0], XmNmaximum, 36222);
  XtSetArg(arglst[1], XmNminimum, -36000);
  XtSetArg(arglst[2], XmNpageIncrement, 100);
  XtSetArg(arglst[3], XmNincrement, 10);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 120);
  XtSetArg(arglst[6], XmNy, 75);
  XtSetArg(arglst[7], XmNwidth, 190);
  XtSetArg(arglst[8], XmNsliderSize, 10);
  ctfAmajSW = XmCreateScrollBar(ctfScrollsFormW, "ctfs_amajs", arglst, 9);
  *tag[++j] = CTF_ANGMAJOR;
  XtAddCallback(ctfAmajSW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = CTF_ANGMAJOR;
  XtAddCallback(ctfAmajSW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(ctfAmajSW);  

  XtSetArg(arglst[0], XmNmaximum, 11111);
  XtSetArg(arglst[1], XmNminimum, -10000);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 120);
  XtSetArg(arglst[5], XmNy, 105);
  XtSetArg(arglst[6], XmNwidth, 190);
  XtSetArg(arglst[7], XmNsliderSize, 10);
  ctfFmajSW = XmCreateScrollBar(ctfScrollsFormW, "ctfs_fmajs", arglst, 8);
  *tag[++j] = CTF_FOCUSMAJ;
  XtAddCallback(ctfFmajSW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = CTF_FOCUSMAJ;
  XtAddCallback(ctfFmajSW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(ctfFmajSW);  

  XtSetArg(arglst[0], XmNmaximum, 11111);
  XtSetArg(arglst[1], XmNminimum, -10000);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 120);
  XtSetArg(arglst[5], XmNy, 135);
  XtSetArg(arglst[6], XmNwidth, 190);
  XtSetArg(arglst[7], XmNsliderSize, 10);
  ctfFminSW = XmCreateScrollBar(ctfScrollsFormW, "ctfs_fmins", arglst, 8);
  *tag[++j] = CTF_FOCUSMIN;
  XtAddCallback(ctfFminSW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = CTF_FOCUSMIN;
  XtAddCallback(ctfFminSW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(ctfFminSW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 325);
  XtSetArg(arglst[2], XmNy, 70);
  ctfAmajTW = XmCreateText(ctfScrollsFormW, "ctfs_amajt", arglst, 3);
  XtAddCallback(ctfAmajTW, XmNvalueChangedCallback, 
		ctfText_changed, NULL);
  XtManageChild(ctfAmajTW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 325);
  XtSetArg(arglst[2], XmNy, 100);
  ctfFmajTW = XmCreateText(ctfScrollsFormW, "ctfs_fmajt", arglst, 3);
  XtAddCallback(ctfFmajTW, XmNvalueChangedCallback, 
		ctfText_changed, NULL);
  XtManageChild(ctfFmajTW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 325);
  XtSetArg(arglst[2], XmNy, 130);
  ctfFminTW = XmCreateText(ctfScrollsFormW, "ctfs_fmint", arglst, 3);
  XtAddCallback(ctfFminTW, XmNvalueChangedCallback, 
		ctfText_changed, NULL);
  XtManageChild(ctfFminTW);

  // Lattice points form (mid-right)

  XtSetArg(arglst[0], XmNheight, 240);
  XtSetArg(arglst[1], XmNwidth, 238);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNtopWidget, displayFFTFormW);
  XtSetArg(arglst[5], XmNborderWidth, 2);
  XtSetArg(arglst[6], XmNresizable, 0);
  latPointsFormW = XmCreateForm(fftScreenW, "lpf", arglst, 7);
  XtManageChild(latPointsFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Define Lattice:"));
  XtSetArg(arglst[1], XmNx, 5);
  XtSetArg(arglst[2], XmNy, 1);
  latPointsTitleW = XmCreateLabel(latPointsFormW, "lpf_title", arglst, 3);
  XtManageChild(latPointsTitleW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 50);
  XtSetArg(arglst[4], XmNy, 20);
  XtSetArg(arglst[5], XmNspacing, 3);
  latPointsRadioW = XmCreateRadioBox(latPointsFormW, "lpf_radio", arglst, 6);
  XtManageChild(latPointsRadioW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Layer Line (1D)"));
  layerLinesTW = XmCreateToggleButton(latPointsRadioW, "lpf_rb1", arglst, 1);
  *tag[++j] = LAYERLINES;
  XtAddCallback(layerLinesTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(layerLinesTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("2D Lattice (2D)"));
  XtSetArg(arglst[1], XmNset, 1);
  twodLinesTW = XmCreateToggleButton(latPointsRadioW, "lpf_rb2", arglst, 2);
  *tag[++j] = TWODLINES;
  XtAddCallback(twodLinesTW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(twodLinesTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Miller Indices"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 90);
  millerLabelW = XmCreateLabel(latPointsFormW, "lpf_milllbl", arglst, 3);
  XtManageChild(millerLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("h1, k1"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 115);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  lat1LabelW = XmCreateLabel(latPointsFormW, "lpf_lat1lab", arglst, 4);
  XtManageChild(lat1LabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("h2, k2"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 145);
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  lat2LabelW = XmCreateLabel(latPointsFormW, "lpf_lat2lab", arglst, 4);
  XtManageChild(lat2LabelW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 95);
  XtSetArg(arglst[2], XmNy, 115);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  lat1XtextW = XmCreateText(latPointsFormW, "lpf_1x", arglst, 4);
  *tag[++j] = LAT1X;
  XtAddCallback(lat1XtextW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(lat1XtextW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 155);
  XtSetArg(arglst[2], XmNy, 115);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  lat1YtextW = XmCreateText(latPointsFormW, "lpf_1y", arglst, 4);
  *tag[++j] = LAT1Y;
  XtAddCallback(lat1YtextW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(lat1YtextW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 95);
  XtSetArg(arglst[2], XmNy, 145);
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  lat2XtextW = XmCreateText(latPointsFormW, "lpf_2x", arglst, 4);
  *tag[++j] = LAT2X;
  XtAddCallback(lat2XtextW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(lat2XtextW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 155);
  XtSetArg(arglst[2], XmNy, 145);
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  lat2YtextW = XmCreateText(latPointsFormW, "lpf_2y", arglst, 4);
  *tag[++j] = LAT2Y;
  XtAddCallback(lat2YtextW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(lat2YtextW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Enter indices - pick 2 points"));
  XtSetArg(arglst[1], XmNx, 5);
  XtSetArg(arglst[2], XmNy, 175);
  pick2LW = XmCreateLabel(latPointsFormW, "lpf_pick2", arglst, 3);
  XtManageChild(pick2LW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Draw 2D Lattice"));
  XtSetArg(arglst[1], XmNx, 5);
  XtSetArg(arglst[2], XmNy, 200);
  drawLatToggleW = XmCreateToggleButton(latPointsFormW, "lpf_dlb", arglst, 3);
  *tag[++j] = DRAWLAT;
  XtAddCallback(drawLatToggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(drawLatToggleW);

  // Lattice toggles form (bottom right)

  XtSetArg(arglst[0], XmNheight, 250);
  XtSetArg(arglst[1], XmNwidth, 238);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizable, 0);
  latTogglesFormW = XmCreateForm(fftScreenW, "ltf", arglst, 6);
  XtManageChild(latTogglesFormW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fourier Filtering/Averaging"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  latTogglesTitleW = XmCreateLabel(latTogglesFormW, "ltf_title", arglst, 3);
  XtManageChild(latTogglesTitleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter FFT"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  filterFFTtoggleW = XmCreateToggleButton(latTogglesFormW, "ltf_fftt", arglst, 3);
  *tag[++j] = FILTER;
  XtAddCallback(filterFFTtoggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(filterFFTtoggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Filter Mask Hole Diameter:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  filtDescW = XmCreateLabel(latTogglesFormW, "ltf_filtdesc", arglst, 3);
  XtManageChild(filtDescW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 45);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 10);
  filtSizeW = XmCreateScrollBar(latTogglesFormW, "ltf_filtscr", arglst, 8);
  *tag[++j] = FILTSIZE;
  XtAddCallback(filtSizeW, XmNvalueChangedCallback, 
		fft_change, (XtPointer)tag[j]);
  *tag[++j] = FILTSIZE;
  XtAddCallback(filtSizeW, XmNdragCallback, 
		fft_change, (XtPointer)tag[j]);
  XtManageChild(filtSizeW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("10    "));
  XtSetArg(arglst[1], XmNx, 165);
  XtSetArg(arglst[2], XmNy, 95);
  filtLabelW = XmCreateLabel(latTogglesFormW, "ltf_filtlbl", arglst, 3);
  XtManageChild(filtLabelW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 130);
  XtSetArg(arglst[5], XmNspacing, 1);
  hardSoftRadioW = XmCreateRadioBox(latTogglesFormW, "ltf_radio", arglst, 6);
  XtManageChild(hardSoftRadioW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Hard Cutoff Filter"));
  hardToggleW = XmCreateToggleButton(hardSoftRadioW, "ltf_hard", arglst, 1);
  *tag[++j] = HARD;
  XtAddCallback(hardToggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(hardToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Soft Cutoff Filter"));
  XtSetArg(arglst[1], XmNset, 1);
  softToggleW = XmCreateToggleButton(hardSoftRadioW, "ltf_soft", arglst, 2);
  *tag[++j] = SOFT;
  XtAddCallback(softToggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(softToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Draw Hi(Red)/Low(Green)"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 195);
  XtSetArg(arglst[3], XmNset, 1);
  drawHiLoToggleW = XmCreateToggleButton(latTogglesFormW, "ltf_hl", arglst, 4);
  *tag[++j] = DRAWHILO;
  XtAddCallback(drawHiLoToggleW, XmNvalueChangedCallback, 
		fft_change_toggle, (XtPointer)tag[j]);
  XtManageChild(drawHiLoToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fourier Average"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 220);
  latTogglesDoW = XmCreatePushButton(latTogglesFormW, "ltf_do", arglst, 3);
  XtAddCallback(latTogglesDoW, XmNdisarmCallback,
		fourAver_manage, (XtPointer)tag[j]);
  XtManageChild(latTogglesDoW);

} // end function create_fftscreen
