#include "gui.h"

void create_fftfeedbackscreen () {
  // function name: create_fftfeedbackscreen
  // Create/initialize FFT feedback screen
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("FFT detail"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 450);
  XtSetArg(arglst[7], XmNheight, 230);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  fftFeedbackScreenW = XmCreateFormDialog(toplevel_widget, "fb", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 190);
  fftFeedbackExitW = XmCreatePushButton(fftFeedbackScreenW, "fb_x", arglst, 5);
  XtAddCallback(fftFeedbackExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(fftFeedbackExitW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Shift Phase Origin"));
  XtSetArg(arglst[1], XmNx, 175);
  XtSetArg(arglst[2], XmNy, 115);
  apOrigDoW = XmCreatePushButton(fftFeedbackScreenW, "fb_do", arglst, 3);
  XtAddCallback(apOrigDoW, XmNactivateCallback, 
		apNewOrig_do_activate, NULL);
  XtManageChild(apOrigDoW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 34);
  XtSetArg(arglst[2], XmNheight, 30);
  XtSetArg(arglst[3], XmNx, 175);
  XtSetArg(arglst[4], XmNy, 145);
  apOrigResetW = XmCreatePushButton(fftFeedbackScreenW, "fb_rst", arglst, 5);
  XtAddCallback(apOrigResetW, XmNactivateCallback, 
		apNewOrig_do_activate, NULL);
  XtManageChild(apOrigResetW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("No shift in X yet  "));
  XtSetArg(arglst[1], XmNx, 220);
  XtSetArg(arglst[2], XmNy, 145);
  apOrigLabel1W = XmCreateLabel(fftFeedbackScreenW, "fb_xl", arglst, 3);
  XtManageChild(apOrigLabel1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("No shift in Y yet  "));
  XtSetArg(arglst[1], XmNx, 220);
  XtSetArg(arglst[2], XmNy, 175);
  apOrigLabel2W = XmCreateLabel(fftFeedbackScreenW, "fb_yl", arglst, 3);
  XtManageChild(apOrigLabel2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                    "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 20);
  fftFeedbackLabel1W = XmCreateLabel(fftFeedbackScreenW, "fb_l1", arglst, 3);
  XtManageChild(fftFeedbackLabel1W);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                    "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 50);
  fftFeedbackLabel2W = XmCreateLabel(fftFeedbackScreenW, "fb_l2", arglst, 3);
  XtManageChild(fftFeedbackLabel2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                    "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 80);
  fftFeedbackLabel3W = XmCreateLabel(fftFeedbackScreenW, "fb_l3", arglst, 3);
  XtManageChild(fftFeedbackLabel3W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Shift X"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 115);
  newXOrigW = XmCreateLabel(fftFeedbackScreenW, "fb_nxo", arglst, 3);
  XtManageChild(newXOrigW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Shift Y"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 145);
  newYOrigW = XmCreateLabel(fftFeedbackScreenW, "fb_nyo", arglst, 3);
  XtManageChild(newYOrigW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNy, 115);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, newXOrigW);
  fftnewXtextW = XmCreateText(fftFeedbackScreenW, "fb_nxt", arglst, 4);
  XtManageChild(fftnewXtextW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNy, 145);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, newYOrigW);
  fftnewYtextW = XmCreateText(fftFeedbackScreenW, "fb_nyt", arglst, 4);
  XtManageChild(fftnewYtextW);

} // end function create_fftfeedbackscreen
