#define SWAP(a,b) {temp=(a); (a)=(b); (b)=temp;}
#define PI 3.14159265358979323
#define TINY 1.0e-20
#define MAX(x,y)  (((x)>(y)) ? (x) : (y))  
#define MIN(x,y)  (((x)<(y)) ? (x) : (y)) 

void cmpt_fit(double ca2d_avg[], double ca2d_std[], int * hkl_max, 
	      double * res_hi,
	      double poly_paras[], int * poly_order, 
	      int * poly_orderb, int * poly_orderd,
	      double * wavelength, double * A, double * Cs,
	      double * pixel_size, double * chisq, 
	      float *auto2DdrawBuf, float *auto2DdataBuf);

void cmpt_fit_(double ca2d_avg[], double ca2d_std[], int * hkl_max, 
	       double * res_hi,
               double poly_paras[], int * poly_order, 
	       int * poly_orderb, int * poly_orderd,
               double * wavelength, double * A, double * Cs,
               double * pixel_size, double * chisq, 
	       float *auto2DdrawBuf, float *auto2DdataBuf);

void yji_mrqmin(int x[], double y[], double sig[], double a[], int ia[],
		int ma, double **covar, double **alpha, double *chisq,
		void (*funcs)(int, int, double [], double *, 
			      double [], int, int, int, double,
			      int, double, double, double),
		double *alamda, int num_gauss_bkg, int num_gauss_ctf, 
		double wavelength,
		int idim_half, double res_hi, 
		double A, double Cs, double pixel_size,
		float *auto2DdrawBuf, float *auto2DdataBuf);

void yji_fpoly_ctf(int idx, int idy, double a[], double *ymode, double dyda[], 
		   int na, int order_poly1, int order_poly2, double  wavelength, 
		   int idim_half, double A, double Cs, double pixel_size);

void covsrt(double **covar, int ma, int ia[], int mfit);

void gaussj(double **a, int n, double **b, int m);

void mrqcof(int x[], double y[], double sig[], double a[],
	    int ia[], int ma, double **alpha, double beta[], double *chisq,
	    void(*funcs)(int, int, double [], double *, double [], int, int, 
			 int, double, int, double, double, double),
	    int num_gauss_bkg, int num_gauss_ctf, double wavelength, 
	    int idim_half, double res_hi, double A, double Cs, 
	    double pixel_size);

void mrqmin_1d (double x[], double y[], double sig[], int ndata, 
		double a[], int ia[],
		int ma, double **covar, double **alpha, double *chisq,
		void (*funcs)(double, double [], double *, 
			      double [], int, int, int, double,
			      int, double, double, double, int, int),
		double *alamda, int num_gauss_bkg, int num_gauss_ctf, 
		double wavelength,
		int idim_half, double A, double Cs, 
		double pixel_size, int *nmfit, int annlow, int annhigh);

void fpoly_ctf_1d (double  x, double *a, double  *y, double *dyda, 
		   int na, int order_poly1,
		   int order_poly2, double  wavelength, int idim_half, 
		   double  A, double  Cs,
		   double  pixel_size, int annlow, int annhigh );

void cmpt_fit1d(double ca1d_avg[], double ca1d_std[], int * ndata,
		int *annlow, int *annhigh,
		double poly_paras[], int * poly_order, int * poly_orderb, 
		int * poly_orderd,
		double * wavelength, int * hkl_max, double * A, double * Cs,
		double * pixel_size, double * chisq);

void cmpt_fit1d_(double ca1d_avg[], double ca1d_std[], int * ndata,
		 int *annlow, int *annhigh,
		 double poly_paras[], int * poly_order, int * poly_orderb, 
		 int * poly_orderd,
		 double * wavelength, int * hkl_max, double * A, double * Cs,
		 double * pixel_size, double * chisq);

void mrqcof_1d(double x[], double y[], double sig[], int ndata, double a[],
	       int ia[], int ma, double **alpha, double beta[], double *chisq,
	       void(*funcs)(double, double [], double *, double [], int, 
			    int, int, double,
			    int, double, double, double, int, int),
	       int num_gauss_bkg, int num_gauss_ctf,double wavelength,
	       int idim_half,
	       double A, double Cs, double pixel_size, 
	       int annlow, int annhigh);

void lubksb_1d(double **a, int n, int *indx, double b[]);

void ludcmp_1d(double **a, int n, int *indx, double *d);

void invmatrix_1d(double **a, double **y, int n);

double condnumcal_1d(double **matrix, double **alpha, int n);

double normcal_1d (double ** matrix, int n);

