#include "gui.h"

void create_fix2dscreen () {
  // function name: create_fix2d
  // Create and initialize attributes of fix blemish screen
  
  int *tag[10], i, j=-1;
  for (i=0; i<10; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Remove Blemishes"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 500);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  fix2DScreenW = XmCreateFormDialog(toplevel_widget, "fix2d", arglst, 9);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Remove blemishes from raw or boxed data"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 30);
  fix2DTitleW = XmCreateLabel(fix2DScreenW, "fix2d_title", arglst, 3);
  XtManageChild(fix2DTitleW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 420);
  fix2DExitW = XmCreatePushButton(fix2DScreenW, "fix2d_exit", arglst, 5);
  XtAddCallback(fix2DExitW, XmNactivateCallback, fix2d_deactivate, NULL);
  XtManageChild(fix2DExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 120);
  XtSetArg(arglst[4], XmNy, 420);
  fix2DHelpW = XmCreatePushButton(fix2DScreenW, "fix2d_help", arglst, 5);
  *tag[++j] = FIX2D;
  XtAddCallback(fix2DHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(fix2DHelpW);

  // Regions widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Regions: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 100);
  fix2DRegionsLabelW = XmCreateLabel(fix2DScreenW, "fix2d_rl", arglst, 3);
  XtManageChild(fix2DRegionsLabelW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 100);
  fix2DRegionsTextW = XmCreateText(fix2DScreenW, "fix2d_rt", arglst, 3);
  XtManageChild(fix2DRegionsTextW);
  XmTextSetString(fix2DRegionsTextW, "1    ");

  // StdDev widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("StdDev:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 140);
  fix2DStdLabelW = XmCreateLabel(fix2DScreenW, "fix2d_sl", arglst, 3);
  XtManageChild(fix2DStdLabelW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 140);
  fix2DStdTextW = XmCreateText(fix2DScreenW, "fix2d_st", arglst, 3);
  XtManageChild(fix2DStdTextW);
  XmTextSetString(fix2DStdTextW, "5    ");

  // Action buttons
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fix Values"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 420);
  fix2DDoW = XmCreatePushButton(fix2DScreenW, "fix2d_do", arglst, 3);
  *tag[++j] = FIX2D;
  XtAddCallback(fix2DDoW, XmNactivateCallback, fix2D_do_activate, 
		(XtPointer)tag[j]);
  XtManageChild(fix2DDoW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Preview"));
  XtSetArg(arglst[1], XmNx, 315);
  XtSetArg(arglst[2], XmNy, 420);
  fix2DPreviewW = XmCreatePushButton(fix2DScreenW, "fix2d_pre", arglst, 3);
  *tag[++j] = FIXPREVIEW;
  XtAddCallback(fix2DPreviewW, XmNactivateCallback, fix2D_do_activate, 
		(XtPointer)tag[j]);
  XtManageChild(fix2DPreviewW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Restore Original"));
  XtSetArg(arglst[1], XmNx, 400);
  XtSetArg(arglst[2], XmNy, 420);
  fix2DRestoreW = XmCreatePushButton(fix2DScreenW, "fix2d_res", arglst, 3);
  *tag[++j] = FIXRESTORE;
  XtAddCallback(fix2DRestoreW, XmNactivateCallback, fix2D_do_activate, 
		(XtPointer)tag[j]);
  XtManageChild(fix2DRestoreW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Show changes"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 180);
  fix2DFlickW = XmCreatePushButton(fix2DScreenW, "fix2d_flick", arglst, 3);
  *tag[++j] = 1;
  XtAddCallback(fix2DFlickW, XmNarmCallback, fix2D_flicker_activate, 
		(XtPointer)tag[j]);
  *tag[++j] = 0;
  XtAddCallback(fix2DFlickW, XmNdisarmCallback, fix2D_flicker_activate, 
		(XtPointer)tag[j]);
  XtManageChild(fix2DFlickW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Draw regions grid"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 100);
  fix2DGridW = XmCreateToggleButton(fix2DScreenW, "fix2d_grid", arglst, 3);
  XtAddCallback(fix2DGridW, XmNvalueChangedCallback, 
		fix2D_toggle_change, NULL);
  XtManageChild(fix2DGridW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Draw regions stats"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 130);
  fix2DStatsW = XmCreateToggleButton(fix2DScreenW, "fix2d_stats", arglst, 3);
  XtAddCallback(fix2DStatsW, XmNvalueChangedCallback, 
		fix2D_toggle_change, NULL);
  XtManageChild(fix2DStatsW);

} // end function create_fix2dscreen
