#include "gui.h"

void create_fixscreen () {
  // function name: create_fixscreen
  // Create/initialize fix map/image value screen
  
  int *tag1, *tag2, *tag3, *tag4, *tag5, *tag6, *tag7;

  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));
  tag3 = (int *) malloc(sizeof(int));
  tag4 = (int *) malloc(sizeof(int));
  tag5 = (int *) malloc(sizeof(int));
  tag6 = (int *) malloc(sizeof(int));
  tag7 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Fix Map or Image Values"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 500);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  fixScreenW = XmCreateFormDialog(toplevel_widget, "fix", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 420);
  fixExitW = XmCreatePushButton(fixScreenW, "fix_exit", arglst, 5);
  XtAddCallback(fixExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(fixExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 120);
  XtSetArg(arglst[4], XmNy, 420);
  fixHelpW = XmCreatePushButton(fixScreenW, "fix_help", arglst, 5);
  *tag1 = FIXADD;
  XtAddCallback(fixHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(fixHelpW);

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 10);
  XtSetArg(arglst[2], XmNwidth, 500);
  XtSetArg(arglst[3], XmNheight, 345);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  XtSetArg(arglst[5], XmNresizePolicy, XmRESIZE_NONE);
  fixFormW = XmCreateForm(fixScreenW, "fix_form", arglst, 6);
  XtManageChild(fixFormW);

  // Options for "fixing" map
  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 10);
  XtSetArg(arglst[2], XmNunitType, XmPIXELS);
  XtSetArg(arglst[3], XmNspacing, 2);
  XtSetArg(arglst[4], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[5], XmNborderWidth, 2);
  fixControlsW = XmCreateRadioBox(fixFormW, "fix_con", arglst, 6);
  XtManageChild(fixControlsW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Add a constant"));
  fixAddW = XmCreateToggleButton(fixControlsW, "fix_add", arglst, 1);
  *tag2 = FIXADD;
  XtAddCallback(fixAddW, XmNvalueChangedCallback, fix_change, (XtPointer)tag2);
  XtManageChild(fixAddW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Multiply by a constant"));
  fixMulW = XmCreateToggleButton(fixControlsW, "fix_mul", arglst, 1);
  *tag3 = FIXMULT;
  XtAddCallback(fixMulW, XmNvalueChangedCallback, fix_change, (XtPointer)tag3);
  XtManageChild(fixMulW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Overwrite with constant"));
  XtSetArg(arglst[1], XmNset, 1);
  fixOvrW = XmCreateToggleButton(fixControlsW, "fix_ovr", arglst, 2);
  *tag4 = FIXOVER;
  XtAddCallback(fixOvrW, XmNvalueChangedCallback, fix_change, (XtPointer)tag4);
  XtManageChild(fixOvrW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Invert Contrast"));
  fixInvW = XmCreateToggleButton(fixControlsW, "fix_inv", arglst, 1);
  *tag5 = INVERT;
  XtAddCallback(fixInvW, XmNvalueChangedCallback, fix_change, (XtPointer)tag5);
  XtManageChild(fixInvW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Shot Noise"));
  fixShtW = XmCreateToggleButton(fixControlsW, "fix_sht", arglst, 1);
  *tag6 = NOISE;
  XtAddCallback(fixShtW, XmNvalueChangedCallback, fix_change, (XtPointer)tag6);
  XtManageChild(fixShtW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Gaussian Noise"));
  fixGsnW = XmCreateToggleButton(fixControlsW, "fix_gsn", arglst, 1);
  *tag7 = GAUSSNOISE;
  XtAddCallback(fixGsnW, XmNvalueChangedCallback, fix_change, (XtPointer)tag7);
  XtManageChild(fixGsnW);

  // Other children of fixFormW
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Fix Values"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 10);
  fixDoW = XmCreatePushButton(fixFormW, "fix_do", arglst, 3);
  XtAddCallback(fixDoW, XmNactivateCallback, fix_do_activate, NULL);
  XtManageChild(fixDoW);

  // By default not managed
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("StdDev Value:"));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 145);
  fixGaussStdLabelW = XmCreateLabel(fixFormW, "fix_stdl", arglst, 3);

  // By default not managed
  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 360);
  XtSetArg(arglst[2], XmNy, 140);
  fixGaussStdTextW = XmCreateText(fixFormW, "fix_std", arglst, 3);

  // --- Columm 1
  XtSetArg(arglst[0], XmNx, 10); // Common attribute

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Min Radius:"));
  XtSetArg(arglst[2], XmNy, 210);
  fixMinLW = XmCreateLabel(fixFormW, "fix_minl", arglst, 3);
  XtManageChild(fixMinLW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Max Radius:"));
  XtSetArg(arglst[2], XmNy, 245);
  fixMaxLW = XmCreateLabel(fixFormW, "fix_maxl", arglst, 3);
  XtManageChild(fixMaxLW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Value:"));
  XtSetArg(arglst[2], XmNy, 280);
  fixTextLW = XmCreateLabel(fixFormW, "fix_textl", arglst, 3);
  XtManageChild(fixTextLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 210);
  fixMinW = XmCreateText(fixFormW, "fix_min", arglst, 3);
  XtManageChild(fixMinW);
  XtSetArg(arglst[2], XmNy, 245);
  fixMaxW = XmCreateText(fixFormW, "fix_max", arglst, 3);
  XtManageChild(fixMaxW);
  XtSetArg(arglst[2], XmNy, 280);
  fixTextW = XmCreateText(fixFormW, "fix_text", arglst, 3);
  XtManageChild(fixTextW);

  // --- Columm 2
  XtSetArg(arglst[0], XmNx, 250); // Common attribute

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("X Range:"));
  XtSetArg(arglst[2], XmNy, 210);
  fixBegXLW = XmCreateLabel(fixFormW, "fix_begxl", arglst, 3);
  XtManageChild(fixBegXLW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Y Range:"));
  XtSetArg(arglst[2], XmNy, 245);
  fixBegYLW = XmCreateLabel(fixFormW, "fix_begyl", arglst, 3);
  XtManageChild(fixBegYLW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Z Range:"));
  XtSetArg(arglst[2], XmNy, 280);
  fixBegZLW = XmCreateLabel(fixFormW, "fix_begzl", arglst, 3);
  XtManageChild(fixBegZLW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 210);
  fixBegXW = XmCreateText(fixFormW, "fix_begx", arglst, 3);
  XtManageChild(fixBegXW);
  XtSetArg(arglst[2], XmNy, 245);
  fixBegYW = XmCreateText(fixFormW, "fix_begy", arglst, 3);
  XtManageChild(fixBegYW);
  XtSetArg(arglst[2], XmNy, 280);
  fixBegZW = XmCreateText(fixFormW, "fix_begz", arglst, 3);
  XtManageChild(fixBegZW);

  // --- Columm 3
  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 390);
  XtSetArg(arglst[2], XmNy, 210);
  fixEndXW = XmCreateText(fixFormW, "fix_endx", arglst, 3);
  XtManageChild(fixEndXW);
  XtSetArg(arglst[2], XmNy, 245);
  fixEndYW = XmCreateText(fixFormW, "fix_endy", arglst, 3);
  XtManageChild(fixEndYW);
  XtSetArg(arglst[2], XmNy, 280);
  fixEndZW = XmCreateText(fixFormW, "fix_endz", arglst, 3);
  XtManageChild(fixEndZW);

} // end function create_fixscreen
