#include "gui.h"

void create_fouraverscreen() {
  // function name: create_fouraverscreen
  // Create and initialize attributes of Fourier average screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  // All arrow behaviors controlled by phaseArrowButton()
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Fourier Average"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 450);
  fourAverScreenW = XmCreateFormDialog(toplevel_widget, "fa", arglst, 8);

  // Top widgets

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Last Action:  "));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 1);
  fourAverLastW = XmCreateLabel(fourAverScreenW, "fa_last", arglst, 3);
  XtManageChild(fourAverLastW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("No refinement yet  "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 25);
  XtSetArg(arglst[3], XmNalignment, XmALIGNMENT_BEGINNING);
  refineLabelW = XmCreateLabel(fourAverScreenW, "fa_refine", arglst, 4);
  XtManageChild(refineLabelW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("No symmetry imposed yet  "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 60);
  XtSetArg(arglst[3], XmNalignment, XmALIGNMENT_BEGINNING);
  imposeLabelW = XmCreateLabel(fourAverScreenW, "fa_impose", arglst, 4);
  XtManageChild(imposeLabelW);

  // Refine phase origins pulldown

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 20);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  refineMenuBarW = XmCreateMenuBar(fourAverScreenW, "fa_rmb", arglst, 4);
  XtManageChild(refineMenuBarW);

  refineMenuW = XmCreatePulldownMenu(refineMenuBarW, "fa_rm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Refine Phase Origins"));
  XtSetArg(arglst[1], XmNsubMenuId, refineMenuW);
  refineMenuEntryW = XmCreateCascadeButton(refineMenuBarW, "fa_rme", arglst, 2);
  XtManageChild(refineMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("2 Fold"));
  refine2W = XmCreatePushButton(refineMenuW, "fa_r2", arglst, 1);
  *tag[++j] = 1;
  XtAddCallback(refine2W, XmNactivateCallback, 
		refine_changed, (XtPointer)tag[j]);
  XtManageChild(refine2W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("3 Fold"));
  refine3W = XmCreatePushButton(refineMenuW, "fa_r3", arglst, 1);
  *tag[++j] = 2;
  XtAddCallback(refine3W, XmNactivateCallback, 
		refine_changed, (XtPointer)tag[j]);
  XtManageChild(refine3W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("4 Fold"));
  refine4W = XmCreatePushButton(refineMenuW, "fa_r4", arglst, 1);
  *tag[++j] = 3;
  XtAddCallback(refine4W, XmNactivateCallback, 
		refine_changed, (XtPointer)tag[j]);
  XtManageChild(refine4W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("6 Fold"));
  refine6W = XmCreatePushButton(refineMenuW, "fa_r6", arglst, 1);
  *tag[++j] = 4;
  XtAddCallback(refine6W, XmNactivateCallback, 
		refine_changed, (XtPointer)tag[j]);
  XtManageChild(refine6W);

  // Impose symmetry pulldown

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 60);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  imposeMenuBarW = XmCreateMenuBar(fourAverScreenW, "fa_imb", arglst, 4);
  XtManageChild(imposeMenuBarW);

  imposeMenuW = XmCreatePulldownMenu(imposeMenuBarW, "fa_im", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Impose Symmetry"));
  XtSetArg(arglst[1], XmNsubMenuId, imposeMenuW);
  imposeMenuEntryW = XmCreateCascadeButton(imposeMenuBarW, "fa_ime", arglst, 2);
  XtManageChild(imposeMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p2 symmetry"));
  imposep2W = XmCreatePushButton(imposeMenuW, "fa_ip2", arglst, 1);
  *tag[++j] = P2;
  XtAddCallback(imposep2W, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("pgg symmetry"));
  imposepggW = XmCreatePushButton(imposeMenuW, "fa_ipgg", arglst, 1);
  *tag[++j] = PGG;
  XtAddCallback(imposepggW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposepggW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("cmm symmetry"));
  imposecmmW = XmCreatePushButton(imposeMenuW, "fa_icmm", arglst, 1);
  *tag[++j] = CMM;
  XtAddCallback(imposecmmW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposecmmW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p4 symmetry"));
  imposep4W = XmCreatePushButton(imposeMenuW, "fa_ip4", arglst, 1);
  *tag[++j] = P4;
  XtAddCallback(imposep4W, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep4W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p4m symmetry"));
  imposep4mW = XmCreatePushButton(imposeMenuW, "fa_ip4n", arglst, 1);
  *tag[++j] = P4M;
  XtAddCallback(imposep4mW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep4mW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p4g symmetry"));
  imposep4gW = XmCreatePushButton(imposeMenuW, "fa_ip4g", arglst, 1);
  *tag[++j] = P4G;
  XtAddCallback(imposep4gW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep4gW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p6 symmetry"));
  imposep6W = XmCreatePushButton(imposeMenuW, "fa_ip6", arglst, 1);
  *tag[++j] = P6;
  XtAddCallback(imposep6W, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep6W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p6m symmetry"));
  imposep6mW = XmCreatePushButton(imposeMenuW, "fa_ip6m", arglst, 1);
  *tag[++j] = P6M;
  XtAddCallback(imposep6mW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep6mW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("pm symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposepmW = XmCreatePushButton(imposeMenuW, "fa_pmi", arglst, 2);
  *tag[++j] = PM;
  XtAddCallback(imposepmW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposepmW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("pg symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposepgW = XmCreatePushButton(imposeMenuW, "fa_ipg", arglst, 2);
  *tag[++j] = PG;
  XtAddCallback(imposepgW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposepgW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("cm symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposecmW = XmCreatePushButton(imposeMenuW, "fa_icm", arglst, 2);
  *tag[++j] = CM;
  XtAddCallback(imposecmW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposecmW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("pmm symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposepmmW = XmCreatePushButton(imposeMenuW, "fa_ipmm", arglst, 2);
  *tag[++j] = PMM;
  XtAddCallback(imposepmmW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposepmmW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("pmg symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposepmgW = XmCreatePushButton(imposeMenuW, "fa_ipmg", arglst, 2);
  *tag[++j] = PMG;
  XtAddCallback(imposepmgW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposepmgW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p3 symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposep3W = XmCreatePushButton(imposeMenuW, "fa_ip3", arglst, 2);
  *tag[++j] = P3;
  XtAddCallback(imposep3W, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep3W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p3m1 symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposep3m1W = XmCreatePushButton(imposeMenuW, "fa_ip3m1", arglst, 2);
  *tag[++j] = P3M1;
  XtAddCallback(imposep3m1W, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep3m1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("p31m symmetry"));
  XtSetArg(arglst[1], XmNsensitive, 0); 
  imposep31mW = XmCreatePushButton(imposeMenuW, "fa_ip31m", arglst, 2);
  *tag[++j] = P31M;
  XtAddCallback(imposep31mW, XmNactivateCallback, 
		impose_changed, (XtPointer)tag[j]);
  XtManageChild(imposep31mW);

  // Upper middle widgets

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 34);
  XtSetArg(arglst[2], XmNheight, 30);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 117);
  fourAverResetW = XmCreatePushButton(fourAverScreenW, "fa_reset", arglst, 5);
  XtAddCallback(fourAverResetW, XmNactivateCallback, 
		fourAver_resetSfs, NULL);
  XtManageChild(fourAverResetW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Reset to P1"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 145);
  fourAverResetLW = XmCreateLabel(fourAverScreenW, "fa_resetl", arglst, 3);
  XtManageChild(fourAverResetLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Phase Origin"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 100);
  phaseOrigLW = XmCreateLabel(fourAverScreenW, "fa_palw", arglst, 3);
  XtManageChild(phaseOrigLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("x"));
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 125);
  moveOrigXlabelW = XmCreateLabel(fourAverScreenW, "fa_moxl", arglst, 3);
  XtManageChild(moveOrigXlabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("y"));
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 155);
  moveOrigYlabelW = XmCreateLabel(fourAverScreenW, "fa_moyl", arglst, 3);
  XtManageChild(moveOrigYlabelW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 125);
  XtSetArg(arglst[3], XmNvalue, "0.0     ");
  moveOrigXW = XmCreateText(fourAverScreenW, "fa_mox", arglst, 4);
  XtManageChild(moveOrigXW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 155);
  XtSetArg(arglst[3], XmNvalue, "0.0     ");
  moveOrigYW = XmCreateText(fourAverScreenW, "fa_moy", arglst, 4);
  XtManageChild(moveOrigYW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNy, 125);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, moveOrigXW);
  phasXupW = XmCreateArrowButton(fourAverScreenW, "fa_xup", arglst, 6);
  XtManageChild(phasXupW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNy, 137);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, moveOrigXW);
  phasXdownW = XmCreateArrowButton(fourAverScreenW, "fa_xdn", arglst, 6);
  XtManageChild(phasXdownW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNy, 155);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, moveOrigYW);
  phasYupW = XmCreateArrowButton(fourAverScreenW, "fa_yup", arglst, 6);
  XtManageChild(phasYupW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNy, 167);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNrightWidget, moveOrigYW);
  phasYdownW = XmCreateArrowButton(fourAverScreenW, "fa_ydn", arglst, 6);
  XtManageChild(phasYdownW);  

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Origin Shift"));
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 100); 
  shiftOrigTW = XmCreateToggleButton(fourAverScreenW, "fa_shft", arglst, 3);
  *tag[++j] = SHIFTORIGX;
  XtAddCallback(shiftOrigTW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(shiftOrigTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("del x"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 125);
  XtSetArg(arglst[3], XmNsensitive, 0);
  shiftOrigXlabelW = XmCreateLabel(fourAverScreenW, "fa_soxl", arglst, 4);
  XtManageChild(shiftOrigXlabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("del y"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 155);
  XtSetArg(arglst[3], XmNsensitive, 0);
  shiftOrigYlabelW = XmCreateLabel(fourAverScreenW, "fa_soyl", arglst, 4);
  XtManageChild(shiftOrigYlabelW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 125);
  XtSetArg(arglst[3], XmNvalue, "0.0     ");
  XtSetArg(arglst[4], XmNsensitive, 0);
  shiftOrigXW = XmCreateText(fourAverScreenW, "fa_sox", arglst, 5);
  XtManageChild(shiftOrigXW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 320);
  XtSetArg(arglst[2], XmNy, 155);
  XtSetArg(arglst[3], XmNvalue, "0.0     ");
  XtSetArg(arglst[4], XmNsensitive, 0);
  shiftOrigYW = XmCreateText(fourAverScreenW, "fa_soy", arglst, 5);
  XtManageChild(shiftOrigYW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Move origin"));
  XtSetArg(arglst[1], XmNx, 445);
  XtSetArg(arglst[2], XmNy, 150);
  moveOrigBW = XmCreatePushButton(fourAverScreenW, "fa_mob", arglst, 3);
  XtAddCallback(moveOrigBW, XmNactivateCallback, 
		movePhaseOrigin_activate, NULL);
  XtManageChild(moveOrigBW);
  
  // Lower-middle set of controls

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Radius of Integration Window"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 220);
  fourAverRadiusLW = XmCreateLabel(fourAverScreenW, "fa_rlw", arglst, 3);
  XtManageChild(fourAverRadiusLW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 220);
  XtSetArg(arglst[3], XmNvalue, "1.00");
  fourAverRadiusTW = XmCreateText(fourAverScreenW, "fa_rtw", arglst, 4);
  *tag[++j] = FARADIUS;
  XtAddCallback(fourAverRadiusTW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(fourAverRadiusTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Cut Value (Cut*Radius=Integration Radius)"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 260);
  fourAverCutLW = XmCreateLabel(fourAverScreenW, "fa_clw", arglst, 3);
  XtManageChild(fourAverCutLW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 260);
  XtSetArg(arglst[3], XmNvalue, "2.00");
  fourAverCutTW = XmCreateText(fourAverScreenW, "fa_ctw", arglst, 4);
  *tag[++j] = FACUT;
  XtAddCallback(fourAverCutTW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(fourAverCutTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Pixel size (nm)"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 300);
  fourAverRasterLW = XmCreateLabel(fourAverScreenW, "fa_rlw", arglst, 3);
  XtManageChild(fourAverRasterLW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 300);
  XtSetArg(arglst[3], XmNvalue, "1.00");
  fourAverRasterTW = XmCreateText(fourAverScreenW, "fa_rtw", arglst, 4);
  *tag[++j] = RASTERSTEP;
  XtAddCallback(fourAverRasterTW, XmNvalueChangedCallback, 
		latText_changed, (XtPointer)tag[j]);
  XtManageChild(fourAverRasterTW);

  // Bottom row of controls

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 400);
  fourAverExitW = XmCreatePushButton(fourAverScreenW, "fa_exit", arglst, 5);
  XtAddCallback(fourAverExitW, XmNactivateCallback, 
		fouraver_deactivate, NULL);
  XtManageChild(fourAverExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 90);
  XtSetArg(arglst[4], XmNy, 400);
  fourAverHelpW = XmCreatePushButton(fourAverScreenW, "fa_help", arglst, 5);
  *tag[++j] = FOURAVERHELP;
  XtAddCallback(fourAverHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(fourAverHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write Structure Factors"));
  XtSetArg(arglst[1], XmNx, 190);
  XtSetArg(arglst[2], XmNy, 400); 
  fourAverSfTogW = XmCreateToggleButton(fourAverScreenW, "fa_sft", arglst, 3);
  *tag[++j] = FOURAVERSF;
  XtAddCallback(fourAverSfTogW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(fourAverSfTogW);

} // end function create_fouraverscreen
