#include "gui.h"

void create_fourierfiltscreen () {
  // function name: create_fourierfiltscreen
  // Create/initialize Fourier 
  
  int *tag1;
  tag1 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Fourier Filter Boxed Images"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 250);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  fourFiltScreenW = XmCreateFormDialog(toplevel_widget, "flt", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 200);
  fourFiltExitW = XmCreatePushButton(fourFiltScreenW, "flt_exit", arglst, 5);
  XtAddCallback(fourFiltExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(fourFiltExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 300);
  XtSetArg(arglst[4], XmNy, 200);
  fourFiltHelpW = XmCreatePushButton(fourFiltScreenW, "flt_help", arglst, 5);
  *tag1 = FOURIERFILT;
  XtAddCallback(fourFiltHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(fourFiltHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fourier Filter"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 200);
  fourFiltDoW = XmCreatePushButton(fourFiltScreenW, "flt_do", arglst, 3);
  XtAddCallback(fourFiltDoW, XmNactivateCallback, fourierFilt_work, NULL);
  XtManageChild(fourFiltDoW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FFT size = 0000 x 0000  "));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 150);
  fourFiltLabelW = XmCreateLabel(fourFiltScreenW, "flt_lab", arglst, 3);
  XtManageChild(fourFiltLabelW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Min Resolution"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  fourFiltRNLW = XmCreateLabel(fourFiltScreenW, "flt_rnl", arglst, 3);
  XtManageChild(fourFiltRNLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Max Resolution"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 100);
  fourFiltRXLW = XmCreateLabel(fourFiltScreenW, "flt_rxl", arglst, 3);
  XtManageChild(fourFiltRXLW);

  XtSetArg(arglst[0], XmNcolumns,  9);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 10);
  resMinTextW = XmCreateText(fourFiltScreenW, "flt_rnt", arglst, 3);
  XtManageChild(resMinTextW);

  XtSetArg(arglst[0], XmNcolumns,  9);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 100);
  resMaxTextW = XmCreateText(fourFiltScreenW, "flt_rxt", arglst, 3);
  XtManageChild(resMaxTextW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Min Cutoff"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  fourFiltCNLW = XmCreateLabel(fourFiltScreenW, "flt_cnl", arglst, 3);
  XtManageChild(fourFiltCNLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Max Resolution"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 140);
  fourFiltCXLW = XmCreateLabel(fourFiltScreenW, "flt_cxl", arglst, 3);
  XtManageChild(fourFiltCXLW);

  XtSetArg(arglst[0], XmNcolumns,  9);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 40);
  cutMinTextW = XmCreateText(fourFiltScreenW, "flt_cnt", arglst, 3);
  XtManageChild(cutMinTextW);

  XtSetArg(arglst[0], XmNcolumns,  9);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 140);
  cutMaxTextW = XmCreateText(fourFiltScreenW, "flt_cxt", arglst, 3);
  XtManageChild(cutMaxTextW);

} // end function create_optionscreen
