#include <string.h>

#ifndef LISTS_H
#define LISTS_H

float min,max;
float thetamin, thetamax;
float phimin, phimax;
float omegamin, omegamax;
float xmin,xmax;
float ymin,ymax;
float magmin,magmax;
float cc1min,cc1max;
float cc2min,cc2max;
float cc3min,cc3max;
float deltaMin,deltaMax;
float deltaXmin,deltaYmin,deltaXmax,deltaYmax;
float distanceMin,distanceMax;
float deltaStd;

typedef struct Particle_Info {
  int particle_number;
  float theta,phi,omega,x,y,mag;
  float cc1,cc2,cc3;
  float origX;
  float origY;
  float deltaX;
  float deltaY;
  float distance;     /* From center */
  int rank;
  int toggle;
  int neighbors;
  float *projection;
  struct Particle_Info *next;
}P_INFO;

typedef struct Info {
  char filename[80];
  float a,b,c,d,e,f,g;
  P_INFO *info;
}INFO; 

#endif


extern INFO info;

P_INFO *Add_Particle(P_INFO *head,int particle_number,
		     float f1,float f2,float f3,float f4,float f5,
		     float f6,float cc1,float cc2,float cc3,
		     int state, int ncol, int nrow);
void Display_Particle_List(INFO head);

int find_number_in_range(P_INFO *head,float start,float end,int paramNum,
			 int *badCount);
float find_max_height(P_INFO *head,float start,float end,float step,
		      int paramNum, int *badCount);

void Get_Particle_Info(INFO *head,FILE *fIn, int ncol, int nrow);

void Free_Particle_Info(INFO *head);

void add_missing_particles(INFO *head, int nimg, int ncol, int nrow);

void find_minmax(P_INFO *head);

void sortParticles(P_INFO *head, int maxParts, int key, int incSort);

extern void param_srt_rwa();
