#include "gui.h"

// RSS - figure out how to use smaller font in thetaValueW etc.

void create_mapshadescreen() {
  // function name: create_mapshadescreen
  // Create and initialize attributes of 3D rendering screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  // Icos arrow behaviors controlled by icosaArrowActivateButton()

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("3D Rendering"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 500);
  XtSetArg(arglst[5], XmNy, 50);
  XtSetArg(arglst[6], XmNwidth, 650);
  XtSetArg(arglst[7], XmNheight, 820);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  mapShadeScreenW = XmCreateFormDialog(toplevel_widget, "map", arglst, 9);

  // Top set of toggles

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Shade"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10); 
  secondShadeW = XmCreateToggleButton(mapShadeScreenW, "map_sect", arglst, 3);
  *tag[++j] = USEMAPSHADE;
  XtAddCallback(secondShadeW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(secondShadeW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Stereo"));
  XtSetArg(arglst[1], XmNx, 135);
  XtSetArg(arglst[2], XmNy, 10); 
  stereoShadeW = XmCreateToggleButton(mapShadeScreenW, "map_stetog", arglst, 3);
  *tag[++j] = USESTEREO;
  XtAddCallback(stereoShadeW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(stereoShadeW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Radial Cueing"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 10); 
  radialShadeW = XmCreateToggleButton(mapShadeScreenW, "map_radtog", arglst, 3);
  *tag[++j] = USERADIAL;
  XtAddCallback(radialShadeW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(radialShadeW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Radial/Icos Proj"));
  XtSetArg(arglst[1], XmNx, 450);
  XtSetArg(arglst[2], XmNy, 10); 
  radProjShadeW = XmCreateToggleButton(mapShadeScreenW, "map_rpstog", arglst, 3);
  *tag[++j] = USERADPROJ;
  XtAddCallback(radProjShadeW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(radProjShadeW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Immediate Update"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40); 
  immediateUpdateW = XmCreateToggleButton(mapShadeScreenW, "map_immtog", arglst, 3);
  *tag[++j] = USEIMMEDIATE;
  XtAddCallback(immediateUpdateW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(immediateUpdateW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Contrast Stretch"));
  XtSetArg(arglst[1], XmNx, 180);
  XtSetArg(arglst[2], XmNy, 40); 
  radialCSToggleW = XmCreateToggleButton(mapShadeScreenW, "map_rcstog", arglst, 3);
  XtAddCallback(radialCSToggleW, XmNvalueChangedCallback, 
		reverse_sections, NULL);
  XtManageChild(radialCSToggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("# Radial Shades:"));
  XtSetArg(arglst[1], XmNx, 340);
  XtSetArg(arglst[2], XmNy, 43);
  radialLabelW = XmCreateLabel(mapShadeScreenW, "map_rcslab", arglst, 3);
  XtManageChild(radialLabelW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 480);
  XtSetArg(arglst[2], XmNy, 38);
  radialTextW = XmCreateText(mapShadeScreenW, "map_rcstxt", arglst, 3);
  XtManageChild(radialTextW);

  //   --- following toggles are not managed ---
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Cntrst Stretch RadPrj"));
  XtSetArg(arglst[1], XmNx, 175);
  XtSetArg(arglst[2], XmNy, 40); 
  radProjCSToggleW = XmCreateToggleButton(mapShadeScreenW, "map_rpcst", arglst, 3);
  XtAddCallback(radProjCSToggleW, XmNvalueChangedCallback, 
		reverse_sections, NULL);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Revers RadPrj"));
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 40); 
  radProjToggleW = XmCreateToggleButton(mapShadeScreenW, "map_rpcst", arglst, 3);
  XtAddCallback(radProjToggleW, XmNvalueChangedCallback, 
		reverse_sections, NULL);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Icos RadPrj"));
  XtSetArg(arglst[1], XmNx, 515);
  XtSetArg(arglst[2], XmNy, 40); 
  icosRadProjToggleW = XmCreateToggleButton(mapShadeScreenW, "map_rpcst", arglst, 3);
  XtAddCallback(icosRadProjToggleW, XmNvalueChangedCallback, 
		reverse_sections, NULL);
  //   --- preceeding toggles are not managed ---
  

  // Movie sub-form (just below top set of toggles)

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 75);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  movieFormW = XmCreateForm(mapShadeScreenW, "map_mf", arglst, 3);
  XtManageChild(movieFormW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("MOVIE"));
  XtSetArg(arglst[1], XmNx, 0);
  XtSetArg(arglst[2], XmNy, 0);
  movieFormLW = XmCreateLabel(movieFormW, "map_mfl", arglst, 3);
  XtManageChild(movieFormLW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("             NO Step:"));
  XtSetArg(arglst[1], XmNx, 5);
  XtSetArg(arglst[2], XmNy, 15);
  stepValueLabelW = XmCreateLabel(movieFormW, "map_mfsvl", arglst, 3);
  XtManageChild(stepValueLabelW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 180);
  XtSetArg(arglst[2], XmNy, 12);
  stepTextW = XmCreateText(movieFormW, "map_mfsvt", arglst, 3);
  XtManageChild(stepTextW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Default"));
  XtSetArg(arglst[1], XmNy, 14);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, stepTextW);
  stepToggleW = XmCreatePushButton(movieFormW, "map_mvsvb", arglst, 4);
  XtAddCallback(stepToggleW, XmNactivateCallback, 
		surfDensValueChange, NULL);
  XtManageChild(stepToggleW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("# Frames:"));
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 15);
  numFramesLabelW = XmCreateLabel(movieFormW, "map_mfnfl", arglst, 3);
  XtManageChild(numFramesLabelW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 435);
  XtSetArg(arglst[2], XmNy, 12);
  frameTextW = XmCreateText(movieFormW, "map_mfnft", arglst, 3);
  XtManageChild(frameTextW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Default"));
  XtSetArg(arglst[1], XmNy, 14);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, frameTextW);
  stepToggle2W = XmCreatePushButton(movieFormW, "map_mvnfb", arglst, 4);
  XtAddCallback(stepToggle2W, XmNactivateCallback, 
		surfDensValueChange, NULL);
  XtManageChild(stepToggle2W);

  // Select parameters text

  XtSetArg(arglst[0], XmNcolumns, 50);
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 130);
  XtSetArg(arglst[3], XmNeditable, 0);
  XtSetArg(arglst[4], XmNvalue, "Select parameters.");
  timeLeftLabelW = XmCreateText(mapShadeScreenW, "map_timeleft", arglst, 5);
  XtManageChild(timeLeftLabelW);

  // Surface density scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Surf. Density:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 180);
  surfDensLabelW = XmCreateLabel(mapShadeScreenW, "map_surfl", arglst, 3);
  XtManageChild(surfDensLabelW);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 50);
  XtSetArg(arglst[3], XmNincrement, 10);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 135);
  XtSetArg(arglst[6], XmNy, 183);
  XtSetArg(arglst[7], XmNwidth, 150);
  surfDensScrollW = XmCreateScrollBar(mapShadeScreenW, "map_surfs", arglst, 8);
  XtAddCallback(surfDensScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(surfDensScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(surfDensScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 175);
  XtSetArg(arglst[3], XmNvalue, "-1.0");
  surfDensValueW = XmCreateText(mapShadeScreenW, "map_surfv", arglst, 4);
  XtAddCallback(surfDensValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(surfDensValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 180);
  surfDensToggleW = XmCreatePushButton(mapShadeScreenW, "map_surft", arglst, 5);
  *tag[++j] = SURFDENS;
  XtAddCallback(surfDensToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(surfDensToggleW);

  // Fract scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fract:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 210);
  XtSetArg(arglst[3], XmNsensitive, 0);
  fractLabelW = XmCreateLabel(mapShadeScreenW, "map_fracl", arglst, 4);
  XtManageChild(fractLabelW);

  XtSetArg(arglst[0], XmNmaximum, 1111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 50);
  XtSetArg(arglst[3], XmNincrement, 10);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 135);
  XtSetArg(arglst[6], XmNy, 213);
  XtSetArg(arglst[7], XmNwidth, 150);
  XtSetArg(arglst[8], XmNsensitive, 0);
  XtSetArg(arglst[9], XmNvalue, 750);
  fractScrollW = XmCreateScrollBar(mapShadeScreenW, "map_fracs", arglst, 10);
  XtAddCallback(fractScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(fractScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(fractScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 205);
  XtSetArg(arglst[3], XmNvalue, "0.75");
  fractValueW = XmCreateText(mapShadeScreenW, "map_fracv", arglst, 4);
  XtAddCallback(fractValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(fractValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 210);
  XtSetArg(arglst[5], XmNsensitive, 0);
  fractToggleW = XmCreatePushButton(mapShadeScreenW, "map_fract", arglst, 6);
  *tag[++j] = FRACT;
  XtAddCallback(fractToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(fractToggleW);

  // Lightangle X scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Lightangle X:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 240);
  XtSetArg(arglst[3], XmNsensitive, 0);
  angxLabelW = XmCreateLabel(mapShadeScreenW, "map_angxl", arglst, 4);
  XtManageChild(angxLabelW);

  XtSetArg(arglst[0], XmNmaximum, 109);
  XtSetArg(arglst[1], XmNminimum, -90);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 243);
  XtSetArg(arglst[6], XmNwidth, 150);
  XtSetArg(arglst[7], XmNsensitive, 0);
  XtSetArg(arglst[8], XmNvalue, 10);
  angxScrollW = XmCreateScrollBar(mapShadeScreenW, "map_angxs", arglst, 9);
  XtAddCallback(angxScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(angxScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(angxScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 235);
  XtSetArg(arglst[3], XmNvalue, "10");
  angxValueW = XmCreateText(mapShadeScreenW, "map_angxv", arglst, 4);
  XtAddCallback(angxValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(angxValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 240);
  XtSetArg(arglst[5], XmNsensitive, 0);
  angxToggleW = XmCreatePushButton(mapShadeScreenW, "map_angxt", arglst, 6);
  *tag[++j] = ANGX;
  XtAddCallback(angxToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(angxToggleW);

  // Lightangle Y scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Lightangle Y:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 270);
  XtSetArg(arglst[3], XmNsensitive, 0);
  angyLabelW = XmCreateLabel(mapShadeScreenW, "map_angyl", arglst, 4);
  XtManageChild(angyLabelW);

  XtSetArg(arglst[0], XmNmaximum, 109);
  XtSetArg(arglst[1], XmNminimum, -90);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 273);
  XtSetArg(arglst[6], XmNwidth, 150);
  XtSetArg(arglst[7], XmNsensitive, 0);
  XtSetArg(arglst[8], XmNvalue, 10);
  angyScrollW = XmCreateScrollBar(mapShadeScreenW, "map_angys", arglst, 9);
  XtAddCallback(angyScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(angyScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(angyScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 265);
  XtSetArg(arglst[3], XmNvalue, "10");
  angyValueW = XmCreateText(mapShadeScreenW, "map_angyv", arglst, 4);
  XtAddCallback(angyValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(angyValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 270);
  XtSetArg(arglst[5], XmNsensitive, 0);
  angyToggleW = XmCreatePushButton(mapShadeScreenW, "map_angyt", arglst, 6);
  *tag[++j] = ANGY;
  XtAddCallback(angyToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(angyToggleW);

  // Theta scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Theta"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 310);
  XtSetArg(arglst[3], XmNwidth, 65);
  thetaButtonW = XmCreatePushButton(mapShadeScreenW, "map_thetab", arglst, 4);
  XtAddCallback(thetaButtonW, XmNactivateCallback, 
		rotate_xyz_activate, NULL);
  XtManageChild(thetaButtonW);

  XtSetArg(arglst[0], XmNmaximum, 776);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 313);
  XtSetArg(arglst[6], XmNwidth, 150);
  XtSetArg(arglst[7], XmNvalue, 360);
  thetaScrollW = XmCreateScrollBar(mapShadeScreenW, "map_thetas", arglst, 8);
  XtAddCallback(thetaScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(thetaScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(thetaScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 305);
  XtSetArg(arglst[3], XmNvalue, "0");
  thetaValueW = XmCreateText(mapShadeScreenW, "map_thetav", arglst, 4);
  XtAddCallback(thetaValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(thetaValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 310);
  thetaToggleW = XmCreatePushButton(mapShadeScreenW, "map_thetat", arglst, 5);
  *tag[++j] = THETA;
  XtAddCallback(thetaToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(thetaToggleW);

  // Phi scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Phi"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 340);
  XtSetArg(arglst[3], XmNwidth, 65);
  phiButtonW = XmCreatePushButton(mapShadeScreenW, "map_phib", arglst, 4);
  XtAddCallback(phiButtonW, XmNactivateCallback, 
		rotate_xyz_activate, NULL);
  XtManageChild(phiButtonW);

  XtSetArg(arglst[0], XmNmaximum, 776);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 343);
  XtSetArg(arglst[6], XmNwidth, 150);
  XtSetArg(arglst[7], XmNvalue, 360);
  phiScrollW = XmCreateScrollBar(mapShadeScreenW, "map_phis", arglst, 8);
  XtAddCallback(phiScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(phiScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(phiScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 335);
  XtSetArg(arglst[3], XmNvalue, "0");
  phiValueW = XmCreateText(mapShadeScreenW, "map_phiv", arglst, 4);
  XtAddCallback(phiValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(phiValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 340);
  phiToggleW = XmCreatePushButton(mapShadeScreenW, "map_phit", arglst, 5);
  *tag[++j] = PHI;
  XtAddCallback(phiToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(phiToggleW);

  // Omega scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Omega"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 370);
  XtSetArg(arglst[3], XmNwidth, 65);
  omegaButtonW = XmCreatePushButton(mapShadeScreenW, "map_omegab", arglst, 4);
  XtAddCallback(omegaButtonW, XmNactivateCallback, 
		rotate_xyz_activate, NULL);
  XtManageChild(omegaButtonW);

  XtSetArg(arglst[0], XmNmaximum, 776);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 373);
  XtSetArg(arglst[6], XmNwidth, 150);
  XtSetArg(arglst[7], XmNvalue, 360);
  omegaScrollW = XmCreateScrollBar(mapShadeScreenW, "map_omegas", arglst, 8);
  XtAddCallback(omegaScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(omegaScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(omegaScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 365);
  XtSetArg(arglst[3], XmNvalue, "0");
  omegaValueW = XmCreateText(mapShadeScreenW, "map_omegav", arglst, 4);
  XtAddCallback(omegaValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(omegaValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 370);
  omegaToggleW = XmCreatePushButton(mapShadeScreenW, "map_omegat", arglst, 5);
  *tag[++j] = OMEGA;
  XtAddCallback(omegaToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(omegaToggleW);

  // Minradius scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("MinRadius:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 415);
  minRadiusLabelW = XmCreateLabel(mapShadeScreenW, "map_minrl", arglst, 3);
  XtManageChild(minRadiusLabelW);

  XtSetArg(arglst[0], XmNmaximum, 736);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 418);
  XtSetArg(arglst[6], XmNheight, 15);
  XtSetArg(arglst[7], XmNwidth, 150);
  XtSetArg(arglst[8], XmNvalue, 360);
  minRadiusScrollW = XmCreateScrollBar(mapShadeScreenW, "map_minrs", arglst, 9);
  XtAddCallback(minRadiusScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(minRadiusScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(minRadiusScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 410);
  XtSetArg(arglst[3], XmNvalue, "0");
  minRadiusValueW = XmCreateText(mapShadeScreenW, "map_minrv", arglst, 4);
  XtAddCallback(minRadiusValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(minRadiusValueW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("       "));
  XtSetArg(arglst[1], XmNx, 355);
  XtSetArg(arglst[2], XmNy, 415);
  minRadiusAngW = XmCreateLabel(mapShadeScreenW, "map_maxra", arglst, 3);
  XtManageChild(minRadiusAngW);

  // Maxradius scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Maxradius:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 445);
  maxRadiusLabelW = XmCreateLabel(mapShadeScreenW, "map_maxrl", arglst, 3);
  XtManageChild(maxRadiusLabelW);

  XtSetArg(arglst[0], XmNmaximum, 736);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 135);
  XtSetArg(arglst[5], XmNy, 448);
  XtSetArg(arglst[6], XmNheight, 15);
  XtSetArg(arglst[7], XmNwidth, 150);
  maxRadiusScrollW = XmCreateScrollBar(mapShadeScreenW, "map_maxrs", arglst, 8);
  XtAddCallback(maxRadiusScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(maxRadiusScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(maxRadiusScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 440);
  XtSetArg(arglst[3], XmNvalue, "0");
  maxRadiusValueW = XmCreateText(mapShadeScreenW, "map_maxrv", arglst, 4);
  XtAddCallback(maxRadiusValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(maxRadiusValueW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("       "));
  XtSetArg(arglst[1], XmNx, 355);
  XtSetArg(arglst[2], XmNy, 445);
  maxRadiusAngW = XmCreateLabel(mapShadeScreenW, "map_maxra", arglst, 3);
  XtManageChild(maxRadiusAngW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 420);
  maxRadiusToggleW = XmCreatePushButton(mapShadeScreenW, "map_maxrt", arglst, 5);
  *tag[++j] = MAXRADIUS;
  XtAddCallback(maxRadiusToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(maxRadiusToggleW);

  // Pixelsize scroll w/ associated labels, text, and buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("PixelSize:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 475);
  pixelSizeLabelW = XmCreateLabel(mapShadeScreenW, "map_pixl", arglst, 3);
  XtManageChild(pixelSizeLabelW);

  XtSetArg(arglst[0], XmNmaximum, 2222);
  XtSetArg(arglst[1], XmNminimum, 100);
  XtSetArg(arglst[2], XmNpageIncrement, 100);
  XtSetArg(arglst[3], XmNincrement, 10);
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 135);
  XtSetArg(arglst[6], XmNy, 478);
  XtSetArg(arglst[7], XmNheight, 15);
  XtSetArg(arglst[8], XmNwidth, 150);
  XtSetArg(arglst[9], XmNvalue, 1000);
  XtSetArg(arglst[10], XmNsensitive, 0);
  pixelSizeScrollW = XmCreateScrollBar(mapShadeScreenW, "map_pixs", arglst, 11);
  XtAddCallback(pixelSizeScrollW, XmNvalueChangedCallback, 
		surfDensScrollChange, NULL);
  XtAddCallback(pixelSizeScrollW, XmNdragCallback, 
		surfDensScrollChange, NULL);
  XtManageChild(pixelSizeScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 293);
  XtSetArg(arglst[2], XmNy, 470);
  XtSetArg(arglst[3], XmNsensitive, 0);
  XtSetArg(arglst[3], XmNvalue, "1.0");
  pixelSizeValueW = XmCreateText(mapShadeScreenW, "map_pixv", arglst, 4);
  XtAddCallback(pixelSizeValueW, XmNvalueChangedCallback, 
		surfDensValueChange, NULL);
  XtManageChild(pixelSizeValueW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 420);
  XtSetArg(arglst[4], XmNy, 460);
  pixelSizeToggleW = XmCreatePushButton(mapShadeScreenW, "map_pixt", arglst, 5);
  *tag[++j] = PIXELSIZE;
  XtAddCallback(pixelSizeToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(pixelSizeToggleW);

  // Included volume widgets

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Included Volume:"));
  XtSetArg(arglst[1], XmNx, 460);
  XtSetArg(arglst[2], XmNy, 162);
  volumeLabelW = XmCreateLabel(mapShadeScreenW, "map_voll", arglst, 3);
  XtManageChild(volumeLabelW);

  XtSetArg(arglst[0], XmNx, 460);
  XtSetArg(arglst[1], XmNy, 180);
  XtSetArg(arglst[2], XmNcolumns, 16);
  XtSetArg(arglst[3], XmNrows, 2);
  XtSetArg(arglst[4], XmNscrollVertical, 0);
  XtSetArg(arglst[5], XmNscrollHorizontal, 0);
  XtSetArg(arglst[6], XmNeditMode, XmMULTI_LINE_EDIT);
  XtSetArg(arglst[7], XmNeditable, 0);
  volumeValueW = XmCreateScrolledText(mapShadeScreenW, "map_volv", arglst, 8);
  XtManageChild(volumeValueW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(""));
  XtSetArg(arglst[1], XmNy, 180); 
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, volumeValueW);
  volumeToggleW = XmCreateToggleButton(mapShadeScreenW, "map_volt", arglst, 4);
  *tag[++j] = VOLUME;
  XtAddCallback(volumeToggleW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(volumeToggleW);

  // Icosahedron widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Icosahedron"));
  XtSetArg(arglst[1], XmNx, 450);
  XtSetArg(arglst[2], XmNy, 300); 
  mapIcosTogW = XmCreateToggleButton(mapShadeScreenW, "map_itog", arglst, 3);
  XtAddCallback(mapIcosTogW, XmNvalueChangedCallback, 
		reverse_sections, NULL);
  XtManageChild(mapIcosTogW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, mapIcosTogW);
  XtSetArg(arglst[4], XmNy, 290);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  icosaUpW = XmCreateArrowButton(mapShadeScreenW, "map_iup", arglst, 6);
  XtManageChild(icosaUpW);
  XtSetArg(arglst[4], XmNy, 305);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  icosaDownW = XmCreateArrowButton(mapShadeScreenW, "map_idn", arglst, 6);
  XtManageChild(icosaDownW);

  // Hard rotate button

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Hard Rotate"));
  XtSetArg(arglst[1], XmNx, 540);
  XtSetArg(arglst[2], XmNy, 340); 
  hardRotateButtonW = XmCreatePushButton(mapShadeScreenW, "map_hr", arglst, 3);
  XtAddCallback(hardRotateButtonW, XmNactivateCallback, 
		rotate_do_activate, NULL);
  XtManageChild(hardRotateButtonW);

  // Sample widgets

  XtSetArg(arglst[0], XmNcolumns, 2);
  XtSetArg(arglst[1], XmNx, 540);
  XtSetArg(arglst[2], XmNy, 385);
  XtSetArg(arglst[3], XmNvalue, "1    ");
  sampleRenderW = XmCreateText(mapShadeScreenW, "map_samt", arglst, 4);
  XtManageChild(sampleRenderW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, sampleRenderW);
  XtSetArg(arglst[4], XmNy, 385);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  sampleUW = XmCreateArrowButton(mapShadeScreenW, "map_samu", arglst, 6);
  XtAddCallback(sampleUW, XmNactivateCallback, samRenArrowActivate, NULL);
  XtManageChild(sampleUW);
  XtSetArg(arglst[4], XmNy, 402);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  sampleDW = XmCreateArrowButton(mapShadeScreenW, "map_samd", arglst, 6);
  XtAddCallback(sampleDW, XmNactivateCallback, samRenArrowActivate, NULL);
  XtManageChild(sampleDW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Sample"));
  XtSetArg(arglst[1], XmNy, 390);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, sampleUW);
  sampleLW = XmCreateLabel(mapShadeScreenW, "map_saml", arglst, 4);
  XtManageChild(sampleLW);

  // Image Resample toggle

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Image Resample Mode  "));
  XtSetArg(arglst[1], XmNx, 450);
  XtSetArg(arglst[2], XmNy, 460); 
  loHiResW = XmCreateToggleButton(mapShadeScreenW, "map_lohi", arglst, 3);
  *tag[++j] = LOHIRES;
  XtAddCallback(loHiResW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(loHiResW);

  // View button and pulldowns

  XtSetArg(arglst[0], XmNspacing, 12);
  XtSetArg(arglst[1], XmNx, 456);
  XtSetArg(arglst[2], XmNy, 340);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  foldMenuBarW = XmCreateMenuBar(mapShadeScreenW, "map_fmb", arglst, 4);
  XtManageChild(foldMenuBarW);

  foldMenuW = XmCreatePulldownMenu(foldMenuBarW, "map_fm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("View"));
  XtSetArg(arglst[1], XmNsubMenuId, foldMenuW);
  foldMenuEntryW = XmCreateCascadeButton(foldMenuBarW, "map_fme", arglst, 2);
  XtManageChild(foldMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("5-fold"));
  fold5W = XmCreatePushButton(foldMenuW, "map_f5", arglst, 1);
  XtAddCallback(fold5W, XmNactivateCallback, foldAxis_activate, NULL);
  XtManageChild(fold5W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("3-fold"));
  fold3W = XmCreatePushButton(foldMenuW, "map_f3", arglst, 1);
  XtAddCallback(fold3W, XmNactivateCallback, foldAxis_activate, NULL);
  XtManageChild(fold3W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("2-fold"));
  fold2W = XmCreatePushButton(foldMenuW, "map_f2", arglst, 1);
  XtAddCallback(fold2W, XmNactivateCallback, foldAxis_activate, NULL);
  XtManageChild(fold2W);

  // unblob sub-form (just above cut sub-form)

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 510);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  unblobFormW = XmCreateForm(mapShadeScreenW, "map_uf", arglst, 3);
  XtManageChild(unblobFormW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Unblob Size"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  unblobSizeLW = XmCreateLabel(unblobFormW, "map_usl", arglst, 3);
  XtManageChild(unblobSizeLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Unblob Radius"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  unblobRadiusLW = XmCreateLabel(unblobFormW, "map_url", arglst, 3);
  XtManageChild(unblobRadiusLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Fill:"));
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 70);
  unblobRadiusLW = XmCreateLabel(unblobFormW, "map_url", arglst, 3);
  XtManageChild(unblobRadiusLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  1"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 40);
  unblobRadiusValueW = XmCreateLabel(unblobFormW, "map_urvl", arglst, 3);
  XtManageChild(unblobRadiusValueW);

  XtSetArg(arglst[0], XmNcolumns, 9);
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 10);
  unblobSizeValueW = XmCreateText(unblobFormW, "map_usvt", arglst, 3);
  XtAddCallback(unblobSizeValueW, XmNvalueChangedCallback, 
		unblob_text_change, NULL);
  XtManageChild(unblobSizeValueW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNvalue, "0.0");
  unblobFillValueW = XmCreateText(unblobFormW, "map_ufvt", arglst, 4);
  XtManageChild(unblobFillValueW);

  XtSetArg(arglst[0], XmNmaximum, 11111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 125);
  XtSetArg(arglst[5], XmNy, 15);
  XtSetArg(arglst[6], XmNwidth, 100);
  unblobSizeScrollW = XmCreateScrollBar(unblobFormW, "map_uss", arglst, 6);
  *tag[++j] = UNBLOBSIZE;
  XtAddCallback(unblobSizeScrollW, XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = UNBLOBSIZE;
  XtAddCallback(unblobSizeScrollW, XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(unblobSizeScrollW);  

  XtSetArg(arglst[0], XmNmaximum, 22);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 125);
  XtSetArg(arglst[5], XmNy, 45);
  XtSetArg(arglst[6], XmNwidth, 100);
  unblobRadiusScrollW = XmCreateScrollBar(unblobFormW, "map_urs", arglst, 7);
  *tag[++j] = UNBLOBRADIUS;
  XtAddCallback(unblobRadiusScrollW, XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = UNBLOBRADIUS;
  XtAddCallback(unblobRadiusScrollW, XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(unblobRadiusScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Clean Unblob"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70); 
  unblobToggleW = XmCreateToggleButton(unblobFormW, "map_utog", arglst, 3);
  XtAddCallback(unblobToggleW, XmNvalueChangedCallback, 
		reverse_sections, NULL);
  XtManageChild(unblobToggleW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Save as Gold"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 70); 
  unblobGoldW = XmCreatePushButton(unblobFormW, "map_ugold", arglst, 3);
  XtAddCallback(unblobGoldW, XmNactivateCallback, unblob_save_activate, NULL);
  XtManageChild(unblobGoldW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 10);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, unblobSizeValueW);
  unblobResetW = XmCreatePushButton(unblobFormW, "map_ureset", arglst, 6);
  XtAddCallback(unblobResetW, XmNactivateCallback, unblob_reset_activate, NULL);
  XtManageChild(unblobResetW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 450);
  XtSetArg(arglst[4], XmNy, 15);
  unblobsizeToggleW = XmCreatePushButton(unblobFormW, "map_ustw", arglst, 5);
  *tag[++j] = UNBLOBSIZE;
  XtAddCallback(unblobsizeToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(unblobsizeToggleW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 450);
  XtSetArg(arglst[4], XmNy, 45);
  unblobradiusToggleW = XmCreatePushButton(unblobFormW, "map_urtw", arglst, 5);
  *tag[++j] = UNBLOBRADIUS;
  XtAddCallback(unblobradiusToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(unblobradiusToggleW);

  // Cut map sub-form (just above bottom row of buttons)

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 620);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  cutFormW = XmCreateForm(mapShadeScreenW, "map_cf", arglst, 3);
  XtManageChild(cutFormW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Cut:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  cutFormLabelW = XmCreateLabel(cutFormW, "map_cfl", arglst, 3);
  XtManageChild(cutFormLabelW);

  XtSetArg(arglst[0], XmNy, 35);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Min"));
  XtSetArg(arglst[2], XmNx, 100);
  cutLabelMinW = XmCreateLabel(cutFormW, "map_clmin", arglst, 3);
  XtManageChild(cutLabelMinW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Max"));
  XtSetArg(arglst[2], XmNx, 250);
  cutLabelMaxW = XmCreateLabel(cutFormW, "map_clmax", arglst, 3);
  XtManageChild(cutLabelMaxW);

  XtSetArg(arglst[0], XmNx, 20);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("X"));
  XtSetArg(arglst[2], XmNy, 60);
  cutLabelXW = XmCreateLabel(cutFormW, "map_clx", arglst, 3);
  XtManageChild(cutLabelXW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Y"));
  XtSetArg(arglst[2], XmNy, 90);
  cutLabelYW = XmCreateLabel(cutFormW, "map_cly", arglst, 3);
  XtManageChild(cutLabelYW);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Z"));
  XtSetArg(arglst[2], XmNy, 120);
  cutLabelZW = XmCreateLabel(cutFormW, "map_clz", arglst, 3);
  XtManageChild(cutLabelZW);

  XtSetArg(arglst[0], XmNx, 170);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("   1"));
  XtSetArg(arglst[2], XmNy, 60);
  cutMinValueW[0] = XmCreateLabel(cutFormW, "map_cmin0", arglst, 3);
  XtManageChild(cutMinValueW[0]);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("   1"));
  XtSetArg(arglst[2], XmNy, 90);
  cutMinValueW[1] = XmCreateLabel(cutFormW, "map_cmin1", arglst, 3);
  XtManageChild(cutMinValueW[1]);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("   1"));
  XtSetArg(arglst[2], XmNy, 120);
  cutMinValueW[2] = XmCreateLabel(cutFormW, "map_cmin2", arglst, 3);
  XtManageChild(cutMinValueW[2]);

  XtSetArg(arglst[0], XmNx, 330);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("   0"));
  XtSetArg(arglst[2], XmNy, 60);
  cutMaxValueW[0] = XmCreateLabel(cutFormW, "map_cmax0", arglst, 3);
  XtManageChild(cutMaxValueW[0]);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("   0"));
  XtSetArg(arglst[2], XmNy, 90);
  cutMaxValueW[1] = XmCreateLabel(cutFormW, "map_cmax1", arglst, 3);
  XtManageChild(cutMaxValueW[1]);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("   0"));
  XtSetArg(arglst[2], XmNy, 120);
  cutMaxValueW[2] = XmCreateLabel(cutFormW, "map_cmax2", arglst, 3);
  XtManageChild(cutMaxValueW[2]);

  XtSetArg(arglst[0], XmNx, 440);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("  0% to 100%"));
  XtSetArg(arglst[2], XmNy, 60);
  perValueW[0] = XmCreateLabel(cutFormW, "map_per0", arglst, 3);
  XtManageChild(perValueW[0]);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("  0% to 100%"));
  XtSetArg(arglst[2], XmNy, 90);
  perValueW[1] = XmCreateLabel(cutFormW, "map_per1", arglst, 3);
  XtManageChild(perValueW[1]);
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("  0% to 100%"));
  XtSetArg(arglst[2], XmNy, 120);
  perValueW[2] = XmCreateLabel(cutFormW, "map_per2", arglst, 3);
  XtManageChild(perValueW[2]);

  // "MIN" scroll bar common attributes
  XtSetArg(arglst[0], XmNmaximum, 22);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNvalue, 1);
  XtSetArg(arglst[3], XmNpageIncrement, 5);	
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 55);
  XtSetArg(arglst[6], XmNwidth, 100);

  XtSetArg(arglst[7], XmNy, 65);
  cutMinScrollW[0] = XmCreateScrollBar(cutFormW, "map_smin0", arglst, 8);
  *tag[++j] = MINX;
  XtAddCallback(cutMinScrollW[0], XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = MINX;
  XtAddCallback(cutMinScrollW[0], XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(cutMinScrollW[0]);  

  XtSetArg(arglst[7], XmNy, 95);
  cutMinScrollW[1] = XmCreateScrollBar(cutFormW, "map_smin1", arglst, 8);
  *tag[++j] = MINY;
  XtAddCallback(cutMinScrollW[1], XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = MINY;
  XtAddCallback(cutMinScrollW[1], XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(cutMinScrollW[1]);  

  XtSetArg(arglst[7], XmNy, 125);
  cutMinScrollW[2] = XmCreateScrollBar(cutFormW, "map_smin2", arglst, 8);
  *tag[++j] = MINZ;
  XtAddCallback(cutMinScrollW[2], XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = MINZ;
  XtAddCallback(cutMinScrollW[2], XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(cutMinScrollW[2]);  

  // "MAX" scroll bar common attributes
  XtSetArg(arglst[0], XmNmaximum, 22);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNvalue, 1);
  XtSetArg(arglst[3], XmNpageIncrement, 5);	
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[5], XmNx, 205);
  XtSetArg(arglst[6], XmNwidth, 100);

  XtSetArg(arglst[7], XmNy, 65);
  cutMaxScrollW[0] = XmCreateScrollBar(cutFormW, "map_smax0", arglst, 8);
  *tag[++j] = MAXX;
  XtAddCallback(cutMaxScrollW[0], XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = MAXX;
  XtAddCallback(cutMaxScrollW[0], XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(cutMaxScrollW[0]);  

  XtSetArg(arglst[7], XmNy, 95);
  cutMaxScrollW[1] = XmCreateScrollBar(cutFormW, "map_smax1", arglst, 8);
  *tag[++j] = MAXY;
  XtAddCallback(cutMaxScrollW[1], XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = MAXY;
  XtAddCallback(cutMaxScrollW[1], XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(cutMaxScrollW[1]);  

  XtSetArg(arglst[7], XmNy, 125);
  cutMaxScrollW[2] = XmCreateScrollBar(cutFormW, "map_smax2", arglst, 8);
  *tag[++j] = MAXZ;
  XtAddCallback(cutMaxScrollW[2], XmNvalueChangedCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  *tag[++j] = MAXZ;
  XtAddCallback(cutMaxScrollW[2], XmNdragCallback, 
		unblob_scroll_change, (XtPointer)tag[j]);
  XtManageChild(cutMaxScrollW[2]);  

  // Cut form toggle button common attributes
  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 26);
  XtSetArg(arglst[3], XmNx, 400);

  XtSetArg(arglst[4], XmNy, 60);
  maxxToggleW = XmCreatePushButton(cutFormW, "map_maxxt", arglst, 5);
  *tag[++j] = MAXX;
  XtAddCallback(maxxToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(maxxToggleW);

  XtSetArg(arglst[4], XmNy, 90);
  maxyToggleW = XmCreatePushButton(cutFormW, "map_maxyt", arglst, 5);
  *tag[++j] = MAXY;
  XtAddCallback(maxyToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(maxyToggleW);

  XtSetArg(arglst[4], XmNy, 120);
  maxzToggleW = XmCreatePushButton(cutFormW, "map_maxzt", arglst, 5);
  *tag[++j] = MAXZ;
  XtAddCallback(maxzToggleW, XmNactivateCallback, 
		stepMode_button_change, (XtPointer)tag[j]);
  XtManageChild(maxzToggleW);

  // Bottom row of buttons

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 15);
  XtSetArg(arglst[4], XmNy, 780);
  mapShadeExitW = XmCreatePushButton(mapShadeScreenW, "map_exit", arglst, 5);
  XtAddCallback(mapShadeExitW, XmNactivateCallback, mapshade_deactivate, NULL);
  XtManageChild(mapShadeExitW);
  
  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 87);
  XtSetArg(arglst[4], XmNy, 780);
  mapShadeStopW = XmCreatePushButton(mapShadeScreenW, "map_stop", arglst, 5);
  XtManageChild(mapShadeStopW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("TryIt"));
  XtSetArg(arglst[1], XmNx, 140);
  XtSetArg(arglst[2], XmNy, 780);
  mapShadeDoW = XmCreatePushButton(mapShadeScreenW, "map_do", arglst, 3);
  XtAddCallback(mapShadeDoW, XmNactivateCallback, mapShade_activate, NULL);
  XtManageChild(mapShadeDoW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 220);
  XtSetArg(arglst[4], XmNy, 777);
  mapShadeHelpW = XmCreatePushButton(mapShadeScreenW, "map_help", arglst, 5);
  *tag[++j] = USEMAPSHADE;
  XtAddCallback(mapShadeHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(mapShadeHelpW);

  //RSS - make sure that NULL is OK
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Movie"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 780);
  mapShadeCueW = XmCreatePushButton(mapShadeScreenW, "map_cue", arglst, 3);
  *tag[++j] = 0;
  XtAddCallback(mapShadeCueW, XmNactivateCallback, mapMovie_activate, 
		(XtPointer)tag[j]);
  XtManageChild(mapShadeCueW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Invert Map Contrast"));
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 780);
  irevToggleW = XmCreatePushButton(mapShadeScreenW, "map_irev", arglst, 3);
  *tag[++j] = IREV;
  XtAddCallback(irevToggleW, XmNactivateCallback, stepMode_change, 
		(XtPointer)tag[j]);
  XtManageChild(irevToggleW);

} // end function create_mapshadescreen
