#include "gui.h"

void create_modelscreen() {
  // function name: create_modelscreen
  // Create and initialize attributes of model builder screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Model Builder"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 140);
  XtSetArg(arglst[5], XmNy, 350);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 600);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  modelScreenW = XmCreateFormDialog(toplevel_widget, "mod", arglst, 9);

  // Object widgets

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Choose Object: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 20);
  modelChooseLW = XmCreateLabel(modelScreenW, "mod_chl", arglst, 3);
  XtManageChild(modelChooseLW);

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNx, 134);
  XtSetArg(arglst[2], XmNy, 18);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  modelMenuBarW = XmCreateMenuBar(modelScreenW, "mod_mb", arglst, 4);
  XtManageChild(modelMenuBarW);

  modelMenuW = XmCreatePulldownMenu(modelMenuBarW, "mod_m", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Object"));
  XtSetArg(arglst[1], XmNsubMenuId, modelMenuW);
  modelMenuEntryW = XmCreateCascadeButton(modelMenuBarW, "mod_me", arglst, 2);
  XtManageChild(modelMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Cube"));
  modelCubeW = XmCreatePushButton(modelMenuW, "mod_cube", arglst, 1);
  *tag[++j] = SQUARE;
  XtAddCallback(modelCubeW, XmNactivateCallback, 
		modelObject_change, (XtPointer)tag[j]);
  XtManageChild(modelCubeW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Sphere"));
  modelSphereW = XmCreatePushButton(modelMenuW, "mod_sph", arglst, 1);
  *tag[++j] = CIRCLE;
  XtAddCallback(modelSphereW, XmNactivateCallback, 
		modelObject_change, (XtPointer)tag[j]);
  XtManageChild(modelSphereW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Triangle"));
  modelTriW = XmCreatePushButton(modelMenuW, "mod_tri", arglst, 1);
  *tag[++j] = TRIANGLE;
  XtAddCallback(modelTriW, XmNactivateCallback, 
		modelObject_change, (XtPointer)tag[j]);
  XtManageChild(modelTriW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Cylinder"));
  modelCylW = XmCreatePushButton(modelMenuW, "mod_cyl", arglst, 1);
  *tag[++j] = CYLINDER;
  XtAddCallback(modelCylW, XmNactivateCallback, 
		modelObject_change, (XtPointer)tag[j]);
  XtManageChild(modelCylW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Icosahedron"));
  modelIcosW = XmCreatePushButton(modelMenuW, "mod_icos", arglst, 1);
  *tag[++j] = ICOS;
  XtAddCallback(modelIcosW, XmNactivateCallback, 
		modelObject_change, (XtPointer)tag[j]);
  XtManageChild(modelIcosW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Object to build:  Cube         "));
  XtSetArg(arglst[1], XmNx, 230);
  XtSetArg(arglst[2], XmNy, 20);
  modelLabelW = XmCreateLabel(modelScreenW, "mod_lab", arglst, 3);
  XtManageChild(modelLabelW);

  // Fill widgets

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Object Fill Value: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  modelFillLW = XmCreateLabel(modelScreenW, "mod_filll", arglst, 3);
  XtManageChild(modelFillLW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 170);
  XtSetArg(arglst[2], XmNy, 68);
  XtSetArg(arglst[3], XmNvalue, "-11.0");
  modelFillTW = XmCreateText(modelScreenW, "map_fillt", arglst, 4);
  XtManageChild(modelFillTW);

  // Toggles (just above buttons)

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Replicate to Icosahedral vertices"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 500); 
  mbReplW = XmCreateToggleButton(modelScreenW, "mod_repl", arglst, 3);
  *tag[++j] = ICOSREPL;
  XtAddCallback(mbReplW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(mbReplW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Immediate Update"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 530); 
  mbImmediateUpdateW = XmCreateToggleButton(modelScreenW, "mod_imm", arglst, 3);
  *tag[++j] = MBUSEIMMEDIATE;
  XtAddCallback(mbImmediateUpdateW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(mbImmediateUpdateW);

  // Bottom row of buttons

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 565);
  modelExitW = XmCreatePushButton(modelScreenW, "mod_exit", arglst, 5);
  XtAddCallback(modelExitW, XmNactivateCallback, model_deactivate, NULL);
  XtManageChild(modelExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 70);
  XtSetArg(arglst[4], XmNy, 563);
  modelHelpW = XmCreatePushButton(modelScreenW, "mod_help", arglst, 5);
  *tag[++j] = MODELHELP;
  XtAddCallback(modelHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(modelHelpW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Try It"));
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 565);
  modelDoW = XmCreatePushButton(modelScreenW, "mod_do", arglst, 3);
  XtAddCallback(modelDoW, XmNactivateCallback, model_activate, NULL);
  XtManageChild(modelDoW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Clear All"));
  XtSetArg(arglst[1], XmNx, 208);
  XtSetArg(arglst[2], XmNy, 565);
  modelClearW = XmCreatePushButton(modelScreenW, "mod_clr", arglst, 3);
  XtAddCallback(modelClearW, XmNactivateCallback, model_clear_activate, NULL);
  XtManageChild(modelClearW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Undo"));
  XtSetArg(arglst[1], XmNx, 302);
  XtSetArg(arglst[2], XmNy, 565);
  modelUndoW = XmCreatePushButton(modelScreenW, "mod_undo", arglst, 3);
  XtAddCallback(modelUndoW, XmNactivateCallback, model_undo_activate, NULL);
  XtManageChild(modelUndoW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Save"));
  XtSetArg(arglst[1], XmNx, 360);
  XtSetArg(arglst[2], XmNy, 565);
  modelSaveW = XmCreatePushButton(modelScreenW, "mod_save", arglst, 3);
  XtAddCallback(modelSaveW, XmNactivateCallback, model_save_activate, NULL);
  XtManageChild(modelSaveW);

  // Center widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Center"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 130);
  modelCenLW = XmCreateLabel(modelScreenW, "mod_cenl", arglst, 3);
  XtManageChild(modelCenLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("x         "));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 150);
  modelXLW = XmCreateLabel(modelScreenW, "mod_cenxl", arglst, 3);
  XtManageChild(modelXLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("y"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 180);
  modelYLW = XmCreateLabel(modelScreenW, "mod_cenyl", arglst, 3);
  XtManageChild(modelYLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("z"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 210);
  modelZLW = XmCreateLabel(modelScreenW, "mod_cenzl", arglst, 3);
  XtManageChild(modelZLW);

  XtSetArg(arglst[0], XmNx, 110);                     // Common scroll attr
  XtSetArg(arglst[1], XmNmaximum, 700);               // Common scroll attr
  XtSetArg(arglst[2], XmNminimum, 0);                 // Common scroll attr
  XtSetArg(arglst[3], XmNpageIncrement, 10);          // Common scroll attr
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);  // Common scroll attr
  XtSetArg(arglst[5], XmNwidth, 150);                 // Common scroll attr

  XtSetArg(arglst[6], XmNy, 150);
  mbCenterxScrollW = XmCreateScrollBar(modelScreenW, "mod_cxs", arglst, 7);
  XtAddCallback(mbCenterxScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbCenterxScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbCenterxScrollW);  

  XtSetArg(arglst[6], XmNy, 180);
  mbCenteryScrollW = XmCreateScrollBar(modelScreenW, "mod_cys", arglst, 7);
  XtAddCallback(mbCenteryScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbCenteryScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbCenteryScrollW);  

  XtSetArg(arglst[6], XmNy, 210);
  mbCenterzScrollW = XmCreateScrollBar(modelScreenW, "mod_czs", arglst, 7);
  XtAddCallback(mbCenterzScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbCenterzScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbCenterzScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);   // Common text attr
  XtSetArg(arglst[1], XmNx, 275);       // Common text attr
  XtSetArg(arglst[2], XmNvalue, "0");   // Common text attr

  XtSetArg(arglst[3], XmNy, 145);
  mbCenterxTextW = XmCreateText(modelScreenW, "map_cxt", arglst, 4);
  XtManageChild(mbCenterxTextW);

  XtSetArg(arglst[3], XmNy, 175);
  mbCenteryTextW = XmCreateText(modelScreenW, "map_cyt", arglst, 4);
  XtManageChild(mbCenteryTextW);

  XtSetArg(arglst[3], XmNy, 205);
  mbCenterzTextW = XmCreateText(modelScreenW, "map_czt", arglst, 4);
  XtManageChild(mbCenterzTextW);

  // Dimension widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Dimensions"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 260);
  modelDimLW = XmCreateLabel(modelScreenW, "mod_diml", arglst, 3);
  XtManageChild(modelDimLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("width"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 280);
  modelWLW = XmCreateLabel(modelScreenW, "mod_dimwl", arglst, 3);
  XtManageChild(modelWLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("height"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 310);
  modelHLW = XmCreateLabel(modelScreenW, "mod_dimhl", arglst, 3);
  XtManageChild(modelHLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("depth"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 340);
  modelDLW = XmCreateLabel(modelScreenW, "mod_dimdl", arglst, 3);
  XtManageChild(modelDLW);

  XtSetArg(arglst[0], XmNx, 110);                     // Common scroll attr
  XtSetArg(arglst[1], XmNmaximum, 700);               // Common scroll attr
  XtSetArg(arglst[2], XmNminimum, 0);                 // Common scroll attr
  XtSetArg(arglst[3], XmNpageIncrement, 10);          // Common scroll attr
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);  // Common scroll attr
  XtSetArg(arglst[5], XmNwidth, 150);                 // Common scroll attr
  XtSetArg(arglst[6], XmNvalue, 10);                  // Common scroll attr

  XtSetArg(arglst[7], XmNy, 280);
  mbDimensionxScrollW = XmCreateScrollBar(modelScreenW, "mod_dxs", arglst, 8);
  XtAddCallback(mbDimensionxScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbDimensionxScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbDimensionxScrollW);  

  XtSetArg(arglst[7], XmNy, 310);
  mbDimensionyScrollW = XmCreateScrollBar(modelScreenW, "mod_dys", arglst, 8);
  XtAddCallback(mbDimensionyScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbDimensionyScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbDimensionyScrollW);  

  XtSetArg(arglst[7], XmNy, 340);
  mbDimensionzScrollW = XmCreateScrollBar(modelScreenW, "mod_dzs", arglst, 8);
  XtAddCallback(mbDimensionzScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbDimensionzScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbDimensionzScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);   // Common text attr
  XtSetArg(arglst[1], XmNx, 275);       // Common text attr
  XtSetArg(arglst[2], XmNvalue, "10");  // Common text attr

  XtSetArg(arglst[3], XmNy, 275);
  mbDimensionxTextW = XmCreateText(modelScreenW, "map_dxt", arglst, 4);
  XtManageChild(mbDimensionxTextW);

  XtSetArg(arglst[3], XmNy, 305);
  mbDimensionyTextW = XmCreateText(modelScreenW, "map_dyt", arglst, 4);
  XtManageChild(mbDimensionyTextW);

  XtSetArg(arglst[3], XmNy, 335);
  mbDimensionzTextW = XmCreateText(modelScreenW, "map_dzt", arglst, 4);
  XtManageChild(mbDimensionzTextW);

  // Rotation widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Rotation"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 390);
  modelRotLW = XmCreateLabel(modelScreenW, "mod_rotl", arglst, 3);
  XtManageChild(modelRotLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("theta"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 410);
  modelThetaLW = XmCreateLabel(modelScreenW, "mod_rottl", arglst, 3);
  XtManageChild(modelThetaLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("phi"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 440);
  modelPhiLW = XmCreateLabel(modelScreenW, "mod_rotpl", arglst, 3);
  XtManageChild(modelPhiLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("omega"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 470);
  modelOmegaLW = XmCreateLabel(modelScreenW, "mod_rotol", arglst, 3);
  XtManageChild(modelOmegaLW);

  XtSetArg(arglst[0], XmNx, 110);                     // Common scroll attr
  XtSetArg(arglst[1], XmNmaximum, 370);               // Common scroll attr
  XtSetArg(arglst[2], XmNminimum, -360);              // Common scroll attr
  XtSetArg(arglst[3], XmNpageIncrement, 10);          // Common scroll attr
  XtSetArg(arglst[4], XmNorientation, XmHORIZONTAL);  // Common scroll attr
  XtSetArg(arglst[5], XmNwidth, 150);                 // Common scroll attr
  XtSetArg(arglst[6], XmNsliderSize, 10);             // Common scroll attr

  XtSetArg(arglst[7], XmNy, 410);
  mbRotatetScrollW = XmCreateScrollBar(modelScreenW, "mod_rts", arglst, 8);
  XtAddCallback(mbRotatetScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbRotatetScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbRotatetScrollW);  

  XtSetArg(arglst[7], XmNy, 440);
  mbRotatepScrollW = XmCreateScrollBar(modelScreenW, "mod_rps", arglst, 8);
  XtAddCallback(mbRotatepScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbRotatepScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbRotatepScrollW);  

  XtSetArg(arglst[7], XmNy, 470);
  mbRotateoScrollW = XmCreateScrollBar(modelScreenW, "mod_ros", arglst, 8);
  XtAddCallback(mbRotateoScrollW, XmNvalueChangedCallback, 
		mb_scroll_change, NULL);
  XtAddCallback(mbRotateoScrollW, XmNdragCallback, 
		mb_scroll_change, NULL);
  XtManageChild(mbRotateoScrollW);  

  XtSetArg(arglst[0], XmNcolumns, 5);   // Common text attr
  XtSetArg(arglst[1], XmNx, 275);       // Common text attr
  XtSetArg(arglst[2], XmNvalue, "0");   // Common text attr

  XtSetArg(arglst[3], XmNy, 405);
  mbRotatetTextW = XmCreateText(modelScreenW, "map_rtt", arglst, 4);
  XtManageChild(mbRotatetTextW);

  XtSetArg(arglst[3], XmNy, 435);
  mbRotatepTextW = XmCreateText(modelScreenW, "map_rpt", arglst, 4);
  XtManageChild(mbRotatepTextW);

  XtSetArg(arglst[3], XmNy, 465);
  mbRotateoTextW = XmCreateText(modelScreenW, "map_rot", arglst, 4);
  XtManageChild(mbRotateoTextW);

} // end function create_modelscreen
