#include "gui.h"

void create_movementscreen () {
  // function name: create_movementscreen
  // Create/initialize movement screen (relates angle and diameter to distance)
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Movement of Surface Features"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 700);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 600);
  XtSetArg(arglst[7], XmNheight, 350);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  movementScreenW = XmCreateFormDialog(toplevel_widget, "mvm", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 300);
  moveExitW = XmCreatePushButton(movementScreenW, "mvm_exit", arglst, 5);
  XtAddCallback(moveExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(moveExitW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Particle Diameter:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  movementLabelW = XmCreateLabel(movementScreenW, "mvm_dl", arglst, 3);
  XtManageChild(movementLabelW);

  XtSetArg(arglst[0], XmNcolumns,  7);
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 10);
  diamTextW = XmCreateText(movementScreenW, "mvm_dt", arglst, 3);
  XtAddCallback(diamTextW, XmNvalueChangedCallback, diamText_change, NULL);
  XtManageChild(diamTextW);

  XtSetArg(arglst[0], XmNscrollVertical, 1);
  XtSetArg(arglst[1], XmNscrollHorizontal, 0);
  XtSetArg(arglst[2], XmNeditMode, XmMULTI_LINE_EDIT);
  XtSetArg(arglst[3], XmNcursorPositionVisible, 1);
  XtSetArg(arglst[4], XmNwordWrap, 1);
  XtSetArg(arglst[5], XmNcolumns, 82);
  XtSetArg(arglst[6], XmNrows, 12);
  XtSetArg(arglst[7], XmNx, 10);
  XtSetArg(arglst[8], XmNy, 50);
  movementTextW = XmCreateScrolledText(movementScreenW, 
					 "mvm_txt", arglst, 9);
  XtManageChild(movementTextW);

} // end function create_movementscreen
