#include "gui.h"

void create_moviecontourscreen () {
  // function name: create_moviecontourscreen
  // Create and initialize attributes of movie contour screen
  
  int *tag[20], i, j=-1;
  for (i=0; i<20; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Contour"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 500);
  XtSetArg(arglst[5], XmNy, 520);
  XtSetArg(arglst[6], XmNwidth, 550);
  XtSetArg(arglst[7], XmNheight, 200);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  movconScreenW = XmCreateFormDialog(toplevel_widget, "mvc", arglst, 9);

  // Push buttons

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 15);
  XtSetArg(arglst[4], XmNy, 15);
  movconExitW = XmCreatePushButton(movconScreenW, "mvc_exit", arglst, 5);
  XtAddCallback(movconExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(movconExitW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Tryit"));
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 160);
  movconTryW = XmCreatePushButton(movconScreenW, "mvc_try", arglst, 3);
  *tag[++j] = TRYIT;
  XtAddCallback(movconTryW, XmNactivateCallback, movieMinMax_change, 
		(XtPointer)tag[j]);
  XtManageChild(movconTryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Set Break Point"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 45);
  movconBrkW = XmCreatePushButton(movconScreenW, "mvc_brk", arglst, 3);
  *tag[++j] = BREAKPOINT;
  XtAddCallback(movconBrkW, XmNactivateCallback, movieMinMax_change, 
		(XtPointer)tag[j]);
  XtManageChild(movconBrkW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Reset"));
  XtSetArg(arglst[1], XmNx, 450);
  XtSetArg(arglst[2], XmNy, 160);
  movconResetW = XmCreatePushButton(movconScreenW, "mvc_rst", arglst, 3);
  XtAddCallback(movconResetW, XmNactivateCallback, movie_contour_state, NULL);
  XtManageChild(movconResetW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Clear"));
  XtSetArg(arglst[1], XmNx, 310);
  XtSetArg(arglst[2], XmNy, 160);
  movconClearW = XmCreatePushButton(movconScreenW, "mvc_clr", arglst, 3);
  XtAddCallback(movconClearW, XmNactivateCallback, movie_contour_state, NULL);
  XtManageChild(movconClearW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Use this Density"));
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 160);
  movconUseW = XmCreatePushButton(movconScreenW, "mvc_use", arglst, 3);
  XtAddCallback(movconUseW, XmNactivateCallback, movie_contour_state, NULL);
  XtManageChild(movconUseW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write RAW file"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 160);
  movconWriteW = XmCreatePushButton(movconScreenW, "mvc_wrt", arglst, 3);
  XtAddCallback(movconWriteW, XmNactivateCallback, movie_contour_state, NULL);
  XtManageChild(movconWriteW);

  // Toggle buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Apply to movie"));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 45); 
  movconTogW = XmCreateToggleButton(movconScreenW, "mvc_tog", arglst, 3);
  *tag[++j] = USECONT;
  XtAddCallback(movconTogW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag[j]);
  XtManageChild(movconTogW);

  // Text boxes

  XtSetArg(arglst[0], XmNcolumns, 50);
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 10);
  movconTextW = XmCreateText(movconScreenW, "mvc_txt", arglst, 3);
  XtManageChild(movconTextW);

  // Scrolls and labels

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0  "));
  XtSetArg(arglst[1], XmNx, 160);
  XtSetArg(arglst[2], XmNy, 45);
  movconBrkLW = XmCreateLabel(movconScreenW, "mvc_rbkl", arglst, 3);
  XtManageChild(movconBrkLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("0.000"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 90);
  movconConLW = XmCreateLabel(movconScreenW, "mvc_conl", arglst, 3);
  XtManageChild(movconConLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Start"));
  XtSetArg(arglst[1], XmNx, 70);
  XtSetArg(arglst[2], XmNy, 120);
  movconScrollLW = XmCreateLabel(movconScreenW, "mvc_scrl", arglst, 3);
  XtManageChild(movconScrollLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0  "));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 90);
  movconNumLW = XmCreateLabel(movconScreenW, "mvc_numl", arglst, 3);
  XtManageChild(movconNumLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Num Contours"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 120);
  movconNumScrLW = XmCreateLabel(movconScreenW, "mvc_numscrl", arglst, 3);
  XtManageChild(movconNumScrLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0  "));
  XtSetArg(arglst[1], XmNx, 390);
  XtSetArg(arglst[2], XmNy, 90);
  movconDelLW = XmCreateLabel(movconScreenW, "mvc_dell", arglst, 3);
  XtManageChild(movconDelLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Delta"));
  XtSetArg(arglst[1], XmNx, 430);
  XtSetArg(arglst[2], XmNy, 120);
  movconDelScrLW = XmCreateLabel(movconScreenW, "mvc_delscrl", arglst, 3);
  XtManageChild(movconDelScrLW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, -100);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 420);
  XtSetArg(arglst[5], XmNy, 90);
  movconScrollW = XmCreateScrollBar(movconScreenW, "mvc_scrw", arglst, 6);
  *tag[++j] = DELTA;
  XtAddCallback(movconScrollW, XmNvalueChangedCallback, 
		movieMinMax_change, (XtPointer)tag[j]);
  *tag[++j] = DELTA;
  XtAddCallback(movconScrollW, XmNdragCallback, 
		movieMinMax_change, (XtPointer)tag[j]);
  XtManageChild(movconScrollW);  

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 230);
  XtSetArg(arglst[5], XmNy, 90);
  movconNumScrollW = XmCreateScrollBar(movconScreenW, "mvc_nscrw", arglst, 6);
  *tag[++j] = NUMCONT;
  XtAddCallback(movconNumScrollW, XmNvalueChangedCallback, 
		movieMinMax_change, (XtPointer)tag[j]);
  *tag[++j] = NUMCONT;
  XtAddCallback(movconNumScrollW, XmNdragCallback, 
		movieMinMax_change, (XtPointer)tag[j]);
  XtManageChild(movconNumScrollW);  

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, -100);
  XtSetArg(arglst[2], XmNpageIncrement, 5);	
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 60);
  XtSetArg(arglst[5], XmNy, 90);
  movconConScrollW = XmCreateScrollBar(movconScreenW, "mvc_cscrw", arglst, 6);
  *tag[++j] = CONTOUR;
  XtAddCallback(movconConScrollW, XmNvalueChangedCallback, 
		movieMinMax_change, (XtPointer)tag[j]);
  *tag[++j] = CONTOUR;
  XtAddCallback(movconConScrollW, XmNdragCallback, 
		movieMinMax_change, (XtPointer)tag[j]);
  XtManageChild(movconConScrollW);  

} // end function create_moviecontourscreen
