#include "gui.h"

void create_optionscreen () {
  // function name: create_optionscreen
  // Create/initialize option screen
  
  int *tag1, *tag2;
  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Options"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 100);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 500);
  XtSetArg(arglst[7], XmNheight, 570);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  optionsScreenW = XmCreateFormDialog(toplevel_widget, "opt", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 5);
  XtSetArg(arglst[4], XmNy, 5);
  optionsExitW = XmCreatePushButton(optionsScreenW, "opt_exit", arglst, 5);
  XtAddCallback(optionsExitW, XmNactivateCallback, options_deactivate, NULL);
  XtManageChild(optionsExitW);

  // Min/max map value widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Min MapValue"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 60);
  minMapLabelW = XmCreateLabel(optionsScreenW, "opt_minl", arglst, 3);
  XtManageChild(minMapLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Max MapValue"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 90);
  maxMapLabelW = XmCreateLabel(optionsScreenW, "opt_maxl", arglst, 3);
  XtManageChild(maxMapLabelW);

  XtSetArg(arglst[0], XmNcolumns,  8);
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 60);
  minMapTextW = XmCreateText(optionsScreenW, "opt_mint", arglst, 3);
  XtManageChild(minMapTextW);
  XtSetArg(arglst[2], XmNy, 90);
  maxMapTextW = XmCreateText(optionsScreenW, "opt_maxt", arglst, 3);
  XtManageChild(maxMapTextW);

  // Background option widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Background Options: "));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 60);
  optionsBkgW = XmCreateLabel(optionsScreenW, "opt_bkg", arglst, 3);
  XtManageChild(optionsBkgW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNx, 330);
  XtSetArg(arglst[3], XmNy, 90);
  optionsBkgrW = XmCreateRadioBox(optionsScreenW, "opt_bkgr", arglst, 4);
  XtManageChild(optionsBkgrW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Average"));
  XtSetArg(arglst[1], XmNset, 1);
  optionsAvgW = XmCreateToggleButton(optionsBkgrW, "opt_avg", arglst, 2);
  *tag1 = USEAVGPIXEL;
  XtAddCallback(optionsAvgW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag1);
  XtManageChild(optionsAvgW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Random"));
  optionsRanW = XmCreateToggleButton(optionsBkgrW, "opt_ran", arglst, 1);
  *tag2 = USERANDPIXEL;
  XtAddCallback(optionsRanW, XmNvalueChangedCallback, 
		boxMode_change, (XtPointer)tag2);
  XtManageChild(optionsRanW);

  // Display option widgets
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Display Options: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 200);
  optionsDspW = XmCreateLabel(optionsScreenW, "opt_dsp", arglst, 3);
  XtManageChild(optionsDspW);

  XtSetArg(arglst[0], XmNx, 90); // Common toggle attribute
  
  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Circle/Image/Section number"));
  XtSetArg(arglst[2], XmNy, 220);
  XtSetArg(arglst[3], XmNset, 1);
  optionsCirW = XmCreateToggleButton(optionsScreenW, "opt_cir", arglst, 4);
  XtAddCallback(optionsCirW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(optionsCirW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Init box Counter"));
  XtSetArg(arglst[2], XmNy, 250);
  optionsBoxW = XmCreateToggleButton(optionsScreenW, "opt_box", arglst, 3);
  XtAddCallback(optionsBoxW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(optionsBoxW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Auto-Zoom"));
  XtSetArg(arglst[2], XmNy, 280);
  XtSetArg(arglst[3], XmNset, 1);
  optionsZoomW = XmCreateToggleButton(optionsScreenW, "opt_zoom", arglst, 4);
  XtAddCallback(optionsZoomW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(optionsZoomW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Reverse Excise"));
  XtSetArg(arglst[2], XmNy, 310);
  optionsExW = XmCreateToggleButton(optionsScreenW, "opt_ex", arglst, 3);
  XtAddCallback(optionsExW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(optionsExW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("FFT screen motion feedback"));
  XtSetArg(arglst[2], XmNy, 340);
  optionsFftW = XmCreateToggleButton(optionsScreenW, "opt_fft", arglst, 3);
  XtAddCallback(optionsFftW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(optionsFftW);

  // Bottom set of toggles
  XtSetArg(arglst[0], XmNx, 10); // Common toggle attribute

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Calculate SFs for incoming MAPs"));
  XtSetArg(arglst[2], XmNy, 380);
  calcSfsW = XmCreateToggleButton(optionsScreenW, "opt_csf", arglst, 3);
  XtAddCallback(calcSfsW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(calcSfsW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("BIN MAPs before calculating SFs"));
  XtSetArg(arglst[2], XmNy, 410);
  calcBinW = XmCreateToggleButton(optionsScreenW, "opt_cb", arglst, 3);
  XtAddCallback(calcBinW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(calcBinW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Use True Phi rotation"));
  XtSetArg(arglst[2], XmNy, 440);
  XtSetArg(arglst[3], XmNset, 1);
  truePhiW = XmCreateToggleButton(optionsScreenW, "opt_tp", arglst, 4);
  XtAddCallback(truePhiW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(truePhiW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Force BYTE output"));
  XtSetArg(arglst[2], XmNy, 470);
  forceByteW = XmCreateToggleButton(optionsScreenW, "opt_fb", arglst, 3);
  XtAddCallback(forceByteW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(forceByteW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Force AVG value as BKG for circle boxes"));
  XtSetArg(arglst[2], XmNy, 500);
  forceAvgBkgW = XmCreateToggleButton(optionsScreenW, "opt_fabw", arglst, 3);
  XtAddCallback(forceAvgBkgW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(forceAvgBkgW);

  XtSetArg(arglst[1], XmNlabelString, 
	   XmStringCreateLocalized("Use Min/Max for Color"));
  XtSetArg(arglst[2], XmNy, 530);
  minmaxColorW = XmCreateToggleButton(optionsScreenW, "opt_mmc", arglst, 3);
  XtAddCallback(minmaxColorW, XmNvalueChangedCallback, 
		dispMode_change, NULL);
  XtManageChild(minmaxColorW);

} // end function create_optionscreen
