#include "gui.h"

void create_partprocscreen() {
  // function name: create_partprocscreen
  // Create and initialize attributes of particle processing screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  // Bin arrow behaviors controlled by binPPArrowButton()
  // Step arrow behaviors controlled by stepPPArrowButton()
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Partproc"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 400);
  XtSetArg(arglst[5], XmNy, 120);
  XtSetArg(arglst[6], XmNwidth, 950);
  XtSetArg(arglst[7], XmNheight, 700);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[9], XmNresizable, 0);
  partprocScreenW = XmCreateFormDialog(toplevel_widget, "pp", arglst, 10);

  // Top left labels, text, and browse buttons
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Parameter File:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  paramFileLabelW = XmCreateLabel(partprocScreenW, "ppfl", arglst, 3);
  XtManageChild(paramFileLabelW);
  
  XtSetArg(arglst[0], XmNcolumns, 24);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 10);
  paramFileTextW = XmCreateText(partprocScreenW, "ppft", arglst, 3);
  XtManageChild(paramFileTextW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Browse"));
  XtSetArg(arglst[1], XmNx, 470);
  XtSetArg(arglst[2], XmNy, 10);
  paramFileBrowseW = XmCreatePushButton(partprocScreenW, 
					"ppfb", arglst, 3);
  *tag[++j] = PARAMFILE;
  XtAddCallback(paramFileBrowseW, XmNactivateCallback, 
		paramFile_browse_activate, (XtPointer)tag[j]);
  XtManageChild(paramFileBrowseW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Map File:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  paramMapFileLabelW = XmCreateLabel(partprocScreenW, "ppml", arglst, 3);
  XtManageChild(paramMapFileLabelW);
  
  XtSetArg(arglst[0], XmNcolumns, 24);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 40);
  paramMapFileTextW = XmCreateText(partprocScreenW, "ppmt", arglst, 3);
  XtManageChild(paramMapFileTextW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Browse"));
  XtSetArg(arglst[1], XmNx, 470);
  XtSetArg(arglst[2], XmNy, 40);
  paramMapFileBrowseW = XmCreatePushButton(partprocScreenW, 
					   "ppmb", arglst, 3);
  *tag[++j] = PARAMMAP;
  XtAddCallback(paramMapFileBrowseW, XmNactivateCallback, 
		paramFile_browse_activate, (XtPointer)tag[j]);
  XtManageChild(paramMapFileBrowseW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Scan File:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  paramScanFileLabelW = XmCreateLabel(partprocScreenW, "ppsl", arglst, 3);
  XtManageChild(paramScanFileLabelW);
  
  XtSetArg(arglst[0], XmNcolumns, 24);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 70);
  paramScanFileTextW = XmCreateText(partprocScreenW, "ppst", arglst, 3);
  XtManageChild(paramScanFileTextW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Browse"));
  XtSetArg(arglst[1], XmNx, 470);
  XtSetArg(arglst[2], XmNy, 70);
  paramScanFileBrowseW = XmCreatePushButton(partprocScreenW, 
					    "ppsb", arglst, 3);
  *tag[++j] = PARAMSCAN;
  XtAddCallback(paramScanFileBrowseW, XmNactivateCallback, 
		paramFile_browse_activate, (XtPointer)tag[j]);
  XtManageChild(paramScanFileBrowseW);
  
  // Top right menu bar
  
  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  partprocMenuBarW = XmCreateMenuBar(partprocScreenW, "pp_mb", arglst, 4);
  XtManageChild(partprocMenuBarW);
  
  // Help pulldown
  
  ppHelpMenuW = XmCreatePulldownMenu(partprocMenuBarW, "pp_helpm", NULL, 0);
  
  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNsubMenuId, ppHelpMenuW);
  XtSetArg(arglst[2], XmNwidth, 34);
  XtSetArg(arglst[3], XmNheight, 30);
  ppHelpMenuEntryW = XmCreateCascadeButton(partprocMenuBarW, 
					   "pp_helpme", arglst, 4);
  XtManageChild(ppHelpMenuEntryW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Unit Cell"));
  ppHelpUnitBW = XmCreatePushButton(ppHelpMenuW, "pp_helpb1", arglst, 1);
  *tag[++j] = UNITCELL;
  XtAddCallback(ppHelpUnitBW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(ppHelpUnitBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("XY Plot"));
  ppHelpXYBW = XmCreatePushButton(ppHelpMenuW, "pp_helpb2", arglst, 1);
  *tag[++j] = XYPLOT;
  XtAddCallback(ppHelpXYBW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(ppHelpXYBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Histogram"));
  ppHelpHistBW = XmCreatePushButton(ppHelpMenuW, "pp_helpb3", arglst, 1);
  *tag[++j] = HISTOGRAM;
  XtAddCallback(ppHelpHistBW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(ppHelpHistBW);
  
  // Batch pulldown
  
  ppBatchMenuW = XmCreatePulldownMenu(partprocMenuBarW, "pp_batchm", NULL, 0);
  
  XtSetArg(arglst[0], XmNlabelString,
	   XmStringCreateLocalized("Batch Job"));
  XtSetArg(arglst[1], XmNsubMenuId, ppBatchMenuW);
  ppBatchMenuEntryW = XmCreateCascadeButton(partprocMenuBarW, 
					    "pp_batchme", arglst, 2);
  XtManageChild(ppBatchMenuEntryW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Batch Job"));
  ppBatchBatchBW = XmCreatePushButton(ppBatchMenuW, "pp_batchb1", arglst, 1);
  *tag[++j] = BATCHJOB;
  XtAddCallback(ppBatchBatchBW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ppBatchBatchBW);
  
  // Calc pulldown
  
  ppCalcMenuW = XmCreatePulldownMenu(partprocMenuBarW, "pp_calcm", NULL, 0);
  
  XtSetArg(arglst[0], XmNlabelString,
	   XmStringCreateLocalized("Calc"));
  XtSetArg(arglst[1], XmNsubMenuId, ppCalcMenuW);
  ppCalcMenuEntryW = XmCreateCascadeButton(partprocMenuBarW, 
					   "pp_calcme", arglst, 2);
  XtManageChild(ppCalcMenuEntryW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Movement of Surface Features"));
  ppCalcMoveBW = XmCreatePushButton(ppCalcMenuW, "pp_calcb1", arglst, 1);
  XtAddCallback(ppCalcMoveBW, XmNactivateCallback, movement_activate, NULL);
  XtManageChild(ppCalcMoveBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Number of Views per ASU"));
  ppCalcViewBW = XmCreatePushButton(ppCalcMenuW, "pp_calcb2", arglst, 1);
  XtAddCallback(ppCalcViewBW, XmNactivateCallback, views_activate, NULL);
  XtManageChild(ppCalcViewBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Projections in ASU"));
  ppCalcProjBW = XmCreatePushButton(ppCalcMenuW, "pp_calcb3", arglst, 1);
  XtAddCallback(ppCalcProjBW, XmNactivateCallback, projASU_activate, NULL);
  XtManageChild(ppCalcProjBW);
  
  // Symmetry pulldown
  
  ppSymmMenuW = XmCreatePulldownMenu(partprocMenuBarW, "pp_symmm", NULL, 0);
  
  XtSetArg(arglst[0], XmNlabelString,
	   XmStringCreateLocalized("Symmetry"));
  XtSetArg(arglst[1], XmNsubMenuId, ppSymmMenuW);
  ppSymmMenuEntryW = XmCreateCascadeButton(partprocMenuBarW, 
					   "pp_symmme", arglst, 2);
  XtManageChild(ppSymmMenuEntryW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("532"));
  ppSymm532BW = XmCreatePushButton(ppSymmMenuW, "pp_symmb1", arglst, 1);
  *tag[++j] = 532;
  XtAddCallback(ppSymm532BW, XmNactivateCallback, symmetry_activate, 
		(XtPointer)tag[j]);
  XtManageChild(ppSymm532BW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("52"));
  ppSymm52BW = XmCreatePushButton(ppSymmMenuW, "pp_symmb2", arglst, 1);
  *tag[++j] = 52;
  XtAddCallback(ppSymm52BW, XmNactivateCallback, symmetry_activate, 
		(XtPointer)tag[j]);
  XtManageChild(ppSymm52BW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("5"));
  ppSymm5BW = XmCreatePushButton(ppSymmMenuW, "pp_symmb3", arglst, 1);
  *tag[++j] = 5;
  XtAddCallback(ppSymm5BW, XmNactivateCallback, symmetry_activate, 
		(XtPointer)tag[j]);
  XtManageChild(ppSymm5BW);
  
  // Display pulldown
  
  ppDispMenuW = XmCreatePulldownMenu(partprocMenuBarW, "pp_dispm", NULL, 0);
  
  XtSetArg(arglst[0], XmNlabelString,
	   XmStringCreateLocalized("Display"));
  XtSetArg(arglst[1], XmNsubMenuId, ppDispMenuW);
  ppDispMenuEntryW = XmCreateCascadeButton(partprocMenuBarW, 
					   "pp_dispme", arglst, 2);
  XtManageChild(ppDispMenuEntryW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Histogram"));
  ppDispHistBW = XmCreatePushButton(ppDispMenuW, "pp_dispb1", arglst, 1);
  XtAddCallback(ppDispHistBW, XmNactivateCallback, ico_hist_activate, NULL);
  XtManageChild(ppDispHistBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Asymmetric Unit"));
  ppDispUnitBW = XmCreatePushButton(ppDispMenuW, "pp_dispb2", arglst, 1);
  XtAddCallback(ppDispUnitBW, XmNactivateCallback, unitCell_activate, NULL);
  XtManageChild(ppDispUnitBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Sort Particles"));
  ppDispSortBW = XmCreatePushButton(ppDispMenuW, "pp_dispb3", arglst, 1);
  XtAddCallback(ppDispSortBW, XmNactivateCallback, partproc_sort_activate, NULL);
  XtManageChild(ppDispSortBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("XY Plot"));
  ppDispPlotBW = XmCreatePushButton(ppDispMenuW, "pp_dispb4", arglst, 1);
  XtAddCallback(ppDispPlotBW, XmNactivateCallback, xyPlot_activate, NULL);
  XtManageChild(ppDispPlotBW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Plot Circular Average"));
  ppDispCavgBW = XmCreatePushButton(ppDispMenuW, "pp_dispb5", arglst, 1);
  XtAddCallback(ppDispCavgBW, XmNactivateCallback, plotCavgPP_activate, NULL);
  XtManageChild(ppDispCavgBW);
  
  // Toggles and other contols on mid-left
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Display centers "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 140); 
  XtSetArg(arglst[3], XmNset, 1); 
  ppDispCentW = XmCreateToggleButton(partprocScreenW, "pp_dispc", arglst, 4);
  *tag[++j] = DISPCENTERS;
  XtAddCallback(ppDispCentW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(ppDispCentW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Pick new particle center"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 170); 
  ppPickNewW = XmCreateToggleButton(partprocScreenW, "pp_pickn", arglst, 3);
  *tag[++j] = NEWXY;
  XtAddCallback(ppPickNewW, XmNdisarmCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(ppPickNewW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("MAP Projections"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 190); 
  mapProjW = XmCreateToggleButton(partprocScreenW, "pp_mapproj", arglst, 3);
  *tag[++j] = PARAMPROJ;
  XtAddCallback(mapProjW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(mapProjW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Projection Contour"));
  XtSetArg(arglst[1], XmNx, 170);
  XtSetArg(arglst[2], XmNy, 190); 
  ppProjContW = XmCreateToggleButton(partprocScreenW, "pp_prjcont", arglst, 3);
  *tag[++j] = PROJCONTOUR;
  XtAddCallback(ppProjContW, XmNdisarmCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(ppProjContW);
  
  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 190);
  projContourTextW = XmCreateText(partprocScreenW, "pp_prjctxt", arglst, 3);
  XtManageChild(projContourTextW);
  
  XtSetArg(arglst[0], XmNwidth, 512);
  XtSetArg(arglst[1], XmNheight, 512);
  XtSetArg(arglst[2], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNresizePolicy, XmRESIZE_ANY);
  XtSetArg(arglst[5], XmNborderWidth, 1);
  icosaW = XmCreateDrawingArea(partprocScreenW, "pp_icosa", arglst, 6);
  XtAddCallback(icosaW, XmNexposeCallback, DrawICOSWindow, NULL);
  XtAddCallback(icosaW, XmNinputCallback, icosaClick, NULL);
  XtManageChild(icosaW);

  //RSS111 - figure out how to use fixed font
  XtSetArg(arglst[0], XmNscrollVertical, 1);
  XtSetArg(arglst[1], XmNscrollHorizontal, 0);
  XtSetArg(arglst[2], XmNeditMode, XmMULTI_LINE_EDIT);
  XtSetArg(arglst[3], XmNcursorPositionVisible, 1);
  XtSetArg(arglst[4], XmNwordWrap, 1);
  XtSetArg(arglst[5], XmNcolumns, 60);
  XtSetArg(arglst[6], XmNrows, 5);
  XtSetArg(arglst[7], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[8], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[9], XmNbottomWidget, icosaW);
  partPointTextW = XmCreateScrolledText(partprocScreenW, "pp_st", arglst, 10);
  XtManageChild(partPointTextW);

  // Up/down arrow behaviors controlled by ppinArrowButton
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNrightWidget, partPointTextW);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNbottomWidget, icosaW);
  ppinDownW = XmCreateArrowButton(partprocScreenW, "pp_down", arglst, 7);
  XtManageChild(ppinDownW);  
  
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNrightWidget, partPointTextW);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNbottomWidget, ppinDownW);
  ppinUpW = XmCreateArrowButton(partprocScreenW, "pp_up", arglst, 7);
  XtManageChild(ppinUpW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNrightWidget, partPointTextW);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNbottomWidget, ppinUpW);
  ppinTextW = XmCreateText(partprocScreenW, "pp_text", arglst, 5);
  XtManageChild(ppinTextW);

  // Subform containing CTF parameters

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 230);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[4], XmNresizable, 0);
  parmheadW = XmCreateForm(partprocScreenW, "ppph", arglst, 5);
  XtManageChild(parmheadW);

  XtSetArg(arglst[0], XmNx, 10); // Common attribute for column of labels

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("pixSize "));
  XtSetArg(arglst[2], XmNy, 10);
  phPixLW = XmCreateLabel(parmheadW, "ppph_pixlw", arglst, 3);
  XtManageChild(phPixLW);
  
  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Voltage "));
  XtSetArg(arglst[2], XmNy, 40);
  phVoltLW = XmCreateLabel(parmheadW, "ppph_voltlw", arglst, 3);
  XtManageChild(phVoltLW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Famp "));
  XtSetArg(arglst[2], XmNy, 70);
  phAmpLW = XmCreateLabel(parmheadW, "ppph_amplw", arglst, 3);
  XtManageChild(phAmpLW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("df major "));
  XtSetArg(arglst[2], XmNy, 100);
  phMajLW = XmCreateLabel(parmheadW, "ppph_majlw", arglst, 3);
  XtManageChild(phMajLW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("df minor "));
  XtSetArg(arglst[2], XmNy, 130);
  phMinLW = XmCreateLabel(parmheadW, "ppph_minlw", arglst, 3);
  XtManageChild(phMinLW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Ang major "));
  XtSetArg(arglst[2], XmNy, 160);
  phAngLW = XmCreateLabel(parmheadW, "ppph_anglw", arglst, 3);
  XtManageChild(phAngLW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Cs Coef"));
  XtSetArg(arglst[2], XmNy, 190);
  phCsLW = XmCreateLabel(parmheadW, "ppph_cslw", arglst, 3);
  XtManageChild(phCsLW);

  XtSetArg(arglst[0], XmNcolumns, 9);  // Common attr for column of text boxes
  XtSetArg(arglst[1], XmNx, 102);      // Common attr for column of text boxes

  XtSetArg(arglst[2], XmNy, 10);
  pixsizeW = XmCreateText(parmheadW, "ppph_pixtw", arglst, 3);
  XtManageChild(pixsizeW);
  
  XtSetArg(arglst[2], XmNy, 40);
  voltsW = XmCreateText(parmheadW, "ppph_voltw", arglst, 3);
  XtManageChild(voltsW);

  XtSetArg(arglst[2], XmNy, 70);
  ampfacsW = XmCreateText(parmheadW, "ppph_amptw", arglst, 3);
  XtManageChild(ampfacsW);

  XtSetArg(arglst[2], XmNy, 100);
  delfMajW = XmCreateText(parmheadW, "ppph_majtw", arglst, 3);
  XtManageChild(delfMajW);
  
  XtSetArg(arglst[2], XmNy, 130);
  delfMinW = XmCreateText(parmheadW, "ppph_mintw", arglst, 3);
  XtManageChild(delfMinW);

  XtSetArg(arglst[2], XmNy, 160);
  angMajW = XmCreateText(parmheadW, "ppph_angtw", arglst, 3);
  XtManageChild(angMajW);

  XtSetArg(arglst[2], XmNy, 190);
  csCoefW = XmCreateText(parmheadW, "ppph_cstw", arglst, 3);
  XtManageChild(csCoefW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Units"));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 10);
  phUnitLW = XmCreateLabel(parmheadW, "ppph_unitlw", arglst, 3);
  XtManageChild(phUnitLW);
  
  XtSetArg(arglst[0], XmNcolumns, 3);
  XtSetArg(arglst[1], XmNx, 332);
  XtSetArg(arglst[2], XmNy, 10);
  unitsW = XmCreateText(parmheadW, "ppph_unittw", arglst, 3);
  XtManageChild(unitsW);  

  // Subform containing Proj ASU parameters

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 235);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[4], XmNresizable, 0);
  projasuW = XmCreateForm(partprocScreenW, "pppj", arglst, 5);
  XtManageChild(projasuW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Delta Angle:"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  projasuLabelW = XmCreateLabel(projasuW, "pppj_label", arglst, 3);
  XtManageChild(projasuLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Project This"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 60);
  projasuOneW = XmCreatePushButton(projasuW, "pppj_one", arglst, 3);
  XtAddCallback(projasuOneW, XmNactivateCallback, project_one, NULL);
  XtManageChild(projasuOneW);

  XtSetArg(arglst[0], XmNcolumns, 14);
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 10);
  projasuTextW = XmCreateText(projasuW, "pppj_text", arglst, 3);
  XtManageChild(projasuTextW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Theta"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 90);
  thetaProjLW = XmCreateLabel(projasuW, "pppj_thel", arglst, 3);
  XtManageChild(thetaProjLW);

  XtSetArg(arglst[0], XmNcolumns, 10);
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 90);
  thetaProjW = XmCreateText(projasuW, "pppj_thet", arglst, 3);
  XtManageChild(thetaProjW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Phi"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 120);
  phiProjLW = XmCreateLabel(projasuW, "pppj_phil", arglst, 3);
  XtManageChild(phiProjLW);

  XtSetArg(arglst[0], XmNcolumns, 10);
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 120);
  phiProjW = XmCreateText(projasuW, "pppj_phit", arglst, 3);
  XtManageChild(phiProjW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Omega"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 150);
  omegaProjLW = XmCreateLabel(projasuW, "pppj_omel", arglst, 3);
  XtManageChild(omegaProjLW);

  XtSetArg(arglst[0], XmNcolumns, 10);
  XtSetArg(arglst[1], XmNx, 130);
  XtSetArg(arglst[2], XmNy, 150);
  omegaProjW = XmCreateText(projasuW, "pppj_omet", arglst, 3);
  XtManageChild(omegaProjW);

  // Subform containing Min/Max parameters
  
  XtSetArg(arglst[0], XmNx, 240);
  XtSetArg(arglst[1], XmNy, 540);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[4], XmNresizable, 0);
  ppMinMaxFormW = XmCreateForm(partprocScreenW, "ppmm", arglst, 5);
  XtManageChild(ppMinMaxFormW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Min/Max:"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 1);
  ppMinMaxLW = XmCreateLabel(ppMinMaxFormW, "ppmm_lab", arglst, 3);
  XtManageChild(ppMinMaxLW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 30);
  ppMinTextW = XmCreateText(ppMinMaxFormW, "ppmm_mint", arglst, 3);
  XtManageChild(ppMinTextW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 70);
  ppMaxTextW = XmCreateText(ppMinMaxFormW, "ppmm_maxt", arglst, 3);
  XtManageChild(ppMaxTextW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 75);
  XtSetArg(arglst[5], XmNy, 35);
  XtSetArg(arglst[6], XmNwidth, 100);
  ppMinScrollW = XmCreateScrollBar(ppMinMaxFormW, "ppmm_mins", arglst, 7);
  XtAddCallback(ppMinScrollW, XmNvalueChangedCallback, 
		ppMinMax_scroll_change, NULL);
  XtAddCallback(ppMinScrollW, XmNdragCallback, 
		ppMinMax_scroll_change, NULL);
  XtManageChild(ppMinScrollW);  

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 10);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 75);
  XtSetArg(arglst[5], XmNy, 75);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 100);
  ppMaxScrollW = XmCreateScrollBar(ppMinMaxFormW, "ppmm_maxs", arglst, 8);
  XtAddCallback(ppMaxScrollW, XmNvalueChangedCallback, 
		ppMinMax_scroll_change, NULL);
  XtAddCallback(ppMaxScrollW, XmNdragCallback, 
		ppMinMax_scroll_change, NULL);
  XtManageChild(ppMaxScrollW);  

  // Subform containing Sort parameters
  
  XtSetArg(arglst[0], XmNx, 3);
  XtSetArg(arglst[1], XmNy, 235);
  XtSetArg(arglst[2], XmNborderWidth, 2);
  XtSetArg(arglst[3], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[4], XmNresizable, 0);
  parmTogsW = XmCreateForm(partprocScreenW, "pppt", arglst, 5);
  XtManageChild(parmTogsW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Choose parameters for histogram: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  parmTogsLabelW = XmCreateLabel(parmTogsW, "pppt_lab", arglst, 3);
  XtManageChild(parmTogsLabelW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Increasing"));
  XtSetArg(arglst[1], XmNx, 300);
  XtSetArg(arglst[2], XmNy, 10);
  incDecW = XmCreatePushButton(parmTogsW, "pppt_inc", arglst, 3);
  *tag[++j] = INCDEC;  
  XtAddCallback(incDecW, XmNactivateCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(incDecW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Particle Number"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 40);
  idtW = XmCreateToggleButton(parmTogsW, "pppt_ptle", arglst, 3);
  *tag[++j] = IDT;  
  XtAddCallback(idtW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(idtW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Theta"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 60);
  thetatW = XmCreateToggleButton(parmTogsW, "pppt_theta", arglst, 3);
  *tag[++j] = THETAT;  
  XtAddCallback(thetatW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(thetatW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Phi"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 80);
  phitW = XmCreateToggleButton(parmTogsW, "pppt_phi", arglst, 3);
  *tag[++j] = PHIT;  
  XtAddCallback(phitW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(phitW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Omega"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 100);
  omegatW = XmCreateToggleButton(parmTogsW, "pppt_omega", arglst, 3);
  *tag[++j] = OMEGAT;  
  XtAddCallback(omegatW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(omegatW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("X"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 120);
  xtW = XmCreateToggleButton(parmTogsW, "pppt_x", arglst, 3);
  *tag[++j] = XT;  
  XtAddCallback(xtW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(xtW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("delta X"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 120);
  deltaXTW = XmCreateToggleButton(parmTogsW, "pppt_dx", arglst, 3);
  *tag[++j] = DELTAXT;  
  XtAddCallback(deltaXTW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(deltaXTW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ABS(delta X)"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 120);
  absDeltaXTW = XmCreateToggleButton(parmTogsW, "pppt_adx", arglst, 3);
  *tag[++j] = ABSDELTAXT;  
  XtAddCallback(absDeltaXTW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(absDeltaXTW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Y"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 140);
  ytW = XmCreateToggleButton(parmTogsW, "pppt_y", arglst, 3);
  *tag[++j] = YT;  
  XtAddCallback(ytW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(ytW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("delta Y"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 140);
  deltaYTW = XmCreateToggleButton(parmTogsW, "pppt_dy", arglst, 3);
  *tag[++j] = DELTAYT;  
  XtAddCallback(deltaYTW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(deltaYTW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ABS(delta Y)"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 140);
  absDeltaYTW = XmCreateToggleButton(parmTogsW, "pppt_ady", arglst, 3);
  *tag[++j] = ABSDELTAYT;  
  XtAddCallback(absDeltaYTW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(absDeltaYTW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Distance"));
  XtSetArg(arglst[1], XmNx, 330);
  XtSetArg(arglst[2], XmNy, 130);
  distanceTW = XmCreateToggleButton(parmTogsW, "pppt_dis", arglst, 3);
  *tag[++j] = DISTANCET;  
  XtAddCallback(distanceTW, XmNvalueChangedCallback,
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(distanceTW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Mag"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 160);
  magtW = XmCreateToggleButton(parmTogsW, "pppt_mag", arglst, 3);
  *tag[++j] = MAGT;  
  XtAddCallback(magtW, XmNvalueChangedCallback,
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(magtW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("PFT CC"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 180);
  pftccW = XmCreateToggleButton(parmTogsW, "pppt_pftcc", arglst, 3);
  *tag[++j] = PFTCC;  
  XtAddCallback(pftccW, XmNvalueChangedCallback, 
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(pftccW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("PRJ CC"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 200);
  prjccW = XmCreateToggleButton(parmTogsW, "pppt_prjcc", arglst, 3);
  *tag[++j] = PRJCC;  
  XtAddCallback(prjccW, XmNvalueChangedCallback,
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(prjccW);
    
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("CMP CC"));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 220);
  cmpccW = XmCreateToggleButton(parmTogsW, "pppt_cmpcc", arglst, 3);
  *tag[++j] = CMPCC;  
  XtAddCallback(cmpccW, XmNvalueChangedCallback,
		paramMode_change, (XtPointer)tag[j]);
  XtManageChild(cmpccW);

  // Subform containing Hist controls: NOTE parent is parmTogs
  
  XtSetArg(arglst[0], XmNx, 200);
  XtSetArg(arglst[1], XmNy, 50);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[4], XmNresizable, 0);
  histControlsW = XmCreateForm(parmTogsW, "pphc", arglst, 5);
  XtManageChild(histControlsW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Bins: "));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 10);
  histBinLW = XmCreateLabel(histControlsW, "pphc_binl", arglst, 3);
  XtManageChild(histBinLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNvalue, "20");
  binTextW = XmCreateText(histControlsW, "pphc_bint", arglst, 4);
  XtManageChild(binTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, binTextW);
  XtSetArg(arglst[5], XmNy, 28);
  binPPDownW = XmCreateArrowButton(histControlsW, "pphc_bdown", arglst, 6);
  XtManageChild(binPPDownW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, binTextW);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNbottomWidget, binPPDownW);
  binPPUpW = XmCreateArrowButton(histControlsW, "pphc_bup", arglst, 7);
  XtManageChild(binPPUpW);  
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("StepSize: "));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 50);
  histStepLW = XmCreateLabel(histControlsW, "pphc_stepl", arglst, 3);
  XtManageChild(histStepLW);

  XtSetArg(arglst[0], XmNcolumns, 7);
  XtSetArg(arglst[1], XmNx, 90);
  XtSetArg(arglst[2], XmNy, 50);
  histStepTextW = XmCreateText(histControlsW, "pphc_stept", arglst, 3);
  XtManageChild(histStepTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, histStepTextW);
  XtSetArg(arglst[5], XmNy, 68);
  stepPPDownW = XmCreateArrowButton(histControlsW, "pphc_stepd", arglst, 6);
  XtManageChild(stepPPDownW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, histStepTextW);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNbottomWidget, stepPPDownW);
  stepPPUpW = XmCreateArrowButton(histControlsW, "pphc_stepu", arglst, 7);
  XtManageChild(stepPPUpW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("StrtX"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 90);
  histStartXLW = XmCreateLabel(histControlsW, "pphc_stxl", arglst, 3);
  XtManageChild(histStartXLW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 55);
  XtSetArg(arglst[2], XmNy, 90);
  strtXPPW = XmCreateText(histControlsW, "pphc_stxt", arglst, 3);
  XtManageChild(strtXPPW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("EndX"));
  XtSetArg(arglst[1], XmNx, 115);
  XtSetArg(arglst[2], XmNy, 90);
  histEndXLW = XmCreateLabel(histControlsW, "pphc_endxl", arglst, 3);
  XtManageChild(histEndXLW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNx, 155);
  XtSetArg(arglst[2], XmNy, 90);
  endXPPW = XmCreateText(histControlsW, "pphc_endxt", arglst, 3);
  XtManageChild(endXPPW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Max Particles"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 130);
  histMaxLW = XmCreateLabel(histControlsW, "pphc_maxl", arglst, 3);
  XtManageChild(histMaxLW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 120);
  XtSetArg(arglst[2], XmNy, 130);
  XtSetArg(arglst[3], XmNvalue, "10000");
  maxYPPW = XmCreateText(histControlsW, "pphc_maxt", arglst, 4);
  XtManageChild(maxYPPW);

  // Bottom left buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Compute Circular Avg"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 490);
  ppCavgBW = XmCreatePushButton(partprocScreenW, "pp_cavb", arglst, 3);
  *tag[++j] = CAVGPP;
  XtAddCallback(ppCavgBW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ppCavgBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Add delta omega"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 520);
  ppDoaBW = XmCreatePushButton(partprocScreenW, "pp_doab", arglst, 3);
  *tag[++j] = DELTAOMEGA;
  XtAddCallback(ppDoaBW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ppDoaBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Manipulate Particle Params"));
  XtSetArg(arglst[1], XmNx, 200);
  XtSetArg(arglst[2], XmNy, 520);
  ppMppBW = XmCreatePushButton(partprocScreenW, "pp_mppb", arglst, 3);
  *tag[++j] = MANIPPP;
  XtAddCallback(ppMppBW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ppMppBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Add delta X,Y to centers"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 550);
  ppDxyaBW = XmCreatePushButton(partprocScreenW, "pp_dxyab", arglst, 3);
  *tag[++j] = DELTAXY;
  XtAddCallback(ppDxyaBW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ppDxyaBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rebox ALL Particles"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 580);
  ppRbAllBW = XmCreatePushButton(partprocScreenW, "pp_rbab", arglst, 3);
  *tag[++j] = ALL;
  XtAddCallback(ppRbAllBW, XmNactivateCallback, 
		partproc_rebox_activate, (XtPointer)tag[j]);
  XtManageChild(ppRbAllBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rebox This Particles"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 610);
  ppRbOneBW = XmCreatePushButton(partprocScreenW, "pp_rbob", arglst, 3);
  *tag[++j] = 0;
  XtAddCallback(ppRbOneBW, XmNactivateCallback, 
		partproc_rebox_activate, (XtPointer)tag[j]);
  XtManageChild(ppRbOneBW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write New Param File"));
  XtSetArg(arglst[1], XmNx, 75);
  XtSetArg(arglst[2], XmNy, 650);
  ppWnewBW = XmCreatePushButton(partprocScreenW, "pp_wnewb", arglst, 3);
  *tag[++j] = PARTPROCWRITE;
  XtAddCallback(ppWnewBW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(ppWnewBW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 15);
  XtSetArg(arglst[4], XmNy, 650);
  partprocExitW = XmCreatePushButton(partprocScreenW, "pp_exit", arglst, 5);
  XtAddCallback(partprocExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(partprocExitW);

} // end function create_partprocscreen
