#include "gui.h"

void create_refscreen () {
  // function name: create_refscreen
  // Create and initialize attributes of reference based boxing screen
  
  int *tag[20], i, j=-1;
  for (i=0; i<20; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Reference based refine boxing"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 850);
  XtSetArg(arglst[5], XmNy, 150);
  XtSetArg(arglst[6], XmNwidth, 600);
  XtSetArg(arglst[7], XmNheight, 395);
  refScreenW = XmCreateFormDialog(toplevel_widget, "ref", arglst, 8);

  // Push buttons

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Select All"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 15);
  refAllW = XmCreatePushButton(refScreenW, "ref_all", arglst, 3);
  XtAddCallback(refAllW, XmNactivateCallback, ref_select_activate, 
		NULL);
  XtManageChild(refAllW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Reset"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 45);
  refResetW = XmCreatePushButton(refScreenW, "ref_reset", arglst, 3);
  XtAddCallback(refResetW, XmNactivateCallback, ref_select_activate, 
		NULL);
  XtManageChild(refResetW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Regrid"));
  XtSetArg(arglst[1], XmNx, 100);
  XtSetArg(arglst[2], XmNy, 75);
  refRegridW = XmCreatePushButton(refScreenW, "ref_regrid", arglst, 3);
  XtAddCallback(refRegridW, XmNactivateCallback, ref_select_activate, 
		NULL);
  XtManageChild(refRegridW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Do It"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 15);
  refDoW = XmCreatePushButton(refScreenW, "ref_do", arglst, 3);
  XtAddCallback(refDoW, XmNactivateCallback, ref_deactivate, NULL);
  XtManageChild(refDoW);

  // Toggle buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Dark Circle Reference  "));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 40);
  refDarkTW = XmCreateToggleButton(refScreenW, "ref_dark", arglst, 3);
  *tag[++j] = DARKREF;
  XtAddCallback(refDarkTW, XmNvalueChangedCallback, 
		box_change, (XtPointer)tag[j]);
  XtManageChild(refDarkTW);
  
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Circular Avg Ref"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 15);
  refCircAvgW = XmCreateToggleButton(refScreenW, "ref_cavg", arglst, 3);
  *tag[++j] = REFCIRCAVG;
  XtAddCallback(refCircAvgW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(refCircAvgW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Iterate"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 70);
  refAutomateW = XmCreateToggleButton(refScreenW, "ref_auto", arglst, 3);
  *tag[++j] = REFAUTOMATE;
  XtAddCallback(refAutomateW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(refAutomateW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Use disk file reference"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 100);
  refReadfileW = XmCreateToggleButton(refScreenW, "ref_readf", arglst, 3);
  *tag[++j] = REFREADFILE;
  XtAddCallback(refReadfileW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(refReadfileW);

  // Other widgets

  XtSetArg(arglst[0], XmNscrollVertical, 1);
  XtSetArg(arglst[1], XmNscrollHorizontal, 0);
  XtSetArg(arglst[2], XmNeditMode, XmMULTI_LINE_EDIT);
  XtSetArg(arglst[3], XmNcursorPositionVisible, 1);
  XtSetArg(arglst[4], XmNwordWrap, 1);
  XtSetArg(arglst[5], XmNcolumns, 82);
  XtSetArg(arglst[6], XmNrows, 13);
  XtSetArg(arglst[7], XmNx, 15);
  XtSetArg(arglst[8], XmNy, 195);
  refTextW = XmCreateScrolledText(refScreenW, "ref_text", arglst, 9);
  XtManageChild(helpTextW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("# Iterations"));
  XtSetArg(arglst[1], XmNx, 380);
  XtSetArg(arglst[2], XmNy, 15);
  refIterLW = XmCreateLabel(refScreenW, "ref_il", arglst, 3);
  XtManageChild(refIterLW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("No file"));
  XtSetArg(arglst[1], XmNx, 240);
  XtSetArg(arglst[2], XmNy, 130);
  refReadLW = XmCreateLabel(refScreenW, "ref_rl", arglst, 3);
  XtManageChild(refReadLW);
  
  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, refIterLW);
  XtSetArg(arglst[3], XmNy, 15);
  XtSetArg(arglst[4], XmNvalue, "5");
  refIterTW = XmCreateText(refScreenW, "ref_it", arglst, 5);
  XtManageChild(refIterTW);

} // end function create_refscreen
