#include "gui.h"

void create_rotfltscreen() {
  // function name: create_rotfltscreen
  // Create and initialize attributes of rotation filtering screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  // [xy]orig[Up|Down]ArrowW controlled by rotfltArrowActivate
  // rotfltImgNumArrow[UpDown]W controlled by fftImgNumArrowButton
  
  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("RotFlt"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 240);
  XtSetArg(arglst[5], XmNy, 200);
  XtSetArg(arglst[6], XmNwidth, 800);
  XtSetArg(arglst[7], XmNheight, 600);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  XtSetArg(arglst[9], XmNresizable, 0);
  rotfltScreenW = XmCreateFormDialog(toplevel_widget, "rf", arglst, 10);

  XtSetArg(arglst[0], XmNwidth, 512);
  XtSetArg(arglst[1], XmNheight, 512);
  XtSetArg(arglst[2], XmNx, 3);
  XtSetArg(arglst[3], XmNy, 3);
  XtSetArg(arglst[4], XmNborderWidth, 2);
  rotfltDrawW = XmCreateDrawingArea(rotfltScreenW, "rf_draw", arglst, 5);
  XtAddCallback(rotfltDrawW, XmNexposeCallback, DrawROTFLTWindow, NULL);
  XtAddCallback(rotfltDrawW, XmNinputCallback, rotfltClick, NULL);
  XtManageChild(rotfltDrawW);

  // Right hand side controls

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Xscale"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 30);
  xscaleLabelW = XmCreateLabel(rotfltScreenW, "rf_xsl", arglst, 3);
  XtManageChild(xscaleLabelW);

  XtSetArg(arglst[0], XmNmaximum, 10);
  XtSetArg(arglst[1], XmNminimum, -10);
  XtSetArg(arglst[2], XmNpageIncrement, 2);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 595);
  XtSetArg(arglst[5], XmNy, 30);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 1);
  xscaleScrollW = XmCreateScrollBar(rotfltScreenW, "rf_xs", arglst, 8);
  XtAddCallback(xscaleScrollW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtAddCallback(xscaleScrollW, XmNdragCallback, rotflt_change, NULL);
  XtManageChild(xscaleScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Yscale"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 55);
  yscaleLabelW = XmCreateLabel(rotfltScreenW, "rf_ysl", arglst, 3);
  XtManageChild(yscaleLabelW);

  XtSetArg(arglst[0], XmNmaximum, 50);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 595);
  XtSetArg(arglst[5], XmNy, 55);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 4);
  yscaleScrollW = XmCreateScrollBar(rotfltScreenW, "rf_ys", arglst, 8);
  XtAddCallback(yscaleScrollW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtAddCallback(yscaleScrollW, XmNdragCallback, rotflt_change, NULL);
  XtManageChild(yscaleScrollW);  

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Refine Origin"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 112);
  refineButtonW = XmCreatePushButton(rotfltScreenW, "rf_refb", arglst, 3);
  XtAddCallback(refineButtonW, XmNactivateCallback, rotflt_change, NULL);
  XtManageChild(refineButtonW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNx, 705);
  XtSetArg(arglst[4], XmNy, 52);
  XtSetArg(arglst[5], XmNspacing, 8);
  rotfltRadioW = XmCreateRadioBox(rotfltScreenW, "rf_radio", arglst, 6);
  XtManageChild(rotfltRadioW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Linear"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10); 
  XtSetArg(arglst[3], XmNset, 1); 
  linROTFLTtoggleW = XmCreateToggleButton(rotfltRadioW, "rf_rb1", arglst, 4);
  XtAddCallback(linROTFLTtoggleW, XmNvalueChangedCallback, 
		rotflt_change, NULL);
  XtManageChild(linROTFLTtoggleW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Log"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40); 
  logROTFLTtoggleW = XmCreateToggleButton(rotfltRadioW, "rf_rb2", arglst, 3);
  XtAddCallback(logROTFLTtoggleW, XmNvalueChangedCallback, 
		rotflt_change, NULL);
  XtManageChild(logROTFLTtoggleW);

  // Subform containing refine widgets

  XtSetArg(arglst[0], XmNx, 530);
  XtSetArg(arglst[1], XmNy, 140);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNwidth, 100);
  XtSetArg(arglst[4], XmNheight, 60);
  rotfltResetW = XmCreateForm(rotfltScreenW, "rf_form", arglst, 5);
  XtManageChild(rotfltResetW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Rel SrchWin"));
  XtSetArg(arglst[1], XmNx, 1);
  XtSetArg(arglst[2], XmNy, 2);
  rotfltResetLW = XmCreateLabel(rotfltResetW, "rf_forml1", arglst, 3);
  XtManageChild(rotfltResetLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("1.000 "));
  XtSetArg(arglst[1], XmNx, 40);
  XtSetArg(arglst[2], XmNy, 30);
  refineResetLabelW = XmCreateLabel(rotfltResetW, "rf_forml2", arglst, 3);
  XtManageChild(refineResetLabelW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 1);
  XtSetArg(arglst[4], XmNy, 30);
  refineResetButtonW = XmCreatePushButton(rotfltResetW, "rf_formr", arglst, 5);
  XtAddCallback(refineResetButtonW, XmNactivateCallback, 
		rotflt_change, NULL);
  XtManageChild(refineResetButtonW);

  // Origin widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("X orig"));
  XtSetArg(arglst[1], XmNx, 640);
  XtSetArg(arglst[2], XmNy, 142);
  rotfltXorigLW = XmCreateLabel(rotfltScreenW, "rf_xol", arglst, 3);
  XtManageChild(rotfltXorigLW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 700);
  XtSetArg(arglst[2], XmNy, 142);
  xorigTextW = XmCreateText(rotfltScreenW, "rf_xot", arglst, 3);
  XtManageChild(xorigTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, xorigTextW);
  XtSetArg(arglst[5], XmNy, 137);
  xorigUpArrowW = XmCreateArrowButton(rotfltScreenW, "rf_xup", arglst, 6);
  XtManageChild(xorigUpArrowW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, xorigTextW);
  XtSetArg(arglst[5], XmNy, 153);
  xorigDownArrowW = XmCreateArrowButton(rotfltScreenW, "rf_xdn", arglst, 6);
  XtManageChild(xorigDownArrowW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Y orig"));
  XtSetArg(arglst[1], XmNx, 640);
  XtSetArg(arglst[2], XmNy, 172);
  rotfltYorigLW = XmCreateLabel(rotfltScreenW, "rf_yol", arglst, 3);
  XtManageChild(rotfltYorigLW);

  XtSetArg(arglst[0], XmNcolumns, 6);
  XtSetArg(arglst[1], XmNx, 700);
  XtSetArg(arglst[2], XmNy, 172);
  yorigTextW = XmCreateText(rotfltScreenW, "rf_yot", arglst, 3);
  XtManageChild(yorigTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, yorigTextW);
  XtSetArg(arglst[5], XmNy, 173);
  yorigUpArrowW = XmCreateArrowButton(rotfltScreenW, "rf_yup", arglst, 6);
  XtManageChild(yorigUpArrowW);  

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, yorigTextW);
  XtSetArg(arglst[5], XmNy, 192);
  yorigDownArrowW = XmCreateArrowButton(rotfltScreenW, "rf_ydn", arglst, 6);
  XtManageChild(yorigDownArrowW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Use G-zero"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 230); 
  XtSetArg(arglst[3], XmNset, 1); 
  jZerotoggleW = XmCreateToggleButton(rotfltScreenW, "rf_sjz", arglst, 4);
  XtAddCallback(jZerotoggleW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtManageChild(jZerotoggleW);

  // Sliders at mid-right

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Symmetry"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 260);
  nrotDescW = XmCreateLabel(rotfltScreenW, "rf_nrd", arglst, 3);
  XtManageChild(nrotDescW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 625);
  XtSetArg(arglst[5], XmNy, 260);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 5);
  nrotScrollW = XmCreateScrollBar(rotfltScreenW, "rf_nrs", arglst, 8);
  XtAddCallback(nrotScrollW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtAddCallback(nrotScrollW, XmNdragCallback, rotflt_change, NULL);
  XtManageChild(nrotScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  5"));
  XtSetArg(arglst[1], XmNx, 750);
  XtSetArg(arglst[2], XmNy, 260);
  nrotLabelW = XmCreateLabel(rotfltScreenW, "rf_nrl", arglst, 3);
  XtManageChild(nrotLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Sym Limit"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 290);
  lgendDescW = XmCreateLabel(rotfltScreenW, "rf_lgd", arglst, 3);
  XtManageChild(lgendDescW);

  XtSetArg(arglst[0], XmNmaximum, 111);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 625);
  XtSetArg(arglst[5], XmNy, 290);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 100);
  lgendScrollW = XmCreateScrollBar(rotfltScreenW, "rf_lgs", arglst, 8);
  XtAddCallback(lgendScrollW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtAddCallback(lgendScrollW, XmNdragCallback, rotflt_change, NULL);
  XtManageChild(lgendScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("100"));
  XtSetArg(arglst[1], XmNx, 750);
  XtSetArg(arglst[2], XmNy, 290);
  lgendLabelW = XmCreateLabel(rotfltScreenW, "rf_lgl", arglst, 3);
  XtManageChild(lgendLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("# Annuli"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 320);
  nannuliDescW = XmCreateLabel(rotfltScreenW, "rf_nad", arglst, 3);
  XtManageChild(nannuliDescW);

  XtSetArg(arglst[0], XmNmaximum, 100);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 625);
  XtSetArg(arglst[5], XmNy, 320);
  XtSetArg(arglst[6], XmNwidth, 100);
  XtSetArg(arglst[7], XmNvalue, 30);
  nannuliScrollW = XmCreateScrollBar(rotfltScreenW, "rf_nas", arglst, 8);
  XtAddCallback(nannuliScrollW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtAddCallback(nannuliScrollW, XmNdragCallback, rotflt_change, NULL);
  XtManageChild(nannuliScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  30"));
  XtSetArg(arglst[1], XmNx, 750);
  XtSetArg(arglst[2], XmNy, 320);
  nannuliLabelW = XmCreateLabel(rotfltScreenW, "rf_nal", arglst, 3);
  XtManageChild(nannuliLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Omega"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 350);
  phi0DescW = XmCreateLabel(rotfltScreenW, "rf_phd", arglst, 3);
  XtManageChild(phi0DescW);

  XtSetArg(arglst[0], XmNmaximum, 219);
  XtSetArg(arglst[1], XmNminimum, -180);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 625);
  XtSetArg(arglst[5], XmNy, 350);
  XtSetArg(arglst[6], XmNwidth, 100);
  phi0ScrollW = XmCreateScrollBar(rotfltScreenW, "rf_phs", arglst, 7);
  XtAddCallback(phi0ScrollW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtAddCallback(phi0ScrollW, XmNdragCallback, rotflt_change, NULL);
  XtManageChild(phi0ScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 750);
  XtSetArg(arglst[2], XmNy, 350);
  phi0LabelW = XmCreateLabel(rotfltScreenW, "rf_phl", arglst, 3);
  XtManageChild(phi0LabelW);

  // Bottom right controls

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("FFT step"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 390);
  fftStepLabelW = XmCreateLabel(rotfltScreenW, "rf_fftsl", arglst, 3);
  XtManageChild(fftStepLabelW);

  XtSetArg(arglst[0], XmNcolumns, 9);
  XtSetArg(arglst[1], XmNx, 595);
  XtSetArg(arglst[2], XmNy, 390);
  fftStepTextW = XmCreateText(rotfltScreenW, "rf_fftst", arglst, 3);
  XtManageChild(fftStepTextW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Filter Img"));
  XtSetArg(arglst[3], XmNx, 530);
  XtSetArg(arglst[4], XmNy, 450);
  tryitButtonW = XmCreatePushButton(rotfltScreenW, "rf_tryb", arglst, 5);
  XtAddCallback(tryitButtonW, XmNactivateCallback, 
		rotflt_forceTryit_activate, NULL);
  XtManageChild(tryitButtonW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Stretch"));
  XtSetArg(arglst[1], XmNx, 640);
  XtSetArg(arglst[2], XmNy, 450); 
  XtSetArg(arglst[3], XmNset, 1); 
  rotfltStretchW = XmCreateToggleButton(rotfltScreenW, "rf_stch", arglst, 4);
  XtAddCallback(rotfltStretchW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtManageChild(rotfltStretchW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Live"));
  XtSetArg(arglst[1], XmNx, 730);
  XtSetArg(arglst[2], XmNy, 450); 
  backTtoggleW = XmCreateToggleButton(rotfltScreenW, "rf_btt", arglst, 3);
  XtAddCallback(backTtoggleW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtManageChild(backTtoggleW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Crosshair for center"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 480); 
  rotfltXhairW = XmCreateToggleButton(rotfltScreenW, "rf_xhair", arglst, 3);
  XtAddCallback(rotfltXhairW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtManageChild(rotfltXhairW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Contour plot of residuals"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 510);
  rotfltContW = XmCreateToggleButton(rotfltScreenW, "rf_cont", arglst, 3);
  XtAddCallback(rotfltContW, XmNvalueChangedCallback, rotflt_change, NULL);
  XtManageChild(rotfltContW);

  // Bottom row of buttons and other widgets

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 550);
  rotfltExitW = XmCreatePushButton(rotfltScreenW, "rf_exit", arglst, 5);
  XtAddCallback(rotfltExitW, XmNactivateCallback, rotflt_deactivate, NULL);
  XtManageChild(rotfltExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 90);
  XtSetArg(arglst[4], XmNy, 550);
  rotfltHelpW = XmCreatePushButton(rotfltScreenW, "rf_help", arglst, 5);
  *tag[++j] = ROTFLTHELP;
  XtAddCallback(rotfltHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(rotfltHelpW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write Filtered Image"));
  XtSetArg(arglst[1], XmNx, 530);
  XtSetArg(arglst[2], XmNy, 550);
  rotfltWriteW = XmCreatePushButton(rotfltScreenW, "rf_write", arglst, 3);
  XtAddCallback(rotfltWriteW, XmNactivateCallback, 
		rotflt_write_activate, NULL);
  XtManageChild(rotfltWriteW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 400);
  XtSetArg(arglst[3], XmNy, 539);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  rotfltImgnumArrowUpW = 
    XmCreateArrowButton(rotfltScreenW, "rf_iup", arglst, 5);
  XtManageChild(rotfltImgnumArrowUpW);  
  XtSetArg(arglst[3], XmNy, 558);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  rotfltImgnumArrowDownW = 
    XmCreateArrowButton(rotfltScreenW, "rf_idn", arglst, 5);
  XtManageChild(rotfltImgnumArrowDownW);  

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, rotfltImgnumArrowDownW);
  XtSetArg(arglst[3], XmNy, 545);
  rotfltImgNumW = XmCreateText(rotfltScreenW, "rf_itx", arglst, 4);
  XtManageChild(rotfltImgNumW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Img#"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, rotfltImgnumArrowDownW);
  XtSetArg(arglst[3], XmNy, 545);
  rotfltImgNumLW = XmCreateLabel(rotfltScreenW, "rf_ilb", arglst, 4);
  XtManageChild(rotfltImgNumLW);

} // end function create_rotfltscreen
