#include "gui.h"

void create_mainscreen() {
  // function name: create_mainscreen
  // Create and initialize attributes of main robem screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Robem"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 20);
  XtSetArg(arglst[5], XmNy, 20);
  XtSetArg(arglst[6], XmNwidth, 900);
  XtSetArg(arglst[7], XmNheight, 900);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_ANY);
  mainWindowW = XmCreateFormDialog(toplevel_widget, "main", arglst, 9);

  // Main menu bar

  XtSetArg(arglst[0], XmNspacing, 15);
  XtSetArg(arglst[1], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[2], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNrightAttachment, XmATTACH_FORM);
  mainMenuBarW = XmCreateMenuBar(mainWindowW, "main_mb", arglst, 5);
  XtManageChild(mainMenuBarW);

  // Main tool bar

  XtSetArg(arglst[0], XmNheight, 38);
  XtSetArg(arglst[1], XmNborderWidth, 1);
  XtSetArg(arglst[2], XmNresizable, 0);
  XtSetArg(arglst[3], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNtopWidget, mainMenuBarW);
  mainToolFormW = XmCreateForm(mainWindowW, "main_tool", arglst, 7);
  XtManageChild(mainToolFormW);

  // Main scroll bars

  XtSetArg(arglst[0], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  hScrollW = XmCreateScrollBar(mainWindowW, "main_hori", arglst, 4);
  XtAddCallback(hScrollW, XmNvalueChangedCallback, plotChange, NULL);
  XtManageChild(hScrollW);

  XtSetArg(arglst[0], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[1], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNtopWidget, mainToolFormW);
  XtSetArg(arglst[4], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNbottomWidget, hScrollW);
  vScrollW = XmCreateScrollBar(mainWindowW, "main_vert", arglst, 6);
  XtAddCallback(vScrollW, XmNvalueChangedCallback, plotChange, NULL);
  XtManageChild(vScrollW);

  // Main robem drawing area

  XtSetArg(arglst[0], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[1], XmNrightWidget, vScrollW);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNtopWidget, mainToolFormW);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNbottomWidget, hScrollW);
  XtSetArg(arglst[7], XmNresizePolicy, XmRESIZE_ANY);
  drawingW = XmCreateDrawingArea(mainWindowW, "main_draw", arglst, 8);
  XtAddCallback(drawingW, XmNexposeCallback, DrawWindowExpose, NULL);
  XtAddCallback(drawingW, XmNresizeCallback, formResize, NULL);
  XtAddCallback(drawingW, XmNinputCallback, plotClick, NULL);
  XtManageChild(drawingW);

  // Immediate children of main menu bar

  mfileMenuW = XmCreatePulldownMenu(mainMenuBarW, "mfilem", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("File"));
  XtSetArg(arglst[1], XmNsubMenuId, mfileMenuW);
  mfileMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "mfileme", arglst, 2);
  XtManageChild(mfileMenuEntryW);

  mmanMenuW = XmCreatePulldownMenu(mainMenuBarW, "mmanm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Manipulate"));
  XtSetArg(arglst[1], XmNsubMenuId, mmanMenuW);
  mmanMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "mmanme", arglst, 2);
  XtManageChild(mmanMenuEntryW);

  mdispMenuW = XmCreatePulldownMenu(mainMenuBarW, "mdispm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Display"));
  XtSetArg(arglst[1], XmNsubMenuId, mdispMenuW);
  mdispMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "mdispme", arglst, 2);
  XtManageChild(mdispMenuEntryW);

  mfftMenuW = XmCreatePulldownMenu(mainMenuBarW, "mfftm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("FFT"));
  XtSetArg(arglst[1], XmNsubMenuId, mfftMenuW);
  mfftMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "mfftme", arglst, 2);
  XtManageChild(mfftMenuEntryW);

  mccMenuW = XmCreatePulldownMenu(mainMenuBarW, "mccm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("CC"));
  XtSetArg(arglst[1], XmNsubMenuId, mccMenuW);
  mccMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "mccme", arglst, 2);
  XtManageChild(mccMenuEntryW);

  mpartMenuW = XmCreatePulldownMenu(mainMenuBarW, "mpartm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("PartProc"));
  XtSetArg(arglst[1], XmNsubMenuId, mpartMenuW);
  mpartMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "mpartme", arglst, 2);
  XtManageChild(mpartMenuEntryW);

  moptMenuW = XmCreatePulldownMenu(mainMenuBarW, "moptm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Options"));
  XtSetArg(arglst[1], XmNsubMenuId, moptMenuW);
  moptMenuEntryW = XmCreateCascadeButton(mainMenuBarW, "moptme", arglst, 2);
  XtManageChild(moptMenuEntryW);

  // File menu buttons and submenus

  mreadMenuW = XmCreatePulldownMenu(mfileMenuW, "mreadm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Read"));
  XtSetArg(arglst[1], XmNsubMenuId, mreadMenuW);
  mreadMenuEntryW = XmCreateCascadeButton(mfileMenuW, "mreadme", arglst, 2);
  XtManageChild(mreadMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Image Files (PIF/MAP etc.)"));
  readAllW = XmCreatePushButton(mreadMenuW, "mread_b1", arglst, 1);
  *tag[++j] = ALL;
  XtAddCallback(readAllW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readAllW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("MRC/CCP4"));
  readMrcW = XmCreatePushButton(mreadMenuW, "mread_b2", arglst, 1);
  *tag[++j] = MRC;
  XtAddCallback(readMrcW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readMrcW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Structure Factors"));
  readSfW = XmCreatePushButton(mreadMenuW, "mread_b3", arglst, 1);
  *tag[++j] = SF;
  XtAddCallback(readSfW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readSfW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Box Coords"));
  readBoxW = XmCreatePushButton(mreadMenuW, "mread_b4", arglst, 1);
  *tag[++j] = BOXCOORDS;
  XtAddCallback(readBoxW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readBoxW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("State"));
  readStateW = XmCreatePushButton(mreadMenuW, "mread_b5", arglst, 1);
  *tag[++j] = STATE;
  XtAddCallback(readStateW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readStateW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Archive"));
  readArchiveW = XmCreatePushButton(mreadMenuW, "mread_b6", arglst, 1);
  *tag[++j] = ARCHIVE;
  XtAddCallback(readArchiveW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readArchiveW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Test Area"));
  readTestW = XmCreatePushButton(mreadMenuW, "mread_b7", arglst, 1);
  *tag[++j] = TESTARCH;
  XtAddCallback(readTestW, XmNactivateCallback, 
		read_activate, (XtPointer)tag[j]);
  XtManageChild(readTestW);

  mwriteMenuW = XmCreatePulldownMenu(mfileMenuW, "mwritem", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Write"));
  XtSetArg(arglst[1], XmNsubMenuId, mwriteMenuW);
  mwriteMenuEntryW = XmCreateCascadeButton(mfileMenuW, "mwriteme", arglst, 2);
  XtManageChild(mwriteMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Circle boxes"));
  writeCircW = XmCreatePushButton(mwriteMenuW, "mwrite_b1", arglst, 1);
  *tag[++j] = CIRCLEPACKED;
  XtAddCallback(writeCircW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(writeCircW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rectangular box"));
  writeRectW = XmCreatePushButton(mwriteMenuW, "mwrite_b2", arglst, 1);
  *tag[++j] = RECTPACKED;
  XtAddCallback(writeRectW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(writeRectW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Box Coords"));
  writeBoxW = XmCreatePushButton(mwriteMenuW, "mwrite_b3", arglst, 1);
  *tag[++j] = BOXCOORDS;
  XtAddCallback(writeBoxW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(writeBoxW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Scanned Image"));
  writeScanW = XmCreatePushButton(mwriteMenuW, "mwrite_b4", arglst, 1);
  *tag[++j] = IMG;
  XtAddCallback(writeScanW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(writeScanW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Map"));
  writeMapW = XmCreatePushButton(mwriteMenuW, "mwrite_b5", arglst, 1);
  *tag[++j] = MAP;
  XtAddCallback(writeMapW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(writeMapW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("State"));
  writeStateW = XmCreatePushButton(mwriteMenuW, "mwrite_b6", arglst, 1);
  *tag[++j] = STATE;
  XtAddCallback(writeStateW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(writeStateW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("RAW image"));
  rawButtonW = XmCreatePushButton(mwriteMenuW, "mwrite_b7", arglst, 1);
  *tag[++j] = TIFF;
  XtAddCallback(rawButtonW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(rawButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("PCX Image"));
  pcxButtonW = XmCreatePushButton(mwriteMenuW, "mwrite_b8", arglst, 1);
  *tag[++j] = PCX;
  XtAddCallback(pcxButtonW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(pcxButtonW);

  mappMenuW = XmCreatePulldownMenu(mfileMenuW, "mappm", NULL, 0);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Append"));
  XtSetArg(arglst[1], XmNsubMenuId, mappMenuW);
  mappMenuEntryW = XmCreateCascadeButton(mfileMenuW, "mappme", arglst, 2);
  XtManageChild(mappMenuEntryW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Circle boxes"));
  appCircW = XmCreatePushButton(mappMenuW, "mapp_b1", arglst, 1);
  *tag[++j] = APPENDCIRCLEPACKED;
  XtAddCallback(appCircW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(appCircW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rect boxes"));
  appRectW = XmCreatePushButton(mappMenuW, "mapp_b2", arglst, 1);
  *tag[++j] = APPENDRECT;
  XtAddCallback(appRectW, XmNactivateCallback, 
		write_activate, (XtPointer)tag[j]);
  XtManageChild(appRectW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Exit"));
  exitButtonW = XmCreatePushButton(mfileMenuW, "mfile_exit", arglst, 1);
  XtAddCallback(exitButtonW, XmNactivateCallback, exit_activate, NULL);
  XtManageChild(exitButtonW);

  // Manip menu buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fix Values"));
  fixButtonW = XmCreatePushButton(mmanMenuW, "mman_b1", arglst, 1);
  XtAddCallback(fixButtonW, XmNactivateCallback, fix_activate, NULL);
  XtManageChild(fixButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Remove Blemishes"));
  removeBlemishButtonW = XmCreatePushButton(mmanMenuW, "mman_b2", arglst, 1);
  XtAddCallback(removeBlemishButtonW, XmNactivateCallback, 
		removeBlemish_activate, NULL);
  XtManageChild(removeBlemishButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rotate 3D Map"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  rotateButtonW = XmCreatePushButton(mmanMenuW, "mman_b3", arglst, 2);
  *tag[++j] = ROTATE;
  XtAddCallback(rotateButtonW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(rotateButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Truncate/Addto"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  truncaddButtonW = XmCreatePushButton(mmanMenuW, "mman_b4", arglst, 2);
  XtAddCallback(truncaddButtonW, XmNactivateCallback, truncadd_activate, NULL);
  XtManageChild(truncaddButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Invert 3D Map"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  invertButtonW = XmCreatePushButton(mmanMenuW, "mman_b5", arglst, 2);
  *tag[++j] = INVERT;
  XtAddCallback(invertButtonW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(invertButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Rescale Densities in 3D Map"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  rescaleButtonW = XmCreatePushButton(mmanMenuW, "mman_b6", arglst, 2);
  XtAddCallback(rescaleButtonW, XmNactivateCallback, rescale_activate, NULL);
  XtManageChild(rescaleButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Subtract 3D Map"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  subtractMapButtonW = XmCreatePushButton(mmanMenuW, "mman_b7", arglst, 2);
  XtAddCallback(subtractMapButtonW, XmNactivateCallback, 
		subtractMap_activate, NULL);
  XtManageChild(subtractMapButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Calculate Structure Factors for 3D Map"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  calcSFButtonW = XmCreatePushButton(mmanMenuW, "mman_b8", arglst, 2);
  XtAddCallback(calcSFButtonW, XmNactivateCallback, 
		calcSF_activate, NULL);
  XtManageChild(calcSFButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Paint Boxes"));
  editBoxButtonW = XmCreatePushButton(mmanMenuW, "mman_b9", arglst, 1);
  XtAddCallback(editBoxButtonW, XmNactivateCallback, 
		editBox_activate, NULL);
  XtManageChild(editBoxButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Excise Map"));
  paintMapButtonW = XmCreatePushButton(mmanMenuW, "mman_b10", arglst, 1);
  *tag[++j] = PAINTMAP;
  XtAddCallback(paintMapButtonW, XmNactivateCallback, 
		mapMovie_activate, (XtPointer)tag[j]);
  XtManageChild(paintMapButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Normalize Means&Vars"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  normalizeW = XmCreatePushButton(mmanMenuW, "mman_b11", arglst, 2);
  *tag[++j] = 1;
  XtAddCallback(normalizeW, XmNactivateCallback, 
		normalize_activate, (XtPointer)tag[j]);
  XtManageChild(normalizeW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Normalize Bkgs&Vars"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  normalizeBkgW = XmCreatePushButton(mmanMenuW, "mman_b12", arglst, 2);
  *tag[++j] = 2;
  XtAddCallback(normalizeBkgW, XmNactivateCallback, 
		normalize_activate, (XtPointer)tag[j]);
  XtManageChild(normalizeBkgW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Linear Gradient"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  linGradW = XmCreatePushButton(mmanMenuW, "mman_b13", arglst, 2);
  XtAddCallback(linGradW, XmNactivateCallback, 
		linGrad_activate, NULL);
  XtManageChild(linGradW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Check Backgrounds"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  checkBkgW = XmCreatePushButton(mmanMenuW, "mman_b14", arglst, 2);
  XtAddCallback(checkBkgW, XmNactivateCallback, 
		checkBkg_activate, NULL);
  XtManageChild(checkBkgW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Fourier Filter"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  fourFiltW = XmCreatePushButton(mmanMenuW, "mman_b15", arglst, 2);
  XtAddCallback(fourFiltW, XmNactivateCallback, 
		fourierFilt_activate, NULL);
  XtManageChild(fourFiltW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Add Average Particle"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  addAverageW = XmCreatePushButton(mmanMenuW, "mman_b16", arglst, 2);
  XtAddCallback(addAverageW, XmNactivateCallback, 
		addAverage_activate, NULL);
  XtManageChild(addAverageW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Interpolate"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  interpolateW = XmCreatePushButton(mmanMenuW, "mman_b17", arglst, 2);
  *tag[++j] = INTERP;
  XtAddCallback(interpolateW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(interpolateW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Binning"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  binningW = XmCreatePushButton(mmanMenuW, "mman_b18", arglst, 2);
  *tag[++j] = BINNING;
  XtAddCallback(binningW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(binningW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Model Builder"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  modelW = XmCreatePushButton(mmanMenuW, "mman_b19", arglst, 2);
  XtAddCallback(modelW, XmNactivateCallback, 
		model_screen_activate, NULL);
  XtManageChild(modelW);

  // Display menu buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Alter Colormap"));
  colorButtonW = XmCreatePushButton(mdispMenuW, "mdisp_b1", arglst, 1);
  *tag[++j] = COLORMAP;
  XtAddCallback(colorButtonW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(colorButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Info"));
  statsW = XmCreatePushButton(mdispMenuW, "mdisp_b2", arglst, 1);
  *tag[++j] = STATS;
  XtAddCallback(statsW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(statsW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Crystal Display"));
  crysW = XmCreatePushButton(mdispMenuW, "mdisp_b3", arglst, 1);
  *tag[++j] = 0;
  XtAddCallback(crysW, XmNactivateCallback, 
		crysDisp_screen_activate, (XtPointer)tag[j]);
  XtManageChild(crysW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Spherical Average"));
  circAvgButtonW = XmCreatePushButton(mdispMenuW, "mdisp_b4", arglst, 1);
  XtAddCallback(circAvgButtonW, XmNactivateCallback, 
		circAvg_screen_activate, NULL);
  XtManageChild(circAvgButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("3D Rendering"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  mapShadeButtonW = XmCreatePushButton(mdispMenuW, "mdisp_b5", arglst, 2);
  XtAddCallback(mapShadeButtonW, XmNactivateCallback, 
		mapShadeScreen_activate, NULL);
  XtManageChild(mapShadeButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("2D Movie/Display"));
  XtSetArg(arglst[1], XmNsensitive, 0);
  mapMovieButtonW = XmCreatePushButton(mdispMenuW, "mdisp_b6", arglst, 2);
  *tag[++j] = MAPMOVIE;
  XtAddCallback(mapMovieButtonW, XmNactivateCallback, 
		mapMovie_activate, (XtPointer)tag[j]);
  XtManageChild(mapMovieButtonW);

  // FFT menu buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FFT"));
  fftButtonW = XmCreatePushButton(mfftMenuW, "mfft_b1", arglst, 1);
  XtAddCallback(fftButtonW, XmNactivateCallback, fft_activate, NULL);
  XtManageChild(fftButtonW);

  // CC menu buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Correlate Avg"));
  emcorButtonW = XmCreatePushButton(mccMenuW, "mcc_b1", arglst, 1);
  *tag[++j] = EMCORAVG;
  XtAddCallback(emcorButtonW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(emcorButtonW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Image Convolution"));
  imgconvButtonW = XmCreatePushButton(mccMenuW, "mcc_b2", arglst, 1);
  *tag[++j] = IMGCONV;
  XtAddCallback(imgconvButtonW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(imgconvButtonW);

  // PartProc menu buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Particle Processing"));
  partButtonW = XmCreatePushButton(mpartMenuW, "mpart_b1", arglst, 1);
  *tag[++j] = PARTPROC;
  XtAddCallback(partButtonW, XmNactivateCallback,
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(partButtonW);

  // PartProc menu buttons

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Options"));
  optButtonW = XmCreatePushButton(moptMenuW, "mopt_b1", arglst, 1);
  *tag[++j] = OPTIONS;
  XtAddCallback(optButtonW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(optButtonW);

  // Tool bar widgets

  // Up/down arrow behaviors controlled by button_zoom_activate()
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  zoomArrowUpW = XmCreateArrowButton(mainToolFormW, "mt_zup", arglst, 5);
  XtManageChild(zoomArrowUpW);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  zoomArrowDownW = XmCreateArrowButton(mainToolFormW, "mt_zdn", arglst, 5);
  XtManageChild(zoomArrowDownW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, zoomArrowUpW);
  XtSetArg(arglst[3], XmNy, 1);
  XtSetArg(arglst[4], XmNvalue, "1.00");
  zoomTextW = XmCreateText(mainToolFormW, "mt_zt", arglst, 5);
  XtManageChild(zoomTextW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("D"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, zoomTextW);
  XtSetArg(arglst[3], XmNy, 3);
  drawLiteButtonW = XmCreatePushButton(mainToolFormW, "mt_dlb", arglst, 4);
  XtAddCallback(drawLiteButtonW, XmNactivateCallback, drawLiteActivate, NULL);
  XtManageChild(drawLiteButtonW);

  XtSetArg(arglst[0], XmNborderWidth, 1);
  XtSetArg(arglst[1], XmNresizable, 0);
  XtSetArg(arglst[2], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, drawLiteButtonW);
  subToolFormW = XmCreateForm(mainToolFormW, "mt_subf", arglst, 6);
  XtManageChild(subToolFormW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNresizable, 0);
  mainRadioW = XmCreateRadioBox(subToolFormW, "mt_toolr", arglst, 4);
  XtManageChild(mainRadioW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Zoom"));
  XtSetArg(arglst[1], XmNforeground, pixels_return[RED]);
  zoomToolW = XmCreateToggleButton(mainRadioW, "mr_zoom", arglst, 2);
  *tag[++j] = USEZOOM;
  XtAddCallback(zoomToolW, XmNvalueChangedCallback, 
		toolMode_change, (XtPointer)tag[j]);
  XtManageChild(zoomToolW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Box"));
  XtSetArg(arglst[1], XmNforeground, pixels_return[BLUE]);
  boxToolW = XmCreateToggleButton(mainRadioW, "mr_box", arglst, 2);
  *tag[++j] = USEBOX;
  XtAddCallback(boxToolW, XmNvalueChangedCallback, 
		toolMode_change, (XtPointer)tag[j]);
  XtManageChild(boxToolW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Point"));
  pointToolW = XmCreateToggleButton(mainRadioW, "mr_point", arglst, 1);
  *tag[++j] = USEPOINT;
  XtAddCallback(pointToolW, XmNvalueChangedCallback, 
		toolMode_change, (XtPointer)tag[j]);
  XtManageChild(pointToolW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 19);
  XtSetArg(arglst[3], XmNy, 5);
  XtSetArg(arglst[4], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[6], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[7], XmNleftWidget, mainRadioW);
  sectionW = XmCreatePushButton(subToolFormW, "mt_section", arglst, 8);
  *tag[++j] = USESECTION;
  XtAddCallback(sectionW, XmNactivateCallback, 
		mapMovie_show_activate, (XtPointer)tag[j]);
  XtManageChild(sectionW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("ImgNum:"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, subToolFormW);
  XtSetArg(arglst[3], XmNy, 5);
  imgNumLabelW = XmCreateLabel(mainToolFormW, "mt_imglbl", arglst, 4);
  XtManageChild(imgNumLabelW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, imgNumLabelW);
  XtSetArg(arglst[3], XmNy, 1);
  XtSetArg(arglst[4], XmNvalue, "1");
  imgNumTextW = XmCreateText(mainToolFormW, "mt_imgtxt", arglst, 5);
  *tag[++j] = IMGNUMBUTTON;
  XtAddCallback(imgNumTextW, XmNvalueChangedCallback, 
		imgNumText_changed, (XtPointer)tag[j]);
  XtManageChild(imgNumTextW);

  // Up/down arrow behaviors controlled by imgNumArrowActivateButton()
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, imgNumTextW);
  XtSetArg(arglst[4], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  imgnumArrowUpW = XmCreateArrowButton(mainToolFormW, "mt_iaup", arglst, 6);
  XtManageChild(imgnumArrowUpW);
  XtSetArg(arglst[4], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  imgnumArrowDownW = XmCreateArrowButton(mainToolFormW, "mt_iadn", arglst, 6);
  XtManageChild(imgnumArrowDownW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, imgnumArrowUpW);
  lockW = XmCreateToggleButton(mainToolFormW, "mt_lock", arglst, 5);
  *tag[++j] = USELOCK;
  XtAddCallback(lockW, XmNdisarmCallback, toggle_change, (XtPointer)tag[j]);
  XtManageChild(lockW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("FirstBox:"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, lockW);
  XtSetArg(arglst[3], XmNy, 5);
  boxInitLabelW = XmCreateLabel(mainToolFormW, "mt_boxlbl", arglst, 4);
  XtManageChild(boxInitLabelW);

  XtSetArg(arglst[0], XmNcolumns, 4);
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, boxInitLabelW);
  XtSetArg(arglst[3], XmNy, 1);
  XtSetArg(arglst[4], XmNvalue, "1");
  boxInitW = XmCreateText(mainToolFormW, "mt_boxtxt", arglst, 5);
  *tag[++j] = USEBOX;
  XtAddCallback(boxInitW, XmNvalueChangedCallback, 
		imgNumText_changed, (XtPointer)tag[j]);
  XtManageChild(boxInitW);

  // Up/down arrow behaviors controlled by boxInitArrowActivateButton()
  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, boxInitW);
  XtSetArg(arglst[4], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  boxinitArrowUpW = XmCreateArrowButton(mainToolFormW, "mtboxup", arglst, 6);
  XtManageChild(boxinitArrowUpW);
  XtSetArg(arglst[4], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  boxinitArrowDownW = XmCreateArrowButton(mainToolFormW, "mtboxdn", arglst, 6);
  XtManageChild(boxinitArrowDownW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(";1"));
  XtSetArg(arglst[1], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[2], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[3], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[4], XmNleftWidget, boxinitArrowUpW);
  XtSetArg(arglst[5], XmNheight, 19);
  XtSetArg(arglst[6], XmNwidth, 28);
  versionToolW = XmCreatePushButton(mainToolFormW, "mt_ver", arglst, 7);
  *tag[++j] = VERSION;
  XtAddCallback(versionToolW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(versionToolW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 19);
  XtSetArg(arglst[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(arglst[4], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(arglst[5], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[6], XmNleftWidget, versionToolW);
  helpToolW = XmCreatePushButton(mainToolFormW, "mt_help", arglst, 7);
  *tag[++j] = HELPTOOLW;
  XtAddCallback(helpToolW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(helpToolW);

} // end function create_mainscreen
