#include "gui.h"

void create_subtractmapscreen () {
  // function name: create_subtractmapscreen
  // Create and initialize attributes of subtract map screen
  
  int *tag[100], i, j=-1;
  for (i=0; i<100; i++)
    tag[i] = (int *) malloc(sizeof(int));

  // All arrow behaviors controlled by smMMaxArrowButton

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, XmStringCreateLocalized("Subtract 3D map"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 600);
  XtSetArg(arglst[5], XmNy, 100);
  XtSetArg(arglst[6], XmNwidth, 680);
  XtSetArg(arglst[7], XmNheight, 600);
  subScreenW = XmCreateFormDialog(toplevel_widget, "sub", arglst, 8);

  // Main form buttons

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 10);
  XtSetArg(arglst[4], XmNy, 550);
  subExitW = XmCreatePushButton(subScreenW, "sub_exit", arglst, 5);
  XtAddCallback(subExitW, XmNactivateCallback, subtractmap_deactivate, NULL);
  XtManageChild(subExitW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Subtract Map"));
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 550);
  subDoW = XmCreatePushButton(subScreenW, "sub_do", arglst, 3);
  XtAddCallback(subDoW, XmNactivateCallback, subtractMap_work, NULL);
  XtManageChild(subDoW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 300);
  XtSetArg(arglst[4], XmNy, 550);
  subHelpW = XmCreatePushButton(subScreenW, "sub_help", arglst, 5);
  *tag[++j] = SUBTRACTMAP;
  XtAddCallback(subHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag[j]);
  XtManageChild(subHelpW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("2D"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 90);
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  sub2dW = XmCreatePushButton(subScreenW, "sub_2d", arglst, 4);
  XtAddCallback(sub2dW, XmNactivateCallback, subtractMap_2d3d_activate, 
		NULL);
  XtManageChild(sub2dW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("3D"));
  XtSetArg(arglst[1], XmNy, 90); 
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, sub2dW);
  sub3dW = XmCreatePushButton(subScreenW, "sub_3d", arglst, 4);
  XtAddCallback(sub3dW, XmNactivateCallback, subtractMap_2d3d_activate, 
		NULL);
  XtManageChild(sub3dW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("3D Render"));
  XtSetArg(arglst[1], XmNy, 90);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, sub3dW);
  subRenderW = XmCreatePushButton(subScreenW, "sub_rend", arglst, 4);
  XtAddCallback(subRenderW, XmNactivateCallback, 
		subMapShadeScreen_activate, NULL);
  XtManageChild(subRenderW);

  // Main form toggles

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Icosahedral speedup (1/4 map used)"));
  XtSetArg(arglst[1], XmNx, 370);
  XtSetArg(arglst[2], XmNy, 530); 
  subIcosW = XmCreateToggleButton(subScreenW, "sub_icos", arglst, 3);
  *tag[++j] = ICOSAQUARTER;
  XtAddCallback(subIcosW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(subIcosW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Save Second and Difference Maps"));
  XtSetArg(arglst[1], XmNx, 370);
  XtSetArg(arglst[2], XmNy, 570); 
  subS2ndW = XmCreateToggleButton(subScreenW, "sub_s2nd", arglst, 3);
  *tag[++j] = SAVESECOND;
  XtAddCallback(subS2ndW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(subS2ndW);

  // Mag widgets

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 425);
  XtSetArg(arglst[2], XmNy, 220);
  XtSetArg(arglst[3], XmNvalue, "1.0");
  subMagsecTW = XmCreateText(subScreenW, "sub_magsect", arglst, 4);
  XtManageChild(subMagsecTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Mag: "));
  XtSetArg(arglst[1], XmNy, 220);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, subMagsecTW);
  subMagsecLW = XmCreateLabel(subScreenW, "sub_smagsecl", arglst, 4);
  XtManageChild(subMagsecLW);

  XtSetArg(arglst[0], XmNmaximum, 2444);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 10);	
  XtSetArg(arglst[3], XmNx, 500);
  XtSetArg(arglst[4], XmNy, 225);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[7], XmNvalue, 1000);
  subMagScrollW = XmCreateScrollBar(subScreenW, "sub_magscr", arglst, 8);
  XtAddCallback(subMagScrollW, XmNvalueChangedCallback, 
		diffSec_scroll_change, NULL);
  XtAddCallback(subMagScrollW, XmNdragCallback, 
		diffSec_scroll_change, NULL);
  XtManageChild(subMagScrollW);  

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Save"));
  XtSetArg(arglst[1], XmNy, 220);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, subMagScrollW);
  subMagSaveW = XmCreatePushButton(subScreenW, "sub_magsave", arglst, 4);
  XtAddCallback(subMagSaveW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subMagSaveW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 220);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subMagSaveW);
  subMagResetW = XmCreatePushButton(subScreenW, "sub_magres", arglst, 6);
  XtAddCallback(subMagResetW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subMagResetW);

  // SM widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Min:        "));
  XtSetArg(arglst[1], XmNx, 410);
  XtSetArg(arglst[2], XmNy, 10);
  subSmMinLW = XmCreateLabel(subScreenW, "sub_smminl", arglst, 3);
  XtManageChild(subSmMinLW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Max:        "));
  XtSetArg(arglst[1], XmNx, 410);
  XtSetArg(arglst[2], XmNy, 30);
  subSmMaxLW = XmCreateLabel(subScreenW, "sub_smmaxl", arglst, 3);
  XtManageChild(subSmMaxLW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 12);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subSmMinLW);
  subSmResetW = XmCreatePushButton(subScreenW, "sub_smreset", arglst, 6);
  XtAddCallback(subSmResetW, XmNactivateCallback, smMinMax_reset_activate, NULL);
  XtManageChild(subSmResetW);

  // Diff section widgets

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 425);
  XtSetArg(arglst[2], XmNy, 160);
  XtSetArg(arglst[3], XmNvalue, "1.0");
  subDiff1TW = XmCreateText(subScreenW, "sub_diff1t", arglst, 4);
  XtManageChild(subDiff1TW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Slope: "));
  XtSetArg(arglst[1], XmNy, 160);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, subDiff1TW);
  subDiff1LW = XmCreateLabel(subScreenW, "sub_diff1l", arglst, 4);
  XtManageChild(subDiff1LW);

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 425);
  XtSetArg(arglst[2], XmNy, 190);
  XtSetArg(arglst[3], XmNvalue, "0.0");
  subDiff2TW = XmCreateText(subScreenW, "sub_diff2t", arglst, 4);
  XtManageChild(subDiff2TW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Offset: "));
  XtSetArg(arglst[1], XmNy, 190);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, subDiff2TW);
  subDiff2LW = XmCreateLabel(subScreenW, "sub_diff2l", arglst, 4);
  XtManageChild(subDiff2LW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Subtract Section"));
  XtSetArg(arglst[1], XmNx, 400);
  XtSetArg(arglst[2], XmNy, 130); 
  XtSetArg(arglst[3], XmNset, 1);
  subDiffBW = XmCreateToggleButton(subScreenW, "sub_diffb", arglst, 4);
  XtAddCallback(subDiffBW, XmNvalueChangedCallback, 
		subtractMap_diffSection, NULL);
  XtManageChild(subDiffBW);

  XtSetArg(arglst[0], XmNmaximum, 244);
  XtSetArg(arglst[1], XmNminimum, -200);
  XtSetArg(arglst[2], XmNpageIncrement, 10);	
  XtSetArg(arglst[3], XmNx, 500);
  XtSetArg(arglst[4], XmNy, 165);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[7], XmNvalue, 100);
  subDiffSW = XmCreateScrollBar(subScreenW, "sub_diffs", arglst, 8);
  XtAddCallback(subDiffSW, XmNvalueChangedCallback, 
		diffSec_scroll_change, NULL);
  XtAddCallback(subDiffSW, XmNdragCallback, 
		diffSec_scroll_change, NULL);
  XtManageChild(subDiffSW);

  XtSetArg(arglst[0], XmNmaximum, 4444);
  XtSetArg(arglst[1], XmNminimum, -4000);
  XtSetArg(arglst[2], XmNpageIncrement, 10);	
  XtSetArg(arglst[3], XmNx, 500);
  XtSetArg(arglst[4], XmNy, 195);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  subDiffS2W = XmCreateScrollBar(subScreenW, "sub_diff2s", arglst, 7);
  XtAddCallback(subDiffS2W, XmNvalueChangedCallback, 
		diffSec_scroll_change, NULL);
  XtAddCallback(subDiffS2W, XmNdragCallback, 
		diffSec_scroll_change, NULL);
  XtManageChild(subDiffS2W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Save"));
  XtSetArg(arglst[1], XmNy, 175);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, subDiffSW);
  subDiffSBW = XmCreatePushButton(subScreenW, "sub_smreset", arglst, 4);
  XtAddCallback(subDiffSBW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subDiffSBW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 175);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subDiffSBW);
  subDiffRBW = XmCreatePushButton(subScreenW, "sub_smreset", arglst, 6);
  XtAddCallback(subDiffRBW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subDiffRBW);

  // File widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Original Map: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  subFile1LW = XmCreateLabel(subScreenW, "sub_file1l", arglst, 3);
  XtManageChild(subFile1LW);

  XtSetArg(arglst[0], XmNcolumns, 19);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 10);
  XtSetArg(arglst[3], XmNeditable, FALSE);
  subFile1TW = XmCreateText(subScreenW, "sub_file1t", arglst, 4);
  XtManageChild(subFile1TW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Subtract Map: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 50);
  subFile2LW = XmCreateLabel(subScreenW, "sub_file2l", arglst, 3);
  XtManageChild(subFile2LW);

  XtSetArg(arglst[0], XmNcolumns, 19);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 50);
  XtSetArg(arglst[3], XmNeditable, FALSE);
  subFile2TW = XmCreateText(subScreenW, "sub_file2t", arglst, 4);
  XtManageChild(subFile2TW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Browse"));
  XtSetArg(arglst[1], XmNx, 400);
  XtSetArg(arglst[2], XmNy, 50);
  subFile2BW = XmCreatePushButton(subScreenW, "sub_file2b", arglst, 3);
  *tag[++j] = SUBTRACTMAP;
  XtAddCallback(subFile2BW, XmNactivateCallback, 
		simple_activate, (XtPointer)tag[j]);
  XtManageChild(subFile2BW);

  // Flicker widgets

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Flicker"));
  XtSetArg(arglst[1], XmNx, 400);
  XtSetArg(arglst[2], XmNy, 100); 
  subFlickSW = XmCreatePushButton(subScreenW, "sub_fs", arglst, 3);
  *tag[++j] = 0;
  XtAddCallback(subFlickSW, XmNarmCallback, subtractMap_flicker_arm, 
		(XtPointer)tag[j]);
  *tag[++j] = 0;
  XtAddCallback(subFlickSW, XmNdisarmCallback, subtractMap_flicker_disarm, 
		(XtPointer)tag[j]);
  XtManageChild(subFlickSW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("*10"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, subFlickSW);
  XtSetArg(arglst[3], XmNy, 100); 
  subFlickMW = XmCreatePushButton(subScreenW, "sub_ms", arglst, 4);
  *tag[++j] = 1;
  XtAddCallback(subFlickMW, XmNarmCallback, subtractMap_flicker_arm, 
		(XtPointer)tag[j]);
  *tag[++j] = 1;
  XtAddCallback(subFlickMW, XmNdisarmCallback, subtractMap_flicker_disarm, 
		(XtPointer)tag[j]);
  XtManageChild(subFlickMW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Inf"));
  XtSetArg(arglst[1], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[2], XmNleftWidget, subFlickMW);
  XtSetArg(arglst[3], XmNy, 100); 
  subFlickIW = XmCreatePushButton(subScreenW, "sub_is", arglst, 4);
  *tag[++j] = 2;
  XtAddCallback(subFlickIW, XmNarmCallback, subtractMap_flicker_arm, 
		(XtPointer)tag[j]);
  *tag[++j] = 2;
  XtAddCallback(subFlickIW, XmNdisarmCallback, subtractMap_flicker_disarm, 
		(XtPointer)tag[j]);
  XtManageChild(subFlickIW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 21);
  XtSetArg(arglst[2], XmNheight, 21);
  XtSetArg(arglst[3], XmNy, 92);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subFlickIW);
  subFlickUpW = XmCreatePushButton(subScreenW, "sub_flup", arglst, 6);
  XtAddCallback(subFlickUpW, XmNactivateCallback, 
		flickArrowActivate, NULL);
  XtManageChild(subFlickUpW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 21);
  XtSetArg(arglst[2], XmNheight, 21);
  XtSetArg(arglst[3], XmNy, 110);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subFlickIW);
  subFlickDownW = XmCreatePushButton(subScreenW, "sub_fldn", arglst, 6);
  XtAddCallback(subFlickDownW, XmNactivateCallback, 
		flickArrowActivate, NULL);
  XtManageChild(subFlickDownW);

  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNspacing, 1);
  XtSetArg(arglst[4], XmNx, 590);
  XtSetArg(arglst[5], XmNy, 50);
  subFlickTypeW = XmCreateRadioBox(subScreenW, "sub_flickrad", arglst, 6);
  XtManageChild(subFlickTypeW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("1,2"));
  XtSetArg(arglst[1], XmNset, 1);
  subFlick12W = XmCreateToggleButton(subFlickTypeW, "sub_flick12", arglst, 2);
  *tag[++j] = 12;
  XtAddCallback(subFlick12W, XmNvalueChangedCallback, 
		flicker_change, (XtPointer)tag[j]);
  XtManageChild(subFlick12W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("1,3"));
  subFlick13W = XmCreateToggleButton(subFlickTypeW, "sub_flick13", arglst, 1);
  *tag[++j] = 13;
  XtAddCallback(subFlick13W, XmNvalueChangedCallback, 
		flicker_change, (XtPointer)tag[j]);
  XtManageChild(subFlick13W);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("2,3"));
  subFlick23W = XmCreateToggleButton(subFlickTypeW, "sub_flick23", arglst, 1);
  *tag[++j] = 23;
  XtAddCallback(subFlick23W, XmNvalueChangedCallback, 
		flicker_change, (XtPointer)tag[j]);
  XtManageChild(subFlick23W);

  // Threshold widgets

  XtSetArg(arglst[0], XmNcolumns, 5);
  XtSetArg(arglst[1], XmNx, 425);
  XtSetArg(arglst[2], XmNy, 250);
  XtSetArg(arglst[3], XmNvalue, "-2000.0");
  subThreshTW = XmCreateText(subScreenW, "sub_thesht", arglst, 4);
  XtManageChild(subThreshTW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Threshold: "));
  XtSetArg(arglst[1], XmNy, 250);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, subThreshTW);
  subThreshLW = XmCreateLabel(subScreenW, "sub_theshl", arglst, 4);
  XtManageChild(subThreshLW);

  XtSetArg(arglst[0], XmNmaximum, 2444);
  XtSetArg(arglst[1], XmNminimum, -2000);
  XtSetArg(arglst[2], XmNpageIncrement, 10);	
  XtSetArg(arglst[3], XmNx, 500);
  XtSetArg(arglst[4], XmNy, 255);
  XtSetArg(arglst[5], XmNwidth, 100);
  XtSetArg(arglst[6], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[7], XmNvalue, -2000);
  subThreshSW = XmCreateScrollBar(subScreenW, "sub_threshs", arglst, 8);
  XtAddCallback(subThreshSW, XmNvalueChangedCallback, 
		diffSec_scroll_change, NULL);
  XtAddCallback(subThreshSW, XmNdragCallback, 
		diffSec_scroll_change, NULL);
  XtManageChild(subThreshSW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("ShowIt"));
  XtSetArg(arglst[1], XmNy, 255);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, subThreshSW);
  XtSetArg(arglst[4], XmNset, 1);
  subThreshDoW = XmCreateToggleButton(subScreenW, "sub_threshdo", arglst, 5);
  *tag[++j] = THRESHDOIT;
  XtAddCallback(subThreshDoW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(subThreshDoW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("abs()"));
  XtSetArg(arglst[1], XmNy, 275);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, subThreshSW);
  subThreshAbsW = XmCreateToggleButton(subScreenW, "sub_threshdo", arglst, 4);
  *tag[++j] = THRESHABS;
  XtAddCallback(subThreshAbsW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(subThreshAbsW);

  // ---------- Subform for step 1 (Magnification) ----------

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Step 1: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 115);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  subMagLW = XmCreateLabel(subScreenW, "sub_magl", arglst, 4);
  XtManageChild(subMagLW);

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 140);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNresizable, FALSE);
  XtSetArg(arglst[4], XmNresizePolicy, XmRESIZE_NONE);
  subMagFW = XmCreateForm(subScreenW, "sub_magf", arglst, 5);
  XtManageChild(subMagFW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Find Mag"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 120);
  subMagFindW = XmCreatePushButton(subMagFW, "sub_magfind", arglst, 3);
  XtAddCallback(subMagFindW, XmNactivateCallback, subtractMap_cc, NULL);
  XtManageChild(subMagFindW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Histogram"));
  XtSetArg(arglst[1], XmNy, 120);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, subMagFindW);
  subMagHistW = XmCreateToggleButton(subMagFW, "sub_maghist", arglst, 4);
  XtAddCallback(subMagHistW, XmNvalueChangedCallback, 
		subtractMap_findMag_disp, NULL);
  XtManageChild(subMagHistW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Starting Mag: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  subMagStartLW = XmCreateLabel(subMagFW, "sub_stmagl", arglst, 3);
  XtManageChild(subMagStartLW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 10);
  subMagStartTW = XmCreateText(subMagFW, "sub_stmagt", arglst, 3);
  XtManageChild(subMagStartTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Step Size: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  subMagStepLW = XmCreateLabel(subMagFW, "sub_spmagl", arglst, 3);
  XtManageChild(subMagStepLW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 40);
  subMagStepTW = XmCreateText(subMagFW, "sub_spmagt", arglst, 3);
  XtManageChild(subMagStepTW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Number of Steps: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 70);
  subMagNumLW = XmCreateLabel(subMagFW, "sub_numagl", arglst, 3);
  XtManageChild(subMagNumLW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 70);
  subMagNumTW = XmCreateText(subMagFW, "sub_numagt", arglst, 3);
  XtManageChild(subMagNumTW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 10);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subMagStartTW);
  subMag1ResetW = XmCreatePushButton(subMagFW, "sub_magres1", arglst, 6);
  XtAddCallback(subMag1ResetW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subMag1ResetW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 40);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subMagStartTW);
  subMag2ResetW = XmCreatePushButton(subMagFW, "sub_magres2", arglst, 6);
  XtAddCallback(subMag2ResetW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subMag2ResetW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 70);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subMagNumTW);
  subMag3ResetW = XmCreatePushButton(subMagFW, "sub_magres3", arglst, 6);
  XtAddCallback(subMag3ResetW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subMag3ResetW);

  // ---------- Subform for step 2 (Radii) ----------

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Step 2: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 295);
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  subRadLW = XmCreateLabel(subScreenW, "sub_radl", arglst, 4);
  XtManageChild(subRadLW);

  XtSetArg(arglst[0], XmNx, 10);
  XtSetArg(arglst[1], XmNy, 320);
  XtSetArg(arglst[2], XmNborderWidth, 1);
  XtSetArg(arglst[3], XmNresizable, 0);
  XtSetArg(arglst[4], XmNresizePolicy, XmRESIZE_NONE);
  subRadFW = XmCreateForm(subScreenW, "sub_radf", arglst, 5);
  XtManageChild(subRadFW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Radial Density"));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 10); 
  subRadrdW = XmCreateToggleButton(subRadFW, "sub_radrd", arglst, 3);
  XtAddCallback(subRadrdW, XmNvalueChangedCallback, radTog_change, NULL);
  XtManageChild(subRadrdW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Weighted Radial Density"));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 35); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[RED]);
  subRadwrW = XmCreateToggleButton(subRadFW, "sub_radwr", arglst, 4);
  XtAddCallback(subRadwrW, XmNvalueChangedCallback, radTog_change, NULL);
  XtManageChild(subRadwrW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Correlation Coefficient"));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 60); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[GREEN]);
  subRadccW = XmCreateToggleButton(subRadFW, "sub_radcc", arglst, 4);
  XtAddCallback(subRadccW, XmNvalueChangedCallback, radTog_change, NULL);
  XtManageChild(subRadccW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Weighted Correlation Coefficient"));
  XtSetArg(arglst[1], XmNx, 280);
  XtSetArg(arglst[2], XmNy, 85); 
  XtSetArg(arglst[3], XmNforeground, pixels_return[BLUE]);
  subRadwcW = XmCreateToggleButton(subRadFW, "sub_radwc", arglst, 4);
  XtAddCallback(subRadwcW, XmNvalueChangedCallback, radTog_change, NULL);
  XtManageChild(subRadwcW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Min Radius: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  subRadMinLW = XmCreateLabel(subRadFW, "sub_radminl", arglst, 3);
  XtManageChild(subRadMinLW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 10);
  subRadMinTW = XmCreateText(subRadFW, "sub_radmint", arglst, 3);
  XtManageChild(subRadMinTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Max Radius: "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 40);
  subRadMaxLW = XmCreateLabel(subRadFW, "sub_radmaxl", arglst, 3);
  XtManageChild(subRadMaxLW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 40);
  subRadMaxTW = XmCreateText(subRadFW, "sub_radmaxt", arglst, 3);
  XtManageChild(subRadMaxTW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Show Radii"));
  XtSetArg(arglst[1], XmNy, 10);
  XtSetArg(arglst[2], XmNy, 70);
  XtSetArg(arglst[3], XmNset, 1);
  subRadRadiiW = XmCreateToggleButton(subRadFW, "sub_radradii", arglst, 4);
  *tag[++j] = SHOWRADII;
  XtAddCallback(subRadRadiiW, XmNvalueChangedCallback, 
		toggle_change, (XtPointer)tag[j]);
  XtManageChild(subRadRadiiW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, subRadMinTW);
  XtSetArg(arglst[4], XmNy, 9);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  subRadMinUpW = XmCreateArrowButton(subRadFW, "sub_radminu", arglst, 6);
  XtManageChild(subRadMinUpW);
  XtSetArg(arglst[4], XmNy, 25);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  subRadMinDownW = XmCreateArrowButton(subRadFW, "sub_radmind", arglst, 6);
  XtManageChild(subRadMinDownW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNrightAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNrightWidget, subRadMaxTW);
  XtSetArg(arglst[4], XmNy, 39);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_UP);
  subRadMaxUpW = XmCreateArrowButton(subRadFW, "sub_radmaxu", arglst, 6);
  XtManageChild(subRadMaxUpW);
  XtSetArg(arglst[4], XmNy, 55);
  XtSetArg(arglst[5], XmNarrowDirection, XmARROW_DOWN);
  subRadMaxDownW = XmCreateArrowButton(subRadFW, "sub_radmaxd", arglst, 6);
  XtManageChild(subRadMaxDownW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("                                 "));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 100);
  subEquationW = XmCreateLabel(subRadFW, "sub_radeq", arglst, 3);
  XtManageChild(subEquationW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Find Scaling"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 140);
  *tag[++j] = 0;
  subRadBW = XmCreatePushButton(subRadFW, "sub_radbw", arglst, 3);
  XtAddCallback(subRadBW, XmNactivateCallback, subtractMap_findRad,
		(XtPointer)tag[j]);
  XtManageChild(subRadBW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Histogram"));
  XtSetArg(arglst[1], XmNy, 140);
  XtSetArg(arglst[2], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[3], XmNleftWidget, subRadBW);
  subRadDW = XmCreateToggleButton(subRadFW, "sub_raddw", arglst, 4);
  XtAddCallback(subRadDW, XmNvalueChangedCallback, 
		subtractMap_findRad_disp, NULL);
  XtManageChild(subRadDW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNy, 140);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, subRadDW);
  subRadRW = XmCreatePushButton(subRadFW, "sub_radrw", arglst, 6);
  XtAddCallback(subRadRW, XmNactivateCallback, 
		diffSecSave_activate, NULL);
  XtManageChild(subRadRW);

} // end function create_subtractmapscreen
