#include "gui.h"

void create_truncaddscreen () {
  // function name: create_truncaddscreen
  // Create and initialize attributes of Truncate/Add to map screen
  
  int *tag1;
  tag1 = (int *) malloc(sizeof(int));

  // All arrow behaviors controlled by gbsArrowActivateButton()

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Truncate/Addto map"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 640);
  XtSetArg(arglst[5], XmNy, 250);
  XtSetArg(arglst[6], XmNwidth, 450);
  XtSetArg(arglst[7], XmNheight, 500);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  truncaddScreenW = XmCreateFormDialog(toplevel_widget, "ta", arglst, 9);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Set New Dimensions"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 10);
  taTitleW = XmCreateLabel(truncaddScreenW, "ta_title", arglst, 3);
  XtManageChild(taTitleW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 20);
  XtSetArg(arglst[4], XmNy, 450);
  truncaddExitW = XmCreatePushButton(truncaddScreenW, "ta_exit", arglst, 5);
  XtAddCallback(truncaddExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(truncaddExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 30);
  XtSetArg(arglst[2], XmNheight, 34);
  XtSetArg(arglst[3], XmNx, 80);
  XtSetArg(arglst[4], XmNy, 450);
  truncaddHelpW = XmCreatePushButton(truncaddScreenW, "ta_help", arglst, 5);
  *tag1 = TAHELP;
  XtAddCallback(truncaddHelpW, XmNactivateCallback, 
		context_help_screen_activate, (XtPointer)tag1);
  XtManageChild(truncaddHelpW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Truncate/Add"));
  XtSetArg(arglst[1], XmNx, 180);
  XtSetArg(arglst[2], XmNy, 450);
  truncaddDoW = XmCreatePushButton(truncaddScreenW, "ta_do", arglst, 3);
  XtAddCallback(truncaddDoW, XmNactivateCallback, truncadd_do_activate, NULL);
  XtManageChild(truncaddDoW);

  // Buttons for choosing whole and front/back, left/right, top/bottom map
  XtSetArg(arglst[0], XmNwidth, 97);  // Common attribute

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Left Half"));
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 250);
  taLeftW = XmCreatePushButton(truncaddScreenW, "ta_left", arglst, 4);
  XtAddCallback(taLeftW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taLeftW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Right Half"));
  XtSetArg(arglst[2], XmNx, 175);
  XtSetArg(arglst[3], XmNy, 250);
  taRightW = XmCreatePushButton(truncaddScreenW, "ta_right", arglst, 4);
  XtAddCallback(taRightW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taRightW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Top Half"));
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 290);
  taTopW = XmCreatePushButton(truncaddScreenW, "ta_top", arglst, 4);
  XtAddCallback(taTopW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taTopW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Bottom Half"));
  XtSetArg(arglst[2], XmNx, 175);
  XtSetArg(arglst[3], XmNy, 290);
  taBottomW = XmCreatePushButton(truncaddScreenW, "ta_bottom", arglst, 4);
  XtAddCallback(taBottomW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taBottomW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Front Half"));
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 330);
  taFrontW = XmCreatePushButton(truncaddScreenW, "ta_front", arglst, 4);
  XtAddCallback(taFrontW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taFrontW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Back Half"));
  XtSetArg(arglst[2], XmNx, 175);
  XtSetArg(arglst[3], XmNy, 330);
  taBackW = XmCreatePushButton(truncaddScreenW, "ta_back", arglst, 4);
  XtAddCallback(taBackW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taBackW);

  XtSetArg(arglst[1], XmNlabelString, XmStringCreateLocalized("Whole Map"));
  XtSetArg(arglst[2], XmNx, 82);
  XtSetArg(arglst[3], XmNy, 370);
  taWholeW = XmCreatePushButton(truncaddScreenW, "ta_whole", arglst, 4);
  XtAddCallback(taWholeW, XmNactivateCallback, truncadd_half_activate, NULL);
  XtManageChild(taWholeW);

  // Fill value text box and label
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Fill Value:"));
  XtSetArg(arglst[1], XmNx, 250);
  XtSetArg(arglst[2], XmNy, 380);
  taFillLabelW = XmCreateLabel(truncaddScreenW, "ta_xl", arglst, 3);
  XtManageChild(taFillLabelW);

  XtSetArg(arglst[0], XmNcolumns, 8);
  XtSetArg(arglst[1], XmNx, 350);
  XtSetArg(arglst[2], XmNy, 380);
  taFillW = XmCreateText(truncaddScreenW, "ta_fill", arglst, 3);
  XtManageChild(taFillW);
  XmTextSetString(taFillW, "0.0");

  // Labels for map indices
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("X range:"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 80);
  taXLabelW = XmCreateLabel(truncaddScreenW, "ta_xl", arglst, 3);
  XtManageChild(taXLabelW);
  
  XtSetArg(arglst[0], XmNalignment, XmALIGNMENT_BEGINNING);
  XtSetArg(arglst[1], XmNx, 260);
  XtSetArg(arglst[2], XmNy, 80);
  XtSetArg(arglst[3], XmNwidth, 170);
  taDimXW = XmCreateLabel(truncaddScreenW, "ta_dimx", arglst, 4);
  XtManageChild(taDimXW);
  
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Y range:"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 115);
  taYLabelW = XmCreateLabel(truncaddScreenW, "ta_yl", arglst, 3);
  XtManageChild(taYLabelW);
  
  XtSetArg(arglst[0], XmNalignment, XmALIGNMENT_BEGINNING);
  XtSetArg(arglst[1], XmNx, 260);
  XtSetArg(arglst[2], XmNy, 115);
  XtSetArg(arglst[3], XmNwidth, 170);
  taDimYW = XmCreateLabel(truncaddScreenW, "ta_dimy", arglst, 4);
  XtManageChild(taDimYW);
    
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Z range:"));
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 150);
  taZLabelW = XmCreateLabel(truncaddScreenW, "ta_zl", arglst, 3);
  XtManageChild(taZLabelW);

  XtSetArg(arglst[0], XmNalignment, XmALIGNMENT_BEGINNING);
  XtSetArg(arglst[1], XmNx, 260);
  XtSetArg(arglst[2], XmNy, 150);
  XtSetArg(arglst[3], XmNwidth, 170);
  taDimZW = XmCreateLabel(truncaddScreenW, "ta_dimz", arglst, 4);
  XtManageChild(taDimZW);

  // Text boxes for map indices
  XtSetArg(arglst[0], XmNcolumns, 4); // Common attribute

  XtSetArg(arglst[1], XmNx, 120);

  XtSetArg(arglst[2], XmNy, 80);
  taBegXW = XmCreateText(truncaddScreenW, "ta_begx", arglst, 3);
  XtManageChild(taBegXW);
  XtSetArg(arglst[2], XmNy, 115);
  taBegYW = XmCreateText(truncaddScreenW, "ta_begy", arglst, 3);
  XtManageChild(taBegYW);
  XtSetArg(arglst[2], XmNy, 150);
  taBegZW = XmCreateText(truncaddScreenW, "ta_begz", arglst, 3);
  XtManageChild(taBegZW);

  XtSetArg(arglst[1], XmNx, 190);

  XtSetArg(arglst[2], XmNy, 80);
  taEndXW = XmCreateText(truncaddScreenW, "ta_endx", arglst, 3);
  XtManageChild(taEndXW);
  XtSetArg(arglst[2], XmNy, 115);
  taEndYW = XmCreateText(truncaddScreenW, "ta_endy", arglst, 3);
  XtManageChild(taEndYW);
  XtSetArg(arglst[2], XmNy, 150);
  taEndZW = XmCreateText(truncaddScreenW, "ta_endz", arglst, 3);
  XtManageChild(taEndZW);

  // Global box size label and controls
  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Global Box Size"));
  XtSetArg(arglst[1], XmNx, 270);
  XtSetArg(arglst[2], XmNy, 10);
  gbsLabelW = XmCreateLabel(truncaddScreenW, "ta_gbsl", arglst, 3);
  XtManageChild(gbsLabelW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 405);
  XtSetArg(arglst[3], XmNy, 2);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  gbsUpArrowW = XmCreateArrowButton(truncaddScreenW, "ta_gbsup", arglst, 5);
  XtManageChild(gbsUpArrowW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 405);
  XtSetArg(arglst[3], XmNy, 23);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  gbsDownArrowW = XmCreateArrowButton(truncaddScreenW, "ta_gbsdn", arglst, 5);
  XtManageChild(gbsDownArrowW);

} // end function create_truncaddscreen
