      SUBROUTINE CTF_FIRSTPEAK_PFT (defocus, wavelength1, fft_rad,
     $     pixel_size,IDIM1, Cs, pi, units, amp_fac)

C     Determine location of first peak in the CTF
C     Author Wei Zhang
      
      implicit none
      
      integer*4 idim1, units
      real*4  defocus, wavelength, pixel_size,wavelength1
      real*4  fw, fft_rad, a, b, c, cs, pi, pixsize2
      real*4  amp_fac, angle
      
      angle = asin(amp_fac)
      wavelength = wavelength1 * 10.0 ! We want wavelength in Angstroms
      a       = Cs*10000000.0   ! Want to use Cs in Angstroms
      b       = -2.0*defocus*10000.0 ! 10000. converts defocus to Angstroms
      c       = wavelength * (1.0 - (2.0*angle)/pi)
      fw      = sqrt((-sqrt(B*B - 4.0*A*C) - B)/(2.0*A))
      
      if(units == 2) then
         pixsize2 = pixel_size * 10.0 ! Convert from nm to Angstroms
      else
         pixsize2 = pixel_size  ! Already Angstroms
      endif
      
      fft_rad = fw*(pixsize2*idim1)/wavelength
      
      return
      end
